#ifndef Blb_bshD.c
/*  */
#ifdef Doc_bshD.c
\Section{Bishop-Taylor equilibrium configurations}
Two equilibria $\gc(r,z)$ and $\bgY(r,z)$ have the same shape of magnetic
surfaced $\gc=\gc(\bgY)$

\ebox{
\gD^*\bgY
=
r^2\left(\R{\na\bgY}{r^2}\right)
=
-r^2\bsp'(\bgY)-\baF\baF'(\bgY)
,\quad
\gD^*\gc
=
\R{d\gc}{d\bgY}\gD^*\bgY
+\R{d^2\gc}{d^2\bgY}|\na\bgY|^2
}
it is necessary that

\ebox{
|\na\bgY|^2
=
\ga(\bgY)
+r^2\gb(\bgY)
}
This lead to the following representation of derivatives
\bqbl
\na\bgY
=
\bgY'_r\wse_r
+\bgY'_z\wse_z
,\quad
|\na\bgY|
=
r^2g(\gY,r)
,\quad
\bgY'_r
=
r^2h(\bgY,r)
,\quad
\bgY'_z
=
r^2\q{g^2-h^2}
,\\
r^2\na\R{\na\bgY}{r^2}
=
r\left.\R{\pa(rh)}{\pa r}\right|_{z=const}
+r^2\left.\R{\pa\q{g^2-h^2}}{\pa z}\right|_{z=const}
=
-r^2\bsp'
-\baF\baF'
,\\
r(rh)'_r
+r^2(\q{g^2-h^2})'_z
=
rh
+r^2h'_r
+r^2h'_\bgY\bgY'_r
+r^2\R{gg'_\bgY-hh'_\bgY}{\q{g^2-h^2}}\bgY'_z
=
-r^2\bsp'
-\baF\baF'
,\\
rh
+r^2h'_r
+r^2h'_\bgY\bgY'_r
+r^2\R{gg'_\bgY-hh'_\bgY}{\q{g^2-h^2}}\bgY'_z
=
rh
+r^2h'_r
+r^4gg'_\bgY
=
-r^2\bsp'
-\baF\baF',
,\\
rh
+r^2h'_r
+r^4gg'_\bgY
=
rh
+r^2h'_r
+\R{1}{2}(\ga'+r^2\gb')
=
-r^2\bsp'
-\baF\baF'
.\eqbl
where $h$ has the form
\bqbl
L(\bgY)
=
\bsp'
+\R{1}{2}\gb'
,\quad
M(\bgY)
=
-\baF\baF'
-\R{1}{2}\ga'
,\quad
r(rh)'_r
=
-r^2L
-M
,\\
h
=
-\R{L}{2}\R{r^2-r^2_0}{r}
+\R{M}{r}\log\R{r}{r_0}
,\quad
r_0
=
r_0(\bgY)
.\eqbl
Equation for mixed derivatives $\bgY''_{rz}=\bgY''_{zr}$ gives
\bqbl
\bgY'_r
=
r^2h
,\quad
\bgY'_z
=
r^2\q{g^2-h^2}
,\quad
r^2h'_\bgY\bgY'_z
=
(r^2\q{g^2-h^2})'_r
+r^2\R{gg'_\bgY-hh'_\bgY}{\q{g^2-h^2}}\bgY'_r
,\\
h'_\bgY r^2\q{g^2-h^2}
=
\R{2\q{g^2-h^2}}{r}
+\R{gg'_r-hh'_r}{\q{g^2-h^2}}
+r^2\R{gg'_\bgY-hh'_\bgY}{\q{g^2-h^2}}h
,\\
\R{r^3h}{2}(g^2)'_\bgY
-r^3g^2h'_\bgY
+\R{r}{2}(g^2)'_r
-\R{r}{2}(h^2)'_r
+2(g^2-h^2)
=
0
,\\
\R{h}{2r}(\ga'+r^2\gb')
-\R{1}{r}(\ga+r^2\gb)h'_\bgY
+\R{\gb}{r^2}
-\R{r}{2}(h^2)'_r
-2h^2
=
0
,\\
h
=
-\R{L}{2}\R{r^2-r^2_0}{r}
+\R{M}{r}\log\R{r}{r_0}
,\quad
h'_r
=
-\R{L}{2}
-\R{L}{2}\R{r^2_0}{r^2}
+\R{M}{r^2}
.\eqbl
Because of the presence of a single
\bqbl
M^2\left(\log\R{r}{r_0}\right)^2
\eqbl
in the last term of the previous equation
\bqbl
M=0
,\quad
\ga=\ga_0-\baF^2
,\quad
\waB^2
=
\R{|\na\bgY|^2+\baF^2}{r^2}
=
\gb+\R{\ga_0}{r^2}
,\eqbl
and
\bqbl
h
\equiv
-L\bsh
,\quad
\bsh
\equiv
\R{r^2-r^2_0}{2r}
,\quad
h'_r
=
-\R{L}{2}
-\R{L}{2}\R{r^2_0}{r^2}
-(\ga+r^2\gb)h'_\bgY
+\R{\gb}{r}
+hL\R{r^2+r^2_0}{2}
-2rh^2
=
0
,\\
\left(\R{\ga+r^2\gb}{h^2}\right)'_\bgY
+\R{2\gb}{rh^3}
+L\R{r^2+r^2_0}{h^2}
-\R{4r}{h}
=
0
.\eqbl

\Subsection{Equations for characteristics}
In new notations

\ebox{
X
\equiv r^2_0
,\quad
S
\equiv
\R{\ga}{L^2}
,\quad
Q
\equiv
\R{\gb}{L^2}
,\quad
\bgY'_\gl
=
-L
}

\bqbl
\left(\R{S+r^2Q}{\bsh^2}\right)'_\gl
+\R{2Q}{r\bsh^3}
-\R{3r^2}{\bsh^2}
+\R{r^2_0}{\bsh^2}
=
0
,\\
S'_\gl
+r^2Q'_\gl
-2\R{S+r^2Q}{\bsh}\bsh'_\gl
+\R{2Q}{r\bsh}
-3r^2
+r^2_0
=
0
,\\
Q'_\gl
=
3
,\quad
S'_\gl
+2\R{S+r^2Q}{r^2-X}X'_\gl
+\R{4Q}{r^2-X}
+X
,\\
S'_\gl(r^2-X)
+2(S+r^2Q)X'_\gl
+4Q
+X(r^2-X)
=
0
.\eqbl
\ebox{
Q'_\gl
=
3
,\quad
Q
=
3\gl
,\quad
S'_\gl
=
-6\gl X'_\gl-X
,\quad
U=S+X\gl
,\quad
U'_\gl
=
-5\gl X'_\gl
,\quad
X'_\gl
=
-\R{6\gl}{U+2X\gl}
}

Asymptotics

\ebox{
U'
=
-5\gl X'
,\quad
X'_\gl
=
-\R{6\gl}{U+2X\gl}
,\quad
X
=
1-3\gl
,\quad
U
=
\R{15}{2}\gl^2
,\quad
X
=
1-3\gl+\R{9}{8}\gl^2
}

Scaling
\bqbl
X=R_0^2\baX
,\quad
S=R_0^6\baS
,\quad
\gl=R_0^4\bgl
.\eqbl

\Subsection{Equations in working variables}
Inroducing intersections of magnetic surface with the mid-plane
\bqbl
Y_{1,2}
\equiv
r^2_{1,2}
,\quad
Y_1(Y_1-X)^2
=
4S+12Y_1\gl
,\quad
Y_2(Y_2-X)^2
=
4S+12Y_2\gl
,\\
Y'[(Y-X)^2+2Y(Y-X)-12\gl]
=
4\left(-X+3Y+\R{12\gl}{X-Y}\right)
,\\
Y'(3Y^2+X^2-4XY-12\gl)
=
4\R{3Y^2+X^2-4XY-12\gl}{Y-X}
,\quad
\R{dY_1}{d\gl}
=
\R{4}{Y_1-X}
,\eqbl

\ebox{
U=S+\gl X
,\quad
U'_\gl
=
-5\gl X'
,\quad
X'_\gl
=
-\R{24\gl}{(Y_1-X)[Y_1(Y_1-X)-12\gl]}
,\quad
\R{dY_1}{d\gl}
=
\R{4}{Y_1-X}
,\\
Y_1
=
r^2_1
,\quad
-\R{d\gl}{dr_1}
=
r_1\R{X-Y_1}{2}
,\quad
\R{dX}{dr_1}
=
\R{12r_1\gl}{12\gl-Y_1(X-Y_1)}
,\quad
\R{dU}{dr_1}
=
-5\gl\R{dX}{dr_1}
}

\bqbl
Y_2
=
\R{2X-Y_1+\q{(2X-Y_1)^2-4(X-Y_1)^2+48\gl}}{2}
=
X+2\R{Y_1(X-Y_1)+12\gl}{Y_1+\q{Y_1(4X-3Y_1)+48\gl}}
\eqbl

\Subsection{Shape of magnetic surfaces}
\bqbl
dr
=
-\R{\bgY'_z}{|\na\bgY|}dl
,\quad
dz
=
\R{\bgY'_r}{|\na\bgY|}dl
,\quad
dr
=
\mp\q{1-\R{r^2(r^2-X)^2}{4(S+3r^2\gl)}}dl
,\quad
dz
=
\R{r(r^2-X)}{2\q{S+3r^2\gl}}dl
,\\
\R{dz}{dr^2}
=
-\R{r^2-X}
{2\q{4S+12r^2\gl-r^2(r^2-X)^2}}
,\quad
z
=
-\oint\R{r^2-X}{2\q{4S+12r^2\gl-r^2(r^2-X)^2}}dr^2
.\eqbl

\ebox{
12\gl
=
Y_2(Y_2+Y_1-2X)+(Y_1-X)^2
,\quad
4S
=
-Y_2Y_1(Y_2+Y_1-2X)
,\\
4S+12\gl r^2-r^2(r^2-X)^2
=
(Y_2-r^2)(r^2-Y_1)(r^2+Y_2+Y_1-2X)
=
a^2\sin^2\gt(r^2+2d)
}
Equation for the shape of magnetic surfaces
\bqbl
r^2
\equiv
X+y
,\quad
Y_1
\equiv
X+y_1
,\quad
Y_2
\equiv
X+y_2
,\quad
y=d+a\cos\gt
,\quad
d\equiv\R{y_2+y_1}{2}
,\quad
a\equiv\R{y_2-y_1}{2}
,\\
\R{dz}{dy}
=
-\R{y}{2\q{4S+12(X+y)\gl-(X+y)y^2}}
=
-\R{y}{2\q{(y-y_1)(y_2-y)(y+X+y_2+y_1)}}
.\eqbl
New variable
\bqbl
(y-y_1)(y_2-y)(y+X+y_2+y_1)
=
a^2\sin^2\gt(a\cos\gt+X+3d)
,\\
\R{dz}{dy}
=
-\R{d+a\cos\gt}{2a\sin\gt\q{X+3d+a\cos\gt}}
.\eqbl

\ebox{
r^2
=
X+y
,\quad
y=d+a\cos\gt
,\quad
\R{dz}{d\gt}
=
\R{d+a\cos\gt}{2\q{X+3d+a\cos\gt}}
}

\Subsection{Equilibrium profiles}
\bqbl
rh
=
-\R{L(r^2-X)}{2}
,\quad
\gD^*\bgY
=
-Lr^2
+\R{1}{2}(\ga'+r^2\gb')
=
-p'r^2-\baF\baF'
,\\
\baF^2
=
\baF^2_0
-L^2S
,\quad
p'_\bgY
=
L
+\R{1}{2L}\R{d(3L^2\gl)}{d\gl}
=
\R{5}{2}L
+3L'_\gl\gl
,\quad
\baF\baF'_\bgY
=
\R{(L^2S)'_\gl}{2L}
,\\
L
=
2
,\quad
\baF^2
=
\baF^2_0
-4S
,\quad
p'_\bgY
=
5
.\eqbl

\ebox{
\baF^2
=
\baF^2_0
-L^2S
,\quad
T
=
\R{2L'_\gl S+LS'_\gl}{2}
,\quad
P
=
\R{5}{2}L
+3\gl L'_\gl
,\quad
\bsj_p
=
R_0\bsp'_\bgY
,\quad
\bsj_s
=
\R{2L'_\gl S+LS'_\gl}{2R_0}
+\bsj_p
}

Magnetic flux
\bqbl
|\na\bgY|^2
=
L^2S+3r^2L^2\gl
=
L^2\R{g_{\gt\gt}}{D^2_{\gl\gt}}
,\quad
4S+12r^2\gl
=
4\R{g_{\gt\gt}}{D^2}
,\quad
D_{\gl\gt}
=
\q{\R{4g_{\gt\gt}}{4S+12r^2\gl}}
,\\
g_{\gt\gt}
=
\R{a^2\sin^2\gt(r^2+2d)+r^2(d+a\cos\gt)^2}{4r^2(r^2+2d)}
,\quad
4S+12r^2\gl
=
a^2\sin^2\gt(r^2+2d)
+r^2(d+a\cos\gt)^2
,\\
D^2_{\gl\gt}
=
\R{1}{r^2(r^2+2d)}
,\quad
D_{\gl\gt}
=
\R{1}{r\q{r^2+2d}}
,\quad
\bgF'_\gl
=
\R{\baF}{2\gp}\oint\R{D_{\gl\gt}d\gt}{r}
=
\R{\baF}{2\gp}\oint\R{d\gt}{r^2\q{r^2+2d}}
.\eqbl

\ebox{
\bgF'_\gl
=
\R{\baF}{2\gp}\oint\R{d\gt}{r^2\q{(r^2+2d)}}
=
\R{\q{\baF^2_0-L^2S}}{2\gp}\oint\R{d\gt}{r^2\q{(r^2+2d)}}
}

\Subsection{Junk}
\Subsubsection{Proof of closeness}
Condition of closed surfaces
\bqbl
\int^\gp_0\R{d+a\cos\gt}{2\q{X+a\cos\gt+3d}}d\gt
=
0
,\quad
\R{d}{d\gl}\int^\gp_0\R{d+a\cos\gt}{\q{X+3d+a\cos\gt}}d\gt
=
0
,\\
Y_1
=
X+y_1
,\quad
Y_2
=
X+y_2
,\quad
y_2=d+a
,\quad
y_1=d-a
,\\
a'_\gl
=
\R{4a}{a^2-d^2}
,\quad
d'_\gl
=
\R{2}{X+2d}
,\quad
X'_\gl+3d'_\gl
=
-\R{4d}{a^2-d^2}+\R{4}{X+2d}
.\eqbl

Checking invariance of closure
\bqbl
z''_{\gl\gq}
=
-\R{d'+a'\cos\gq}{2\q{X+3d+a\cos\gq}}
+\R{(d+a\cos\gq)(X'+3d'+a'\cos\gq)}{4(X+3d+a\cos\gq)^{3/2}}
\\\quad=
\R{(d+a\cos\gq)(X'+3d'+a'\cos\gq)-(2d'+2a'\cos\gq)(X+3d+a\cos\gq)}
{4(X+3d+a\cos\gq)^{3/2}}
\\\quad=
\R{(d+a\cos\gq)(X'+d')
-(2X+4d)d'
-(2X+5d+a\cos\gq)a'\cos\gq
}
{4(X+3d+a\cos\gq)^{3/2}}
\\\quad=
\R{-d(d+a\cos\gq)
-(2X+5d+a\cos\gq)a\cos\gq
-(a^2-d^2)
}
{(a^2-d^2)(X+3d+a\cos\gq)^{3/2}}
\\\quad=
-\R{
2(X+3d)a\cos\gq
+a^2\cos^2\gq
+a^2
}
{(a^2-d^2)(X+3d+a\cos\gq)^{3/2}}
=
-\R{1}{a^2-d^2}\left(\R{2a\sin\gq}{\q{X+3d+a\cos\gq}}\right)'_\gq
,\\
\left(\R{2a\sin\gq}{\q{X+3d+a\cos\gq}}\right)'_\gq
=
\R{
2(X+3d)a\cos\gq
+a^2\cos^2\gq
+a^2
}{(X+3d+a\cos\gq)^{3/2}}
.\eqbl

\Subsubsection{Initial conditions for characteristics}
Initial conditions
\bqbl
Y_1
=
(1-s)^2
,\quad
\R{d\gl}{dY}
=
\R{Y_1-X}{4}
,\quad
X
=
1
-3\gl
+\R{9}{8}\gl^2
,\quad
\R{d\gl}{ds}
=
\R{(s-1)^3-(s-1)X}{2}
,\\
\gl
=
s^2\left(\R{1}{2}-\R{3}{4}s+\R{19}{32}s^2\right)
.\eqbl

\ebox{
Y_1
=
(1-s)^2
,\quad
\gl
=
s^2\left(\R{1}{2}-\R{3}{4}s+\R{19}{32}s^2\right)
,\quad
X
=
1
-3\gl
+\R{9}{8}\gl^2
,\quad
U
=
\R{15}{2}\gl^2
}
#endif

#ifndef mzl_System_bshD.c /* --------------- Use of Variables --------{ */
#ifndef H/* ---------- Used External Variables ------{ */
#endif /* }======== End of Used External Variables ======= */

#endif /* }======== End of Use of Variables ======== */

int Na;		/*  */
int Na1;	/*  */
int Np;		/*  */
int Np1;	/*  */
double sa[];	/*  */
double gt[];	/*  */
double cs1[];	/*  */
double sn1[];	/*  */
double sr[];	/*  */
double sz[];	/*  */
double sR[];	/*  */
double sZ[];	/*  */
#endif

#undef Doc_Cb_Structure
#ifdef Blb_bshD.c
Blb_bshD.c{
}
#endif

#undef Doc_Table_Of_Content
#ifndef Blb_bshD.c
	PS p= -1 (  0);
#endif
