#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <time.h>
#include <sys/time.h>

extern time_t time(time_t *t);
extern struct tm *localtime(const time_t *timep);
static struct tm *ltm;
static time_t stTime;

#ifndef mzl_MLIB
extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;
#endif

extern int ID;
extern int ESNa,ESNa1,ESNp,ESNp1,ESNap;
extern double ESRext;
extern double ESBt;
extern double ESRBt;

extern double ESsr[],ESsra[],ESsrq[],ESsraq[];
extern double ESsz[],ESsza[],ESszq[],ESszaq[];
extern double ESaB[],ESaBa[],ESaBq[],ESaBaq[];
extern double ESgH[],ESgHa[],ESgHq[],ESgHaq[];

extern double ESgq[],EScs1[],ESsn1[];
extern double ESsa[],ESpa[];

extern double ESaP[],ESaP1a[];
extern double ESaT[],ESaT1a[];
extern double ESdgY[],ESdgY1a[];
extern double ESdgF[],ESdgF1a[];

int bsh2ESI(char *FNm, int Fl)
{
  int i,j,ji;
  char Date[32];
  time_t time(time_t *t);
  struct tm *localtime(const time_t *timep);
  struct tm *ltm;
  time_t stTime;
  char GrName[16][32]={
    "<ESI dimensions>",
    "<ESI [gq]>",
    "<ESI [sa]>",
    "<ESI [baF bsp gF gY]>",
    "<ESI bgFa bgFaa bgYa bgYaa>",
    "<ESI T Ta P Pa>",
    "<ESI r ra rq raq>",
    "<ESI z za zq zaq>",
    "<ESI B Ba Bq Baq>",
    "<ESI ghq ghaq ghqq ghaqq>",
    "<ESI [gz]>",   		/* only for 3D */
    "<ESI rgz ragz rqgz>",   	/* only for 3D */
    "<ESI zgz zagz zqgz>",   	/* only for 3D */
    "<ESI Bgz Bagz Bqgz>",   	/* only for 3D */
    "<ESI ghgz ghagz ghqgz>",	/* only for 3D */
    ""
  };

  char FNmM[16];
  char FNmB[16];
  FILE *lF,*lf;
  int Na,Na1,Nq,Nq1;
  int kD,L,Naq;

  Na	=ESNa;
  Nq	=ESNp;
  Na1	=Na+1;
  Nq1	=Nq+1;
  Naq	=Nq1*Na1;
  kD	=sizeof(double);

  if((Fl&0x1 == 0)) goto Label1;

  lF	=fopen(FNm,"w");
  if(lF == NULL){
    CbStr2UserMessage("%s cannot be open",FNm);
    return(1);
  }

  time(&stTime);
  ltm	=localtime(&stTime);
  sprintf(Date,"Date: %2.2d/%2.2d/%2.2d at %2.2d:%2.2d"
	  ,ltm->tm_mon+1,ltm->tm_mday,ltm->tm_year%100,ltm->tm_hour
	  ,ltm->tm_min); 
  fprintf(lF,"!!! Do not edit this file\n");

  /* Group 0 */
  fprintf(lF,"%s[1]%s %s\n",GrName[0],"(%d x %d %d %e %e %s)",Date);
  fprintf(lF,"%4s x %3s %6s %5s %6s %13s | %5s %s\n",
	  "!Nq1","Na1","ID","Rext","RBtor","Name","Btor"
	  ," - this is a comment starting with !");
  fprintf(lF,"%4d x %3d %6.6d %5.3f %6.3f %13s   %5.3f %s\n"
	  ,Nq1,Na1,ID,ESRext,ESRBt,"Bishop-Taylor",ESBt
	  ," - after-record comment (after Name)");

  /* Group 1 is optional if equidistant and  0 <=gq <= 2*gp */
  fprintf(lF,"\n%s[1](%d%s)\n",GrName[1],Nq1,"%e");
  for(j=0; j < Nq1; j++){
    fprintf(lF,"%24.16e",ESgq[j]);
    if(j%4 == 3) fputc('\n',lF);
  }
  if(j%4 != 0) fputc('\n',lF);

  /* Group 2 optional if equidistant and 0 <= a <= 1 */
  fprintf(lF,"\n%s[1](%d%s)\n",GrName[2],Na1,"%e");
  for(i=0; i < Na1; i++){
    fprintf(lF,"%24.16e",ESsa[i]);
    if(i%4 == 3) fputc('\n',lF);
  }
  if(i%4 != 0) fputc('\n',lF);

  /* Group 3 is ignored by ESI and dropped here */

  /* Group 4 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[4],Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","bgF'/a","(bgF'/a)'"
	  ,"bgY'/a","(bgY'/a)'");
  for(i=0; i < Na1; i++){
    fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	    ,ESdgF[i],ESdgF1a[i],ESdgY[i],ESdgY1a[i]);
  }

  /* Group 5 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[5],Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","T","T'","P","P'");
  for(i=0; i < Na1; i++){
    fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	    ,ESaT[i],ESaT1a[i],ESaP[i],ESaP1a[i]);
  }

  /* Group 6 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[6],Nq1*Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","r","r'_a","r'_q","r''_aq");
  ji	=0;
  for(i=0; i < Na1; i++){
    for(j=0; j < Nq1; j++){
      fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	      ,ESsr[ji],ESsra[ji],ESsrq[ji],ESsraq[ji]);
      ji++;
    }
  }

  /* Group 7 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[7],Nq1*Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","z","z'_a","z'_q","z''_aq");

  ji	=0;
  for(i=0; i < Na1; i++){
    for(j=0; j < Nq1; j++){
      fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	      ,ESsz[ji],ESsza[ji],ESszq[ji],ESszaq[ji]);
      ji++;
    }
  }

  /* Group 8 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[8],Nq1*Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","|B|","|B|'_a","|B|'_q","|B|''_aq");	
  ji	=0;
  for(i=0; i < Na1; i++){
    for(j=0; j < Nq1; j++){
      fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	      ,ESaB[ji],ESaBa[ji],ESaBq[ji],ESaBaq[ji]);
      ji++;
    }
  }

  /* Group 9 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[9],Nq1*Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","gh'_q","gh''_aq","gh''_qq","gh'''_aqq");
  ji	=0;
  for(i=0; i < Na1; i++){
    for(j=0; j < Nq1; j++){
      fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	      ,ESgH[ji],ESgHa[ji],ESgHq[ji],ESgHaq[ji]);
      ji++;
    }
  }

  fclose(lF);

  CbStr2UserMessage("Output: %s",FNm);

  if((Fl&0x2 == 0))  return(0);

 Label1:
  
  /***********  Output to ASCII map and to binary files ***********/
  L	=0;
  sprintf(FNmM,"%sm",FNm);
  sprintf(FNmB,"%sb",FNm);
  lF	=fopen(FNmM,"w");
  lf	=fopen(FNmB,"w");

  time(&stTime);
  ltm	=localtime(&stTime);
  sprintf(Date,"Date: %2.2d/%2.2d/%2.2d at %2.2d:%2.2d"
	  ,ltm->tm_mon+1,ltm->tm_mday,ltm->tm_year%100,ltm->tm_hour
	  ,ltm->tm_min); 
  fprintf(lF,"!!! Do not edit this file\n");

  /* Group 0 */
  fprintf(lF,"%s[1]%s %s\n",GrName[0],"(%d x %d %d %e %e %s)",Date);
  fprintf(lF,"%4s x %3s %6s %5s %6s %13s | %5s %s\n",
	  "!Nq1","Na1","ID","Rext","RBtor","Name","Btor"
	  ," - this is a comment starting with !");
  fprintf(lF,"%4d x %3d %6.6d %5.3f %6.3f %13s   %5.3f %s\n"
	  ,Nq1,Na1,ID,ESRext,ESRBt,"Bishop-Taylor",ESBt
	  ," - after-record comment (after Name)");

  /* Group 1 is optional if equidistant and  0 <=gq <= 2*gp */
  fprintf(lF,"\n%s[0 @ %d:%s](%d%s)\n",GrName[1],L,FNmB,Nq1,"%e");
#ifdef H
  fwrite(ESgq,kD,Nq1,lf);
  L	+=kD*Nq1;
#endif
  /* Group 2 optional if equidistant and 0 <= a <= 1 */
  fprintf(lF,"\n%s[0 @ %d:%s](%d%s)\n",GrName[2],L,FNmB,Na1,"%e");
#ifdef H
  fwrite(ESsa,kD,Na1,lf);
  L	+=kD*Na1;
#endif

  /* Group 3 is ignored by ESI and dropped here */

  /* Group 4 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[4],Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","bgF'/a","(bgF'/a)'"
	  ,"bgY'/a","(bgY'/a)'");
  for(i=0; i < Na1; i++){
    fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	    ,ESdgF[i],ESdgF1a[i],ESdgY[i],ESdgY1a[i]);
  }

  /* Group 5 */
  fprintf(lF,"\n%s[%d]%s\n",GrName[5],Na1,"(%e %e %e %e)");
  fprintf(lF,"!%23s%24s%24s%24s\n","T","Ta","P","Pa");
  for(i=0; i < Na1; i++){
    fprintf(lF,"%24.16e%24.16e%24.16e%24.16e\n"
	    ,ESaT[i],ESaT1a[i],ESaP[i],ESaP1a[i]);
  }

  /* Group 6 */
  fprintf(lF,"\n%s[1 @ %d:%s](%d%%e %d%%e %d%%e %d%%e)\n",GrName[6],L,FNmB
	  ,Naq,Naq,Naq,Naq);
  fwrite(ESsr,kD,Naq,lf);
  fwrite(ESsra,kD,Naq,lf);
  fwrite(ESsrq,kD,Naq,lf);
  fwrite(ESsraq,kD,Naq,lf);
  L	+=4*kD*Naq;

  /* Group 7 */
  fprintf(lF,"\n%s[1 @ %d](%d%%e %d%%e %d%%e %d%%e)\n",GrName[7],L
	  ,Naq,Naq,Naq,Naq);
  fwrite(ESsz,kD,Naq,lf);
  fwrite(ESsza,kD,Naq,lf);
  fwrite(ESszq,kD,Naq,lf);
  fwrite(ESszaq,kD,Naq,lf);
  L	+=4*kD*Naq;

  /* Group 8 */
  fprintf(lF,"\n%s[1 @ %d](%d%%e %d%%e %d%%e %d%%e)\n",GrName[8],L
	  ,Naq,Naq,Naq,Naq);
  fwrite(ESaB,kD,Naq,lf);
  fwrite(ESaBa,kD,Naq,lf);
  fwrite(ESaBq,kD,Naq,lf);
  fwrite(ESaBaq,kD,Naq,lf);
  L	+=4*kD*Naq;

  /* Group 9 */
  fprintf(lF,"\n%s[1 @ %d](%d%%e %d%%e %d%%e %d%%e)\n",GrName[9],L
	  ,Naq,Naq,Naq,Naq);
  fwrite(ESgH,kD,Naq,lf);
  fwrite(ESgHa,kD,Naq,lf);
  fwrite(ESgHq,kD,Naq,lf);
  fwrite(ESgHaq,kD,Naq,lf);
  L	+=4*kD*Naq;
  fclose(lF);
  fclose(lf);
  CbStr2UserMessage("\nOutput: %s %s",FNmM,FNmB);
  /********************** End of map and binary *************************/
  return(0);
}

int BshO()
{
  static int kW=0,kR=0;
  char FNm[0x10]="esiBT.00";

#ifndef Tbl_BshO
  if(kW){
    bsh2ESI(FNm,kW-1);
    kW	=0;
  }
  if(kR){
    File2ESI(FNm);
    kR	=0;
  } 
#endif /*Tbl_BshO*/

  return(0);
}
