#include <stdio.h>
#include <math.h>

extern double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;

extern int ESNa,ESNa1;
extern double ESsa[];
extern double ESgaG[];

static double cr3ha,cha,crha,c2rha,cHa,crHa,chha,ch2ha,ch2h1,ch4h0,ch4h1;
static int iSplA=0,iSplA1;
static double SplAx,SplAxx,SplAX,SplAXX;

static double vA[0x101];
static double glA[0x909];

int ESFirstSetSplA()
{
  double h;

  h	=ESsa[1]-ESsa[0];
  cha	=cr6*h;
  cr3ha	=cr3*h;
  crha	=1./h;
  c2rha	=2.*crha;
  chha	=cr2*h;
  ch2ha	=chha*cha;
  cHa	=cr6*h*h;
  crHa	=6.*crha*crha; 
  ch2h1	=cr3*h*h;
  ch4h1	=-cr3*h*h*h*h/30.;
  ch4h0	=7.*cr4*ch4h1;
  ch4h1	*=2.;
  return(0);
}

int splA(double*g,double*d2g,double*dg0,double*dg1)
{
  static int i,ii,i1;
  double r0,r1;

  r0=(g[1]-g[0])*crHa;
  r1=(g[2]-g[1])*crHa;

  if(dg0 != NULL){
    vA[0]	=-cr2;
    d2g[0]	=cr2*r0-3.*(*dg0)*crha;
    vA[1]	=-1./(4.+vA[0]);
    d2g[1]	=(r0-r1+d2g[0])*vA[1];
  }
  else{
    vA[0]	=2.;
    d2g[0]	=0.;
    vA[1]	=0.;
    d2g[1]	=cr6*(r1-r0);
  }

  i1	=1;
  for(i=2; i < ESNa; i++){
    r0		=r1;
    r1		=(g[i+1]-g[i])*crHa;
    vA[i]	=-1./(4.+vA[i1]);
    d2g[i]	=(r0-r1+d2g[i1])*vA[i];
    i1++;
  }

  if(dg1 == NULL){
    d2g[i1]	=cr6*(r1-r0);
    vA[i1]	=0.;
    ii	=i1-1;
    d2g[i]	=(2.-vA[ii])*d2g[i1]-d2g[ii];
  }
  else{
    d2g[i]	=((*dg1)/cha-r1-d2g[i1])/(vA[i1]+2.);
  }
  while(i > 0){
    d2g[i1]	+=vA[i1]*d2g[i];
    i--;
    i1--;
  }
  if(dg0 == NULL){
    d2g[0]	-=d2g[2];
  }
  return(0);
}

int splA1a(double*g,double*d1g,double*d2g)
{
  static int i,ii;
  
  ii	=1;
  i	=0;
  d1g[0]=(g[ii]-g[i])*crha-(d2g[ii]+2.*d2g[i])*cha;
  while(ii < ESNa1){
    d1g[ii]	=(g[ii]-g[i])*crha+(2.*d2g[ii]+d2g[i])*cha;
    i++;
    ii++;
  }
  return(0);
}

int f2splA(double*g,double*d2g,double*dg0,double*dg1,double*f)
{
  static int i,ii,k,Ind0;

  static double s,sc0,sc1,sc11,sd0,sd1,sd11,rh1,rh11,sq;
  static double r1,r2,r3;
  static double w[6],rw[6];
  static double t11,t13,t22,t23,t31,t32;
  static double bc00= 0.,bc01= 0.,bd00= 0.,bd01= 0.,be0= 1.,bf0= 0.;
  static double bcn0= 0.,bcn1= 0.,bdn0= 0.,bdn1= 0.,ben= 1.,bfn= 0.;

  i	=ESNa;
  rh1=ESsa[i]-ESsa[i-1];

  if(dg1!=NULL){
    bfn= (*dg1);
    bcn0= 1./rh1;
    bcn1= -bcn0;
    bdn0= cr3*rh1;
    bdn1= cr6*rh1;
    ben= 0.;
  }
  else{
    bfn= 0.;
    bcn0= 0.;
    bcn1= 0.;
    bdn0= 0.;
    bdn1= 0.;
    ben= 1.;
  }
  bfn-= bcn0*f[i];
  bcn0= 0.;
  rh1= ESsa[1]-ESsa[0];
  if(dg0!=NULL){
    bf0= (*dg0);
    bc01= 1./rh1;
    bc00= -bc01;
    bd00= -cr3*rh1;
    bd01= -cr6*rh1;
    be0= 0.;
  }
  else{
    bf0= 0.;
    bc01= 0.;
    bc00= 0.;
    bd00= 0.;
    bd01= 0.;
    be0= 1.;
  }
  for(i= 0;i<6;i++){
    w[i]= 0;
  }
  Ind0	=1;

  r1= 0.;
  r2= 0.;
  r3= 0.;
  for(i= 0,ii= 1,sc1= 0.,sd1= 0.,rh1= 0.;i < ESNa1;i++,ii++){
    k= 9*i;
    rh11= rh1;
    sc11= sc1;
    sd11= sd1;
    if(i<ESNa){
      rh1= ESsa[ii]-ESsa[i];
      sd1= cr6*rh1;
      sc1= 1./rh1;
      rh1= sc1*sc1;
    }
    if(i==0){
      sq= cr2*(ESsa[ii]-ESsa[i]);
      w[0]= ESgaG[1]*sc1+sq*(ESgaG[0]+1.);
      w[2]= bc00;
      w[3]= sq*ESgaG[2]+ESgaG[3]*sc1;
      w[4]= bd00;
      w[5]= be0;
      r3= bf0;
      if(Ind0){
	w[2]= 0.;
	r3-= bc00*f[0];
      }
    }
    else if(i<ESNa){
      sq= cr2*(ESsa[ii]-ESsa[i-1]);
      w[0]+= ESgaG[1]*(sc1+sc11)+sq*(ESgaG[0]+1.);
      w[2]+= sc1+sc11;
      w[3]+= sq*ESgaG[2]+ESgaG[3]*(sc1+sc11);
      w[4]+= cr3*(ESsa[ii]-ESsa[i-1]);
      if(i==1&&Ind0){
	r1+= ESgaG[1]*sc11*f[0];
	r3+= sc11*f[0];
      }
    }
    else{
      sq= cr2*(ESsa[i]-ESsa[i-1]);
      w[0]+= sq;
      w[3]+= sq*ESgaG[2]+ESgaG[3]*sc11;
      w[4]+= bdn0;
      w[5]+= ben;
      r3+= bfn;
    }
    r1+= sq*f[i];
    if(i==0){
      t11= -ESgaG[1]*sc1;
      t13= -sc1;
      t23= sd1;
      t31= bc01;
      t32= bd01;
      if(Ind0){
	w[0]= sq;
	t13= 0.;
	t11= 0.;
      }
    }
    else if(ii<ESNa){
      t11= -ESgaG[1]*sc1;
      t13= -sc1;
      t31= -sc1;
      t23= sd1;
      t32= sd1;
    }
    else{
      t11= 0.;
      t13= bcn1;
      t23= bdn1;
      t31= 0.;
      t32= sd1;
      if(i<ESNa){
	r1+= ESgaG[1]*sc1*f[ESNa];
	r3+= sc1*f[ESNa];
      }
    }
    t22= -ESgaG[3]*sc1;

    inv3x3(w,rw);

    g[i]= rw[0]*r1+rw[1]*r2+rw[2]*r3;
    d2g[i]= rw[1]*r1+rw[3]*r2+rw[4]*r3;
    glA[i]= rw[2]*r1+rw[4]*r2+rw[5]*r3;
    if(i<ESNa){
      vA[k+0]= -(rw[0]*t11+rw[2]*t31);
      vA[k+3]= -(rw[1]*t11+rw[4]*t31);
      vA[k+6]= -(rw[2]*t11+rw[5]*t31);
      vA[k+1]= -(rw[1]*t22+rw[2]*t32);
      vA[k+4]= -(rw[3]*t22+rw[4]*t32);
      vA[k+7]= -(rw[4]*t22+rw[5]*t32);
      vA[k+2]= -(rw[0]*t13+rw[1]*t23);
      vA[k+5]= -(rw[1]*t13+rw[3]*t23);
      vA[k+8]= -(rw[2]*t13+rw[4]*t23);

      w[0]= t11*vA[k+0]+t31*vA[k+6];
      w[1]= t11*vA[k+1]+t31*vA[k+7];
      w[2]= t11*vA[k+2]+t31*vA[k+8];
      w[3]= t22*vA[k+4]+t32*vA[k+7];
      w[4]= t13*vA[k+1]+t23*vA[k+4];
      w[5]= t13*vA[k+2]+t23*vA[k+5];


      r1= -(t11*g[i]+t31*glA[i]);
      r2= -(t22*d2g[i]+t32*glA[i]);
      r3= -(t13*g[i]+t23*d2g[i]);
    }
  }
  for(ii= ESNa,i= ii-1;ii>0;ii--,i--){
    k= 9*i;
    g[i]= g[i]+vA[k+0]*g[ii]+vA[k+1]*d2g[ii]+vA[k+2]*glA[ii];
    d2g[i]= d2g[i]+vA[k+3]*g[ii]+vA[k+4]*d2g[ii]+vA[k+5]*glA[ii];
    glA[i]= glA[i]+vA[k+6]*g[ii]+vA[k+7]*d2g[ii]+vA[k+8]*glA[ii];
  }
  return(0);
}

int ESSetSplA(double A)
{
  int iA;
  int i,j,kT1;
  
  if(A > 1.) A=1.;
  if(A < 0.) A=0.;
  while(iSplA < ESNa && ESsa[iSplA+1] < A) iSplA++;
  while(iSplA > 0 && ESsa[iSplA] > A) iSplA--;
  iSplA1	=iSplA+1;
  SplAx		=(A-ESsa[iSplA])*crha;
  SplAxx	=SplAx*SplAx;
  SplAX		=1.-SplAx;
  SplAXX	=SplAX*SplAX;
  return(0);
}

int splRA(double*f, double*df, double*g, double*d2g)
{
  *f	=SplAX*g[iSplA]+SplAx*g[iSplA1]
    +(SplAX*(SplAXX-1.)*d2g[iSplA]+SplAx*(SplAxx-1.)*d2g[iSplA1])*cHa;
  if(df != NULL){
    *df	=(g[iSplA1]-g[iSplA]
	  +((3.*SplAxx-1.)*d2g[iSplA1]-(3.*SplAXX-1.)*d2g[iSplA])*cHa)*crha;
  }
  return(0);
}
