typedef struct{
  int Na;	/* number of radial intervals */
  int Na1;
  int Np;	/* number of poloidal intervals */
  int Np1;
  int Nt;	/* number of toroidal intervals */
  int Nt1;
  int Lp;	/* index of poloidal symmetry */
  int Lt;	/* index of toroidal symmetry */

  int ID;	/* composed ID of coordinate system */
  int IDa;	/* ID of radial coordinate */
  int IDgq;	/* ID of poloidal coordinate */
  int IDgz;	/* ID of toroidal coordinate */

  int kID[8];	/* reserved */
  int ToC[0x40][2];	/* pointers to storage of the groups */

  double Rext;	/* reference major radius */
  double rBtor;	/* reference rBtor at the reference minor radius */
  double aRef;	/* reference minor radius */
  double bspV;	/* plasma pressure at the plasma boundary */

  double *gq;
  double *sa;
  double *gF;
  double *dgF;
  double *d2gF;
  double *gY;
  double *dgY;
  double *d2gY;
  double *aT;
  double *daT;
  double *aP;
  double *daP;
  double *aF;
  double *daF;
  double *bsp;
  double *dbsp;

  double *sr;
  double *sra;
  double *srq;
  double *sraq;
  double *sz;
  double *sza;
  double *szq;
  double *szaq;

  double *aB;
  double *aBa;
  double *aBq;
  double *aBaq;

  double *gH;
  double *gHa;
  double *gHq;
  double *gHaq;
  double *gHqq;
  double *gHaqq;

}ESI;

typedef struct{
  double *gz;

  double *srz;
  double *sraz;
  double *srqz;
  double *sraqz;
  double *szz;
  double *szaz;
  double *szqz;
  double *szaqz;

  double *aBz;
  double *aBaz;
  double *aBqz;
  double *aBaqz;

  double *gHz;
  double *gHaz;
  double *gHqz;
  double *gHaqz;
  double *gHqqz;
  double *gHaqqz;
}ESI3D;
