#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "CbLib.h"

#ifndef mzl_CB
CBTKN *CbTkn;
int NCbTkn,nCbTkn,iCbTkn,mCbTkn=-1;

CBBLOCK *blck;
int Nblck,nblck;

typedef struct ResWord{
  int L;
  char *p;
}ResWord;
typedef struct DefWord{
  int L;
  int Lv;
  char *p;
  char *v;
}DefWord;
ResWord CbCResW[9]={
  4,"blb_",
  4,"mzl_",
  4,"stg_",
  3,"Tbl",
  3,"Asc",
  3,"Bnr",
  3,"Ins",
  3,"Del",
  3,"Doc"
};
static int NCbCResW=9,iCbCResW;
#endif

#ifndef mzl_PRP
char Cword[64];
static int NCprResW=12,iCprResW;
static ResWord CprResW[12]={
  6,"ifndef",
  5,"ifdef",
  2,"if",
  4,"else",
  4,"elif",
  5,"endif",
  5,"undef",
  6,"define",
  7,"include",
  4,"line",
  6,"pragma",
  5,"error"
};
static int NPRD=0,iPRD,iCBD,*kCB=NULL,*kPP=NULL,*kAPRD=NULL,*stPRD=NULL
,*icPRD=NULL;

static int NPRNmDf=0,nPRNmDf=0;
static DefWord *PRNmDf=NULL;

static char *NmF;
static int kB;

static FILE *fp;
#endif

#ifndef mzl_CB
int CbReInitCbTkn()
{
  if(NCbTkn){
    NCbTkn	+=32;
    CbTkn	=(CBTKN*)realloc((void*)CbTkn,(size_t)(NCbTkn*sizeof(CBTKN)));
  }
  else{
    NCbTkn	=32;
    CbTkn	=(CBTKN*)malloc((size_t)(NCbTkn*sizeof(CBTKN)));
  }
  if(CbTkn == NULL){
    CbPrintCbTkn(kB,iCbTkn);
    printf("No memory for %d CbTkn's%c\n",NCbTkn,7);
    return(-1);
  }
  return(0);
}

int CbDeInitCbTkn()
{
  if(NCbTkn){
    while(iCbTkn > 0){
      iCbTkn--;
      free(CbTkn[iCbTkn].Nm);
    }
    free(CbTkn);
    NCbTkn	=0;
    nCbTkn	=0;
  }
  return(0);
}

static char *dots;
int CbPrintCbTkn(int n0,int n)
{
  int i,d,d0,k,m,L;
  char str[5]={'%','3','d',' ','\0'};

  d	=0;
  k	=0;
  i	=n0;
  while(i < n){
    if(d < CbTkn[i].d){
      d	=CbTkn[i].d;
    }
    if(k < CbTkn[i].k1){
      k	=CbTkn[i].k1;
    }
    i++;
  }
  if(k < 10){
    *(str+1)	='1';
  }
  else{
    if(k < 100){
      *(str+1)	='2';
    }
    else{
      if(k < 1000){
	*(str+1)	='3';
      }
      else{
	if(k < 10000){
	  *(str+1)	='4';
	}
	else{
	  *(str+1)	='5';
	}
      }
    }
  }
  dots	=(char*)malloc((size_t)((2*d+1)*sizeof(char)));
  *dots='\0';
  for(i=n0; i < n; i++){
    printf(str,CbTkn[i].k0);
    printf("%s",dots);
    d	=CbTkn[i].d;
    if(CbTkn[i].k >= 0){
      printf("%s%s<%s>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm
	     ,CbTkn[CbTkn[i].k].Nm);
    }
    else{
      printf("%s%s<>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm);
    }
    m	=i;
    d0	=i+1 < n ? CbTkn[i+1].d : 0;
    while(d >= d0){
      if(CbTkn[m].k1 == 0){
	return(-1);
      }
      printf(str,CbTkn[m].k1);
      *(dots+2*d)='\0';
      printf("%s",dots);
      printf("}<%s>\n",CbTkn[m].Nm);
      m	=CbTkn[m].k;
      d--;
    }
    if(d >= 0){
      k	=2*d;
      *(dots+k)= (CbTkn[m].t) ? '.' : '|';
      k++;
      *(dots+k)=' ';
      k++;
      *(dots+k)='\0';
    }
  }
  free(dots);
  return(0);
}

int CbAddCbTokenMain(int iF,char *NmCode, int nL)
{
  int L;
  CbTkn[iCbTkn].d	=iCBD;
  CbTkn[iCbTkn].t	=0;
  CbTkn[iCbTkn].k	=kCB[iCBD];
  CbTkn[iCbTkn].f	=iF;
  CbTkn[iCbTkn].k0	=nL;
  CbTkn[iCbTkn].k1	=0;
  L	=strlen(NmCode)+1;
  CbTkn[iCbTkn].Nm=(char*)malloc((size_t)(L*sizeof(char)));
  strcpy(CbTkn[iCbTkn].Nm,NmCode);
  mCbTkn	=iCbTkn;
  iPRD++;
  CbReInitDepth();
  kAPRD[iPRD]	=1;
  stPRD[iPRD]	=1;
  icPRD[iPRD]	=1;
  kPP[iPRD]	=0;
  iCBD++;
  kCB[iCBD]	=mCbTkn;
  iCbTkn++;
  if(iCbTkn >= NCbTkn){
    if(CbReInitCbTkn() < 0){
      CbPrintCbTkn(kB,iCbTkn);
      return(-1);
    }
  }
  return(0);
}

int CbEndCbTokenMain(int nL)
{
  CbTkn[mCbTkn].k1	=nL;
  iPRD--;
  iCBD--;
  if(iCBD != CbTkn[mCbTkn].d){
    CbPrintCbTkn(kB,iCbTkn);
    printf("%s Line %d:  incorrect Cb structure%c\n"
	   ,NmF,nL,7);
    return(-1);
  }
  return(0);
}

int CbAddCbTokenFile(int iF,int nL)
{
  int L;
  CbTkn[iCbTkn].d	=iCBD;
  CbTkn[iCbTkn].t	=0;
  CbTkn[iCbTkn].k	=kCB[iCBD];
  CbTkn[iCbTkn].f	=iF;
  CbTkn[iCbTkn].k0	=nL;
  CbTkn[iCbTkn].k1	=0;
  L	=strlen(NmF)+1;
  CbTkn[iCbTkn].Nm=(char*)malloc((size_t)(L*sizeof(char)));
  strcpy(CbTkn[iCbTkn].Nm,NmF);
  kB		=iCbTkn;
  iPRD++;
  CbReInitDepth();
  kAPRD[iPRD]	=1;
  stPRD[iPRD]	=1;
  icPRD[iPRD]	=1;
  kPP[iPRD]	=0;
  iCBD++;
  kCB[iCBD]	=kB;
  iCbTkn++;
  if(iCbTkn >= NCbTkn){
    if(CbReInitCbTkn() < 0){
      CbPrintCbTkn(kB,iCbTkn);
      return(-1);
    }
  }
  return(0);
}

int CbEndCbTokenFile(int nL)
{
  CbTkn[kB].k1	=nL;
  iPRD--;
  iCBD--;
  if(iCBD != CbTkn[kB].d){
    CbPrintCbTkn(kB,iCbTkn);
    return(-1);
  }
  return(0);
}

int CbAddCbToken(int iF,char *p,int nL)
{
  int L;

  CbTkn[iCbTkn].d	=iCBD;
  CbTkn[iCbTkn].t	=kPP[iPRD];
  CbTkn[iCbTkn].k	=kCB[iCBD];
  CbTkn[iCbTkn].f	=iF;
  CbTkn[iCbTkn].a	=0;
  CbTkn[iCbTkn].k0	=nL;
  CbTkn[iCbTkn].k1	=0;
  L	=strlen(p)+1;
  CbTkn[iCbTkn].Nm=(char*)malloc((size_t)(L*sizeof(char)));
  strcpy(CbTkn[iCbTkn].Nm,p);
  CbStrCpy1(CbTkn[iCbTkn].Nm,CbTkn[iCbTkn].Nm);
  L	=CbIsCbSectName(p,nL);
  if(L < 0 || (L == 1 && kPP[iPRD] != 0)){
    CbPrintCbTkn(kB,iCbTkn+1);
    printf("%s Line %d: <%s> -wrong name of Cb section%c\n"
	   ,NmF,nL,CbTkn[iCbTkn].Nm,7);
    return(-1);
  }
  L	=kCB[iCBD];
  iCBD++;
  kCB[iCBD]	=iCbTkn;
  iCbTkn++;
  if(L >= 0){
    if(CbTkn[L].d){
      if(CbTkn[L].t < 2){
	if(kPP[iPRD] == CbTkn[L].t){
	  char *p;
	  CbPrintCbTkn(kB,iCbTkn);
	  p	=CbCResW[kPP[iPRD]].p;
	  printf("%s Line %d - wrong nestness of Cb sections: "\
		 "%s inside %s %c\n",NmF,nL,p,p,7);
	  return(	-1);
	}
      }
      else{
	char *p;
	CbPrintCbTkn(kB,iCbTkn);
	p	=CbCResW[kPP[iPRD]].p;
	printf("%s Line %d - wrong nestness of Cb sections: "\
	       "%s inside stg_ %c\n",NmF,nL,p,7);
	return(-1);
      }
    }
    else{
      if(kPP[iPRD]){
	char *p;
	CbPrintCbTkn(kB,iCbTkn);
	p	=CbCResW[kPP[iPRD]].p;
	printf("%s Line %d - wrong nestness of Cb sections: "\
	       "starting %s in Cb structure%c\n",NmF,nL,p,7);
	return(	-1);
      }
    }
  }
  if(iCbTkn >= NCbTkn){
    if(CbReInitCbTkn() < 0){
      CbPrintCbTkn(kB,iCbTkn);
      return(-1);
    }
  }
  return(0);
}

int CbIsCbSectName(char *Nm,int nL)
{
  char *p;

  p	=Nm;
  while(*p != '(' && *p != '\0'){
    p++;
  }
  if(p == Nm){
    printf("%s Line %d - absent section name%c\n",NmF,nL,7);
    return(-1);
  }
  if(*p == '('){
    p++;
    while(*p != 'F' && *p !='\0'){
      p++;
    }
    if(*p == 'F'){
      p++;
      while(isspace(*p)){
	p++;
      }
      if(*p != '='){
	printf("%s Line %d - absent '=' after 'F'%c\n",NmF,nL,7);
	return(-1);
      }
      p++;
      while(isspace(*p)){
	p++;
      }
      while(*p != ')' && *p != ',' && *p != '\0' && !isspace(*p)){
	p++;
      }
      while(isspace(*p)){
	p++;
      }
      if(*p != ')'){
	printf("%s Line %d - absent ')'%c\n",NmF,nL,7);
	return(-1);
      }
    }
    return(1);
  }
  return(0);
}

#endif

#ifndef mzl_PP
int CbInitCbLib(char *NmF0,int kB0)
{
  int i;

  NmF	=NmF0;
  kB	=kB0;
  for(i=0; i < nPRNmDf; i++){
    free(PRNmDf[i].p);
    free(PRNmDf[i].v);
    PRNmDf[i].p	=NULL;
    PRNmDf[i].v	=NULL;
  }
 
  if(NPRD == 0){
    NPRD	=8;
    kAPRD	=(int*)malloc((size_t)(NPRD*sizeof(int)));
    kPP		=(int*)malloc((size_t)(NPRD*sizeof(int)));
    kCB		=(int*)malloc((size_t)(NPRD*sizeof(int)));
    stPRD	=(int*)malloc((size_t)(NPRD*sizeof(int)));
    icPRD	=(int*)malloc((size_t)(NPRD*sizeof(int)));
  }
  kPP[0]	=-1;
  kCB[0]	=-1;
  kAPRD[0]	=1;
  stPRD[0]	=0;
  icPRD[0]	=0;
  iPRD		=0;
  iCBD		=0;
  return(0);
}

int CbReInitDepth()
{
  if(iPRD >= NPRD){
    NPRD	+=8;
    icPRD	=(int*)realloc((void*)icPRD,(size_t)(NPRD*sizeof(int)));
    stPRD	=(int*)realloc((void*)stPRD,(size_t)(NPRD*sizeof(int)));
    kPP		=(int*)realloc((void*)kPP,(size_t)(NPRD*sizeof(int)));
    kCB		=(int*)realloc((void*)kCB,(size_t)(NPRD*sizeof(int)));
    kAPRD	=(int*)realloc((void*)kAPRD,(size_t)(NPRD*sizeof(int)));
  }
  return(0);
}

int CbDeInitCbLib()
{
  int i;

  for(i=0; i < nPRNmDf; i++){
    free(PRNmDf[i].p);
    free(PRNmDf[i].v);
  }
  if(NPRD){
    free(icPRD);
    free(stPRD);
    free(kCB);
    free(kPP);
    free(kAPRD);
  }
  if(NPRNmDf){
    free(PRNmDf);
  }
  return(0);
}

int IsAlNum(char ch)
{
  if(ch == '_' || ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z')
     || ('0' <= ch && ch <= '9'))
    return(1);
  else
    return(0);
}

int IsAlpha(char ch)
{
  if(ch == '_' || ('a' <= ch && ch <= 'z') || ('A' <= ch && ch <= 'Z'))
    return(1);
  else
    return(0);
}

int CbGetCWord(char *w,char *s)
{
  int n;

  n	=0;
  if(IsAlpha(*s) == 0)
    return(0);
  while(IsAlNum(*s)){
    *w++=*s++;
    n++;
    if(n == 33){
      break;
    }
  }
  *w	='\0';
  return(n);
}

int CbGetPRPWord(char *w,char *s)
{
  int n;

  n	=0;
  while(IsAlNum(*s)){
    *w++	=*s++;
    n++;
    if(n == 33){
      break;
    }
  }
  *w	='\0';
  return(n);
}

int CbIsPRPWord(char *str,int nL)
{
  char *p;

  p	=str+1;
  while(isspace(*p)){
    p++;
  }
  CbGetPRPWord(Cword,p);
  for(iCprResW=0; iCprResW < NCprResW; iCprResW++){
    if(strcmp(CprResW[iCprResW].p,Cword) == 0){
      return(p-str+CprResW[iCprResW].L);
    }
  }
  CbPrintCbTkn(kB,iCbTkn);
  printf("%s Line %d - %s is a wrong preprocessor instruction%c\n"
	 ,NmF,nL,str,7);
  return(-1);
}

int CbPRNmVal(char *p)
{
  long int k,k1,k2,k3,ic;
  char *p1;

  while(isspace(*p))
    p++;
  if(*p == '('){
    p++;
    while(isspace(*p))
      p++;
  }
  if(sscanf(p,"%ld",&k) < 1)
    return(0);
  else{
    if(k != 0)
      return(1);
    else
      return(0);
  }
}

int CbIsActiveCFZone(int *k, int iF, char *str,int ic,int nL)
{
  char *p,*p1;
  int i;

  if((i=CbIsPRPWord(str,nL)) < 0){
    return(-1);
  }
  p	=str+i;

  while(isspace(*p)){
    p++;
  }
  *k	=0;
  switch(iCprResW){
  case 0: /* #ifndef */
    iPRD++;
    CbReInitDepth();
    if(kAPRD[iPRD-1]){
      CbGetPRPWord(Cword,p);
      for(i=0; i < nPRNmDf; i++){
	if(strcmp(Cword,PRNmDf[i].p) == 0){
	  break;
	}
      }
      kAPRD[iPRD]	=i < nPRNmDf ? 0 : 1;
    }
    else{
      kAPRD[iPRD]	=0;
    }
    stPRD[iPRD]	=1;
    icPRD[iPRD]	=ic;
    kPP[iPRD]	=-1;
    *k	=1;
    if(kAPRD[iPRD] && ic){
      for(i=0; i < 3; i++){
	if(strncmp(Cword,CbCResW[i].p,CbCResW[i].L) == 0){
	  kPP[iPRD]	=i;
	  if(CbAddCbToken(iF,p+CbCResW[i].L,nL) < 0){
	    return(-1);
	  }
	  break;
	}
      }
    }
    break;
  case 1: /* #ifdef */
    iPRD++;
    CbReInitDepth();
    if(kAPRD[iPRD-1]){
      CbGetPRPWord(Cword,p);
      for(i=0; i < nPRNmDf; i++){
	if(strcmp(Cword,PRNmDf[i].p) == 0){
	  break;
	}
      }
      kAPRD[iPRD]	=i < nPRNmDf ? 1 : 0;
    }
    else{
      kAPRD[iPRD]	=0;
    }
    stPRD[iPRD]	=1;
    icPRD[iPRD]	=ic;
    kPP[iPRD]	=-1;
    *k	=1;
    break;
  case 2: /* #if */
    iPRD++;
    CbReInitDepth();
    if(kAPRD[iPRD-1]){
      kAPRD[iPRD]	=CbPRNmVal(p);
    }
    else{
      kAPRD[iPRD]	=0;
    }
    stPRD[iPRD]	=1;
    icPRD[iPRD]	=ic;
    kPP[iPRD]	=-1;
    *k	=1;
    break;
  case 3: /* #else */
    if(icPRD[iPRD] < ic){
      CbPrintCbTkn(kB,iCbTkn);
      printf("%s Line %d - Extra { between #if #endif%c\n",NmF,nL,7);
      return(-1);
    }
    if(icPRD[iPRD] > ic){
      CbPrintCbTkn(kB,iCbTkn);
      printf("%s Line %d - Extra } between #if #endif%c\n",NmF,nL,7);
      return(-1);
    }
    if(kAPRD[iPRD-1])
      kAPRD[iPRD]	=kAPRD[iPRD] ? 0 : 1;
    else{
      kAPRD[iPRD]	=0;
    }
    *k	=3;
    break;
  case 4: /* #elif */
    if(icPRD[iPRD] < ic){
      CbPrintCbTkn(kB,iCbTkn);
      printf("%s Line %d - Extra { between #if #endif%c\n",NmF,nL,7);
      return(-1);
    }
    if(icPRD[iPRD] > ic){
      CbPrintCbTkn(kB,iCbTkn);
      printf("%s Line %d - Extra } between #if #endif%c\n",NmF,nL,7);
      return(-1);
    }
    if(kAPRD[iPRD-1])
      kAPRD[iPRD]	=kAPRD[iPRD] ? 0 : 1;
    else{
      kAPRD[iPRD]	=0;
    }
    iPRD++;
    CbReInitDepth();
    if(kAPRD[iPRD-1])
      kAPRD[iPRD]	=CbPRNmVal(p);
    else{
      kAPRD[iPRD]	=0;
    }
    stPRD[iPRD]	=stPRD[iPRD-1]+1;
    icPRD[iPRD]	=ic;
    kPP[iPRD]	=-1;
    *k	=4;
    break;
  case 5: /* #endif */
    *k	=2;
    if(kPP[iPRD] >= 0 && ic){
      CbTkn[kCB[iCBD]].k1	=nL;
      iCBD--;
      if(iCBD < 0){
	CbPrintCbTkn(kB,iCbTkn);
	return(-1);
      }
    }
    if(stPRD[iPRD] == 0){
      printf("%s Line %d - extra #endif%c\n",NmF,nL,7);
    }
    else{
      int m;
      m	=stPRD[iPRD];
      for(i=0; i < m; i++){
	if(icPRD[iPRD] < ic){
	  CbPrintCbTkn(kB,iCbTkn);
	  printf("%s Line %d - Extra { between #if #endif%c\n"
		 ,NmF,nL,7);
	  return(-1);
	}
	if(icPRD[iPRD] > ic){
	  CbPrintCbTkn(kB,iCbTkn);
	  printf("%s Line %d - Extra } between #if #endif%c\n"
		 ,NmF,nL,7);
	  return(-1);
	}
	iPRD--;
      }
    }
    break;
  case 6: /* #undef */
    if(kAPRD[iPRD]){
      CbGetPRPWord(Cword,p);
      for(i=0; i < nPRNmDf; i++){
	if(strcmp(Cword,PRNmDf[i].p) == 0){
	  free(PRNmDf[i].v);
	  free(PRNmDf[i].p);
	  nPRNmDf--;
	  while(i < nPRNmDf){
	    PRNmDf[i].p =PRNmDf[i+1].p;
	    PRNmDf[i].v =PRNmDf[i+1].v;
	    PRNmDf[i].L =PRNmDf[i+1].L;
	    PRNmDf[i].Lv =PRNmDf[i+1].Lv;
	    i++;
	  }
	  break;
	}
      }
    }
    break;
  case 7: /* #define */
    if(kAPRD[iPRD]){
      for(i=0; i < nPRNmDf; i++){
	if(strcmp(Cword,PRNmDf[i].p) == 0){
	  break;
	}
      }
      if(i == nPRNmDf){
	nPRNmDf++;
	if(nPRNmDf >= NPRNmDf){
	  NPRNmDf	+=32;
	  PRNmDf	=(DefWord*)realloc((void*)PRNmDf
					   ,(size_t)(NPRNmDf*sizeof(DefWord)));
	}
	PRNmDf[i].L	=strlen(Cword);
	PRNmDf[i].p	=(char *)malloc((size_t)(PRNmDf[i].L+1)*sizeof(char));
	strcpy(PRNmDf[i].p,Cword);
	p	+=PRNmDf[i].L;
	while(isspace(*p))
	  p++;
	p1	=p;
	while(*p1 != '\n' && *p1 != '\0')
	  p1++;
	PRNmDf[i].Lv	=p1-p;
	PRNmDf[i].v	=(char *)malloc((size_t)(PRNmDf[i].Lv+1)*sizeof(char));
	p1		=PRNmDf[i].v;
	while(*p != '\n' && *p != '\0')
	  *p1++=*p;
	*p1++='\0';
      }
    }
    break;
  case 8: /* #include */
    break;
  case 9: /* #line */
    break;
  case 10: /* #pragma */
    break;
  case 11: /* #error */
    break;
  }
  return(kAPRD[iPRD]);
}

int CbInitCbBlocks(int *kBeg,int *kE, char **NmTF)
{
  int i,I,j,d,k;

  Nblck	=0;
  for(i=0; i < iCbTkn; i++){
    if(CbTkn[i].t < 2){
      Nblck++;
    }
  }
  blck	=(CBBLOCK*)malloc((size_t)(Nblck*sizeof(CBBLOCK)));

  j	=0;
  nblck	=1;
  blck[j].k	=mCbTkn;
  while(j < nblck){
    k	=0;
    i	=blck[j].k;
    if(CbTkn[i].a){
      if(CbTkn[i].t < 2){
	CbPrintCbBlb(i);
      }
      else{
	CbPrintCbStg(i);
      }
      printf("%s Line %d: <%s> is double referenced, loop in Cb Structure %c\n"
	     ,NmTF[CbTkn[i].f],CbTkn[i].k0,CbTkn[i].Nm,7);
      return(-1);
    }
    CbTkn[i].a	=1;
    d	=CbTkn[i].d;
    I	=kE[CbTkn[i].f];
    i++;
    while(i < I && CbTkn[i].d > d){
      if(CbTkn[i].d == d+1){
	k++;
      }
      i++;
    }
    i	=blck[j].k;
    if(CbTkn[i].r >= 0){
      if(k){
	CbPrintCbBlb(i);
	printf("%s Line %d: reference <%s> should not contain structure%c\n"
	       ,NmF,CbTkn[i].k0,CbTkn[i].Nm,7);
	return(-1);
      }
      k	=1;
    }

    blck[j].n	=k;
    blck[j].kT	=k ? (int*)malloc((size_t)(k*sizeof(int))) : NULL;
    if(CbTkn[i].r >= 0){
      int kk;
      char *p;

      p	=CbTkn[i].Nm;
      k	=CbTkn[i].r;
      kk=kE[k];
      k	=kBeg[k];
      while(k < kk && (CbTkn[k].t != 0 || strcmp(p,CbTkn[k].Nm) != 0)){
	k++;
      }
      if(k < kk){
#ifdef H
	CbTkn[i].r	=k;
#endif
	CbTkn[k].k	=CbTkn[i].k;
	blck[j].kT[0]	=k;
	CbTkn[k].b	=nblck;
	blck[nblck].k	=k;
	nblck++;
      }
      else{
	CbPrintCbBlb(i);
	printf("%s Line %d <%s> - reference element has not been found%c\n"
	       ,NmF,CbTkn[i].k0,CbTkn[i].Nm,7);
	return(-1);
      }
    }
    else{
      i++;
      k	=0;
      while(i < I && CbTkn[i].d > d){
	if(CbTkn[i].d == d+1){
	  blck[j].kT[k]	=i;
	  if(CbTkn[i].t < 2){
	    CbTkn[i].b	=nblck;
	    blck[nblck].k	=i;
	    nblck++;
	  }
	  k++;
	}
	i++;
      }
    }
    j++;
  }
  return(0);
}

int CbDeInitCbBlocks()
{
  int i;
  for(i=0; i < nblck; i++){
    if(blck[i].n){
      free(blck[i].kT);
    }
  }
  free(blck);
}

int CbMakeCbBlocks(CBTKN **Tkn,int *nTkn,CBBLOCK **Bl,int *nBl)
{
  int i,I,j,d,k;

  NBl	=0;
  for(i=0; i < iTkn; i++){
    if(Tkn[i].t < 2){
      NBl++;
    }
  }
  Bl	=(CBBLOCK*)malloc((size_t)(NBl*sizeof(CBBLOCK)));

  j	=0;
  nBl	=1;
  Bl[j].k	=mTkn;
  while(j < nBl){
    k	=0;
    i	=Bl[j].k;
    if(Tkn[i].a){
      if(Tkn[i].t < 2){
	CbPrintCbBlb(i);
      }
      else{
	CbPrintCbStg(i);
      }
      printf("%s Line %d: <%s> is double referenced, loop in Cb Structure %c\n"
	     ,NmTF[Tkn[i].f],Tkn[i].k0,Tkn[i].Nm,7);
      return(-1);
    }
    Tkn[i].a	=1;
    d	=Tkn[i].d;
    I	=kE[Tkn[i].f];
    i++;
    while(i < I && Tkn[i].d > d){
      if(Tkn[i].d == d+1){
	k++;
      }
      i++;
    }
    i	=Bl[j].k;
    if(Tkn[i].r >= 0){
      if(k){
	CbPrintCbBlb(i);
	printf("%s Line %d: reference <%s> should not contain structure%c\n"
	       ,NmF,Tkn[i].k0,Tkn[i].Nm,7);
	return(-1);
      }
      k	=1;
    }

    Bl[j].n	=k;
    Bl[j].kT	=k ? (int*)malloc((size_t)(k*sizeof(int))) : NULL;
    if(Tkn[i].r >= 0){
      int kk;
      char *p;

      p	=Tkn[i].Nm;
      k	=Tkn[i].r;
      kk=kE[k];
      k	=kBeg[k];
      while(k < kk && (Tkn[k].t != 0 || strcmp(p,Tkn[k].Nm) != 0)){
	k++;
      }
      if(k < kk){
#ifdef H
	Tkn[i].r	=k;
#endif
	Tkn[k].k	=Tkn[i].k;
	Bl[j].kT[0]	=k;
	Tkn[k].b	=nBl;
	Bl[nBl].k	=k;
	nBl++;
      }
      else{
	CbPrintCbBlb(i);
	printf("%s Line %d <%s> - reference element has not been found%c\n"
	       ,NmF,Tkn[i].k0,Tkn[i].Nm,7);
	return(-1);
      }
    }
    else{
      i++;
      k	=0;
      while(i < I && Tkn[i].d > d){
	if(Tkn[i].d == d+1){
	  Bl[j].kT[k]	=i;
	  if(Tkn[i].t < 2){
	    Tkn[i].b	=nBl;
	    Bl[nBl].k	=i;
	    nBl++;
	  }
	  k++;
	}
	i++;
      }
    }
    j++;
  }
  return(0);
}

int CbDeMakeCbBlocks()
{
  int i;
  for(i=0; i < nBl; i++){
    if(Bl[i].n){
      free(Bl[i].kT);
    }
  }
  free(Bl);
}

static char *str="%4d ";

int CbPrintCbStg(int i)
{
  int d,k;

  d	=CbTkn[i].d;
  printf(str,CbTkn[i].k0);
  k	=0;
  while(k < d){
    if(k%2){
      printf(". ");
    }
    else{
      printf("| ");
    }
    k++;
  }
  if(CbTkn[i].k >= 0){
    printf("%s%s<%s>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm
	   ,CbTkn[CbTkn[i].k].Nm);
  }
  else{
    printf("%s%s<>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm);
  }
  printf(str,CbTkn[i].k1);
  k	=0;
  while(k < d){
    if(k%2){
      printf(". ");
    }
    else{
      printf("| ");
    }
    k++;
  }
  printf("}<%s>\n",CbTkn[i].Nm);

  k	=i+1;
  if(k < iCbTkn && CbTkn[k].d == d){
    switch(CbTkn[k].t){
    case 0:
    case 1:
      CbPrintCbBlb(k);
      break;
    case 2:
      CbPrintCbStg(k);
      break;
    }
  }
  return(0);
}

int CbPrintCbBlb(int i)
{
  int d,k;

  d	=CbTkn[i].d;
  printf(str,CbTkn[i].k0);
  k	=0;
  while(k < d){
    if(k%2){
      printf(". ");
    }
    else{
      printf("| ");
    }
    k++;
  }
  if(CbTkn[i].k >= 0){
    printf("%s%s<%s>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm
	   ,CbTkn[CbTkn[i].k].Nm);
  }
  else{
    printf("%s%s<>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm);
  }
  d++;
  k	=i+1;
  if(k < iCbTkn && CbTkn[k].d == d){
    switch(CbTkn[k].t){
    case 0:
    case 1:
      CbPrintCbBlb(k);
      break;
    case 2:
      CbPrintCbStg(k);
      break;
    }
  }
  d--;
  printf(str,CbTkn[i].k1);
  k	=0;
  while(k < d){
    if(k%2){
      printf(". ");
    }
    else{
      printf("| ");
    }
    k++;
  }
  printf("}<%s>\n",CbTkn[i].Nm);
  return(0);
}

static int dp=0,Depth=0;
int CbDepthCbBlocks(iB)
{
  int i,j,k;

  if(Depth < dp){
    Depth	=dp;
  }

  i	=blck[iB].k;
  for(k=0; k < blck[iB].n; k++){
    dp++;
    j	=blck[iB].kT[k];
    switch(CbTkn[j].t){
    case 0:
    case 1:
      j	=CbTkn[j].b;
      CbDepthCbBlocks(j);
      break;
    case 2:
      break;
    }
    dp--;
  }
  return(Depth);
}

int CbPrintCbElem(int i)
{
  printf(str,CbTkn[i].k0);
  *(dots+2*dp)='\0';
  printf("%s",dots);
  if(CbTkn[i].k >= 0){
    printf("%s%s<%s>;\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm
	   ,CbTkn[CbTkn[i].k].Nm);
  }
  else{
    printf("%s%s<>;\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm);
  }
  return(0);
}

int CbPrintCbBlock(int iB)
{
  int i,j,k;

  i	=blck[iB].k;
  printf(str,CbTkn[i].k0);
  *(dots+2*dp)='\0';
  printf("%s",dots);
  if(CbTkn[i].k >= 0){
    printf("%s%s<%s>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm
	   ,CbTkn[CbTkn[i].k].Nm);
  }
  else{
    printf("%s%s<>{\n",CbCResW[CbTkn[i].t].p,CbTkn[i].Nm);
  }

  k	=2*dp;
  *(dots+k)=CbTkn[i].t ? '.' : '|';
  k++;
  *(dots+k)=' ';
  dp++;
  for(k=0; k < blck[iB].n; k++){
    j	=blck[iB].kT[k];
    switch(CbTkn[j].t){
    case 0:
    case 1:
      j	=CbTkn[j].b;
      CbPrintCbBlock(j);
      break;
    case 2:
      CbPrintCbElem(j);
      break;
    }
  }
  dp--;
  printf(str,CbTkn[i].k1);
  *(dots+2*dp)='\0';
  printf("%s",dots);
  printf("}<%s>\n",CbTkn[i].Nm);
  return(0);
}

int CbPrintCbBlocks()
{
  dots	=(char*)malloc((size_t)((2*Depth+1)*sizeof(char)));
  *dots='\0';
  CbPrintCbBlock(0);
  free(dots);
  return(0);
}

#endif
