#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include "XCbType.h"

extern int XCbdxWM,XCbdyWM;
extern Display*theD;
extern int theD_w,theD_h;
extern Window theRW;

extern int wF,hF;

extern GC theGC,theGCH;
extern int NWin;
extern int *ExposeW,*ConfW;
extern WinPar*WinP;
extern int xMessW,yMessW;
extern int Iconw0,Iconh0,Iconw1,Iconh1;
extern char Iconb0[],Iconb1[];
extern int icon_width;
extern int icon_height;
extern char*icon_bits;
extern char*WNames;

static FILE*fp;
static char NmF[128];
static char NmCode[128];
static int dxWM=0,dyWM=0;

int XCbGetShiftWM()
{
  int x,y,k=0;
  Window cw;
  extern XEvent msg;
      
  while(XCheckMaskEvent(theD,ExposureMask|StructureNotifyMask,&msg)){
    if(msg.type == ConfigureNotify) k++;
    ;
  }

  /* XTranslateCoordinates() works only after ConfigureNotify */

  XTranslateCoordinates(theD,WinP[0].W,theRW,0,0,&x,&y,&cw);
  if(WinP[0].iX-x){
    XCbdxWM	=WinP[0].iX-x;
    XCbdyWM	=WinP[0].iY-y;
    printf("??? dxWM OK %d=%d %d=%d k=%d\n",WinP[0].iX,x,WinP[0].iY,y,k);
  }
  else{
    XCbdxWM	=dxWM;
    XCbdyWM	=dyWM;
    printf("??? Failure in dxWM %d=%d %d=%d k=%d\n"
	   ,WinP[0].iX,x,WinP[0].iY,y,k);
  }	
  return(0);
}

int XInitWin(int NW,char *Nm)
{
  int i,j,k;
  static int ii,dw,dh,head=25,hfont=15,igap=10;
  static char *WNames;

  NWin	=NW;
  strcpy(NmCode,Nm);

  WinP	=(WinPar*)malloc((NWin+2)*sizeof(WinPar));
  if(WinP == NULL){
    printf("Allocation failure forWinP in init_win_par\n");
    exit(0);
  }
  ExposeW	=(int*)malloc(2*NWin*sizeof(int));
  ConfW		=ExposeW+NWin;
  for(i=0; i < NW; i++){
    ExposeW[i]	=0;
    ConfW[i]	=0;
  }
  screen_attributes(&theD_w,&theD_h);
  XCbFontDir();
  k	=strlen(NmCode)+4;
  WNames	=(char*)malloc(((NWin+1)*k+5)*sizeof(char));
  for(i=0; i < NW; i++){
    sprintf(WNames+k*i,"%s %2d",NmCode,i);
    WinP[i].nm	=WNames+k*i;
  }
  sprintf(WNames+k*i,"Help");
  WinP[i].nm	=WNames+k*i;
  if(XCbRestoreWindowGeom()){
    for(i=0; i < NW; i++){
      WinP[i].state	=1;
      WinP[i].iconx	=theD_w-130;
      WinP[i].icony	=i ? theD_h-24*(NW-i) : theD_h-101-24*(NW-1);
      WinP[i].mode	=1;
    }

    theD_h=1024;
    theD_h=1000;
    theD_w=1280;
    dh	=(theD_h)/3-head;
    dw	=(theD_w)/5-igap;
    theD_w=1400;

    ii	=0;
    WinP[ii].iW	=dw;
    WinP[ii].iX	=theD_w-5*dw-2*igap-0.5*igap;
    WinP[ii].iH	=dh;
    WinP[ii].iY	=0;
    WinP[ii].ix	=5;
    WinP[ii].iy	=3*hfont;
    WinP[ii].iw	=WinP[ii].iW-2*WinP[ii].ix;
    WinP[ii].ih	=WinP[ii].iH-WinP[ii].iy-5;
    ii++;

    WinP[ii].iW	=2*dw;
    WinP[ii].iX	=theD_w-4*dw-igap-0.5*igap;
    WinP[ii].iH	=2*dh+head;
    WinP[ii].iY	=0;
    WinP[ii].ix	=5;
    WinP[ii].iw	=WinP[ii].iW-2*WinP[ii].ix;
    WinP[ii].iy	=5*hfont;
    WinP[ii].ih	=WinP[ii].iH-WinP[ii].iy-WinP[ii].ix;
    ii++;

    WinP[ii].iW	=2.*dw;
    WinP[ii].iX	=theD_w-4*dw-igap-0.5*igap;
    WinP[ii].iH	=dh;
    WinP[ii].iY	=(dh+head)*2;
    WinP[ii].ix	=5;
    WinP[ii].iy	=3*hfont;
    WinP[ii].iw	=WinP[ii].iW-2*WinP[ii].ix;
    WinP[ii].ih	=WinP[ii].iH-WinP[ii].iy-5;
    ii++;

    if(NWin > 3){
      dh	=(theD_h)/(NWin-3)-head;
    }
    for(i=0; ii < NWin; i++,ii++){
      WinP[ii].iW	=2*dw;
      WinP[ii].iX	=theD_w-2*dw-0.5*igap;
      WinP[ii].iH	=dh;
      WinP[ii].iY	=(dh+head)*i;
      WinP[ii].ix	=5;
      WinP[ii].iy	=3*hfont;
      WinP[ii].iw	=WinP[ii].iW-2*WinP[ii].ix;
      WinP[ii].ih	=WinP[ii].iH-WinP[ii].iy-5;
    }
    xMessW	=WinP[1].iX-4;
    yMessW	=WinP[1].iY+WinP[1].iH+4;
  }
  for(i=0; i < NW; i++){
    WinP[i].Hlp	=0;
    if(i){
      icon_width	=Iconw1;
      icon_height	=Iconh1;
      icon_bits		=Iconb1;
    }
    else{
      icon_width	=Iconw0;
      icon_height	=Iconh0;
      icon_bits		=Iconb0;
    }
    create_window(i);
  }
  WinP[NW].iW	=500+100;
  WinP[NW].iH	=400;
  XCbCreateHelpWindow(WinP+NW);
  WinP[NW+1].iW	=500;
  WinP[NW+1].iH	=400;
  XCbCreateMenuWindow(WinP+NW+1);
  XCbInitHelpTxt();
  XCbSetWindowButtons();
  DisplayActivity();
  XFlush(theD);
#ifdef H
  {
    int x,y;
    Window cw;
    extern XEvent msg;
    while(XCheckMaskEvent(theD,ExposureMask|StructureNotifyMask,&msg)){
      ;
    }
    XTranslateCoordinates(theD,WinP[0].W,theRW,0,0,&x,&y,&cw);
    XCbdxWM	=WinP[0].iX-x;
    XCbdyWM	=WinP[0].iY-y;
  }
#endif
  XCbGetShiftWM();
  return(0);
}

int XDeInitWin()
{
  CloseX();
  free(ExposeW);
  free(WinP);
  free(WNames);
  return(0);
}

int XCbSaveWindowGeom(char *Dir)
{
  int i;
  Window cw;

  sprintf(NmF,"%s/Wrk/%s.win",Dir,NmCode);
  fp	=fopen(NmF,"w");
  if(fp	!= NULL){
    for(i=0; i < NWin; i++){
      XTranslateCoordinates(theD,WinP[i].W,theRW,0,0,&WinP[i].iX,&WinP[i].iY
			    ,&cw);
      WinP[i].iX	+=XCbdxWM;
      WinP[i].iY	+=XCbdyWM;
      fprintf(fp,"%2d %2d %6d %6d Mode State IconX IconY\n",WinP[i].mode,
	      WinP[i].state,WinP[i].iconx,WinP[i].icony);
      fprintf(fp,"%6d %6d %6d %6d X Y W H\n",
	      WinP[i].iX,WinP[i].iY,WinP[i].iW,WinP[i].iH);
      fprintf(fp,"%6d %6d %6d %6d x y w h\n",
	      WinP[i].ix,WinP[i].iy,WinP[i].iw,WinP[i].ih);
    }
    fprintf(fp,"%6d %6d x y of Message Window\n",xMessW,yMessW);
    fprintf(fp,"%6d %6d dx dy of Window Manager\n",XCbdxWM,XCbdyWM);
    fclose(fp);
    printf("%s file with X-Windows geometry has been written\n",NmF);
  }
  return(0);
}

int XCbRestoreWindowGeom()
{
  int i,ix,iy;

  sprintf(NmF,"Wrk/%s.win",NmCode);
  fp	=fopen(NmF,"r");
  if(fp == NULL) return(1);

  for(i=0; i < NWin; i++){
    if(fscanf(fp,"%d %d %d %d Mode State IconX IconY",&WinP[i].mode,
	      &WinP[i].state,&WinP[i].iconx,&WinP[i].icony) < 4){
      return(1);
    }
    if(fscanf(fp,"%d %d %d %d X Y W H",
	      &WinP[i].iX,&WinP[i].iY,&WinP[i].iW,&WinP[i].iH) < 4){
      return(1);
    }
    if(fscanf(fp,"%d %d %d %d x y w h",
	      &WinP[i].ix,&WinP[i].iy,&WinP[i].iw,&WinP[i].ih) < 4){
      return(1);
    }
  }
  xMessW	=WinP[1].iX-4;
  yMessW	=WinP[1].iY+WinP[1].iH+4;
  if(fscanf(fp,"%d %d x y of Message Window\n",&ix,&iy) == 2){
    xMessW=ix;
    yMessW=iy;
    if(fscanf(fp,"%6d %6d dx dy of Window Manager\n",&ix,&iy) == 2){
      dxWM	=ix;
      dyWM	=iy;
    }
  }
  WinP[0].mode	=1;
  fclose(fp);
  return(0);
}
