#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "CbType.h"

static int NType= 11,NpB[11],RdFl[11],IOInsFl[11];
static char*pN[11],*pntN[11]= {"Tbl_","Hlp","Plt","BRc_","BSv_",
				 "BRd_","BWr_","BnrI","BnrO","AscI","AscO"};
static char**BuffIO;
static FILE*fpT0;
static char ln[80];

static CbUnits*XUnits;
static int NXUnits;

static int nTbl;

static char*CW[10]= 
{"str","dbl","int","flt","lng","fch","Dbl","Int","Flt","Lng"};
double cr2,cr3,cr4,cr6,cr12,cgp,c2gp,cgp_4,cr2gp,cgm0,crgm0;

static int FlFbuff= 0;
CbAdd2Fbuff(char*p)
{
  return(0);
}

int CbIsInteger(int*k,char*p)
{
  int i;

  i= 0;
  if(*p=='+'||*p=='-'){
    i++;
    p++;
  }
  *k= i;
  while(isdigit(*p)){
    i++;
    p++;
  }
  if(*k&&i==1){
    return(0);
  }
  *k= i;
  return(1);
}

int CbCheckIfCNumber(char*p)
{
  int i,k,id,ie,ip,im;

  i= 0;
  if(*p=='+'||*p=='-'){
    i++;
    p++;
  }
  if(isdigit(*p)==0&&*p!='.')
    return(-1);
  if(*p=='.'){
    id= 1;
    k= i+1;
  }
  else{
    id= 0;
    k= i;
  }
  ip= 0;
  im= 0;
  while(isdigit(*p)||*p=='+'||*p=='-'||*p=='.'
	||*p=='e'||*p=='E'){

    if(*p=='.'){
      id++;
      if(id>1){
	return(-1);
      }
    }
    if(*p=='+'){
      ip++;
      if(ip>1||(*(p-1)!='e'&&*(p-1)!='E')){
	return(-1);
      }
    }
    if(*p=='-'){
      im++;
      if(im>1||(*(p-1)!='e'&&*(p-1)!='E')){
	return(-1);
      }
    }
    i++;
    p++;
  }
  if(k==i){
    return(-1);
  }
  return(i);
}

#ifdef H
typedef struct CbIOVec{
  int id;
  int d;
  char*V;
  int*st;
  char*Nm;
}CbIOVec;

typedef struct CbIOLoop{
  int pL;
  int d;
  int n;
  int N;
  int nV;
  int nL;
  int*kV;
  int*i0V;
  int*stV;

  char**ImV;
  int*kL;
  int**iV;
  int**fV;
  int*t;
  int i0,i1,st;
  char*NmI;
  char*pi0;
  char*pi1;
  char*pst;
  char***piV;
}CbIOLoop;

typedef struct CbIOObj{
  int id;
  int nU;
  int iU;
  int nL;
  double Sc;
  char*NmE;
  char*pSc;
}CbIOObj;

typedef struct CbIOSet{
  int n;
  int k;
  int nP;
  int kP;
  int kS;
  int nV;
  int kV;
  int N;

  int*kO;
  int*i0;
  int*i1;
  int*ki0;
  int*ki1;
}CbIOSet;

typedef struct CbIOGrp{
  int nV;
  int kV;
}CbIOGrp;
#endif

static int NGrp= 50,nGrp;
static CbIOGrp*IOGrp;

static int NLoop= 50,nLoop;
static CbIOLoop*IOLoop;

static int NPar= 50,nPar;
static char**NmPar;

static int NIOVec= 50,nIOVec;
static CbIOVec*IOVec;

static int NIOObj= 50,nIOObj;
static CbIOObj*IOObj;

static CbPltSet*PltSet;
static int*kGO,NGO;

static CbIOSet**IOSet;
static int NIOStr= 132;
static char*IOStr;

static char*CbIOType[6]= {"  char ","  double ","  int ",
			    " float  ","  long int ","  char "};
static int NIOFunc= 3;
static char*CbIOFunc[3]= {"get","send","plot"};

static FILE*fpT;

static int StackI[10];
static ILc;

int PPrintLine(char*pnt0,char*pnt)
{
  while(*pnt!='\n'&&pnt>pnt0)
    pnt--;
  if(*pnt=='\n')
    pnt++;
  while(*pnt!='\n'&&pnt!='\0'){
    putchar(*pnt);
    pnt++;
  }
  putchar('\n');
  return(0);
}

int CbInitUnits()
{
  int i,j;

  NXUnits= 12;
  XUnits= (CbUnits*)malloc(NXUnits*sizeof(CbUnits));
  FailureAlarm((char*)XUnits," - no memory for XUnits in CbInitUnits");
  i= 0;
  XUnits[i].nmU= "1";
  XUnits[i].nU= 1;
  i= 1;
  XUnits[i].nmU= "t";
  XUnits[i].nU= 3;
  i= 2;
  XUnits[i].nmU= "L";
  XUnits[i].nU= 3;
  i= 3;
  XUnits[i].nmU= "B";
  XUnits[i].nU= 4;
  i= 4;
  XUnits[i].nmU= "I";
  XUnits[i].nU= 4;
  i= 5;
  XUnits[i].nmU= "V";
  XUnits[i].nU= 3;
  i= 6;
  XUnits[i].nmU= "gY";
  XUnits[i].nU= 3;
  i= 7;
  XUnits[i].nmU= "p";
  XUnits[i].nU= 3;
  i= 8;
  XUnits[i].nmU= "n";
  XUnits[i].nU= 5;
  i= 9;
  XUnits[i].nmU= "T";
  XUnits[i].nU= 5;
  i= 10;
  XUnits[i].nmU= "j";
  XUnits[i].nU= 4;
  i= 11;
  XUnits[i].nmU= "M";
  XUnits[i].nU= 3;

  for(i= 0;i<NXUnits;i++){
    XUnits[i].U= (char**)malloc(2*XUnits[i].nU*sizeof(char*));
    XUnits[i].TU= XUnits[i].U+XUnits[i].nU;
    XUnits[i].Ln= 4;
    XUnits[i].U[0]= "";
    XUnits[i].scU= (double*)malloc(XUnits[i].nU*sizeof(double));
    XUnits[i].scU[0]= 1.;
    XUnits[i].sc= 1.;
    XUnits[i].rsc= 1.;
  }

  i= 1;
  XUnits[i].U[1]= "sec";
  XUnits[i].U[2]= "msec";
  XUnits[i].scU[1]= 1000.;
  XUnits[i].scU[2]= 0.001;
  i= 2;
  XUnits[i].U[1]= "m";
  XUnits[i].U[2]= "cm";
  XUnits[i].scU[1]= 100.;
  XUnits[i].scU[2]= 0.01;
  i= 3;
  XUnits[i].U[1]= "T";
  XUnits[i].U[2]= "kG";
  XUnits[i].U[3]= "G";
  XUnits[i].scU[1]= 10.;
  XUnits[i].scU[2]= 1000.;
  XUnits[i].scU[3]= 1e-4;
  i= 4;
  XUnits[i].U[1]= "MA";
  XUnits[i].U[2]= "kA";
  XUnits[i].U[3]= "A";
  XUnits[i].scU[1]= 1000.;
  XUnits[i].scU[2]= 1000.;
  XUnits[i].scU[3]= 1e-6;
  i= 5;
  XUnits[i].U[1]= "V";
  XUnits[i].U[2]= "kV";
  XUnits[i].scU[1]= 0.001;
  XUnits[i].scU[2]= 1000.;
  i= 6;
  XUnits[i].U[1]= "Vsec";
  XUnits[i].U[2]= "mVs";
  XUnits[i].scU[1]= 1000.;
  XUnits[i].scU[2]= 0.001;
  i= 7;
  XUnits[i].U[1]= "MPa";
  XUnits[i].U[2]= "Pa";
  XUnits[i].scU[1]= 1e+6;
  XUnits[i].scU[2]= 1e-6;
  i= 8;
  XUnits[i].U[1]= "e+13";
  XUnits[i].U[2]= "e+20";
  XUnits[i].U[3]= "cm-3";
  XUnits[i].U[4]= "m-3";
  XUnits[i].scU[1]= 0.1;
  XUnits[i].scU[2]= 1e+14;
  XUnits[i].scU[3]= 1e+6;
  XUnits[i].scU[4]= 1e-19;
  i= 9;
  XUnits[i].U[1]= "keV";
  XUnits[i].U[2]= "eV";
  XUnits[i].U[3]= "erg";
  XUnits[i].U[4]= "K^o";
  XUnits[i].scU[1]= 1000.;
  XUnits[i].scU[2]= 1.6022e-12;
  XUnits[i].scU[3]= 1.1604e+4/1.6022e-12;
  XUnits[i].scU[4]= 1./1.1604e+7;
  i= 10;
  XUnits[i].U[1]= "MA/m";
  XUnits[i].U[2]= "kA/m";
  XUnits[i].U[3]= "A/cm";
  XUnits[i].scU[1]= 1000.;
  XUnits[i].scU[2]= 0.1;
  XUnits[i].scU[3]= 0.01;
  i= 11;
  XUnits[i].U[1]= "g";
  XUnits[i].U[2]= "kg";
  XUnits[i].scU[1]= 0.001;
  XUnits[i].scU[2]= 1000.;

  for(i= 0;i<NXUnits;i++){
    for(j= 0;j<XUnits[i].nU;j++){
      XUnits[i].TU[j]= (char*)malloc(5*sizeof(char));
      sprintf(XUnits[i].TU[j],"%4s",XUnits[i].U[j]);
    }
    XUnits[i].iU= 0;
    XUnits[i].pntU= XUnits[i].TU[0];
  }
  fpT0= fopen("In/Units","r");
  if(fpT0==NULL)
    WriteXUnits("Out/Units");
  else
    fclose(fpT0);
  return(0);
}

int CbDeInitUnits()
{
  int i,j;

  for(i= 0;i<NXUnits;i++){
    for(j= 0;j<XUnits[i].nU;j++){
      free(XUnits[i].TU[j]);
    }
    free(XUnits[i].scU);
    XUnits[i].TU= NULL;
    free(XUnits[i].U);
  }
  free(XUnits);
  return(0);
}

int WriteXUnits(char*NmF)
{
int i,j;
if(NmF!=NULL){
fpT0= fopen(NmF,"w");
for(i= 0;i<NXUnits;i++){
fprintf(fpT0,"%2s: ",XUnits[i].nmU);
for(j= 0;j<XUnits[i].nU;j++){
strcpy(ln,"(");
strcat(ln,XUnits[i].nmU);
strcat(ln,".");
strcat(ln,XUnits[i].U[j]);
strcat(ln,")");
fprintf(fpT0," %10s",ln);
}
fprintf(fpT0,";\n");
fprintf(fpT0,"%4s"," ");
for(j= 0;j<XUnits[i].nU;j++)
fprintf(fpT0," %10.3e",XUnits[i].scU[j]);
fprintf(fpT0,";\n");
}
printf("%s with available Units has been written by zcb%c\n",NmF,7);
printf("   Move it into In/ directory for further use\n");
fclose(fpT0);
}
else{
printf("%6s %2s %2s   %6s   %6s ]\n","Name","Ln","N","Units"," ... ");
for(i= 0;i<NXUnits;i++){
printf("%6s %2d %2d",XUnits[i].nmU,XUnits[i].Ln,XUnits[i].nU);
for(j= 0;j<XUnits[i].nU;j++)
printf("   %s.%s",XUnits[i].nmU,XUnits[i].U[j]);
printf("\n");
printf("%12s"," ");
printf(" %10s"," ");
for(j= 1;j<XUnits[i].nU;j++)
printf(" %10.3e",XUnits[i].scU[j]);
printf("\n");
}
}
return(0);
}

/* :8 */
/* 9: */
#line 459 "/u/zakharov/CB/cb2obj.web"

main()
{
int i,k,n,iI,iT;
int NStr,nStr,L,ic;
char*str,*p,ch;
char buff[10000];

CbInitUnits();

BuffIO= (char**)malloc(NType*sizeof(char*));

fpT0= fopen("o.dat","r");
if(fpT0==NULL){
printf("o.dat does not exist%c\n",7);
exit(0);
}
NStr= 133;
str= (char*)malloc(NStr*sizeof(char));
p= str;
nStr= 0;
ic= 0;
while(feof(fpT0)==0){
ch= fgetc(fpT0);
if(ch==EOF)
break;
*p++= ch;
nStr++;
if(nStr>=NStr){
NStr+= 100;
str= (char*)realloc((void*)str,NStr*sizeof(char));
p= str+nStr;
}
}
*p= '\0';
fclose(fpT0);

iI= 7;
BuffIO[iI+3]= str;
BuffIO[2]= str;
nTbl= 3;
for(i= 0;i<NType;i++){
IOInsFl[i]= 0;
}


IOLoop= (CbIOLoop*)malloc(NLoop*sizeof(CbIOLoop));
nLoop= 0;
IOObj= (CbIOObj*)malloc(NIOObj*sizeof(CbIOObj));
nIOObj= 0;

PltSet= (CbPltSet*)malloc(nTbl*sizeof(CbPltSet));
for(k= 0;k<nTbl;k++){
PltSet[k].N= 0;
PltSet[k].n= 0;
PltSet[k].k= 0;
PltSet[k].nP= 0;
PltSet[k].kP= 0;
PltSet[k].nV= 0;
PltSet[k].kV= 0;
}

IOSet= (CbIOSet**)malloc(NType*sizeof(CbIOSet*));
for(n= 0;n<NType;n++){
IOSet[n]= (CbIOSet*)malloc(nTbl*sizeof(CbIOSet));
for(k= 0;k<nTbl;k++){
IOSet[n][k].N= 0;
IOSet[n][k].n= 0;
IOSet[n][k].k= 0;
IOSet[n][k].nP= 0;
IOSet[n][k].kP= 0;
IOSet[n][k].nV= 0;
IOSet[n][k].kV= 0;
}
}
IOStr= (char*)malloc(NIOStr*sizeof(char));
nPar= 0;
NmPar= (char**)malloc(NPar*sizeof(char*));
nIOVec= 0;
IOVec= (CbIOVec*)malloc(NIOVec*sizeof(CbIOVec));
nGrp= 0;
IOGrp= (CbIOGrp*)malloc(NGrp*sizeof(CbIOGrp));

iT= 0;
NGO= 10;
kGO= (int*)malloc(NGO*sizeof(int));

if(CbInitPltSet("o.dat",iT)){
CbDeInitPltSet();
exit(0);
}

free(kGO);

#ifdef H
CbWriteFCodeIOAddr(iI+3,iT);

iT= 0;
if(CbInitIOSet("o.dat",iI,iT)){
CbDeInitIOSet();
exit(0);
}

CbWriteCCodePltAddr(iT);
CbWriteFCodePltAddr(iT);

CbWriteCCodeIOAddr(iI+3,iT);
CbWriteFCodeIOAddr(iI+3,iT);

{
int i0,i1,Nx0,Nx1,Ny0,ix0,ix1,ix2,iy0,iy1;
double aa,bb,cc,Rpl;
double x[5][20],y[30];

Nx0= 5;
Nx1= 20;
Ny0= 30;

ix1= 107;
iy0= 6;
iy1= 44;
ix0= 100;
ix2= 105;

aa= 77777.;
bb= 88888.;
cc= 99999.;
for(i0= 0;i0<Nx0;i0++){
for(i1= 0;i1<Nx1;i1++){
x[i0][i1]= i0*100+i1;
}
}
for(i= 0;i<Ny0;i++){
y[i]= -i;
}
CbIOPar7_0a(Nx0,Nx1,Ny0,iy1,ix0,ix2,Rpl);
CbIOVec7_0a(&aa,&bb,x,&cc,y);
CbIOVecS7_0a(&x[1][0],&x[0][1],&y[1]);
CbIOSet2HD(iI,iT);
}

#endif

CbDeInitIOSet();
free(str);
}

int CbIOPar7_0a(p0,p1,p2,p3,p4,p5,p6)
int p0,p1,p2,p3,p4,p5;
double p6;
{
IOLoop[1].i1= p0;
IOLoop[2].i1= p1;
IOLoop[4].i1= p2;
IOSet[10][0].i1[1]= p3;
IOSet[10][0].i0[2]= p4;
IOSet[10][0].i1[2]= p5;
IOObj[1].Sc= p6;
return(0);
}
int CbIOVec7_0a(p0,p1,p2,p3,p4)
double*p0,*p1,*p2,*p3,*p4;
{
IOVec[0].V= (char*)p0;
IOVec[1].V= (char*)p1;
IOVec[2].V= (char*)p2;
IOVec[3].V= (char*)p3;
IOVec[4].V= (char*)p4;
return(0);
}
int CbIOVecS7_0a(p2_0,p2_1,p4_0)
double*p2_0,*p2_1,*p4_0;
{
char*P;
P= IOVec[2].V;
IOVec[2].st[0]= (char*)p2_0-P;
IOVec[2].st[1]= (char*)p2_1-P;
P= IOVec[4].V;
IOVec[4].st[0]= (char*)p4_0-P;
return(0);
}


/* :9 */
/* 10: */
#line 645 "/u/zakharov/CB/cb2obj.web"

CbNm2IOVec(CbIOVec*IOVec,char*NmIOVec)
{
int d,ic,k,L;
int Fl;
char*p,*p1;

p= NmIOVec;
IOVec->d= 0;
d= 0;
ic= 0;
L= 0;
k= 0;
Fl= 0;
while(*p!='\0'){
if(*p=='['){
ic++;
if(isdigit(*(p+1))){
Fl= 1;
}
else{
Fl= 2;
}
if(ic>1){
printf("%s has a nested '[' %c\n",NmIOVec,7);
return(1);
}
}
if(ic==0){
L++;
k= d;
}
if(*p==']'){
ic--;
d++;
if(ic<0){
printf("%s has more ']' than '[' %c\n",NmIOVec,7);
return(1);
}
}
if(ic&&*p!='['){
if(Fl==1){
if(isdigit(*p)==0){
printf("%s wrong number inside %d's bracket %c\n",NmIOVec,d+1,7);
return(1);
}
}
else{
if(isalnum(*p)==0&&*p!='_'){
printf("%s wrong name of parameter inside %d's bracket %c\n",
NmIOVec,d+1,7);
return(1);
}
}
}
p++;
}
if(ic>0){
printf("%s has more '[' than ']' %c\n",NmIOVec,7);
return(1);
}
if(ic<0){
printf("%s has more ']' than '[' %c\n",NmIOVec,7);
return(1);
}
if(L==0){
printf("%s has no Name of Vector%c\n",NmIOVec,7);
return(1);
}

IOVec->Nm= (char*)malloc((L+1+3*k)*sizeof(char));
p= NmIOVec;
p1= IOVec->Nm;

IOVec->id= k<<4;
L= 0;
while(*p!='\0'){
if(*p=='['){
ic++;
}
if(ic==0){
*p1++= *p;
}
if(*p==']'){
L= 8;
ic--;
if(k){
*p1++= '[';
*p1++= '0';
*p1++= ']';
L= 0;
k--;
}
}
p++;
}
*p1= '\0';
IOVec->id|= L;
IOVec->d= d;
if(d==0){
return(0);
}
IOVec->st= (int*)malloc(d*sizeof(int));
for(k= 0;k<d;k++){
IOVec->st[k]= 0;
}
return(0);
}

int CbDeInitIOVec()
{
int i,k;
for(i= 0;i<nIOVec;i++){
free(IOVec[i].Nm);
if(IOVec[i].d){
free(IOVec[i].st);
}
}
free(IOVec);
return(0);
}

/* :10 */
/* 11: */
#line 770 "/u/zakharov/CB/cb2obj.web"

int CbAdd2IOParList(int n0,char*str)
{
int i;

for(i= n0;i<nPar;i++){
if(strcmp(str,NmPar[i])==0)
return(i);
}
NmPar[i]= (char*)malloc((strlen(str)+1)*sizeof(char));
strcpy(NmPar[i],str);
nPar++;
if(nPar>=NPar){
NPar+= 10;
NmPar= (char**)realloc((void*)NmPar,NPar*sizeof(char*));
}
return(i);
}

int CbDeInitIONmPar()
{
int i;

for(i= 0;i<nPar;i++){
free(NmPar[i]);
}
free(NmPar);
return(0);
}

/* :11 */
/* 12: */
#line 803 "/u/zakharov/CB/cb2obj.web"

int CbAdd2IOVecList(int nL0,int nP0,int n0,int ObjID,char*NmVec)
{
int i,j,d,d0,id;
char*p;
CbIOVec*pV;

i= CbNm2IOVec(IOVec+nIOVec,NmVec);
if(i)
return(-1);
pV= IOVec+nIOVec;
pV->id|= (ObjID&7);
p= pV->Nm;
id= pV->id;
d= pV->d;
d0= pV->id>>4;
for(i= n0;i<nIOVec;i++){
if(strcmp(IOVec[i].Nm,p)==0){
if(IOVec[i].id!=id){
printf("%s vector type <%s> does not match its previous type %s%c\n",
p,CbIOType[id],CbIOType[IOVec[i].id],7);
return(-1);
}
if(IOVec[i].d!=d){
printf("%s vector depth %d does not match its previous value %d%c\n",
p,d,IOVec[i].d,7);
return(-1);
}
free(pV->Nm);
if(pV->d){
free(pV->st);
}
return(i);
}
}
nIOVec++;
if(nIOVec>=NIOVec){
NIOVec+= 10;
IOVec= (CbIOVec*)realloc((void*)IOVec,NIOVec*sizeof(CbIOVec));
}
return(i);
}

/* :12 */
/* 13: */
#line 849 "/u/zakharov/CB/cb2obj.web"

int CbStr2VecPar(int kL,int kV,int nP0,char*NmIOVec)
{
int d,ic,k,L;
char*p,*p1,ch;
CbIOLoop*pL;
int d0,*iV,*fV;
char**piV;

pL= IOLoop+kL;
k= pL->kV[kV];
iV= pL->iV[kV];
fV= pL->fV[kV];
piV= pL->piV[kV];
d0= IOVec[k].d;

p= NmIOVec;
ic= 0;
d= 0;
while(*p!='\0'){
if(*p=='['){
p1= p+1;
ic++;
}
if(*p==']'){
if(isdigit(*p1)){
sscanf(p1,"%d",&k);
while(p1<p){
if(!isdigit(*p1)){
printf("%s contains a non-digit after '[' %c\n",NmIOVec,7);
return(1);
}
p1++;
}
piV[d]= NULL;
iV[d]= k;
fV[d]= -1;
}
else{
ch= *p;
*p= '\0';
ic= pL->d;
k= kL;
while(ic){
if(IOLoop[k].NmI!=NULL&&strcmp(IOLoop[k].NmI,p1)==0){
fV[d]= k;
break;
}
k= IOLoop[k].pL;
ic= IOLoop[k].d;
}
L= p-p1;
piV[d]= (char*)malloc(L*sizeof(char));
p= p1;
p1= piV[d];
while(*p!='\0'){
*p1++= *p++;
}
*p1= '\0';
iV[d]= 0;

if(ic==0){
fV[d]= -1;
CbAdd2IOParList(nP0,piV[d]);
}
else{
fV[d]= ic;
}
*p= ch;
}
d++;
ic= 0;
}
p++;
}
return(0);
}

/* :13 */
/* 14: */
#line 930 "/u/zakharov/CB/cb2obj.web"

CbStr2IOLoop(int nP0,int nV0,int ObjID,char*Str)
{
int i,n,nV,nL,nL0;
int kpL,ic,ic1,d,k,L;
char*p,*p1,*p2;
CbIOLoop*pIO;

nL0= nLoop;
pIO= IOLoop+nLoop;
kpL= pIO->pL;
if(kpL<0){
pIO->d= 0;
}
else{
pIO->d= IOLoop[kpL].d+1;
}

p= Str;
ic= 0;
ic1= 0;
nV= 0;
nL= 0;
while(*p!='\0'){
if(ic1==0){
if(*p=='['){
if(ic){
printf("%s\n has extra '[':\n%s %c\n",Str,p,7);
return(1);
}
ic++;
}
if(*p==']'){
ic--;
if(ic<0){
printf("%s\n has extra ']':\n%s %c\n",Str,p,7);
return(1);
}
}
if(*p=='('){
if(ic>0){
printf("%s\n has extra '[' before:\n%s%c\n",Str,p,7);
return(1);
}
if(ic<0){
printf("%s\n has extra ']' before:\n%s%c\n",Str,p,7);
return(1);
}
if(p>Str&&*(p-1)!=','){
printf("%s\n no ',' before '(':\n%s%c\n",Str,p,7);
return(1);
}
}
}

if(*p=='('){
ic1++;
}
if(*p==')'){
ic1--;
if(ic1<0){
printf("%s\n extra ')' in loop:\n%s%c\n",Str,p,7);
return(1);
}
if(*(p+1)!='\0'&&*(p+1)!=','){
printf("%s\n no ',' after ')':\n%s%c\n",Str,p,7);
return(1);
}
}
if(ic==0&&ic1==0){
if(*p==','){
if(*(p-1)==')')
nL++;
else
nV++;
}
if(*p=='='){
break;
}
}
p++;
}


if(*p=='\0'){
if(ic>0){
printf("%s vector has extra '[' %c\n",Str,7);
return(1);
}
if(ic<0){
printf("%s vector has extra ']' %c\n",Str,7);
return(1);
}
if(ic1>0){
printf("%s loop has extra '(' %c\n",Str,7);
return(1);
}
if(ic1<0){
printf("%s loop has extra ')' %c\n",Str,7);
return(1);
}
if(*(p-1)==')')
nL++;
else
nV++;
pIO->i0= 0;
pIO->i1= 1;
pIO->st= 1;
pIO->NmI= NULL;
pIO->pi0= NULL;
pIO->pi1= NULL;
pIO->pst= NULL;
}

if(*p=='='){
p1= p;
while(*p1!='\0'){
if(*p1=='('){
printf("%s has extra '(' after '='%c\n",Str,7);
return(1);
}
if(*p1==')'){
ic1--;
}
p1++;
}
if(ic1>0){
printf("%s loop has extra '(' %c\n",Str,7);
return(1);
}
if(ic1<0){
printf("%s loop has extra ')' after '='%c\n",Str,7);
return(1);
}

p1= p;
while(*p1!=','&&p1>Str)
p1--;
L= p-p1;
pIO->NmI= (char*)malloc(L*sizeof(char));
p1++;
p2= pIO->NmI;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';

p++;
while(*p!='<'&&*p!='\0'){
p++;
}
if(*p!='<'){
printf("%s contains no '<' sign after '=':\n%s %c\n",Str,p1,7);
return(1);
}
L= p-p1;
p1++;
if(isdigit(*p1)){
sscanf(p1,"%d",&k);
while(p1<p){
if(!isdigit(*p1)){
printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
return(1);
}
p1++;
}
pIO->i0= k;
pIO->pi0= NULL;
}
else{
pIO->pi0= (char*)malloc(L*sizeof(char));
p2= pIO->pi0;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';
pIO->i0= 0;
if(CbAdd2IOParList(nP0,pIO->pi0)<0)
return(1);
}
p++;
while(*p!=':'&&*p!=';'&&*p!='\0'){
p++;
}
L= p-p1;
p1++;
if(isdigit(*p1)){
sscanf(p1,"%d",&k);
while(p1<p){
if(!isdigit(*p1)){
printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
return(1);
}
p1++;
}
pIO->i1= k;
pIO->pi1= NULL;
}
else{
pIO->pi1= (char*)malloc(L*sizeof(char));
p2= pIO->pi1;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';
pIO->i1= 0;
if(CbAdd2IOParList(nP0,pIO->pi1)<0)
return(1);
}
if(*p!=':'){
pIO->st= 1;
pIO->pst= NULL;
}
else{
p++;
while(*p!='\0'){
p++;
}
L= p-p1;
p1++;
if(isdigit(*p1)){
sscanf(p1,"%d",&k);
while(p1<p){
if(!isdigit(*p1)){
printf("%s contains a non-digit starting at\n%s %c\n",Str,p1,7);
return(1);
}
p1++;
}
pIO->st= k;
pIO->pi1= NULL;
}
else{
pIO->pst= (char*)malloc(L*sizeof(char));
p2= pIO->pst;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';
pIO->st= 0;
if(CbAdd2IOParList(nP0,pIO->pst)<0)
return(1);
}
}
}

n= nV+nL;
pIO->n= n;
pIO->nV= nV;
pIO->nL= nL;
if(n)
pIO->t= (int*)malloc(n*sizeof(int));
if(nV){
pIO->kV= (int*)malloc(3*nV*sizeof(int));
pIO->i0V= pIO->kV+nV;
pIO->stV= pIO->i0V+nV;
pIO->iV= (int**)malloc(2*nV*sizeof(int*));
pIO->fV= pIO->iV+nV;
pIO->ImV= (char**)malloc(nV*sizeof(char*));
pIO->piV= (char***)malloc(nV*sizeof(char**));
}
if(nL){
pIO->kL= (int*)malloc(nL*sizeof(int));
}

p= Str;


ic= 0;
ic1= 0;
nV= 0;
nL= 0;
n= 0;
p1= p;
while(*p!='\0'){
if(ic1==0){
if(*p=='['){
ic++;
}
if(*p==']'){
ic--;
}
}
if(*p=='('){
ic1++;
}
if(*p==')'){
ic1--;
}
if(ic==0&&ic1==0){
if(*p==','){
if(*(p-1)==')'){
if(*p1!='('){
printf("%s has no '(' at beginning of the loop:\n%s %c\n",
Str,p1,7);
return(1);
}
*(p-1)= '\0';
pIO->t[n]= 8;
nLoop++;
pIO->kL[nL]= nLoop;
if(nLoop>=NLoop){
NLoop+= 10;
IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
}
IOLoop[nLoop].pL= nL0;
if(CbStr2IOLoop(nP0,nV0,ObjID,p1+1))
return(1);
p1= p+1;
n++;
nL++;
}
else{
*p= '\0';
L= p-p1;
pIO->ImV[nV]= (char*)malloc(L*sizeof(char));
strcpy(pIO->ImV[nV],p1);
k= CbAdd2IOVecList(nL0,nP0,nV0,ObjID,p1);
pIO->kV[nV]= k;
if(k<0){
printf("%s has wrong vector:\n%s %c\n",Str,p1,7);
*p= ',';
return(1);
}
pIO->t[n]= 1;
d= IOVec[k].d;
if(d){
pIO->iV[nV]= (int*)malloc(2*d*sizeof(int));
pIO->fV[nV]= pIO->iV[nV]+d;
pIO->piV[nV]= (char**)malloc(d*sizeof(char*));
if(CbStr2VecPar(nL0,nV,nP0,p1)){
printf("%s has wrong vector parameters:\n%s %c\n",Str,p1,7);
return(1);
}
}
*p= ',';
p1= p+1;
nV++;
n++;
}
}
if(*p=='=')
break;
}
p++;
}
if(*p=='\0'){
if(*(p-1)==')'){
if(*p1!='('){
printf("%s has no '(' at beginning of the loop:\n%s %c\n",
Str,p1,7);
return(1);
}
*(p-1)= '\0';
pIO->t[n]= 8;
nLoop++;
pIO->kL[nL]= nLoop;
if(nLoop>=NLoop){
NLoop+= 10;
IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
}
IOLoop[nLoop].pL= nL0;
if(CbStr2IOLoop(nP0,nV0,ObjID,p1+1))
return(1);
p1= p+1;
n++;
nL++;
}
else{
*p= '\0';
L= p-p1;
pIO->ImV[nV]= (char*)malloc(L*sizeof(char));
strcpy(pIO->ImV[nV],p1);
k= CbAdd2IOVecList(nL0,nP0,nV0,ObjID,p1);
pIO->kV[nV]= k;
if(k<0){
printf("%s has wrong vector:\n%s %c\n",Str,p1,7);
*p= ',';
return(1);
}
pIO->t[n]= 1;
d= IOVec[k].d;
if(d){
pIO->iV[nV]= (int*)malloc(2*d*sizeof(int));
pIO->fV[nV]= pIO->iV[nV]+d;
pIO->piV[nV]= (char**)malloc(d*sizeof(char*));
if(CbStr2VecPar(nL0,nV,nP0,p1)){
printf("%s has wrong vector parameters:\n%s %c\n",Str,p1,7);
return(1);
}
}
*p= ',';
p1= p+1;
nV++;
n++;
}
}

if(kpL<0){
nLoop++;
if(nLoop>=NLoop){
NLoop+= 10;
IOLoop= (CbIOLoop*)realloc((void*)IOLoop,NLoop*sizeof(CbIOLoop));
}
}

return(0);
}

int CbDeInitOneIOLoop(int*ia)
{
int i,j,n,k,m,iV,iL,iVL,nVL;

i= *ia;
iV= 0;
iL= 0;
iVL= 0;
nVL= IOLoop[i].n;
while(iVL<nVL){
if(IOLoop[i].t[iVL]==8){
*ia= IOLoop[i].kL[iL];
CbDeInitOneIOLoop(ia);
iL++;
}
else{
k= IOLoop[i].kV[iV];
if(IOVec[k].d){
for(m= 0;m<IOVec[k].d;m++){
if(IOLoop[i].piV[iV][m]!=NULL)
free(IOLoop[i].piV[iV][m]);
}
free(IOLoop[i].iV[iV]);
free(IOLoop[i].piV[iV]);
}
free(IOLoop[i].ImV[iV]);
iV++;
}
iVL++;
}
if(IOLoop[i].nV){
free(IOLoop[i].ImV);
free(IOLoop[i].kV);
free(IOLoop[i].iV);
free(IOLoop[i].piV);
}

if(IOLoop[i].nL){
free(IOLoop[i].kL);
}
if(IOLoop[i].n){
free(IOLoop[i].t);
}
if(IOLoop[i].NmI!=NULL){
free(IOLoop[i].NmI);
}
if(IOLoop[i].pi0!=NULL){
free(IOLoop[i].pi0);
}
if(IOLoop[i].pi1!=NULL){
free(IOLoop[i].pi1);
}
if(IOLoop[i].pst!=NULL){
free(IOLoop[i].pst);
}
return(0);
}

int CbDeInitIOLoop()
{
int i,j,n,k,m;

i= 0;
while(i<nLoop){
CbDeInitOneIOLoop(&i);
i++;
}
free(IOLoop);
return(0);
}

/* :14 */
/* 15: */
#line 1413 "/u/zakharov/CB/cb2obj.web"

int CbCheckIOFuncPar(char*p,char*NmFile,char*pF)
{
while(isspace(*p))
p++;
if(*p!='('){
printf("%s file: wrong character after %s in I/O function:\n\n",
NmFile,pF);
return(1);
}
p++;
while(*p!=')'&&*p!=';'&&*p!='\0'){
p++;
}
if(*p!=')'){
printf("%s file: no ')' in I/O function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(*p!=';'&&*p!='\0'){
p++;
}
if(*p!=';'){
printf("%s file: no ';' after %s() in I/O function:\n\n",
NmFile,pF);
return(1);
}
return(0);
}

int CbGetIOFuncPar(CbIOSet*pS,int N,char*p,char*NmFile,char*pF)
{
char*p1,ch;
int i,k,n;

pS->i0[N]= 0;
pS->ki0[N]= -1;
pS->i1[N]= (unsigned)(-1)>>1;
pS->ki1[N]= -1;

while(*p!='(')
p++;
p++;
while(isspace(*p))
p++;
if(*p!='"'){
printf("%s file: no first '\"' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
p1= p;
while(*p!='"'&&*p!='='&&*p!='\0')
p++;
if(*p!='"'){
printf("%s file: no second '\"' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
k= pS->k;
n= pS->n;
for(i= k;i<n;i++){
if(strcmp(p1,IOObj[i].NmE)==0){
pS->kO[N]= i;
break;
}
}
if(i==n){
printf("%s file: wrong object name \"%s\" inside I/O function %s:\n\n",
NmFile,p1,pF);
return(1);
}
*p= '"';
p++;
while(isspace(*p))
p++;
if(*p!=')'){
if(*p!=','){
printf("%s file: no ',' after object name inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(isalnum(*p)||*p=='_')
p++;
if(*p!='='){
printf("%s file: no '=' after ',' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(isspace(*p))
p++;
p1= p;
if(isdigit(*p1)){
p++;
while(isdigit(*p))
p++;
while(isspace(*p))
p++;
if(*p!='<'&&*p!=')'){
printf("%s file: wrong number after  '=' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
ch= *p;
*p= '\0';
sscanf(p1,"%d",&i);
pS->i0[N]= i;
pS->ki0[N]= -1;
*p= ch;
}
else{
p++;
while(isalnum(*p)||*p=='_')
p++;
while(isspace(*p))
p++;
if(*p!='<'&&*p!=')'){
printf("%s file: wrong variable after '=' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
ch= *p;
*p= '\0';
i= CbAdd2IOParList(pS->kP,p1);
pS->ki0[N]= i;
*p= ch;
}
if(*p=='<'){
p++;
while(isspace(*p))
p++;
p1= p;
if(isdigit(*p1)){
p++;
while(isdigit(*p))
p++;
while(isspace(*p))
p++;
if(*p!=')'){
printf("%s file: wrong number after '<' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
sscanf(p1,"%d",&i);
pS->i1[N]= i;
pS->ki1[N]= -1;
*p= ')';
}
else{
p++;
while(isalnum(*p)||*p=='_')
p++;
while(isspace(*p))
p++;
if(*p!=')'){
printf("%s file: wrong name after '<' inside I/O function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
i= CbAdd2IOParList(pS->kP,p1);
pS->ki1[N]= i;
*p= ')';
}
}
}
p++;
while(isspace(*p))
p++;
if(*p!=';'){
printf("%s file: no ';' after %s() in I/O function:\n\n",
NmFile,pF);
return(1);
}
return(0);
}

/* :15 */
/* 16: */
#line 1598 "/u/zakharov/CB/cb2obj.web"

int CbInitIOSet(char*NmFile,int iI,int iT)
{
int i,L,iN,N,Lf;
char*p,*p1,*p2,*p0;
char*pF;
CbIOSet*pS;
CbIOObj*pO;

iN= iI+3;
pS= IOSet[iN]+iT;
if(IOInsFl[iN])
return(0);

pF= CbIOFunc[iI%2];
Lf= strlen(pF);
pS= IOSet[iN]+iT;
pS->k= nIOObj;
pS->kP= nPar;
pS->kV= nIOVec;

p= BuffIO[iN];
N= 0;
while(*p!='{')
p++;
p++;
while(*p!='}'){
pO= IOObj+nIOObj;
while(isspace(*p))
p++;
if(*p=='}')
break;
if(*p!='"'){
if(strncmp(pF,p,Lf)==0){
p0= p;
p+= Lf;
if(CbCheckIOFuncPar(p,NmFile,pF)){
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
N++;
p++;
while(*p!=';'&&*p!='\0')
p++;
}
else{
printf("%s file: no first '\"' in I/O object:\n\n",NmFile);
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
}
else{
p0= p;
p++;
while(isspace(*p))
p++;
p1= p;
while(*p!='"'&&*p!='='&&*p!=';'&&*p!='}'){
p++;
}
if(*p!='"'){
printf("%s file: no second '\"' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
L= p-p1;
if(L){
p--;
while(isspace(*p))
p--;
p++;
}
else{
printf("%s file: External name of object is absent\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
L= p-p1;
pO->NmE= (char*)malloc(L*sizeof(char));
p2= pO->NmE;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';
while(*p!='"'){
p++;
}

p2= pO->NmE;
for(i= pS->k;i<nIOObj;i++){
if(strcmp(p2,IOObj[i].NmE)==0){
printf("%s file: External name '%s' == '%s' ",
NmFile,p2,IOObj[i].NmE);
printf("is double defined in I/O object%c:\n\n",7);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
}
p++;
while(isspace(*p))
p++;
if(*p!='('){
pO->nU= -1;
pO->iU= 0;
}
else{
p++;
p1= p;
while(*p!=')'&&*p!='='&&*p!='"'&&*p!=';'&&*p!='}'){
p++;
}
if(*p!=')'){
printf("%s file: no second ')' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
*p= '\0';
if(CbGetUnits(&(pO->nU),&(pO->iU),p1)){
printf("%s file: wrong Units description in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
*p= ')';
p++;
while(isspace(*p))
p++;
}
if(*p!='='){
printf("%s file: no '=' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
p++;
while(isspace(*p))
p++;
if(*p!='('){
printf("%s file: no '(' after '=' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
p++;
p1= p;
while(*p!=')'&&*p!='"'&&*p!=';'&&*p!='}'){
p++;
}
if(*p!=')'){
printf("%s file: no ')' after '=(' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}

*p= '\0';
if(CbGetType(&i,&(pO->id),p1)){
printf("%s file: wrong Units description in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
pO->id&= 7;
*p= ')';
p++;
while(isspace(*p))
p++;
if(*p!='"'){
printf("%s file: no third '\"' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
p++;
p1= p;
while(*p!='"'&&*p!=';'&&*p!='}'){
p++;
}
if(*p!='"'){
printf("%s file: no fourth '\"' in I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
L= p-p1;
if(L==0){
printf("%s file: object is absent\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}

if(L>NIOStr){
NIOStr+= NIOStr-L+132;
free(IOStr);
IOStr= (char*)malloc(NIOStr*sizeof(char));
}
p= p1;
p2= IOStr;
while(*p!='"'){
if(isspace(*p)==0){
*p2++= *p;
}
p++;
}
*p2= '\0';
pO->nL= nLoop;
IOLoop[nLoop].pL= -1;
if(CbStr2IOLoop(pS->kP,pS->kV,pO->id,IOStr)){
printf("%s file: wrong object\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
p++;
while(isspace(*p))
p++;
if(*p=='*'){
p++;
while(isspace(*p))
p++;
p1= p;
p2= IOStr;
while(*p!=';'&&isspace(*p)==0&&*p!='}'){
*p2++= *p++;
}
*p2= '\0';
L= p2-IOStr;
if(isdigit(*IOStr)){
p2= IOStr;
while(isdigit(*p2))
p++;
if(*p2!='\0'){
printf("%s file: wrong Scale factor in I/O object\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
pO->pSc= NULL;
sscanf(IOStr,"%lg",&(pO->Sc));
}
else{
pO->pSc= (char*)malloc(L*sizeof(char));
strcpy(pO->pSc,IOStr);
pO->Sc= 1.;
}
while(isspace(*p))
p++;
}
if(*p!=';'){
printf("%s file: no  ';' at the end of I/O object:\n\n",NmFile);
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
nIOObj++;
if(nIOObj>=NIOObj){
NIOObj+= 50;
IOObj= (CbIOObj*)realloc((void*)IOObj,NIOObj*sizeof(CbIOObj));
}
}
p++;
}

pS->n= nIOObj-pS->k;
pS->N= N;
pS->kO= (int*)malloc(5*N*sizeof(int));
pS->i0= pS->kO+N;
pS->i1= pS->i0+N;
pS->ki0= pS->i1+N;
pS->ki1= pS->ki0+N;

p= BuffIO[iN];
N= 0;
while(*p!='{')
p++;
p++;
while(*p!='}'){
while(isspace(*p))
p++;
if(*p=='}')
break;
if(*p!='"'){
if(strncmp(pF,p,Lf)==0){
p+= Lf;
if(CbGetIOFuncPar(pS,N,p,NmFile,pF)){
p= p0;
while(*p!=';'&&*p!='\0'){
printf("%c",*p);
p++;
}
if(*p!='\0'){
printf("%c",*p);
}
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(1);
}
N++;
}
p++;
while(*p!=';'&&*p!='\0')
p++;
}
else{
p++;
while(*p!=';'&&*p!='\0')
p++;
}
p++;
}

pS->kS= nPar;
for(i= pS->k;i<nIOObj;i++){
pO= IOObj+i;
if(pO->pSc!=NULL){
CbAdd2IOParList(pS->kP,pO->pSc);
}
}

pS->nP= nPar-pS->kP;
pS->nV= nIOVec-pS->kV;
return(0);
}

int CbDeInitIOObj()
{
int k;

for(k= 0;k<NIOObj;k++){
free(IOObj[k].NmE);
}
free(IOObj);
return(0);
}

int CbDeInitIOSet()
{
int k,i;

CbDeInitIOLoop();
CbDeInitIOVec();
CbDeInitIONmPar();
CbDeInitIOObj();
for(k= 0;k<NType;k++){
for(i= 0;i<nTbl;i++){
if(IOSet[k][i].N){
free(IOSet[k][i].kO);
}
}
free(IOSet[k]);
}
free(IOSet);
return(0);
}

/* :16 */
/* 17: */
#line 2080 "/u/zakharov/CB/cb2obj.web"

int CbPrintLoop(int kL)
{
int i,iL,iV,dL,n;
int i1,st,I;

CbIOLoop*pL;

pL= IOLoop+kL;
dL= pL->d;
n= pL->n;

i= 0;
iL= 0;
iV= 0;

if(pL->NmI!=NULL){
printf("{int I%d,I1_%d,st_%d;\n",kL,kL,kL);
if(pL->pi0!=NULL){
printf("I%d=%s;\n",kL,pL->pi0);
}
else{
printf("I%d=%d;\n",kL,pL->i0);
}
if(pL->pi1!=NULL){
printf("I1_%d=%s;\n",kL,pL->pi1);
}
else{
printf("I1_%d=%d;\n",kL,pL->i1);
}
if(pL->pst!=NULL){
printf("st_%d=%s;\n",kL,pL->pst);
}
else{
printf("st_%d=%d;\n",kL,pL->st);
}
printf("while(I%d < I1_%d){\n",kL,kL);
}

while(i<n){
if(pL->t[i]==8){
StackI[dL]= i;
CbPrintLoop(pL->kL[iL]);
iL++;
}
else{
printf("%s;\n",pL->ImV[iV]);
iV++;
}
i++;
}

if(pL->NmI!=NULL){
printf("I%d+=st_%d;\n",kL,kL);
printf("}\n");
printf("}\n");
}

return(0);
}

/* :17 */
/* 18: */
#line 2144 "/u/zakharov/CB/cb2obj.web"

int CbCmpIOLoop(int kL1,int kL2)
{
int i,iL,iV,dL,n;
int i1,st,I;
CbIOLoop*pL1,*pL2;

if(kL1<0||kL2<0||kL1>=nLoop||kL2>=nLoop)
return(-1);

pL1= IOLoop+kL1;
pL2= IOLoop+kL2;

if(pL1->d!=pL2->d)
return(-1);

dL= pL1->d;

if(pL1->n!=pL2->n)
return(-1);
if(pL1->nV!=pL2->nV)
return(-1);
if(pL1->nL!=pL2->nL)
return(-1);
n= pL1->n;

i= 0;
iL= 0;
iV= 0;

if(pL1->NmI!=NULL){
if(pL2->NmI==NULL)
return(-1);
if(strcmp(pL1->NmI,pL2->NmI))
return(-1);

if(pL1->pi0!=NULL){
if(pL2->pi0==NULL)
return(-1);
if(strcmp(pL1->pi0,pL2->pi0))
return(-1);
}
else{
if(pL2->pi0!=NULL)
return(-1);
if(pL1->i0!=pL2->i0)
return(-1);
}

if(pL1->pi1!=NULL){
if(pL2->pi1==NULL)
return(-1);
if(strcmp(pL1->pi1,pL2->pi1))
return(-1);
}
else{
if(pL2->pi1!=NULL)
return(-1);
if(pL1->i1!=pL2->i1)
return(-1);
}

if(pL1->pst!=NULL){
if(pL2->pst==NULL)
return(-1);
if(strcmp(pL1->pst,pL2->pst))
return(-1);
}
else{
if(pL2->pst!=NULL)
return(-1);
if(pL1->st!=pL2->st)
return(-1);
}
}

while(i<n){
if(pL1->t[i]!=pL2->t[i])
return(-1);
if(pL1->t[i]==8){
if(CbCmpIOLoop(pL1->kL[iL],pL2->kL[iL]))
return(-1);
iL++;
}
else{
if(pL1->kV[iV]!=pL2->kV[iV])
return(-1);
iV++;
}
i++;
}

return(0);
}

/* :18 */
/* 19: */
#line 2242 "/u/zakharov/CB/cb2obj.web"

int CbGetUnits(int*nU,int*iU,char*Str)
{
int i,n;
char*p,*p1,ch;

if(*Str=='\0'){
*nU= -1;
*iU= 0;
}
p= Str;
while(isspace(*p)&&*p!='\0'){
p++;
}
p1= p;
while(*p!='.'&&*p!='\0'){
p++;
}
if(*p!='.'){
printf("%s - no '.' in Unit description%c\n",Str,7);
return(1);
}
*p= '\0';

for(n= 0;n<NXUnits;n++){
if(strcmp(p1,XUnits[n].nmU)==0){
*nU= n;
*p= '.';
p++;
p1= p;
while(isspace(*p)==0&&*p!='\0'){
p++;
}
ch= '\0';
if(*p!='\0'){
ch= *p;
*p= '\0';
}
for(i= 0;i<XUnits[n].nU;i++){
if(strcmp(p1,XUnits[n].U[i])==0){
*iU= i;
break;
}
}
if(ch!='\0'){
*p= ch;
}
if(i==XUnits[n].nU){
if(p-p1>0){
printf("%s - wrong Unit name in (%s.) set%c\n",Str,XUnits[n].nmU,7);
return(1);
}
*iU= 0;
}
break;
}
}
if(n==NXUnits){
printf("%s - wrong Units Set%c\n",Str,7);
return(1);
}

return(0);
}

/* :19 */
/* 20: */
#line 2310 "/u/zakharov/CB/cb2obj.web"

int CbGetType(int*Flstar,int*id,char*Str)
{
char*p;
int i,n= 10;
char*CW[10]= {"str","dbl","int","flt","lng","fch","Dbl","Int","Flt","Lng"};

if(Str[3]=='*'){
*Flstar= 1;
Str[3]= '\0';
}
else{
if(Str[3]!='\0'){
printf("%s - wrong Type%c\n",Str,7);
return(1);
}
*Flstar= 0;
}

for(i= 0;i<n;i++){
if(strncmp(Str,CW[i],3)==0){
break;
}
}
if(*Flstar){
Str[3]= '*';
}

if(i==n){
printf("%s - wrong Type%c\n",Str,7);
return(1);
}

if(i==0||i==5){
if(*Flstar==0){
printf("%s - no '*' in  string object of %s type%c\n",Str,CW[i],7);
return(1);
}
else{
p= Str+4;
while(*p!='\0'){
if(isdigit(*p)==0){
printf("%s - non-digit character '%c' in string length%c\n",
Str,*p,7);
return(1);
}
p++;
}
sscanf(Str+4,"%d",Flstar);
}
*id= i;
}
else{
if(i>5){
*id= 8+i-5;
}
else{
*id= i;
}
}
return(0);
}

/* :20 */
/* 21: */
#line 2376 "/u/zakharov/CB/cb2obj.web"

int CbPrintIOSet(int iIO,int iT)
{
int i,j,k,n,iN;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOObj*pO;
CbIOVec*pV;

iN= iIO+3;
pS= IOSet[iN]+iT;
if(pS->n==0)
return(0);

k= pS->kP;
n= k+pS->nP;
for(i= k;i<n;i++){
printf("int %s;\n",NmPar[i]);
}

k= pS->kV;
n= k+pS->nV;
for(i= k;i<n;i++){
pV= IOVec+i;
printf("double %s",pV->Nm);

if(pV->d){
for(j= 0;j<pV->d;j++){
printf("[,%d]",pV->st[j]);
}
}
printf(";\n");
}

k= pS->k;
n= k+pS->n;
for(i= k;i<n;i++){
pO= IOObj+i;
printf("pO->id=%d\n",pO->id);
printf("(%s*)\n",CW[pO->id]);

if(pO->nU<0)
printf("NmE=<%s>(1.)",pO->NmE);
else
printf("NmE=<%s>(%s.%s)",pO->NmE,XUnits[pO->nU].nmU,
XUnits[pO->nU].U[pO->iU]);

if(pO->pSc==NULL)
printf("*%10.3e;\n",pO->Sc);
else
printf("*%s;\n",pO->pSc);
}
return(0);
}

/* :21 */
/* 22: */
#line 2434 "/u/zakharov/CB/cb2obj.web"

CbWriteIOLoopPar(int kL,int ii,char ch)
{
int i,j,k,iL,iV,n,d;
int i0,st,I;
int*fV;
char*p,**p1;
CbIOLoop*pL;

p= NmPar[ii];
pL= IOLoop+kL;
n= pL->n;

if(pL->NmI!=NULL){
if(pL->pi0!=NULL){
if(strcmp(pL->pi0,p)==0){
switch(ch){
case 'c':
fprintf(fpT0,"  IOLoop[%d].i0=p%d;\n",kL,ii);
break;
case 'f':
fprintf(fpT0,"  IOLoop[%d].i0=*p%d;\n",kL,ii);
break;
}
}
}
if(pL->pi1!=NULL){
if(strcmp(pL->pi1,p)==0){
switch(ch){
case 'c':
fprintf(fpT0,"  IOLoop[%d].i1=p%d;\n",kL,ii);
break;
case 'f':
fprintf(fpT0,"  IOLoop[%d].i1=*p%d;\n",kL,ii);
break;
}
}
}
if(pL->pst!=NULL){
if(strcmp(pL->pst,p)==0){
switch(ch){
case 'c':
fprintf(fpT0,"  IOLoop[%d].st=p%d;\n",kL,ii);
break;
case 'f':
fprintf(fpT0,"  IOLoop[%d].st=*p%d;\n",kL,ii);
break;
}
}
}
}

i= 0;
iL= 0;
iV= 0;
while(i<n){
if(pL->t[i]==8){
CbWriteIOLoopPar(pL->kL[iL],ii,ch);
iL++;
}
else{
d= IOVec[pL->kV[iV]].d;
if(d){
p1= pL->piV[iV];
fV= pL->fV[iV];
for(j= 0;j<d;j++){
if(fV[j]<0&&p1[j]!=NULL){
if(strcmp(p1[j],p)==0){
switch(ch){
case 'c':
fprintf(fpT0,"  IOLoop[%d].iV[%d][%d]=p%d;\n",kL,iV,j,ii);
break;
case 'f':
fprintf(fpT0,"  IOLoop[%d].iV[%d][%d]=*p%d;\n",kL,iV,j,ii);
break;
}
}
}
}
}
iV++;
}
i++;
}

return(0);
}

/* :22 */
/* 23: */
#line 2525 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOSetPar(int iI0,int iT,int ii,char ch)
{
int j,k,n;
CbIOSet*pS;

pS= IOSet[iI0+3]+iT;
n= pS->N;
k= 0;
for(j= 0;j<n;j++){
if(pS->ki0[j]==ii){
k++;
}
if(pS->ki1[j]==ii){
k++;
}
}
if(k>2){
fprintf(fpT0,"  { CbIOSet *pS;\n  pS=IOSet[%d]+%d;\n",iI0+3,iT);
for(j= 0;j<n;j++){
if(pS->ki0[j]==ii){
switch(ch){
case 'c':
fprintf(fpT0,"  pS->i0[%d]=p%d;\n",j,ii);
break;
case 'f':
fprintf(fpT0,"  pS->i0[%d]=*p%d;\n",j,ii);
break;
}
}
if(pS->ki1[j]==ii){
switch(ch){
case 'c':
fprintf(fpT0,"  pS->i1[%d]=p%d;\n",j,ii);
break;
case 'f':
fprintf(fpT0,"  pS->i1[%d]=*p%d;\n",j,ii);
break;
}
}
}
fputs("  }\n",fpT0);
}
else{
for(j= 0;j<n;j++){
if(pS->ki0[j]==ii){
switch(ch){
case 'c':
fprintf(fpT0,"  IOSet[%d][%d].i0[%d]=p%d;\n",iI0+3,iT,j,ii);
break;
case 'f':
fprintf(fpT0,"  IOSet[%d][%d].i0[%d]=*p%d;\n",iI0+3,iT,j,ii);
break;
}
}
if(pS->ki1[j]==ii){
switch(ch){
case 'c':
fprintf(fpT0,"  IOSet[%d][%d].i1[%d]=p%d;\n",iI0+3,iT,j,ii);
break;
case 'f':
fprintf(fpT0,"  IOSet[%d][%d].i1[%d]=*p%d;\n",iI0+3,iT,j,ii);
break;
}
}
}
}
return(0);
}

/* :23 */
/* 24: */
#line 2598 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOVecRoutine(int is,int iP,int i,int iIO,int iT,char ch)
{
int j,k,L,ii;

L= 0;
switch(ch){
case 'c':
sprintf(IOStr,"int CbIOVec%d_%d",iIO,iT);
break;
case 'f':
sprintf(IOStr,"void iov%d_%d",iIO,iT);
break;
}
L= strlen(IOStr);
if('a'+is<='z'){
sprintf(IOStr+L,"%c(",'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr+L,"%c%c(",'a'+k,'a'+j);
}
L+= strlen(IOStr+L);
ii= iP;
sprintf(IOStr+L,"p%d",ii);
L+= strlen(IOStr+L);
ii++;
while(ii<=i){
sprintf(IOStr+L,",p%d",ii);
L+= strlen(IOStr+L);
ii++;
}
sprintf(IOStr+L,")\n");
fputs(IOStr,fpT0);

for(j= 0;j<6;j++){
k= 0;
ii= iP;
while(ii<=i){
if((IOVec[ii].id&7)==j){
if(k==0){
sprintf(IOStr,"%s",CbIOType[j]);
L= strlen(IOStr);
sprintf(IOStr+L,"*p%d",ii);
}
else{
sprintf(IOStr+L,",*p%d",ii);
}
L+= strlen(IOStr+L);
k++;
}
ii++;
}
if(k){
fputs(IOStr,fpT0);
fputs(";\n",fpT0);
}
}
fputs("{\n",fpT0);
ii= iP;
while(ii<=i){
fprintf(fpT0,"  IOVec[%d].V=(char*)p%d;\n",ii,ii);
ii++;
}
switch(ch){
case 'c':
fputs("  return(0);\n",fpT0);
break;
case 'f':
break;
}
fputs("}\n",fpT0);

return(0);
}

/* :24 */
/* 25: */
#line 2678 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOParCRoutine(CbIOSet*pS,int is,int iP,int i,int iIO,int iT)
{
int j,k,L,ii,n;
char*p;
CbIOObj*pO;

if('a'+is<='z'){
sprintf(IOStr,"int CbIOPar%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"int CbIOPar%d_%d%c%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
ii= iP;
sprintf(IOStr+L,"p%d",ii);
L+= strlen(IOStr+L);
ii++;
while(ii<=i){
sprintf(IOStr+L,",p%d",ii);
L+= strlen(IOStr+L);
ii++;
}
sprintf(IOStr+L,")\n");
fputs(IOStr,fpT0);

n= pS->kS;
if(iP<n)
sprintf(IOStr,"  int ");
else
sprintf(IOStr,"  double ");
L= strlen(IOStr);
ii= iP;
sprintf(IOStr+L,"p%d",ii);
L+= strlen(IOStr+L);
ii++;
while(ii<=i){
if(ii==n){
sprintf(IOStr+L,";\n  double ");
fputs(IOStr,fpT0);
L= 0;
}
if(L)
sprintf(IOStr+L,",p%d",ii);
else
sprintf(IOStr+L,"p%d",ii);
L+= strlen(IOStr+L);
ii++;
}

sprintf(IOStr+L,";\n{\n");
fputs(IOStr,fpT0);

ii= iP;
while(ii<=i){
k= pS->k;
n= k+pS->n;
for(j= k;j<n;j++){
pO= IOObj+j;
CbWriteIOLoopPar(pO->nL,ii,'c');
}
CbWriteIOSetPar(iIO,iT,ii,'c');
ii++;
}

ii= pS->kS;
k= pS->k;
n= k+pS->n;
while(ii<=i){
p= NmPar[ii];
for(j= k;j<n;j++){
pO= IOObj+j;
if(pO->pSc!=NULL&&strcmp(p,pO->pSc)==0){
fprintf(fpT0,"  IOObj[%d].Sc=p%d;\n",j,ii);
}
}
ii++;
}
fputs("  return(0);\n",fpT0);
fputs("}\n",fpT0);

return(0);
}

/* :25 */
/* 26: */
#line 2767 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOVecPntRoutine(int is,int iP,int i,int iIO,int iT)
{
int j,k,L,ii,d,d0,ic;

ii= iP;
ic= 0;
while(ii<=i){
d0= IOVec[ii].id>>4;
if(d0){
ic= 1;
break;
}
ii++;
}
if(ic==0)
return(0);

if('a'+is<='z'){
sprintf(IOStr,"int CbIOVecP%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"int CbIOVecP%d_%d%c%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
ii= iP;
ic= 0;
while(ii<=i){
d0= IOVec[ii].id>>4;
if(d0){
j= 0;
while(j<d0){
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"p%d_%d",ii,j);
ic++;
j++;
L+= strlen(IOStr+L);
}
}
ii++;
}
sprintf(IOStr+L,")\n");
fputs(IOStr,fpT0);

sprintf(IOStr,"char ");
L= strlen(IOStr);
ii= iP;
ic= 0;
while(ii<=i){
d0= IOVec[ii].id>>4;
if(d0){
j= 0;
while(j<d0){
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"*p%d_%d",ii,j);
ic++;
j++;
L+= strlen(IOStr+L);
}
}
ii++;
}
fputs(IOStr,fpT0);
fputs(";\n{\n",fpT0);
fputs("  char *p;\n",fpT0);
ii= iP;
ic= 0;
while(ii<=i){
d0= IOVec[ii].id>>4;
if(d0){
fprintf(fpT0,"  p=IOVec[%d].V;\n",ii);
j= 0;
while(j<d0){
fprintf(fpT0,"  IOVec[%d].st[%d]=p%d_%d-p;\n",ii,j,ii,j);
ic++;
j++;
}
}
ii++;
}
fputs("  return(0);\n",fpT0);
fputs("}\n",fpT0);

return(0);
}

int CbWriteCCodeIOVecPnt(int iIO,int iT)
{
int i,ii,j,jj,k,L,n,iN,ic,is,iP;
int nL,kV,nV;
int d,d0;
char*p;
CbIOSet*pS;

iN= iIO+3;
pS= IOSet[iN]+iT;
if(pS->n==0)
return(0);


kV= pS->kV;
nV= kV+pS->nV;
L= 0;
is= 0;
for(i= kV;i<nV;i++){
d= IOVec[i].d;
d0= IOVec[i].id>>4;
if(d0){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"CbIOVecP%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"CbIOVecP%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
j= 0;
p= IOVec[i].Nm;
while(j<d0){
while(*p!='['){
p++;
}
p++;
*p= '1';
if(ic){
*(IOStr+L)= ',';
L++;
}
if(d0<d)
sprintf(IOStr+L,"%s",IOVec[i].Nm);
else
sprintf(IOStr+L,"&%s",IOVec[i].Nm);
*p= '0';
ic++;
j++;
L+= strlen(IOStr+L);
}
}

if(L>72){
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecPntRoutine(is,iP,i,iIO,iT);
L= 0;
is++;
}
}
if(L){
i--;
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecPntRoutine(is,iP,i,iIO,iT);
}

return(0);
}

/* :26 */
/* 27: */
#line 2940 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOVecStepRoutine(int is,int iP,int i,int iIO,int iT,char ch)
{
int j,k,L,ii,d,d0,ic;

ii= iP;
ic= 0;
while(ii<=i){
if(IOVec[ii].d){
d= IOVec[ii].d;
j= IOVec[ii].id>>4;
if(j<d){
ic= 1;
break;
}
}
ii++;
}
if(ic==0)
return(0);

switch(ch){
case 'c':
sprintf(IOStr,"int CbIOVecS%d_%d",iIO,iT);
break;
case 'f':
sprintf(IOStr,"void iovs%d_%d",iIO,iT);
break;
}
L= strlen(IOStr);

if('a'+is<='z'){
sprintf(IOStr+L,"%c(",'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr+L,"%c%c(",'a'+k,'a'+j);
}
L+= strlen(IOStr+L);
ii= iP;
ic= 0;
while(ii<=i){
if(IOVec[ii].d){
d= IOVec[ii].d;
j= IOVec[ii].id>>4;
while(j<d){
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"p%d_%d",ii,j);
ic++;
j++;
L+= strlen(IOStr+L);
}
}
ii++;
}
sprintf(IOStr+L,")\n");
fputs(IOStr,fpT0);

for(k= 0;k<6;k++){
ic= 0;
ii= iP;
while(ii<=i){
if(IOVec[ii].d&&(IOVec[ii].id&7)==k){
d= IOVec[ii].d;
j= IOVec[ii].id>>4;
while(j<d){
if(ic){
*(IOStr+L)= ',';
L++;
}
else{
sprintf(IOStr,"%s",CbIOType[k]);
L= strlen(IOStr);
}
sprintf(IOStr+L,"*p%d_%d",ii,j);
ic++;
j++;
L+= strlen(IOStr+L);
}
}
ii++;
}
if(ic){
fputs(IOStr,fpT0);
fputs(";\n",fpT0);
}
}
fputs("{\n",fpT0);
fprintf(fpT0,"char *P;\n");

ii= iP;
while(ii<=i){
if(IOVec[ii].d){
d= IOVec[ii].d;
j= IOVec[ii].id>>4;
if(j<d){
fprintf(fpT0,"  P=IOVec[%d].V;\n",ii);
while(j<d){
fprintf(fpT0,"  IOVec[%d].st[%d]=(char*)p%d_%d-P;\n",ii,j,ii,j);
j++;
}
}
}
ii++;
}
fputs("  return(0);\n",fpT0);
fputs("}\n",fpT0);

return(0);
}


/* :27 */
/* 28: */
#line 3059 "/u/zakharov/CB/cb2obj.web"

int CbWriteCCodeIOVecStep(int iIO,int iT)
{
int i,ii,j,jj,k,L,n,iN,ic,is,iP;
int nL,kV,nV;
int d,d0;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOVec*pV;

iN= iIO+3;
pS= IOSet[iN]+iT;
if(pS->n==0)
return(0);


kV= pS->kV;
nV= kV+pS->nV;
ic= 0;
for(i= kV;i<nV;i++){
if(IOVec[i].d){
d= IOVec[i].d;
j= IOVec[i].id>>4;
if(j<d){
ic= 1;
break;
}
}
}
if(ic==0){
return(0);
}

L= 0;
is= 0;
for(i= kV;i<nV;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"CbIOVecS%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"CbIOVecS%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
if(IOVec[i].d){
d= IOVec[i].d;
d0= IOVec[i].id>>4;
j= d0;
while(j<d){
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"&%s",IOVec[i].Nm);
L+= strlen(IOStr+L);
for(jj= d0;jj<d;jj++){
if(jj==j)
sprintf(IOStr+L,"[1]");
else
sprintf(IOStr+L,"[0]");
L+= 3;
}
ic++;
j++;
}
}
if(L>72){
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecStepRoutine(is,iP,i,iIO,iT,'c');
L= 0;
is++;
}
}
if(L){
i--;
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecStepRoutine(is,iP,i,iIO,iT,'c');
}

return(0);
}

/* :28 */
/* 29: */
#line 3151 "/u/zakharov/CB/cb2obj.web"

int CbWriteCCodeIOAddr(int iN,int iT)
{
int i,ii,j,k,L,n,iIO,ic,is,iP;
int nL,kP,nP,kV,nV;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOObj*pO;
CbIOVec*pV;

iIO= iN-3;
pS= IOSet[iN]+iT;

if(pS->n==0)
return(0);

fpT= fopen("csrc.c","w");
fpT0= fopen("cb.c","w");
if(fpT==NULL||fpT0==NULL){
printf("%s or %s can non be opened\n","csrc.c","cb.c");
exit(0);
}


kP= pS->kP;
nP= kP+pS->nP;
L= 0;
is= 0;
for(i= kP;i<nP;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"CbIOPar%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"CbIOPar%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"%s",NmPar[i]);
L+= strlen(IOStr+L);
ic++;
if(L>72){
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOParCRoutine(pS,is,iP,i,iIO,iT);
L= 0;
is++;
}
}
if(L){
i--;
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOParCRoutine(pS,is,iP,i,iIO,iT);
}


kV= pS->kV;
nV= kV+pS->nV;
L= 0;
is= 0;
for(i= kV;i<nV;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"CbIOVec%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"CbIOVec%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
if(ic){
*(IOStr+L)= ',';
L++;
}
if(IOVec[i].d){
sprintf(IOStr+L,"%s",IOVec[i].Nm);
}
else{
sprintf(IOStr+L,"&%s",IOVec[i].Nm);
}
L+= strlen(IOStr+L);
ic++;
if(L>72){
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecRoutine(is,iP,i,iIO,iT,'c');
L= 0;
is++;
}
}
if(L){
i--;
sprintf(IOStr+L,");\n");
fputs(IOStr,fpT);
CbWriteIOVecRoutine(is,iP,i,iIO,iT,'c');
}


CbWriteCCodeIOVecPnt(iIO,iT);


CbWriteCCodeIOVecStep(iIO,iT);
close(fpT);
close(fpT0);
return(0);
}

/* :29 */
/* 30: */
#line 3274 "/u/zakharov/CB/cb2obj.web"

int CbWriteIOParFRoutine(CbIOSet*pS,int is,int iP,int i,int iIO,int iT)
{
int j,k,L,ii,n;
char*p;
CbIOObj*pO;

if('a'+is<='z'){
sprintf(IOStr,"void iop%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"void iop%d_%d%c%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
ii= iP;
sprintf(IOStr+L,"p%d",ii);
L+= strlen(IOStr+L);
ii++;
while(ii<=i){
sprintf(IOStr+L,",p%d",ii);
L+= strlen(IOStr+L);
ii++;
}
sprintf(IOStr+L,")\n");
fputs(IOStr,fpT0);

n= pS->kS;
if(iP<n)
sprintf(IOStr,"  int ");
else
sprintf(IOStr,"  double ");
L= strlen(IOStr);
ii= iP;
sprintf(IOStr+L,"*p%d",ii);
L+= strlen(IOStr+L);
ii++;
while(ii<=i){
if(ii==n){
sprintf(IOStr+L,";\n  double ");
fputs(IOStr,fpT0);
L= 0;
}
if(L)
sprintf(IOStr+L,",*p%d",ii);
else
sprintf(IOStr+L,"*p%d",ii);
L+= strlen(IOStr+L);
ii++;
}
sprintf(IOStr+L,";\n{\n");
fputs(IOStr,fpT0);

ii= iP;
while(ii<=i){
k= pS->k;
n= k+pS->n;
for(j= k;j<n;j++){
pO= IOObj+j;
CbWriteIOLoopPar(pO->nL,ii,'f');
}
CbWriteIOSetPar(iIO,iT,ii,'f');
ii++;
}

ii= pS->kS;
k= pS->k;
n= k+pS->n;
while(ii<=i){
p= NmPar[ii];
for(j= k;j<n;j++){
pO= IOObj+j;
if(pO->pSc!=NULL&&strcmp(p,pO->pSc)==0){
fprintf(fpT0,"  IOObj[%d].Sc=*p%d;\n",j,ii);
}
}
ii++;
}
fputs("}\n",fpT0);
return(0);
}

/* :30 */
/* 31: */
#line 3360 "/u/zakharov/CB/cb2obj.web"

int CbWriteFCodeIOVecStep(int iIO,int iT)
{
int i,j,jj,k,L,L0,n,iN,ic,is,iP;
int nL,dL,kV,nV;
int d,d0;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOObj*pO;
CbIOVec*pV;

iN= iIO+3;
pS= IOSet[iN]+iT;
if(pS->n==0)
return(0);


kV= pS->kV;
nV= kV+pS->nV;
ic= 0;
for(i= kV;i<nV;i++){
if(IOVec[i].d){
d= IOVec[i].d;
j= IOVec[i].id>>4;
if(j<d){
ic= 1;
break;
}
}
}
if(ic==0){
return(0);
}
L= 0;
is= 0;
for(i= kV;i<nV;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"      call iov%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"      call iov%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
L0= L;
if(IOVec[i].d){
d= IOVec[i].d;
d0= IOVec[i].id>>4;
j= d0;
while(j<d){
if(ic){
*(IOStr+L)= ',';
L++;
}
sprintf(IOStr+L,"%s(",IOVec[i].Nm);
L+= strlen(IOStr+L);
for(jj= d-1;jj>=d0;jj--){
if(jj==j)
sprintf(IOStr+L,"2");
else
sprintf(IOStr+L,"1");
L++;
if(jj>d0){
sprintf(IOStr+L,",");
L++;
}
}
sprintf(IOStr+L,")");
L++;
ic++;
j++;
}
}
if(L>=72){
p= IOStr;
p1= p+L0;
while(p<p1){
fputc(*p,fpT);
p++;
}
fputs("\n     &",fpT);
while(*p!='\0'){
fputc(*p,fpT);
p++;
}
fputs(")\n",fpT);
CbWriteIOVecStepRoutine(is,iP,i,iIO,iT,'f');
L= 0;
is++;
}
}
if(L){
i--;
fputs(IOStr,fpT);
fputs(")\n",fpT);
CbWriteIOVecStepRoutine(is,iP,i,iIO,iT,'f');
}
return(0);
}

/* :31 */
/* 32: */
#line 3468 "/u/zakharov/CB/cb2obj.web"

int CbWriteFCodeIOAddr(int iN,int iT)
{
int i,ii,j,k,L,n,iIO,ic,is,iP;
int nL,kP,nP,dL,kV,nV;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOObj*pO;
CbIOVec*pV;

iIO= iN-3;
pS= IOSet[iN]+iT;
if(pS->n==0)
return(0);

fpT= fopen("csrc.f","w");
fpT0= fopen("cb.f","w");
if(fpT==NULL||fpT0==NULL){
printf("%s or %s can non be opened\n","csrc.f","cb.f");
exit(0);
}


kP= pS->kP;
nP= kP+pS->nP;
L= 0;
is= 0;
for(i= kP;i<nP;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"      call iop%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"      call iop%d_%d%c%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
if(ic){
sprintf(IOStr+L,",%s",NmPar[i]);
}
else{
sprintf(IOStr+L,"%s",NmPar[i]);
}

dL= strlen(IOStr+L);
ic++;
if(L+dL<72){
L+= dL;
dL= 0;
}
else{
p= IOStr;
p1= p+L;
while(p<p1){
fputc(*p,fpT);
p++;
}
fputs("\n     &",fpT);
while(*p!='\0'){
fputc(*p,fpT);
p++;
}
fputs(")\n",fpT);
CbWriteIOParFRoutine(pS,is,iP,i,iIO,iT);
L= 0;
dL= 0;
is++;
}
}
if(L){
i--;
fputs(IOStr,fpT);
fputs(")\n",fpT);
CbWriteIOParFRoutine(pS,is,iP,i,iIO,iT);
}


kV= pS->kV;
nV= kV+pS->nV;
L= 0;
is= 0;
for(i= kV;i<nV;i++){
if(L==0){
iP= i;
ic= 0;
if('a'+is<='z'){
sprintf(IOStr,"      call iov%d_%d%c(",iIO,iT,'a'+is);
}
else{
k= ('a'+is)/('z'-'a');
j= ('a'+is)%('z'-'a');
sprintf(IOStr,"      call iov%d_%d%c(",iIO,iT,'a'+k,'a'+j);
}
L= strlen(IOStr);
}
if(ic){
sprintf(IOStr+L,",%s",IOVec[i].Nm);
}
else{
sprintf(IOStr+L,"%s",IOVec[i].Nm);
}
dL= strlen(IOStr+L);
ic++;
if(L+dL<72){
L+= dL;
dL= 0;
}
else{
p= IOStr;
p1= p+L;
while(p<p1){
fputc(*p,fpT);
p++;
}
fputs("\n     &",fpT);
while(*p!='\0'){
fputc(*p,fpT);
p++;
}
fputs(")\n",fpT);
CbWriteIOVecRoutine(is,iP,i,iIO,iT,'f');
L= 0;
is++;
}
}
if(L){
i--;
fputs(IOStr,fpT);
fputs(")\n",fpT);
CbWriteIOVecRoutine(is,iP,i,iIO,iT,'f');
}


CbWriteFCodeIOVecStep(iIO,iT);

close(fpT);
close(fpT0);
return(0);
}

/* :32 */
/* 33: */
#line 3615 "/u/zakharov/CB/cb2obj.web"

int CbInitIOLoop(int kL)
{
int i,n,iL;
int i0,i1,i2,N;
CbIOLoop*pL;

pL= IOLoop+kL;
n= pL->n;
if(pL->NmI!=NULL){
i0= pL->i0;
i1= pL->i1;
i2= (i1-1-i0)/pL->st+1;
if(i0<i1){
N= pL->nV;
iL= 0;
n= pL->nL;
while(iL<n){
i= pL->kL[iL];
CbInitIOLoop(i);
N+= IOLoop[i].N;
iL++;
}
N*= i2;
}
else{
N= 0;
}
}
else{
N= pL->nV;
iL= 0;
n= pL->nL;
while(iL<n){
i= pL->kL[iL];
CbInitIOLoop(i);
N+= IOLoop[i].N;
iL++;
}
}
pL->N= N;
return(0);
}

/* :33 */
/* 34: */
#line 3662 "/u/zakharov/CB/cb2obj.web"

int CbIOLoop2HD0(int kL,int i0L,int i1L)
{
int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
int i0,i1,i2,I;
int*fV,*vP;
char*p;
CbIOLoop*pL;
CbIOVec*pV;

if(ILc>=i1L)
return(0);
pL= IOLoop+kL;
dL= pL->d;
n= pL->n;

I= pL->i0;
StackI[dL]= I;
i1= pL->i1;
if(I>=i1||ILc>=i1L)
return(0);
i2= pL->st;

i= 0;
iL= 0;
iV= 0;
n= pL->nV;
while(iV<n){
kV= pL->kV[iV];
pV= IOVec+kV;
d= pV->d;
if(d){
stV= 0;
i0= 0;
fV= pL->fV[iV];
vP= pL->iV[iV];
while(d>0){
d--;
st= pV->st[d];
if(fV[d]<0){
i0+= st*vP[d];
}
else{
i0+= st*StackI[fV[d]];
if(fV[d]==dL){
stV+= st;
}
}
}
pL->i0V[iV]= i0;
pL->stV[iV]= stV;
}
else{
pL->i0V[iV]= 0;
pL->stV[iV]= 0;
}
iV++;
}
if(ILc<i0L){
i= (i1-1-I)/i2+1;
n= pL->N/i;
if(ILc+pL->N<i0L){
k= i;
ILc+= n*k;
if(ILc>=i1L)
return(0);
I+= k*i2;
StackI[dL]= I;
iV= 0;
n= pL->nV;
while(iV<n){
pL->i0V[iV]+= k*pL->stV[iV];
iV++;
}
return(0);
}
else{
k= (i0L-ILc)/n;
ILc+= n*k;
if(ILc>=i1L)
return(0);
I+= k*i2;
StackI[dL]= I;
iV= 0;
n= pL->nV;
while(iV<n){
pL->i0V[iV]+= k*pL->stV[iV];
iV++;
}
}
}
n= pL->n;
while(I<i1){
i= 0;
iL= 0;
iV= 0;
while(i<n){
if(pL->t[i]==8){
CbIOLoop2HD(pL->kL[iL],i0L,i1L);
iL++;
}
else{
if(ILc>=i0L){
kV= pL->kV[iV];
pV= IOVec+kV;
p= pV->V+pL->i0V[iV];
id= pV->id&7;
switch(id){
case 0:
printf("%<%s>;\n",p);
break;
case 1:
printf("%10.3e;\n",*(double*)p);
break;
case 2:
printf("%d;\n",*(int*)p);
break;
case 3:
printf("%10.3e;\n",*(float*)p);
break;
case 4:
printf("%ld;\n",*(long*)p);
break;
case 5:
printf("<%s>;\n",p);
break;
}
}
pL->i0V[iV]+= pL->stV[iV];
iV++;
ILc++;
}
if(ILc>=i1L)
return(0);
i++;
}
I+= i2;
StackI[dL]= I;
}
return(0);
}

/* :34 */
/* 35: */
#line 3807 "/u/zakharov/CB/cb2obj.web"

int CbIOObj2HD(int kO,int i0,int i1)
{
int kL;

if(i0>=i1)
return(0);
kL= IOObj[kO].nL;
CbInitIOLoop(kL);
ILc= 0;
CbIOLoop2HD(kL,i0,i1);
return(0);
}

/* :35 */
/* 36: */
#line 3824 "/u/zakharov/CB/cb2obj.web"

int CbIOSet2HD(int iIO,int iT)
{
int i,k,n,iN;
int nL;
char*p,*p1,*p2,*p0;
CbIOSet*pS;
CbIOObj*pO;
CbIOVec*pV;

iN= iIO+3;
pS= IOSet[iN]+iT;
if(pS->N==0)
return(0);

n= pS->N;
for(i= 0;i<n;i++){
CbIOObj2HD(pS->kO[i],pS->i0[i],pS->i1[i]);
}

return(0);
}

/* :36 */
/* 37: */
#line 3850 "/u/zakharov/CB/cb2obj.web"

static int dLd,IL[10],iO[10],nO[10],iVO[10],iLO[10];
static CbIOLoop*pLd[10];

int CbIOLoop2HD(int kL,int i0L,int i1L)
{
int i,iL,iV,id,d,d0,dL,st,stV,n,k,kV;
int i0;
int*fV,*vP;
char*p;
CbIOLoop*pL;
CbIOVec*pV;

if(ILc>=i1L)
return(0);
ILc= 0;
dLd= 0;


pLd[dLd]= IOLoop+kL;
IL[dLd]= pLd[dLd]->i0;
if(IL[dLd]>=pLd[dLd]->i1)
return(0);
iO[dLd]= 0;
iVO[dLd]= 0;
iLO[dLd]= 0;
nO[dLd]= pLd[dLd]->n;


pL= pLd[dLd];
i= 0;
iV= 0;
n= pL->nV;
while(iV<n){
kV= pL->kV[iV];
pV= IOVec+kV;
d= pV->d;
if(d){
stV= 0;
i0= 0;
fV= pL->fV[iV];
vP= pL->iV[iV];
while(d>0){
d--;
st= pV->st[d];
if(fV[d]<0){
i0+= st*vP[d];
}
else{
i0+= st*IL[fV[d]];
if(fV[d]==dLd){
stV+= st;
}
}
}
pL->i0V[iV]= i0;
pL->stV[iV]= stV;
}
else{
pL->i0V[iV]= 0;
pL->stV[iV]= 0;
}
iV++;
}


while(ILc<i1L){
if(pLd[dLd]->t[iO[dLd]]==8){
pL= IOLoop+pLd[dLd]->kL[iLO[dLd]];


dLd++;
pLd[dLd]= pL;
IL[dLd]= pLd[dLd]->i0;
iO[dLd]= 0;
iVO[dLd]= 0;
iLO[dLd]= 0;
nO[dLd]= pLd[dLd]->n;


pL= pLd[dLd];
i= 0;
iV= 0;
n= pL->nV;
while(iV<n){
kV= pL->kV[iV];
pV= IOVec+kV;
d= pV->d;
if(d){
stV= 0;
i0= 0;
fV= pL->fV[iV];
vP= pL->iV[iV];
while(d>0){
d--;
st= pV->st[d];
if(fV[d]<0){
i0+= st*vP[d];
}
else{
i0+= st*IL[fV[d]];
if(fV[d]==dLd){
stV+= st;
}
}
}
pL->i0V[iV]= i0;
pL->stV[iV]= stV;
}
else{
pL->i0V[iV]= 0;
pL->stV[iV]= 0;
}
iV++;
}
}
if(pLd[dLd]->t[iO[dLd]]!=8){
iV= iVO[dLd];
if(ILc>=i0L){
kV= pLd[dLd]->kV[iV];
pV= IOVec+kV;
p= pV->V+pLd[dLd]->i0V[iV];
id= pV->id&7;
switch(id){
case 0:
printf("%<%s>;\n",p);
break;
case 1:
printf("%10.3e;\n",*(double*)p);
break;
case 2:
printf("%d;\n",*(int*)p);
break;
case 3:
printf("%10.3e;\n",*(float*)p);
break;
case 4:
printf("%ld;\n",*(long*)p);
break;
case 5:
printf("<%s>;\n",p);
break;
}
}
pLd[dLd]->i0V[iV]+= pLd[dLd]->stV[iV];
iVO[dLd]++;
iO[dLd]++;
}
while(iO[dLd]>=nO[dLd]){
IL[dLd]+= pLd[dLd]->st;
iO[dLd]= 0;
iVO[dLd]= 0;
iLO[dLd]= 0;
if(IL[dLd]>=pLd[dLd]->i1){
dLd--;
if(dLd<0){
break;
}
else{
iLO[dLd]++;
iO[dLd]++;
}
}
}
if(dLd<0){
break;
}
ILc++;
}
return(0);
}

/* :37 */
/* 38: */
#line 4025 "/u/zakharov/CB/cb2obj.web"

int CbPltSetOpt(CbPltSet*pS,int N,char*NmFile,char*pF,char*str)
{
int k,n;
char*p,*p1,ch;
char Opt[3]= {'c','f','s'};
static int nOpt= 3,iOpt;

p= str;
if(*p=='(')
p++;
while(*p!=')'&&*p!='\0'){
while(isspace(*p))
p++;
for(iOpt= 0;iOpt<nOpt;iOpt++){
if(*p==Opt[iOpt]){
break;
}
}
if(iOpt==nOpt){
printf("%s file: wrong option name '%c' inside option of %s:\n\n",
NmFile,*p,pF);
return(-1);
}
p++;
while(isspace(*p))
p++;
if(*p!='='){
printf("%s file: no '=' after option '%c' inside option of %s:\n\n",
NmFile,ch,pF);
return(-1);
}
p++;
while(isspace(*p))
p++;
p1= p;
if(CbIsInteger(&k,p1)){
p+= k;
while(isspace(*p))
p++;
if(*p!=','&&*p!=')'){
printf("%s file: wrong number after '=' inside option of %s:\n\n",
NmFile,pF);
return(-1);
}
ch= *p;
*p= '\0';
sscanf(p1,"%d",&k);
switch(iOpt){
case 0:
pS->c[N]= k;
pS->pc[N]= -1;
break;
case 1:
pS->f[N]= k;
pS->pf[N]= -1;
break;
case 2:
pS->s[N]= k;
pS->ps[N]= -1;
break;
}
*p= ch;
}
else{
p++;
while(isalnum(*p)||*p=='_')
p++;
while(isspace(*p))
p++;
if(*p!=','&&*p!=')'){
printf("%s file: wrong varible name after '=' inside option of %s:\n\n",
NmFile,pF);
return(-1);
}
ch= *p;
*p= '\0';
k= CbAdd2IOParList(pS->kP,p1);
switch(iOpt){
case 0:
pS->pc[N]= k;
break;
case 1:
pS->pf[N]= k;
break;
case 2:
pS->ps[N]= k;
break;
}
*p= ch;
}
if(*p==')')
break;
p++;
}
if(*p!=')'){
printf("%s file: no ')' at the end of options of %s:\n\n",NmFile,pF);
return(-1);
}
p++;
while(isspace(*p))
p++;
if(*p!=';'){
printf("%s file: no ';' after options of %s:\n\n",NmFile,pF);
return(-1);
}

n= p-str;
return(n);
}

/* :38 */
/* 39: */
#line 4139 "/u/zakharov/CB/cb2obj.web"

int CbCheckPltFuncPar(char*p,char*NmFile,char*pF)
{
while(isspace(*p))
p++;
if(*p!='('){
printf("%s file: wrong character after %s in Plt function:\n\n",
NmFile,pF);
return(1);
}
p++;
while(*p!=')'&&*p!=';'&&*p!='\0'){
p++;
}
if(*p!=')'){
printf("%s file: no ')' in Plt function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(*p!='('&&*p!=';'&&*p!='\0'){
p++;
}
if(*p=='('){
while(*p!=')'&&*p!=';'&&*p!='\0'){
p++;
}
if(*p!=')'){
printf("%s file: no ')' in option parameters in Plt function %s:\n\n",
NmFile,pF);
return(1);
}
while(*p!=';'&&*p!='\0'){
p++;
}
}
if(*p!=';'){
printf("%s file: no ';' after %s() in Plt function:\n\n",
NmFile,pF);
return(1);
}
return(0);
}

int CbGetPltFuncPar(CbPltSet*pS,int N,char*p,char*NmFile,char*pF)
{
char*p1,ch;
int i,k,n;

pS->i0[N]= 0;
pS->ki0[N]= -1;
pS->i1[N]= (unsigned)(-1)>>1;
pS->ki1[N]= -1;

while(*p!='(')
p++;
p++;
while(isspace(*p))
p++;
p1= p;
while(*p!=','&&*p!='='&&*p!=')'&&*p!='\0')
p++;
if(*p!=','){
printf("%s file: no ',' after first object inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
k= pS->k;
n= pS->n;
for(i= k;i<n;i++){
if(CbStrCmp(p1,IOObj[i].NmE)==0){
pS->kXO[N]= i;
break;
}
}
if(i==n){
printf("%s file: wrong object name \"%s\" inside Plt function %s:\n\n",
NmFile,p1,pF);
return(1);
}
*p= ',';
p++;
while(isspace(*p))
p++;
p1= p;
while(*p!=','&&*p!='='&&*p!=')'&&*p!='\0')
p++;
if(*p!=','&&*p!=')'){
printf("%s file: no ') or second ',' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
ch= *p;
*p= '\0';
k= pS->k;
n= pS->n;
for(i= k;i<n;i++){
if(CbStrCmp(p1,IOObj[i].NmE)==0){
pS->kYO[N]= i;
break;
}
}
if(i==n){
printf("%s file: wrong object name \"%s\" inside Plt function %s:\n\n",
NmFile,p1,pF);
return(1);
}
*p= ch;
if(*p!=')'){
if(*p!=','){
printf("%s file: no ',' after object name inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(isalnum(*p)||*p=='_')
p++;
if(*p!='='){
printf("%s file: no '=' after ',' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
p++;
while(isspace(*p))
p++;
p1= p;
if(isdigit(*p1)){
p++;
while(isdigit(*p))
p++;
while(isspace(*p))
p++;
if(*p!='<'&&*p!=')'){
printf("%s file: wrong number after  '=' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
ch= *p;
*p= '\0';
sscanf(p1,"%d",&i);
pS->i0[N]= i;
pS->ki0[N]= -1;
*p= ch;
}
else{
p++;
while(isalnum(*p)||*p=='_')
p++;
while(isspace(*p))
p++;
if(*p!='<'&&*p!=')'){
printf("%s file: wrong variable after '=' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
ch= *p;
*p= '\0';
i= CbAdd2IOParList(pS->kP,p1);
pS->ki0[N]= i;
*p= ch;
}
if(*p=='<'){
p++;
while(isspace(*p))
p++;
p1= p;
if(isdigit(*p1)){
p++;
while(isdigit(*p))
p++;
while(isspace(*p))
p++;
if(*p!=')'){
printf("%s file: wrong number after '<' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
sscanf(p1,"%d",&i);
pS->i1[N]= i;
pS->ki1[N]= -1;
*p= ')';
}
else{
p++;
while(isalnum(*p)||*p=='_')
p++;
while(isspace(*p))
p++;
if(*p!=')'){
printf("%s file: wrong name after '<' inside Plt function %s:\n\n",
NmFile,pF);
return(1);
}
*p= '\0';
i= CbAdd2IOParList(pS->kP,p1);
pS->ki1[N]= i;
*p= ')';
}
}
}
p++;
while(isspace(*p))
p++;
if(*p=='('){
i= CbPltSetOpt(pS,N,NmFile,pF,p);
if(i<0){
printf("%s file: wrong option description in %s:\n\n",NmFile,pF);
return(1);
}
p+= i;
}

if(*p!=';'){
printf("%s file: no ';' after %s() in Plt function:\n\n",
NmFile,pF);
return(1);
}
return(0);
}

/* :39 */
/* 40: */
#line 4364 "/u/zakharov/CB/cb2obj.web"

int CbCmpIOObj(int k1,int k2)
{
int i,nU;

char*CW[10]= {"str","dbl","int","flt","lng","fch","Dbl","Int","Flt","Lng"};
CbIOObj*pO1,*pO2;


if(k1<0||k2<0||k1>nIOObj||k2>nIOObj)
return(-1);

if(nIOObj==0)
return(1);

if(k1==k2){
return(0);
}

pO1= IOObj+k1;
pO2= IOObj+k2;

if(strcmp(pO1->NmE,pO2->NmE)){
return(1);
}
if(pO1->id!=pO2->id){
printf("Non-matching types in Plt object \"%s\": (%s) != (%s)\n",
pO1->NmE,CW[pO1->id],CW[pO2->id]);
return(-1);
}
if(pO1->nU!=pO2->nU){
printf("Non-matching Sets of Units in Plt object \"%s\": (%s.) != (%s.)\n",
pO1->NmE,XUnits[pO1->nU].nmU,XUnits[pO2->nU].nmU);
return(-1);
}
nU= pO1->nU;
if(pO1->iU!=pO2->iU){
printf("Non-matching Units in Plt object \"%s\": (%s.%s) != (%s.%s)\n",
pO1->NmE,XUnits[nU].nmU,XUnits[nU].U[pO1->iU],
XUnits[nU].nmU,XUnits[nU].U[pO2->iU]);
return(-1);
}

if(pO1->pSc==NULL){
if(pO2->pSc==NULL){
if(pO1->Sc!=pO2->Sc){
printf("Non-matching Scale-factors in Plt object %s: *%g != *%g\n"
,pO1->NmE,pO1->Sc,pO2->Sc);
return(-1);
}
}
else{
printf("Non-matching Scale-factors in Plt object \"%s\": *%g != *%s\n"
,pO1->NmE,pO1->Sc,pO2->pSc);
return(-1);
}
}
else{
if(pO2->pSc==NULL){
if(pO1->Sc!=pO2->Sc){
printf("Non-matching Scale-factors in Plt object %s: *%s != *%g\n"
,pO1->NmE,pO1->pSc,pO2->Sc);
return(-1);
}
}
else{
if(strcmp(pO1->pSc,pO2->pSc)){
printf("Non-matching Scale-factors in Plt object \"%s\": *%s != *%s\n"
,pO1->NmE,pO1->pSc,pO2->pSc);
return(-1);
}
}
}

if(CbCmpIOLoop(pO1->nL,pO2->nL)){
printf("Non-matching Structure of 2 images of Plt object \"%s\"\n",
pO1->NmE);
return(-1);
}

return(0);
}

/* :40 */
/* 41: */
#line 4450 "/u/zakharov/CB/cb2obj.web"

int CbInitPltObj(int*iO,int kP,int kV,int n0,char*str,char*NmFile)
{
char*p0,*p,*p1,*p2;
int i,L,iN;
CbIOObj*pO;

iN= 2;
pO= IOObj+nIOObj;
p= str;
p0= p;
p++;
while(isspace(*p))
p++;
p1= p;
while(*p!='"'&&*p!='='&&*p!=';'&&*p!='}'){
p++;
}
if(*p!='"'){
printf("%s file: no second '\"' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
L= p-p1;
if(L){
p--;
while(isspace(*p))
p--;
p++;
}
else{
printf("%s file: External name of object is absent\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
L= p-p1;
pO->NmE= (char*)malloc(L*sizeof(char));
p2= pO->NmE;
while(p1<p){
*p2++= *p1++;
}
*p2= '\0';
while(*p!='"'){
p++;
}
p2= pO->NmE;

printf("????? p2=<%s> %d %d\n",p2,n0,nIOObj);

for(i= n0;i<nIOObj;i++){
printf("????? IOObj[%d].NmE=<%s> <%s>\n",i,IOObj[i].NmE,p2);
if(CbStrCmp(p2,IOObj[i].NmE)==0){
break;
}
}
*iO= i;
if(i<nIOObj){
p1= p+1;
while(isspace(*p1))
p1++;
printf("????? *p1=%c\n",*p1);

if(*p1==';'){
L= p1-str;
return(L);
}
}
p++;
while(isspace(*p))
p++;
if(*p!='('){
pO->nU= -1;
pO->iU= 0;
}
else{
p++;
p1= p;
while(*p!=')'&&*p!='='&&*p!='"'&&*p!=';'&&*p!='}'){
p++;
}
if(*p!=')'){
printf("%s file: no second ')' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
*p= '\0';
if(CbGetUnits(&(pO->nU),&(pO->iU),p1)){
printf("%s file: wrong Units description in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
*p= ')';
p++;
while(isspace(*p))
p++;
}
if(*p!='='){
printf("%s file: no '=' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p++;
while(isspace(*p))
p++;
if(*p!='('){
printf("%s file: no '(' after '=' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p++;
p1= p;
while(*p!=')'&&*p!='"'&&*p!=';'&&*p!='}'){
p++;
}
if(*p!=')'){
printf("%s file: no ')' after '=(' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
*p= '\0';
if(CbGetType(&i,&(pO->id),p1)){
printf("%s file: wrong Type  in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
pO->id&= 7;
*p= ')';
p++;
while(isspace(*p))
p++;
if(*p!='"'){
printf("%s file: no third '\"' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p++;
p1= p;
L= 0;
while(*p!='"'&&*p!=';'&&*p!='}'){
if(isspace(*p)==0)
L++;
p++;
}
if(*p!='"'){
printf("%s file: no fourth '\"' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
if(L==0){
printf("%s file: object is absent\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}

if(L>NIOStr){
NIOStr+= NIOStr-L+132;
free(IOStr);
IOStr= (char*)malloc(NIOStr*sizeof(char));
}
p= p1;
p2= IOStr;
while(*p!='"'){
if(isspace(*p)==0){
*p2++= *p;
}
p++;
}
*p2= '\0';
pO->nL= nLoop;
IOLoop[nLoop].pL= -1;
if(CbStr2IOLoop(kP,kV,pO->id,IOStr)){
printf("%s file: wrong object\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p++;
while(isspace(*p))
p++;
if(*p=='*'){
p++;
while(isspace(*p))
p++;
p1= p;
p2= IOStr;
while(*p!=';'&&isspace(*p)==0&&*p!='}'){
*p2++= *p++;
}
*p2= '\0';
L= p2-IOStr;
i= CbCheckIfCNumber(IOStr);
if(i<0){
pO->pSc= (char*)malloc(L*sizeof(char));
strcpy(pO->pSc,IOStr);
pO->Sc= 1.;
}
else{
p2= IOStr+i;
if(*p2!='\0'){
printf("%s file: wrong Scale factor in Plt object\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
pO->pSc= NULL;
sscanf(IOStr,"%lg",&(pO->Sc));
}
while(isspace(*p))
p++;
}
if(*p!=';'){
printf("%s file: no  ';' at the end of Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}

if(*iO<nIOObj){
i= CbCmpIOObj(*iO,nIOObj);
}
else{
i= 1;
}

printf("??? <%s> nIOObj=%d *iO=%d i=%d\n",pO->NmE,nIOObj,*iO,i);

if(i==0){
free(pO->NmE);
}
else{
if(i>0){
nIOObj++;
if(nIOObj>=NIOObj){
NIOObj+= 50;
IOObj= (CbIOObj*)realloc((void*)IOObj,NIOObj*sizeof(CbIOObj));
}
}
else{
printf("%s file: Non-matching Plt object\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
free(pO->NmE);
return(-1);
}
}
L= p-str;
return(L);
}

/* :41 */
/* 42: */
#line 4713 "/u/zakharov/CB/cb2obj.web"

int CbAddIOGrp(int nG,char*NmFile)
{
int i,j;
CbIOGrp*pG1,*pG;

pG= IOGrp+nGrp;
for(i= nG;i<nGrp;i++){
pG1= IOGrp+i;
if(strcmp(pG1->Nm,pG->Nm)==0){
free(pG->Nm);
free(pG->kO);
printf("%s file: Double defined Plt objects or groups\n\n",NmFile);
return(-1);
}
}
nGrp++;
if(nGrp>=NGrp){
NGrp+= 50;
IOGrp= (CbIOGrp*)realloc((void*)IOGrp,NGrp*sizeof(CbIOGrp));
}
return(0);
}

/* :42 */
/* 43: */
#line 4740 "/u/zakharov/CB/cb2obj.web"

int CbAdd2PltGrpList(CbIOGrp*pG,int kP,int kV,int n0,int nG,
char*str,char*NmFile)
{
char*p,*p1,*p2;
int i,L,iO,iN,nO,nM,ic;
CbIOObj*pO;

iN= 2;
p= str;
ic= 0;

nO= 0;
nM= 0;
while(*p!='\0'){
while(isspace(*p))
p++;
printf("??? *p=%c\n",*p);
switch(*p){
case '{':
ic++;
break;
case '"':
L= CbInitPltObj(kGO+nO,kP,kV,n0,p,NmFile);
if(L<0)
return(-1);
p+= L;
nO++;
break;
case '}':
ic--;
break;
default:
break;
}
if(ic<=0)
break;
p++;
}

printf("??? nO=%d\n",nO);
pG->nO= nO;
pG->kO= (int*)malloc(nO*sizeof(int));
L= 0;
for(i= 0;i<nO;i++){
pG->kO[i]= kGO[i];
pO= IOObj+kGO[i];
L+= strlen(pO->NmE)+1;
}
pG->Nm= (char*)malloc(L*sizeof(char));
p2= pG->Nm;
L= 0;
for(i= 0;i<nO;i++){
pO= IOObj+kGO[i];
p1= pO->NmE;
if(L){
*p2= '.';
}
while(*p1!='\0'){
*p2++= *p1++;
}
*p2= '\0';
L++;
}
if(CbAddIOGrp(nG,NmFile))
return(-1);
L= p-str;
return(L);
}

/* :43 */
/* 44: */
#line 4813 "/u/zakharov/CB/cb2obj.web"

int CbInitPltSet(char*NmFile,int iT)
{
int i,ic,L,iN,N,Lf;
char*p,*p1,*p2,*p0;
char*pF;
CbPltSet*pS;
CbIOObj*pO;
CbIOGrp*pG;

iN= 2;

pS= PltSet+iT;
pF= CbIOFunc[2];

Lf= strlen(pF);
pS->kG= nGrp;
pS->k= nIOObj;
pS->kP= nPar;
pS->kV= nIOVec;

p= BuffIO[iN];
N= 0;
while(*p!='{')
p++;
p++;
ic= 1;
while(ic&&*p!='\0'){
pG= IOGrp+nGrp;
while(isspace(*p))
p++;
p0= p;

switch(*p){
case '{':
ic++;
case '"':
L= CbAdd2PltGrpList(pG,pS->kP,pS->kV,pS->k,pS->kG,p,NmFile);
if(L<0){
printf("%s file: wrong Plt object in the line:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p+= L;
if(*p==';')
break;
case '}':
ic--;
break;
default:
p0= p;
if(strncmp(pF,p,Lf)==0){
p+= Lf;
if(CbCheckIOFuncPar(p,NmFile,pF)){
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
p++;
while(*p!=';'&&*p!='\0')
p++;
if(*p!=';'){
printf("%s file: no  ';' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
N++;
}
else{
printf("%s file: no first '\"' in Plt object:\n\n",NmFile);
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
break;
}
p++;
}

pS->n= nIOObj-pS->k;
pS->N= N;
pS->kXO= (int*)malloc(12*N*sizeof(int));
pS->kYO= pS->kXO+N;
pS->i0= pS->kYO+N;
pS->i1= pS->i0+N;
pS->ki0= pS->i1+N;
pS->ki1= pS->ki0+N;
pS->c= pS->ki1+N;
pS->f= pS->c+N;
pS->s= pS->f+N;
pS->pc= pS->s+N;
pS->pf= pS->pc+N;
pS->ps= pS->pf+N;

for(i= 0;i<N;i++){
pS->kXO[i]= -1;
pS->kYO[i]= -1;
pS->i0[i]= 0;
pS->i1[i]= 0;
pS->ki0[i]= -1;
pS->ki1[i]= -1;
pS->c[i]= 0;
pS->f[i]= 0;
pS->s[i]= 1;
pS->pc[i]= -1;
pS->pf[i]= -1;
pS->ps[i]= -1;
}

p= BuffIO[iN];
N= 0;
while(*p!='{')
p++;
p++;
while(*p!='}'){
while(isspace(*p))
p++;
if(*p=='}')
break;
if(*p!='"'){
if(strncmp(pF,p,Lf)==0){
p+= Lf;
if(CbGetPltFuncPar(pS,N,p,NmFile,pF)){
PPrintLine(p0,p);
printf("\n in Section <%s>%c\n",BuffIO[iN],7);
return(-1);
}
N++;
}
p++;
while(*p!=';'&&*p!='\0')
p++;
}
else{
p++;
while(*p!=';'&&*p!='\0')
p++;
}
p++;
}

pS->kS= nPar;
for(i= pS->k;i<nIOObj;i++){
pO= IOObj+i;
if(pO->pSc!=NULL){
CbAdd2IOParList(pS->kP,pO->pSc);
}
}

pS->nP= nPar-pS->kP;
pS->nV= nIOVec-pS->kV;
return(0);
}

int CbDeInitPltSet()
{
int i;

for(i= 0;i<nTbl;i++){
if(PltSet[i].N){
free(PltSet[i].kXO);
}
}
free(PltSet);

for(i= 0;i<nGrp;i++){
if(IOGrp[i].Nm!=NULL){
free(IOGrp[i].Nm);
}
}
free(IOGrp);
return(0);
}

/* :44 */

