#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifndef mzl_Doc
typedef struct CMMNT{
int t; /* Type of the Comment block */
int kID;  /* nCNmID */
int kCB;  /* nCBTkn */
int k0; /* Starting line # in the file */
int k1; /* End line # in the file */
char *b; /* pointer to beginning of Comment block*/
char *e; /* pointer to end of Comment block*/
}CMMNT;
extern struct tm *pTm;
extern int nHLWrd;
extern int nCMMnt;
extern int iCMMnt;
extern CMMNT *CMMnt;
#endif

#ifndef mzl_FILES
extern char NmSF[];
extern int iFLn;
extern char *Cln;
extern char *FBff;
extern int nFBff;
extern long int *pFLn;
extern int *fFLn;
extern int LCln;
extern char NmF[];
extern int kLnFL;
#endif

#ifndef mzl_PRP
extern char Cword[];
#endif

#ifndef mzl_CB
typedef struct ResWord{
  int L;
  char *p;
}ResWord;
typedef struct CBTKN{
  int L; /* Flag */
  int d; /* depth */
  int t; /* CbType */
  int f; /* File number */
  int k0; /* Starting line # in the file */
  int k1; /* End line # in the file */
  int kTxt; /* Doc Comment */
  int kCMM; /* C Comment */
  int kPg;  /* PS Page */
  int i0; /* Starting Global ID */
  int i1; /* Ending Global ID */
  int j0; /* Starting Global Used ID */
  int j1; /* Ending Global Used ID */
  char *Nm; /* pointer to Name*/
}CBTKN;
extern CBTKN *CBTkn;		/*                .mzl_CB:c2ps.c */
extern ResWord CbCResW[];	/*                .mzl_CB:c2ps.c */
#endif

#ifndef mzl_C
typedef struct CNMID{
  int d;
  int t;
  int n;
  int L;
  int ID;
  int k;
  int kTxt;
  int kCMM;
  int kPg;
  char *p;
}CNMID;
extern CNMID *CNmID;		/*                 .mzl_C:c2ps.c */
#endif

#ifndef mzl_PS
int LndPrt=0,*fPSPg,NPSPg=0,nPSPg=-1;
static FILE *fpP;
static char NmPF[81];
static int PaperW=612,PaperH=792,PX,PY,dPY,FxL,FxL1,FxR,FxR1,FyL,FyU;
static int PShP,PSwP;
static int FlPSPg;
static int hF=7,hBrd,wBrd,iPX,PageN,nLnPg,NChX=80,fClm[80],fClm1[80];
static int FlFnt,iTab;
static char *BffPg,*pBff,**pLn;
static int *fLn,NLn,iLn;
static int iHLWrd,NHLWrd=0;
static CMMNT *HLWrd;

static int PSNLn=0;
int CbDocReInitBffP()
{
  int i;

  if(PSNLn < NLn){
    if(PSNLn){
      pLn=(char **)realloc((void*)pLn,(size_t)NLn*sizeof(char*));
      fLn=(int*)realloc((void*)fLn,(size_t)NLn*sizeof(int));
      i=3*NLn*(NChX+1)+1;
      BffPg=(char*)realloc((void*)BffPg,(size_t)i*sizeof(char));
    }
    else{
      pLn=(char **)malloc((size_t)NLn*sizeof(char*));
      fLn=(int*)malloc((size_t)NLn*sizeof(int));
      BffPg=(char *)malloc((size_t)(3*NLn*(NChX+1)+1)*sizeof(char));
    }
  }
  if(pLn == NULL || fLn == NULL || BffPg == NULL){
    printf("No memory for %d pLn's || fLn || %d BffPg's %c\n"
	   ,NLn,3*NLn*(NChX+1)+1,7);
    exit(0);
  }
  for(i=0; i < NLn; i++)
    fLn[i]=0;
  PSNLn=NLn;
  return(0);
}

int CbDocDeInitBffP()
{
  free(BffPg);
  free(fLn);
  free(pLn);
  PSNLn=0;
  return(0);
}

int CbDocWritePsHead()
{
  fputs("%!PS-Adobe-2.0\n\
/Lshow {exch dup scale show dup scale}def\n\
/Rshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll mul neg 0 rmoveto\n\
dup scale show dup scale}def\n\
/Mshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll -0.5 mul mul 0 rmoveto\n\
dup scale show dup scale}def\n",fpP);
  fputs("/fntWH 2 array def\n",fpP);
  return(0);
}

int CbDocPageTitlePS()
{
  fputs("0.7 setgray 30 setlinewidth newpath 36 -36 moveto 72 0 rlineto\n"
	,fpP);
  fprintf(fpP,"%d %d moveto 72 0 rlineto\n",PSwP-108,-36);
  fprintf(fpP,"36 %d moveto 108 0 rlineto stroke\n",-PShP+36);
  fputs("1 setgray /Helvetica-Bold findfont 24 scalefont setfont\n",fpP);
  fprintf(fpP,"%d -44 moveto (%d)stringwidth\n",PSwP-72,PageN/(LndPrt+1)+1);
  fprintf(fpP,"pop 2 div neg 0 rmoveto (%d)show\n",PageN/(LndPrt+1)+1);
  
  fputs("/Times-Bold findfont 9 scalefont setfont 0 setgray\n",fpP);
  fprintf(fpP,"55 -34 moveto (%2.2d/%2.2d/%2.2d)show\n"
	  ,pTm->tm_mon,pTm->tm_mday,pTm->tm_year);
  fprintf(fpP,"55 -44 moveto (%2.2d:%2.2d:%2.2d)show\n"
	  ,pTm->tm_hour,pTm->tm_min,pTm->tm_sec);
  fprintf(fpP,"50 %d moveto (Cb Research UFcode)show\n",-PShP+38);
  fprintf(fpP,"50 %d moveto (Documenting system)show\n",-PShP+28);
  
  fputs("/Courier-Bold findfont 9 scalefont setfont 0.3 setlinewidth\n",fpP);
  fprintf(fpP,"%d -44 moveto (%s)stringwidth\n",PSwP/2,NmSF);
  fprintf(fpP,"pop 2 div neg 0 rmoveto (%s)show\n",NmSF);
  fprintf(fpP,"%d %d moveto (%s)stringwidth\n",PSwP/2,-PShP+38,NmPF);
  fprintf(fpP,"pop 2 div neg 0 rmoveto (%s)show\n",NmPF);

  FlFnt = 0;
  fprintf(fpP,"/Courier findfont %d scalefont setfont\n",hF);
  fprintf(fpP,"(- page %d -) stringwidth pop 2 div sub %d moveto\n"
	  ,PageN+1,PY-dPY);
  fprintf(fpP,"(- page %d -)show\n",PageN+1);
  return(0);
}

int CbDocSetPSBckGrColor(int iCbC)
{
  switch(iCbC){
  case 0:
    fprintf(fpP,"1 0.4 0.4");
    break;
  case 1:
    fprintf(fpP,"0.6 1 0.6");
    break;
  case 2:
    fprintf(fpP,"0.7 0.7 1");
    break;
  case 3:
    fprintf(fpP,"0.85 0.85 1");
    break;
  case 4:
  case 5:
  case 6:
  case 8:
    fprintf(fpP,"0.9 0.9 1");
    break;
  case 7:
    fprintf(fpP,"1 0.7 0.7");
    break;
  default :
    fprintf(fpP,"0.7 1 0.7");
    break;
  }
  fputs(" setrgbcolor\n",fpP);
  return(0);
}

int CbDocUnSetPSBckGrColor()
{
  fputs("0 0 0 setrgbcolor\n",fpP);
  return(0);
}

int CbDocPSVBrd(int Ind,int jLn,int kLn,int iCb,int Fl)
{
  int i,W,L,sh;

  CbDocSetPSBckGrColor(iCb);
  fprintf(fpP,"newpath %d %d moveto ( ) stringwidth pop %d mul 0"
	  ,PX,FyU+kLn*dPY+hBrd-1,Ind);
  switch(Fl){
  case 0:
    fputs(" rmoveto\n",fpP);
    break;
  case 1:
    fputs(" rlineto\n",fpP);
    break;
  case 2:
    fputs(" rlineto stroke\n",fpP);
    return(0);
    break;
  default:
    break;
  }
  L=(jLn-kLn)*dPY+hBrd;
  fprintf(fpP,"0 %d rlineto stroke\n",L);
  return(0);
}

int CbDocPSVBrdTxt(int *shift,int *width,int Ind,int Msk,int kLn,int Fl)
{
  int i,W,L,L1,sh,iCb,jLn,kTkn;

  iCb=Msk&0x7F;
  jLn=(Msk&0xFF00)>>8;
  kTkn= iCb < 3 ? (Msk&0xFFFF0000)>>16 : -1;
  L1=kTkn < 0 ? 0: (CBTkn[kTkn].L&0x1F000000)>>24;
  switch(Fl){
  case 0:
    fprintf(fpP,"newpath %d %d moveto ( ) stringwidth pop %d mul 0"
	    ,PX+2,FyU+kLn*dPY,Ind);
    fputs(" rmoveto\n",fpP);
    break;
  case 1:
    fprintf(fpP,"newpath %d %d moveto ( )stringwidth pop %d mul 0 rmoveto"
	    ,PX+2,FyU+kLn*dPY,Ind-CbCResW[iCb].L-L1-2);
    if(kTkn < 0){
      fprintf(fpP,"(%s  )show",CbCResW[iCb].p);
    }
    else{
      fprintf(fpP,"(%s%s  )show",CbCResW[iCb].p,CBTkn[kTkn].Nm);
    }
    fputs(" currentpoint\n",fpP);
    break;
  default:
    fputs(" stroke\n",fpP);
    return(0);
    break;
  }
  L=(jLn-kLn)*dPY;
  sh=*width ? *shift+hF : hF;

  W=(CbCResW[iCb].L+L1)*hF;
  if(W+sh < L){
    fprintf(fpP,"currentpoint\n");
    fprintf(fpP,"moveto 90 rotate currentpoint\n");
    i=0;
    while(W+sh+i < L){
      if(i == 0){
	if(sh)
	  fputs("currentpoint\n",fpP);
      }
      else{
	fputs("currentpoint\n",fpP);
      }
      i+=2*W;
    }
    i=0;
    while(W+sh+i < L){
      if(i == 0){
	if(sh)
	  fprintf(fpP,"moveto %d 0  rmoveto\n",sh);
      }
      else{
	fprintf(fpP,"moveto %d 0  rmoveto\n",sh+i);
      }
      if(kTkn < 0)
	fprintf(fpP," (%s)show \n",CbCResW[iCb].p);
      else
	fprintf(fpP," (%s%s)show \n",CbCResW[iCb].p,CBTkn[kTkn].Nm);
      i+=2*W;
    }
    fprintf(fpP,"moveto -90 rotate\n");
    *shift=sh-hF ? 0 : W;
    *width=W/hF;
  }
  else{
    *shift=0;
    *width=0;
  }
  return(0);
}

int CbDocBffP2PS()
{
  int i,L,Ind,Fl,M,IE,Htxt,Wtxt;
  char *p,*p1;

  hBrd=hF/2;
  wBrd=2*hBrd;
  i	=PageN/(LndPrt+1);
  if(i < nPSPg){
    FlPSPg=fPSPg[i];
  }
  else{
    FlPSPg=nPSPg < 0 ? 1 : 0;
  }
  PY=FyU;
  if(FlPSPg){
    if(LndPrt){
      fprintf(fpP,"%%MiniPage %d\n",PageN);
      if(PageN%2){
	fprintf(fpP,"newpath %d %d moveto 0 %d rlineto stroke\n"
		,PSwP/2,FyL,FyU-FyL+hF);
	PX=FxL1;
	fprintf(fpP,"%d ",PX+(FxR1-FxL1)/2);
	FlFnt = 0;
	fprintf(fpP,"/Courier findfont %d scalefont setfont\n",hF);
	fprintf(fpP,"(- page %d -) stringwidth pop 2 div sub %d moveto\n"
		,PageN+1,PY-dPY);
	fprintf(fpP,"(- page %d -)show\n",PageN+1);
      }
      else{
	fprintf(fpP,"%%%%Page: %d %d\n",PageN/2+1,PageN/2+1);
	fputs("90 rotate\n",fpP);
	PX=FxL;
	fprintf(fpP,"%d ",PX+(FxR-FxL)/2);
	CbDocPageTitlePS();
      }
    }
    else{
      fprintf(fpP,"%%%%Page: %d %d\n",PageN,PageN);
      fprintf(fpP,"0 %d translate\n",PShP);
      PX=FxL;
      fprintf(fpP,"%d ",PX+(FxR-FxL)/2);
      CbDocPageTitlePS();
    }
  }
  
  Fl=0;
  for(i=0; i < iLn; i++){
    if((fLn[i]&0x80) == 0 && (fLn[i]&0xC000)){
      Ind=(fLn[i]&0x3F00)>>8;
      if(Ind){
	M=fLn[i]&0xC000;
	if((M&0x4000)){
	  if((M&0x8000)){
	    fClm[Ind]=0x10000|(i<<8)|(fLn[i]&0x00FF);
	  }
	  else{
	    L=i-((fClm[Ind]&0xFF00)>>8)-1;
	    if((fClm[Ind]&0x20000))
	      L++;
	    if(L > 5 || (fClm[Ind]&0x20000)){
	      if(Ind%2 && Fl != 1){
		Fl=1;
		if(FlPSPg){
		  fputs("[1 2] 0 setdash\n",fpP);
		}
	      }
	      if(Ind%2 == 0 && Fl != 2){
		Fl=2;
		if(FlPSPg){
		  fputs("[2 3] 0 setdash\n",fpP);
		}
	      }
	      if(FlPSPg){
		fprintf(fpP,"newpath ( )stringwidth pop %d mul %d add %d"
			" moveto 0 %d",2*Ind,PX,FyU+i*dPY+hF-2,-L*dPY);
		fputs(" rlineto stroke\n",fpP);
	      }
	    }
	    fClm[Ind]=0;
	  }
	}
      }
      else{
	if(Fl){
	  Fl=0;
	  if(FlPSPg){
	    fputs("[] 0 setdash\n",fpP);
	  }
	}
	L=fLn[i]&0xC000;
	if(L == 0xC000){
	  M=(fLn[i]&0x7FFF0000)>>16;
	  CNmID[M].kPg=PageN+1;
	}
	if(FlPSPg){
	  if(L == 0xC000){
	    fprintf(fpP
		    ,"newpath %d %d moveto ( ) stringwidth pop %d mul %d add 0"
		    ,PX,FyU+i*dPY+hF-2,NChX-(fLn[i]&0x3F),-wBrd/2-1);
	    fprintf(fpP," rlineto 0 %d",-hF);
	  }
	  if(L == 0x4000){
	    fprintf(fpP
		    ,"newpath %d %d moveto ( ) stringwidth pop %d mul %d add 0"
		    ,PX,FyU+i*dPY-2,NChX-(fLn[i]&0x3F),-wBrd/2-1);
	    fprintf(fpP," rlineto 0 %d",hF);
	  }
	  fputs(" rlineto stroke\n",fpP);
	}
      }
    }
  }
  for(Ind=0; Ind < NChX; Ind++){
    if((fClm[Ind]&0x80) == 0 && (fClm[Ind]&0x10000)){
      L=iLn-((fClm[Ind]&0xFF00)>>8)-1;
      if((fClm[Ind]&0x20000))
	L++;
      if(Ind%2 && Fl != 1){
	Fl=1;
	if(FlPSPg){
	  fputs("[1 2] 0 setdash\n",fpP);
	}
      }
      if(Ind%2 == 0 && Fl != 2){
	Fl=2;
	if(FlPSPg){
	  fputs("[2 3] 0 setdash\n",fpP);
	}
      }
      if(FlPSPg){
	fprintf(fpP,"newpath ( )stringwidth pop %d mul %d add %d moveto 0 %d"
		,2*Ind,PX,FyU+iLn*dPY+hF-2,-L*dPY);
	fputs(" rlineto stroke\n",fpP);
      }
      fClm[Ind]&=0xFFFF00FF;
      fClm[Ind]|=0x20000;
    }
  }
  if(Fl){
    if(FlPSPg){
      fputs("[] 0 setdash\n",fpP);
    }
  }
  if(FlPSPg){
    fprintf(fpP,"/Courier-Bold findfont %d scalefont setfont\n",hF);
    FlFnt=1;
  }
  Fl=0;
  Htxt=0;
  Wtxt=0;
  for(i=0; i < NChX; i++){
    fClm1[i]=fClm[i];
  }
  for(i=0; i < iLn; i++){
    if((fLn[i]&0x80)){
      if(Fl == 0){
	Fl =1;
	if(FlPSPg){
	  fprintf(fpP,"%d setlinewidth\n",wBrd);
	}
      }
      M=fLn[i];
      L=M&0x7f;
      M >>=8;
      if(L < 3 || L == 3 || L == 8){
	Ind=M&0x3F;
      }
      else{
	Ind=(M&0x3F)+NChX/4;
	if(Ind > NChX)
	  Ind=NChX;
      }
      Ind=NChX-Ind;
      if((M&0x40)){
	if((M&0x80)){
	  if(FlPSPg){
	    Fl =1;
	    CbDocPSVBrd(Ind,i,i,L,2);
	  }
	  fClm[Ind]=(i<<8)|(fLn[i]&0x7FFF00FF);
	  M=(fLn[i]&0x7FFF0000)>>16;
	  CBTkn[M].kPg=PageN+1;
	}
	else{
	  Fl=2;
	  if(FlPSPg){
	    CbDocPSVBrd(Ind,((fClm[Ind]&0xFF00)>>8),i,L,1);
	  }
	  fClm[Ind]=0;
	}
      }
      else{
	if(FlPSPg){
	  Fl =1;
	  CbDocPSVBrd(Ind,i,i,L,2);
	}
      }
    }
  }
  for(Ind=0; Ind < NChX; Ind++){
    if((fClm[Ind]&0x80)){
      if(Fl == 0){
	Fl=1;
	if(FlPSPg){
	  fprintf(fpP,"%d setlinewidth\n",wBrd);
	}
      }
      L=fClm[Ind]&0x7f;
      Fl=2;
      if(FlPSPg){
	CbDocPSVBrd(Ind,((fClm[Ind]&0xFF00)>>8),iLn,L,0);
      }
      fClm[Ind]&=0xFFFF00FF;
    }
    else{
      Htxt=0;
      Wtxt=0;
    }
  }
  if(Fl == 2){
    if(FlPSPg){
      fprintf(fpP,"1 1 1 setrgbcolor\n");
    }
    for(i=0; i < iLn; i++){
      if((fLn[i]&0x80)){
	M=fLn[i];
	L=M&0x7f;
	M >>=8;
	if(L < 3 || L == 3 || L == 8){
	  Ind=M&0x3F;
	}
	else{
	  Ind=(M&0x3F)+NChX/4;
	  if(Ind > NChX)
	    Ind=NChX;
	}
	Ind=NChX-Ind;
	if((M&0x40)){
	  if((M&0x80)){
	    fClm1[Ind]=(i<<8)|(fLn[i]&0x7FFF00FF);
	  }
	  else{
	    if(FlPSPg){
	      CbDocPSVBrdTxt(&Htxt,&Wtxt,Ind,fClm1[Ind],i,1);
	    }
	    fClm1[Ind]=0;
	  }
	}
      }
    }
    if(FlPSPg){
      for(Ind=0; Ind < NChX; Ind++){
	if((fClm1[Ind]&0x80)){
	  if(Fl == 0){
	    Fl=1;
	    fprintf(fpP,"%d setlinewidth\n",wBrd);
	  }
	  CbDocPSVBrdTxt(&Htxt,&Wtxt,Ind,fClm1[Ind],iLn,0);
	  fClm1[Ind]&=0xFFFF00FF;
	}
	else{
	  Htxt=0;
	  Wtxt=0;
	}
      }
    }
  }
  if(Fl && FlPSPg){
    fputs("0.3 setlinewidth 0 setgray\n",fpP);
    if(FlFnt != 1){
      if(FlFnt == 0)
	fprintf(fpP,"/Courier findfont %d scalefont setfont\n",hF);
      if(FlFnt == 2)
	fprintf(fpP,"/Courier-Oblique findfont %d scalefont setfont\n",hF);
    }
    CbDocUnSetPSBckGrColor();
  }
  p=BffPg;
  if(FlPSPg){
    if(FlFnt){
      fprintf(fpP,"/Courier findfont %d scalefont setfont\n",hF);
      FlFnt=0;
    }
    Fl=nLnPg/100;
    M=PX-2*hF;
    L=PY;
    for(i=0; i < iLn; i++){
      if((fLn[i]&0x80000000)){
	fprintf(fpP,"%d %d moveto (->)show\n",M,L);
      }
      else{
	if(i == 0 || i == iLn-1 || Fl != nLnPg/100){
	  Fl=nLnPg/100;
	  if(Fl)
	    fprintf(fpP,"%d (%d)stringwidth pop sub %d moveto (%d)show\n"
		    ,M,Fl,L,nLnPg);
	  else
	    fprintf(fpP,"%d %d moveto (%2d)show\n",M,L,nLnPg%100);
	}
	else{
	  fprintf(fpP,"%d %d moveto (%2d)show\n",M,L,nLnPg%100);
	}
	nLnPg++;
      }
      L+=dPY;
    }
    fprintf(fpP,"%d %d moveto\n",PX,PY);
  }
  else{
    nLnPg=iFLn+1;
    PageN++;
    return(0);
  }
  while(*p != '\0' || *(p+1) != '\0'){
    switch(*p){
    case '0':
      if(FlFnt != 0)
	fprintf(fpP,"/Courier findfont %d scalefont setfont\n",hF);
      FlFnt=0;
      p++;
      break;
    case '1':
      if(FlFnt != 1){
	fprintf(fpP,"/Courier-Bold findfont %d scalefont setfont\n",hF);
      }
      FlFnt=1;
      p++;
      break;
    case '2':
      if(FlFnt != 2)
	fprintf(fpP,"/Courier-Oblique findfont %d scalefont setfont\n",hF);
      FlFnt=2;
      p++;
      break;
    case '3':
      if(FlFnt != 3)
	fprintf(fpP,"/Helvetica-Oblique findfont %d scalefont setfont\n",hF);
      FlFnt=3;
      p++;
      break;
    case '*':
      p++;
      break;
    case '\n':
      PY+=dPY;
      fprintf(fpP,"%d %d moveto\n",PX,PY);
      p++;
      break;
    case '>':
    default:
      p++;
      break;
    }
    if(*p != '\0')
      fputc('(',fpP);
    p1=p;
    while(*p != '\0'){
      if(*p == ')' || *p == '(' || *p == '\\'){
	fputc('\\',fpP);
      }
      fputc(*p,fpP);
      p++;
    }
    if(p > p1)
      fputs(")show\n",fpP);
    if(*(p+1) != '\0')
      p++;
  }
  if(LndPrt == 0 || PageN%2){
    fputs("showpage\n",fpP);
  }
  PageN++;
  return(0);
}

int CbDocPutEmptyLine2BffP()
{
  iPX=0;
  *pBff++='\n';
  *pBff++='\0';
  iLn++;
  if(iLn == NLn){
    *pBff++='\0';
    CbDocBffP2PS();
    pBff=BffPg;
    iLn=0;
  }	
  pLn[iLn]=pBff+1;
  fLn[iLn]=0;
  return(0);
}

int CbDocPutLine2BffP(int Fnt)
{
  int i;
  char *p,*p1;

#ifdef H
  if(*Cln == '\0')
    return(0);
#endif
  p	=Cln;
  while(*p == ' ')
    p++;
  if(*p == '\n'){
    CbDocPutEmptyLine2BffP();
    return(0);
  }
  if(*p != '\0'){
    switch(Fnt){
    case 0:
      *pBff++='0';
      FlFnt=Fnt;
      break;
    case 1:
      *pBff++='1';
      FlFnt=Fnt;
      break;
    case 2:
      *pBff++='2';
      FlFnt=Fnt;
      break;
    case 3:
      *pBff++='3';
      FlFnt=Fnt;
      break;
    default:
      *pBff++='*';
      break;
    }
  }
  else{
    *pBff++='*';
  }

  p	=Cln;
  p1	=pBff;

  while(*p != '\0'){
    if(*p == '\n'){
      *pBff++='\0';
      CbDocPutEmptyLine2BffP();
      if(p > Cln && *(p-1) == '\\'){
	kLnFL++;
	*pBff++	='*';
      }
      else{
	return(0);
      }
    }
    else{
      *pBff++	=*p;
      iPX++;
      if(iPX >= NChX){
	*pBff++	='\0';
	CbDocPutEmptyLine2BffP();
	fLn[iLn] |=0x80000000;
	*pBff++	='>';
      }
    }
    p++;
  }

  if(*(p-1) != '\n')
    *pBff++='\0';
  return(0);
}

int CbDocFBff2PS()
{
  int F,F1,k,kk,i,nw,fP;
  char *p,*s,*s1,*t,*t1;
  CMMNT **pC,pC0;
  
  k	=nHLWrd+nCMMnt;
  pC	=(CMMNT **)malloc((k+1)*sizeof(CMMNT *));
  i	=0;
  s	=FBff+nFBff;
  while(i < k){
    if(iHLWrd < nHLWrd){
      t	=HLWrd[iHLWrd].b;
    }
    else{
      t	=s;
    }
    if(iCMMnt < nCMMnt){
      t1=CMMnt[iCMMnt].b;
    }
    else{
      t1=s;
    }
    if(t < t1){
      pC[i]=HLWrd+iHLWrd;
      iHLWrd++;
    }
    else{
      pC[i]=CMMnt+iCMMnt;
      iCMMnt++;
    }
    i++;
  }
  pC0.b	=s;
  pC0.e	=s;
  pC0.t	=0;
  pC[k]	=&pC0;

  i	=0;
  s	=FBff+pFLn[iFLn];
  p	=Cln;
  if(*s == '#'){
    F	=1;
    fP	=1;
    nw	=0;
    t	=s;
    t1	=s+1;
    F1	=1;
  }
  else{
    F	=0;
    fP	=0;
    if((fFLn[iFLn]&0xC000)){
      fLn[iLn] |=fFLn[iFLn]&0x1FFFFFFF;
    }
    t	=pC[i]->b;
    t1	=pC[i]->e;
    F1	=pC[i]->t;
  }

  k	=0;
  iTab	=0;
  while(*s != '\0'){
    switch(*s){
    case '\n':
      iFLn++;
      *p++=*s;
      if(*(s-1) != '\\'){
	*p	='\0';
	CbDocPutLine2BffP(F);
	p	=Cln;
	if(*(s+1) == '#'){
	  kk	=fFLn[iFLn];
	  if((kk&0x80) && (kk&0x4000) == 0 && (kk&0x7F) == 8){
	    *pBff++='\0';
	    CbDocBffP2PS();
	    pBff	=BffPg;
	    iLn		=0;
	    pLn[iLn]	=pBff+1;
	    fLn[iLn]	=0;
	  }
	  fP	=1;
	  nw	=0;
	  t	=s+1;
	  t1	=s+2;
	  F1	=1;
	}
	else{
	  fP	=0;
	}
      }
      if(fP == 0 && (fFLn[iFLn]&0xC000)){
	fLn[iLn] |=fFLn[iFLn]&0x1FFFFFFF;
      }
      k		=0;
      break;
    case '\t':
      iTab++;
      kk=(k/8+1)*8;
      while(k < kk){
	*p++=' ';
	k++;
      }
      break;
    case ' ':
    case '\v':
    case '\r':
      *p++=' ';
      k++;
      break;
    default :
      if(s >= t){
	if(F != F1){
	  if(p != Cln){
	    *p	='\0';
	    CbDocPutLine2BffP(F);
	    p	=Cln;
	  }
	  F	=F1;
	}
	if(fP && F == 1){
	  nw++;
	  if(nw == 2 && (fFLn[iFLn]&0x80)){
	    fLn[iLn] |=fFLn[iFLn]&0x01FFFFFF;
	  }
	}
      }
      if(s >= t1){
	while(s > pC[i]->b){
	  i++;
	}
	t	=pC[i]->b;
	t1	=pC[i]->e;
	F1	=pC[i]->t;
	if(s < t && F != 0){
	  if(p != Cln){
	    *p	='\0';
	    CbDocPutLine2BffP(F);
	    p	=Cln;
	  }
	  F	=0;
	}
	if(s >= t && F != F1){
	  if(p != Cln){
	    *p	='\0';
	    CbDocPutLine2BffP(F);
	    p	=Cln;
	  }
	  F	=F1;
	}
      }
      *p++	=*s;
      k++;
      break;
    }
    if(p-Cln+8 >= LCln){
      *p	='\0';
      CbDocPutLine2BffP(F);
      p		=Cln;
    }
    s++;
  }
  *p='\0';
  free(pC);
  return(0);
}

int CbDocReInitHLWrd()
{
  if(NHLWrd){
    NHLWrd+=32;
    HLWrd=(CMMNT*)realloc((void*)HLWrd,(size_t)NHLWrd*sizeof(CMMNT));
  }
  else{
    NHLWrd=32;
    HLWrd=(CMMNT*)malloc((size_t)NHLWrd*sizeof(CMMNT));
  }
  if(HLWrd == NULL){
    printf("Error at %d: No memory for %d HLWrd's%c\n",kLnFL,NHLWrd,7);
    exit(0);
  }
  return(0);
}

int CbDocDeInitHLWrd()
{
  if(NHLWrd){
    free(HLWrd);
  }
  NHLWrd=0;
  return(0);
}

int CbDocGetHLWrd(char *S)
{
  int i,j,k,fw,nw,Nw;
  char *p,*s,*t,*w;
  
  s=S;
  p=Cln;
  if((fFLn[iFLn]&0x40000000)){
    k=(fFLn[iFLn]&0x1E000000)>>25;
    switch(k){
    case 0:
    case 6:
    case 7:
      Nw=2;
      break;
    default:
      Nw=1;
      break;
    }
  }
  else{
    Nw=1000;
  }

  w=Cword;
  fw=0;
  nw=0;
  while(iCMMnt < nCMMnt && s > CMMnt[iCMMnt].e){
    iCMMnt++;
  }

  while(*s != '\0'){
    while(*s == '\\' && *(s+1) == '\n'){
      kLnFL++;
      s+=2;
    }
    if(iCMMnt < nCMMnt && CMMnt[iCMMnt].b <= s && s < CMMnt[iCMMnt].e){
      t	=CMMnt[iCMMnt].e;
      while(s < t){
	if(*s == '\n'){
	  kLnFL++;
	}
	s++;
      }
    }
    switch(*s){
    case '\n':
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      *p='\0';
      kLnFL++;
      if(fw){
	fw=0;
	*w='\0';
	nw++;
	if(Nw < 3){
	  HLWrd[nHLWrd].t=1;
	  HLWrd[nHLWrd].k1=kLnFL;
	  HLWrd[nHLWrd].e=s;
	  nHLWrd++;
	}
	else{
	  if(CbDocIfCResWrd(Cword)){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	}
      }
      return((int)(s-S+1));
    case '\t':
    case ' ':
    case '\v':
      if(p > Cln && IsAlNum(*(p-1))){
	*p++=' ';
      }
      if(fw){
	fw=0;
	*w='\0';
	nw++;
	if(Nw < 3){
	  HLWrd[nHLWrd].t=1;
	  HLWrd[nHLWrd].k1=kLnFL;
	  HLWrd[nHLWrd].e=s;
	  nHLWrd++;
	}
	else{
	  if(CbDocIfCResWrd(Cword)){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	}
      }
      s++;
      break;
    case '/':
      if(fw){
	fw=0;
	*w='\0';
	nw++;
	if(Nw < 3){
	  HLWrd[nHLWrd].t=1;
	  HLWrd[nHLWrd].k1=kLnFL;
	  HLWrd[nHLWrd].e=s;
	  nHLWrd++;
	}
	else{
	  if(CbDocIfCResWrd(Cword)){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	}
      }
      t=s;
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '*'){ /*Inside Comment */
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *(p-1)='\0';
	  printf("Error at %d: zero char inside comment%c\n"
		 ,kLnFL,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
	t=s;
	while(*s != '/' || *t != '*'){
	  t=s;
	  s++;
	  while(*s == '\\' && *(s+1) == '\n'){
	    kLnFL++;
	    s+=2;
	  }
	  if(*s == '\0'){
	    *(p-1)='\0';
	    printf("Error at %d: zero char inside comment%c\n"
		   ,kLnFL,7);
	    return((int)(s-S));
	  }
	  if(*s == '\n'){
	    kLnFL++;
	  }
	}
	p--;
	if(p > Cln && IsAlNum(*(p-1))){
	  *p++=' ';
	}
	s++;
      }
      break;
    case '\'':
      if(fw){
	fw=0;
	*w='\0';
	nw++;
	if(Nw < 3){
	  HLWrd[nHLWrd].t=1;
	  HLWrd[nHLWrd].k1=kLnFL;
	  HLWrd[nHLWrd].e=s;
	  nHLWrd++;
	}
	else{
	  if(CbDocIfCResWrd(Cword)){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	}
      }
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      k=kLnFL;
      *p++=*s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '\0'){
	*p='\0';
	printf("Error at %d: zero char inside character constant%c\n",k,7);
	return((int)(s-S));
      }
      if(*s == '\n'){
	kLnFL++;
      }
      i=0;
      j=0;
      while(i == 0){
	if(*s == '\\' && j == 0){
	  j=1;
	}
	else{
	  j=0;
	}
	if(j == 0)
	  i++;
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside character constant%c\n",k,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
      }
      if(i == 1 && *s !='\''){
	printf("Error at %d: wrong character constant%c\n",k,7);
	break;
      }
      *p++='x'; /* Fake substitution */
      *p++='\'';
      s++;
      break;
    case '"':
      if(fw){
	fw=0;
	*w='\0';
	nw++;
	if(Nw < 3){
	  HLWrd[nHLWrd].t=1;
	  HLWrd[nHLWrd].k1=kLnFL;
	  HLWrd[nHLWrd].e=s;
	  nHLWrd++;
	}
	else{
	  if(CbDocIfCResWrd(Cword)){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	}
      }
      if(p > Cln && *(p-1) == ' '){
	p--;
      }
      t=s;
      *p++=*s;
      s++;
      while(*s == '\\' && *(s+1) == '\n'){
	kLnFL++;
	s+=2;
      }
      if(*s == '\0'){
	*p='\0';
	printf("Error at %d:  zero char inside string constant%c\n"
	       ,kLnFL,7);
	return((int)(s-S));
      }
      if(*s == '\n'){
	kLnFL++;
      }
      while(*s != '"' || *t == '\\'){
	t=s;
	s++;
	while(*s == '\\' && *(s+1) == '\n'){
	  kLnFL++;
	  s+=2;
	}
	if(*s == '\0'){
	  *p='\0';
	  printf("Error at %d: zero char inside string constant%c\n"
		 ,kLnFL,7);
	  return((int)(s-S));
	}
	if(*s == '\n'){
	  kLnFL++;
	}
      }
      *p++=*s++;
      break;
    default :
      if(p > Cln && *(p-1) == ' ' && IsAlNum(*s) == 0){
	*(p-1)=*s;
      }
      else{
	*p++=*s;
      }
      if(fw == 0 && IsAlpha(*s) && nw < Nw){
	fw=1;
	w=Cword;
	if(nHLWrd >= NHLWrd){
	  CbDocReInitHLWrd();
	}
	HLWrd[nHLWrd].k0=kLnFL;
	HLWrd[nHLWrd].b=s;
      }
      if(fw){
	if(IsAlNum(*s)){
	  if(w-Cword < 32){
	    *w++=*s;
	  }
	}
	else{
	  fw=0;
	  *w='\0';
	  nw++;
	  if(Nw < 3){
	    HLWrd[nHLWrd].t=1;
	    HLWrd[nHLWrd].k1=kLnFL;
	    HLWrd[nHLWrd].e=s;
	    nHLWrd++;
	  }
	  else{
	    if(CbDocIfCResWrd(Cword)){
	      HLWrd[nHLWrd].t=1;
	      HLWrd[nHLWrd].k1=kLnFL;
	      HLWrd[nHLWrd].e=s;
	      nHLWrd++;
	    }
	  }
	}
      }
      s++;
      break;
    }
    i=p-Cln;
    if(i+3 >= LCln){
      CbDocReInitCln();
      p=Cln+i;
    }
  }
  *p='\0';
  return((int)(s-S));
}

int CbDocWritePS()
{
  int j,n;
  char *p;
  
  strcpy(NmPF,NmF);
  strcpy(NmPF+strlen(NmPF),".ps");
  fpP	=fopen(NmPF,"w");
  if(fpP == NULL){
    printf("%s - file cannot be open for input\n",NmPF);
    return(-1);
  }
  dPY=-1.25*hF;
  if(LndPrt){
    PShP=PaperW;
    PSwP=PaperH;
    FxL=36;
    FxL1=PSwP/2+5;
    FxR=PSwP/2-27;
    FxR1=PSwP-54;
    FyL=-PShP+72-10;
  }
  else{
    PShP=PaperH;
    PSwP=PaperW;
    FxL=72;
    FxL1=FxL;
    FxR=PSwP-72;
    FxR1=FxR;
    FyL=-PShP+72;
  }
  FyU=-72;
  NLn=(FyU-FyL)/(-dPY)+1;
  kLnFL=1;
  iFLn=0;
  iCMMnt=0;
  iHLWrd=0;
  do{
    while((fFLn[iFLn]&0x80000000)){
      iFLn++;
      kLnFL++;
    }
    p=FBff+pFLn[iFLn];
    n=CbDocGetHLWrd(p);
    iFLn=kLnFL-1;
  }while(n);

  CbDocReInitBffP();
  CbDocWritePsHead();
  FlFnt=0;
  PX=FxL;
  PY=FyU;
  PageN=0;
  for(j=0; j < NChX; j++){
    fClm[j]=0;
  }
  pBff=BffPg;
  iLn=0;
  fLn[iLn]=0;
  nLnPg=1;
  kLnFL=1;
  iFLn=0;
  iCMMnt=0;
  CbDocFBff2PS();
  if(iLn){
    *pBff++='\0';
    *pBff++='\0';
    CbDocBffP2PS();
    if(FlPSPg){
      if(LndPrt && PageN%2)
	fputs("showpage\n",fpP);
    }
  }
  CbDocDeInitBffP();
  if(NPSPg > 0){
    free(fPSPg);
    NPSPg=0;
    nPSPg=-1;
  }
  fclose(fpP);
  return(0);
}
#endif
