#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "hb.h"

extern int nHSec;
extern HELPSECT HSec[];
extern char *Month[12];

static struct stat statbuf;
static time_t sTime;
static struct tm *pTm;
static char NmHF[64];

static unsigned int ERR=0x80000000;

int SetHelpSections()
{
  int i;

  for(i=0; i < nHSec; i++){
    HSec[i].I	=0;
    HSec[i].n	=0;
    HSec[i].i	=0;
    HSec[i].k	=0;
  }
  i	=0;
  *HSec[i].Nm	='\0';
  i++;
  strcpy(HSec[i].Nm,"Overview:");
  i++;
  strcpy(HSec[i].Nm,"Tutorial:");
  i++;
  strcpy(HSec[i].Nm,"Known Bugs:");
  i++;
  strcpy(HSec[i].Nm,"Control Parameters:");
  HSec[i].I	=1;
  HSec[i].C[0]	="Hlp";
  HSec[i].x[0]	=".tb";
  i++;
  strcpy(HSec[i].Nm,"Input:");
  HSec[i].I	=4;
  HSec[i].C[0]	="BSv_";
  HSec[i].C[1]	="BRd_";
  HSec[i].C[2]	="BnrI";
  HSec[i].C[3]	="AscI";
  HSec[i].x[0]	=".sv";
  HSec[i].x[1]	=".rd";
  HSec[i].x[2]	=".bi";
  HSec[i].x[3]	=".ai";
  i++;
  strcpy(HSec[i].Nm,"Output:");
  HSec[i].I	=4;
  HSec[i].C[0]	="BSv_";
  HSec[i].C[1]	="BWr_";
  HSec[i].C[2]	="BnrO";
  HSec[i].C[3]	="AscO";
  HSec[i].x[0]	=".sv";
  HSec[i].x[1]	=".wr";
  HSec[i].x[2]	=".bo";
  HSec[i].x[3]	=".ao";
  i++;
  strcpy(HSec[i].Nm,"Tips:");
  i++;
  strcpy(HSec[i].Nm,"Description:");
  i++;
  strcpy(HSec[i].Nm,"Algorithm:");
  i++;
  strcpy(HSec[i].Nm,"ToDo:");
  for(i=0; i < nHSec; i++) HSec[i].L=strlen(HSec[i].Nm);

  return(0);
}

int HlpStr2Txt(FILE *lF,char *str)
{
  int d,i;
  char ln[32];

  i	=1;
  d	=0;
  *ln	='\0';
  while(*str != '\0'){
    if(*str == '\\' && *(str+1) == ';'){
      if(*(str-2) != ';' || *(str-1) != '\n')fputs(";\n",lF);
      i	=1;
      str++;
    }
    else{
      if(i == 1){
	if(*str == '}'){
	  d--;
	  ln[2*d]	='\0';
	}
	i++;
	if(d) fputs(ln,lF);
      }
      putc(*str,lF);
      if(i){
	if(*str == ';'){
	  if(*(str+1) == '\n') putc(';',lF);
	  i=0;
	}
	if(*str == '{'){
	  putc('\n',lF);
	  ln[2*d]	=' ';
	  ln[2*d+1]=' ';
	  d++;
	  ln[2*d]	='\0';
	  i	=1;
	}
	if(*str == '}'){
	  putc('\n',lF);
	  i	=1;
	}
      }
    }
    str++;
   }
  return(0);
}

char *StrReplacePattern(char *str,char *S,char *byS, int L)
{
  int i;
  char *lc,*ls;

  lc	=S;
  while(*str != '\0'){
    if(*lc == *str){
      lc++;
      if(*lc == '\0'){
	lc	=str+1-L;
	ls	=byS;
	while(*ls != '\0') *lc++ =*ls++;
	lc	=S;
      }
    }
    else{
      lc	=S;
    }
    str++;
  }
  return(0);
}

char *HSecInStr(char *B,int *L,char *Nm)
{
  int i;
  char *lc;
  B	=strstr(B,Nm);
  if(B == NULL){
    *L	=0;
    return(B);
  }
  while(*B != '{') B++;
  i	=1;
  lc	=B;
  B++;
  while(i){
    lc++;
    if(*lc == '{') i++;
    if(*lc == '}') i--;
  }
  *lc	='\0';
  *L	=lc-B;
  return(B);
}

int CommObj2Tabular(FILE *lF,char *str)
{
  int k;
  int d,i;
  char ln[32];
  char *lt;
  char End[32]="\\\\\\hline\\end{tabular}\n";
  char Beg[128]="\n\\noindent\\begin{tabular}"
    "{|p{1in}p{1.8in}p{0.5in}p{2.5in}|}\\hline\n";

  /*Assumes a correct syntax*/
  k	=1;
  i	=1;
  d	=0;
  *ln	='\0';
  while(*str != '\0'){
    if(*str == '\\' && *(str+1) == ';'){
      i	=1;
      if(k > 5){
	fputs(End,lF);
	k	=0;
      }
      else{
	fputs("\\\\\n",lF);
	k++;
      }
      str++;
    }
    else{
      if(i == 1 && k == 0){
	fputs(Beg,lF);
	i++;
      }
      if(i){
	if(*str == '}'){
	  d--;
	  ln[2*d]	='\0';
	  fputs("\\c{",lF);
	  if(0 && d) fputs(ln,lF);
	  fputs("\\}}&&&\n",lF);
	  fputs(End,lF);
	  i	=1;
	  k	=0;
	}
	else{
	  fputs("\\c{",lF);
	  if(0 && d) fputs(ln,lF);
	  while(*str != '=') fputc(*str++,lF);
	  fputs("}&",lF);
	  str++;
	  fputs("\\c{",lF);
	  if(*str == '('){
	    while(*str != ')') fputc(*str++,lF);
	    fputc(*str++,lF);
	  }
	  if(*str == '('){
	    while(*str != ')') str++;
	    str++;
	  }
	  if(*str == '{'){
	    ln[2*d]	=' ';
	    ln[2*d+1]=' ';
	    d++;
	    ln[2*d]	='\0';
	    fputs("\\{}&&\\\\\n",lF);
	    k++;
	  }
	  else{
	    while(*str != ';') fputc(*str++,lF);
	    fputs("}&&",lF);
 	    i	=0;
	  }
	}
      }
      else{
	if(*str == ';' && *(str+1) == '\n'){
	  str++;
	  if(*(str+1) != '\\' || *(str+2) != ';'){
	    fputs("\n\\newline ",lF);
	    k++;
	  }
	}
	else{
	  if(*str == '&') fputc('\\',lF);
	  putc(*str,lF);
	}
      }
    }
    str++;
  }  
  if(k) fputs(End,lF);
  return(0);
}

int RemoveComments(char* str)
{
  int d,i;
  char *lc,*lt;

  lc	=str;
  lt	=str+1;

  while(*lt != '\0'){
    if(*lc == '/' && *lt == '*'){
      *lc++	=' ' ;
      *lt++	=' ' ;
      while((*lc != '*' || *lt != '/') && *lt != '\0'){
	*lc++	=' ';
	lt++;
      }
      if(*lc == '*' && *lt == '/'){
	*lc++	=' ' ;
	*lt++	=' ' ;
      }
    }
    if(*lc == '\\' && *lt == '\n'){
      *lc++	=' ';
      *lt++	=' ';
    }
    else{
      lc++;
      lt++;
    }
  }
  return(0);
}

int CompressHlpSection(char* str)
{
  int d,i;
  char *lc,*lt,*lv;


  d	=0;
  lt	=str;
  lc	=str;

  while(*lc != '{' && *lc != '\0') lc++;
  if(lc == '\0'){
    *lt	='\0';
    return(1);
  }
  *lt++ =*lc++;
  d	=1;
  i	=0;
  while(d && *lc != '\0'){
    while(isspace(*lc)) lc++;
    if(*lc == '"'){
      *lt++ =*lc++;
      while(*lc != '"')*lt++ =*lc++;
      *lt++ =*lc++;
      while(*lc != '"' && *lc != '='){
	if(!isspace(*lc)) *lt++ =*lc;
	lc++;
      }
      if(*lc == '"'){
	*lt++ =*lc++;
	while(*lc != '"')*lt++ =*lc++;
	*lt++ =*lc++;
      }
      while(*lc != ';'){
	if(!isspace(*lc)) *lt++ =*lc;
	lc++;
      }
      *lt++ =*lc++;
      lv=lc+1;
      while(*lc != '\\' || *lv != ';'){
	if(isspace(*lv) && (*lc != ';' || *lv != '\n')) *lv =' ';
#ifdef H
	if(*lc == ';' && *lv == '\n'){
	  *lc ='\n';
	  *lv =' ';
	}
#endif
	if(*lc != ' ' || (*(lt-1) != ' ' && *(lt-1) != '\n')) *lt++ =*lc;
	lc++;
	lv++;
      }
      *lt++ =*lc++;
      *lt++ =*lc++;
    }
    else{
      if(*lc == '}'){
	d--;
      }
      else{
	while(*lc != '{'){
	  if(!isspace(*lc)) *lt++ =*lc;
	  if(*lc == '\0') return(1);
	  lc++;
	}
	if(*lc == '{') d++;
      }
      *lt++ =*lc++;
    }
  }
  *lt	='\0';
  return(0);
}

int CntrParam2Hlp(char* Nm)
{
  int i,k,j,n;
  int L,Lt,Lh;
  char *B,*Bt,*Bh,*lc,*lt,*lh;
  FILE *lFt,*lFh;
  char FNm[128],ln[128],sT[32];

  time(&sTime);
  pTm	=localtime(&sTime);
  sprintf(sT,",%8s %d, %d by :;\n"
	  ,Month[pTm->tm_mon],pTm->tm_mday,1900+pTm->tm_year); 
  /*Read In/<HSectionName>.CmC*/
  sprintf(FNm,"In/%s.CmC",Nm);
  k	=stat(FNm,&statbuf);
  if(k){
    out("ss",FNm," is absent\n");
    return(1);
  }
  k	=statbuf.st_size;
  lFt	=fopen(FNm,"r");
  B	=NULL;
  if(IfPatternFound(lFt,"Hlp")){
    k	-=ftell(lFt);
    if(k == 0){
      fclose(lFt);
      return(1);
    }
    B	=(char*)malloc((k+4)*sizeof(char));
    strcpy(B,"Hlp");
    fread(B+3,1,k,lFt);
    *(B+k+3)	='\0';
  }
  fclose(lFt);
  if(B == NULL){
    out("ss",FNm," has no Hlp\n");
    return(1);
  }
  RemoveComments(B);
  CompressHlpSection(B+3);

  /*Read Hlp/<HSectionName>.txt*/
  Bt	=NULL;
  Lt	=0;
  sprintf(FNm,"Hlp/%s.txt",Nm);
  k	=stat(FNm,&statbuf);
  if(k){
    out("ss",FNm," is absent\n");
  }
  else{
    Lt	=statbuf.st_size;
    Bt	=(char*)malloc((Lt+1)*sizeof(char));
    lFt	=fopen(FNm,"r");
    fread(Bt,1,Lt,lFt);
    *(Bt+Lt)	='\0';
    fclose(lFt);
  }

  strncpy(FNm,"Out",3);
  lFt	=fopen(FNm,"w");
  /*Find section positions and write the head;*/
  sprintf(HSec[0].Nm,"Hlp/%s.txt",Nm);
  HSec[0].L	=strlen(HSec[0].Nm);
  if(Lt){
    for(k=0; k < nHSec; k++){
      HSec[k].k	=0;
      HSec[k].n	=0;
      lc	=strstr(Bt,HSec[k].Nm);
      if(lc != NULL){
	HSec[k].k	=1;
	HSec[k].i	=lc-Bt;
      }
    }
    for(k=0; k < nHSec; k++){
      if(HSec[k].k){
	L	=Lt;
	for(i=0; i < nHSec; i++){
	  if(i != k && HSec[i].k && HSec[i].i > HSec[k].i 
	     && L > HSec[i].i) L=HSec[i].i;
	}
	HSec[k].n=L-HSec[k].i;
      }
    }
    if(HSec[0].k){
      fwrite(Bt+HSec[0].i,1,HSec[0].n,lFt);
      if(HSec[0].i) fwrite(Bt,1,HSec[0].i,lFt);
    }
    else{
      fputs(HSec[0].Nm,lFt);
      fputs(sT,lFt);
      k	=0;
      while(k < nHSec && HSec[k].k == 0) k++;
      fwrite(Bt,1,HSec[k].i,lFt);
    }
  }
  else{
    fputs(HSec[0].Nm,lFt);
    fputs(sT,lFt);
  }   

  for(k=1; k < nHSec; k++){	/*Other sections*/


    if(HSec[k].I){
      fputs(HSec[k].Nm,lFt);
      n	=HSec[k].I;
      /*Write Replacement part;*/
      j	=0;
      for(i=0; i < n; i++){
	lc	=HSecInStr(B,&L,HSec[k].C[i]);
	if(lc != NULL){
	  fprintf(lFt,"<%s%s>",Nm,HSec[k].x[i]);
	  if(*HSec[k].Nm == 'C'){ /*Control Parameters:*/
	    fputs(";\n",lFt);
	    HlpStr2Txt(lFt,lc);
	  }
	  j++;
	  *(lc+L)	='}';
	}
      }
      fputs("\\;\n",lFt);

      /*Write preserving part*/
      if(HSec[k].n){
	L	=HSec[k].L;
	lc	=Bt+HSec[k].i+L;
	lt	=lc+1;
	n	=HSec[k].n-L;
	i	=0;
	while(i < n && (*lc != '\\' || *lt != ';') && *lt != '\0'){
	  lc++;
	  lt++;
	  i++;
	}
	if(*lc == '\\' && *lt == ';'){
	  lc	+=2;
	  n	-=i+2;
	  if(*lc == '\n'){
	    lc++;
	    n--;
	  }
	}
	else{
	  lc	=Bt+HSec[k].i+L;
	}
	if(n > 0) fwrite(lc,1,n,lFt);
      }
    }
    else{
      if(HSec[k].n){
	fwrite(Bt+HSec[k].i,1,HSec[k].n,lFt);
      }
      else{
	fputs(HSec[k].Nm,lFt);
	fputs(";\n",lFt);
      }
    }
  }
  printf("%s was written\n",FNm);
  fclose(lFt);
  if(Lt) free(Bt);

  /*Read Hlp/<HSectionName>.Hlp*/
  Bt	=NULL;
  Lt	=0;
  sprintf(FNm,"Hlp/%s.Hlp",Nm);
  k	=stat(FNm,&statbuf);
  if(k){
    out("ss",FNm," is absent\n");
    return(1);
  }
  else{
    Lt	=statbuf.st_size;
    Bt	=(char*)malloc((Lt+1)*sizeof(char));
    lFt	=fopen(FNm,"r");
    fread(Bt,1,Lt,lFt);
    *(Bt+Lt)	='\0';
    fclose(lFt);
  }
  strncpy(FNm,"Out",3);
  lFt	=fopen(FNm,"w");
  /*Find section positions and write the head;*/
  sprintf(HSec[0].Nm,"\\c{%s}",Nm);
  HSec[0].L	=strlen(HSec[0].Nm);
  if(Lt){
    lt	=Bt;
    for(k=0; k < nHSec; k++){
      HSec[k].i	=0;
      HSec[k].k	=0;
      HSec[k].n	=0;
      if(k){
	HSec[k].L--;
	*(HSec[k].Nm+HSec[k].L)='\0';
      }
      lc	=k ? strstr(lt,"\\Subsection") : strstr(lt,"\\Section");
      lh	=lc;
      if(lc != NULL){
	HSec[k].i	=lc-Bt;
	lc	+=k ? 11 : 8;
	while(isspace(*lc)) lc++;
	if(*lc == '{'){
	  lc++;
	  while(isspace(*lc)) lc++;
	  if(strncmp(lc,HSec[k].Nm,HSec[k].L) == 0){
	    lc	+=HSec[k].L;
	    i=1;
	    while(i && *lc != '\0'){
	      if(*lc == '{') i++;
	      if(*lc == '}') i--;
	      lc++;
	    }
	    if(*lc != '\0'){
	      lc++;
	      HSec[k].k=lc-Bt;
	      lt=lc;	
	    }
	  }
	}
      }
    }
    for(k=0; k < nHSec; k++){
      if(HSec[k].k){
	L	=Lt;
	for(i=0; i < nHSec; i++){
	  if(i != k && HSec[i].k && HSec[i].i > HSec[k].i 
	     && L > HSec[i].i) L=HSec[i].i;
	}
	HSec[k].n=L-HSec[k].i;
      }
    }
    if(HSec[0].k){
      fwrite(Bt+HSec[0].i,1,HSec[0].n,lFt);
      if(HSec[0].i) fwrite(Bt,1,HSec[0].i,lFt);
    }
    else{
      fprintf(lFt,"\\Section{%s}\n\\vskip-2ex\n",HSec[0].Nm);
      fprintf(lFt,"\\hskip4ex{%s by\\em Author}\n",sT);
      fprintf(lFt,"\\hfill file \\c{%s}\n",FNm);
      k	=0;
      while(k < nHSec && HSec[k].k == 0) k++;
      fwrite(Bt,1,HSec[k].i,lFt);
    }
  }
  else{
    fprintf(lFt,"\\Section{%s}\n\\vskip-2ex\n",HSec[0].Nm);
    fprintf(lFt,"\\hskip4ex{%s by\\em Author}\n",sT);
    fprintf(lFt,"\\hfill file \\c{%s}\n",FNm);
  }   

  for(k=1; k < nHSec; k++){	/*Other sections*/
    if(HSec[k].I){
      fprintf(lFt,"\\Subsection{%s}\n",HSec[k].Nm);
      /*Write Replacement part;*/
      n	=HSec[k].I;
      for(i=0; i < n; i++){
	lc	=HSecInStr(B,&L,HSec[k].C[i]);
	if(lc != NULL){
	  fputs("\\begin{tabular}{|p{1in}p{1.8in}p{0.5in}p{2.5in}|}"
		"\\hline\n"
		"\\multicolumn{4}{|c|}{\\c{<XRayEmiss.tb>}}\\\\\\hline\n"
		"\\em Name&\\em Internal&\\em Math&\\em Comment\\\\\\hline\n"
		,lFt);
	  CommObj2Tabular(lFt,lc);
	  *(lc+L)	='}';
	}
      }
      /*Write preserving part*/
      if(HSec[k].n){
	lh	="\\begin{tabular}{|p{1in}p{1.8in}p{0.5in}p{2.5in}|}";
	lt	=Bt+HSec[k].i;
	lc	=Bt+HSec[k].k;
	while(isspace(*lc)) lc++;
	L	=strlen(lh);
	n	=HSec[k].n;
	while(lc-lt < n && strncmp(lc,lh,L) == 0){
	  lc	=strstr(lc+L,"\\end{tabular}");
	  if(lc != NULL && lc-lt < n){
	    lc	+=13;
	    while(isspace(*lc)) lc++;
	    if(strncmp(lc,"\\noindent",9) == 0) lc+=9;
	  }
	}
	L	=lc-lt;
	n	-=L;
	if(n > 0) fwrite(lc,1,n,lFt);
      }
    }
    else{
      if(HSec[k].n){
	fwrite(Bt+HSec[k].i,1,HSec[k].n,lFt);
      }
      else{
	fprintf(lFt,"\\Subsection{%s}\n",HSec[k].Nm);
      }
    }
  }
  fclose(lFt);
  free(Bt);
  free(B);
  printf("Out/%s.Hlp was written\n",Nm);
  return(0);
}
