#include <string.h>
#include <math.h>
#include <stdio.h>
#include <time.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include "XCbType.h"
char *ctime(const time_t *timep);
time_t time(time_t *t);
char *CbGetCodeNm();
extern Display*theD;
extern Window theW;
extern int NWin;
extern WinPar*WinP;
extern GC theGC,theGCM;
extern XEvent msg;

extern int wF,hF,xshift;
extern unsigned long int ColorPix[];

extern char nameX[],nameY[],nameP[],PageName[];

double Paper_w= 612.,Paper_h= 792.,Reg_w= 468.,Reg_h= 576.,PS_x= 72.,PS_y= 72.,
PSfw= 10.,PSfh= 14.;
int FlagPSopen= 0,FlagPS=0,PageCount=0,Figcount;
FILE*PSFile=NULL;
double PSx0,PSy0,PSsx,PSsy;
int PSdivX=1,PSdivY=1;
static int nLine,nDots,PSdivXY;

static int iCol=0;

static double PSLineWidth=-1.,PSRed=0.,PSGreen=0.,PSBlue=0.;

extern int XCbNColor;

static double unitx,unity,xmax,ymax,xmin,ymin,xg_0,yg_0,sx,sy;
static int ixmax,ixmin,iymax,iymin;
static int iscUx=0,iscUy=0;
static double scUx=1.,scUy=1.;

static int ix1,ix2,iy1,iy2,i_tip=5;
static int mx1,mx2,my1,my2;
static long int PSFilePos= 0;


int SetWindow(int iW)
{
  theW=WinP[iW].W;
  return(0);
}

int XCbGetPlotLayoutAddress(p0,p1,p2,p3,p4,p5,p6,p7)
     double **p0,**p1,**p2,**p3,**p4,**p5,**p6,**p7;
{
  *p0	=&xg_0;
  *p1	=&yg_0;
  *p2	=&xmin;
  *p3	=&ymin;
  *p4	=&xmax;
  *p5	=&ymax;
  *p6	=&sx;
  *p7	=&sy;
  return(0);
}

int InitXmxYmx()
{
  xmin	=1e+20;
  xmax	=-1e+20;
  ymin	=1e+20;
  ymax	=-1e+20;
  return(0);
}

int UpDateXmxYmx(int iWin,double*xdata,double*ydata,int ndata)
{
  int i;
  xmin=xdata[0];
  xmax=xdata[0];
  ymin=ydata[0];
  ymax=ydata[0];
  for(i=1; i < ndata; i++){
    if(xdata[i] < xmin) xmin= xdata[i];
    if(xdata[i] > xmax) xmax= xdata[i];
    if(ydata[i] < ymin) ymin= ydata[i];
    if(ydata[i] > ymax) ymax= ydata[i];
  }
  u_choice(&xmin,&mx1,&xmax,&mx2,&unitx);
  u_choice(&ymin,&my1,&ymax,&my2,&unity);
  WinP[iWin].xm	=xmin;
  WinP[iWin].ym	=ymin;
  WinP[iWin].xmx=xmax;
  WinP[iWin].ymx=ymax;
  return(0);
}

int VirtualFrame(int iWin,int nL)
{
  ixmin	=WinP[iWin].ix;
  ixmax	=WinP[iWin].ix+WinP[iWin].iw-5;
  iymin	=(hF+1)*(nL+1)+1;
  iymax	=WinP[iWin].iy+WinP[iWin].ih-hF;

  WinP[iWin].xm	=xmin;
  WinP[iWin].ym	=ymin;
  WinP[iWin].xmx=xmax;
  WinP[iWin].ymx=ymax;

  WinP[iWin].sx	=1.;
  WinP[iWin].sy	=-1.;
  return(0);
}

int PlotFrame(int iWin,int length,int ind)
{
  static int i,j,l;
  static char ln[10];
  static double s;
  static int ix,iy;

  ix1	=WinP[iWin].ix+i_tip+length*wF;
  ix2	=WinP[iWin].ix+WinP[iWin].iw-5;
  ixmin	=ix1;
  ixmax	=ix2;
  sx	=(ix2-ix1)/(xmax-xmin);
  xg_0	=(double)ix1;

  iy1	=WinP[iWin].iy+hF+3;
  iy2	=WinP[iWin].iy+WinP[iWin].ih-hF-i_tip;
  iymin	=iy1;
  iymax	=iy2;
  sy	=(iy1-iy2)/(ymax-ymin);
  yg_0	=(double)iy2;

  if(ind < 2){
    if(sx > -sy){
      xmax	=xmin-(xmax-xmin)*sx/sy;
      WinP[iWin].xmx=xmax;
      sx	=-sy;
    }
    else{
      ymax	=ymin-(ymax-ymin)*sy/sx;
      WinP[iWin].ymx=ymax;
      sy	=-sx;
    }
  }
  WinP[iWin].sx	=sx;
  WinP[iWin].sy	=sy;
  WinP[iWin].x	=xg_0;
  WinP[iWin].y	=yg_0;

  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,theW,theGC,WinP[iWin].ix+1,WinP[iWin].iy+1
		 ,WinP[iWin].iw,WinP[iWin].ih);
  XSetForeground(theD,theGC,ColorPix[12]);
  XDrawRectangle(theD,theW,theGC,WinP[iWin].ix+1,WinP[iWin].iy+1
		 ,WinP[iWin].iw,WinP[iWin].ih);

  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawString(theD,theW,theGC,ix1,iy1-2,nameY,strlen(nameY));
  l= strlen(nameP);
  XDrawString(theD,theW,theGC,ix2-wF*l,iy1-2,nameP,l);
  l= strlen(nameX);
  iy= iy2+i_tip;
  XDrawString(theD,theW,theGC,ix2-wF*l,iy+hF-2,nameX,l);
  l= ix2-wF*l;
  for(j= mx1;j<=mx2;j++){
    s= unitx*j;
    ix= (int)(xg_0+(s-xmin)*sx);
    XSetForeground(theD,theGC,ColorPix[1]);
    XDrawLine(theD,theW,theGC,ix,iy1,ix,iy2);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy2);
    if(ix+wF<l){
      numstr(s,ln,5);
      XDrawString(theD,theW,theGC,ix-4*wF,iy+hF-2,ln,5);
    }
  }
  ix= ix1-i_tip;
  for(j= my1;j<=my2;j++){
    s= unity*j;
    iy= (int)(yg_0+(s-ymin)*sy);
    XSetForeground(theD,theGC,ColorPix[1]);
    XDrawLine(theD,theW,theGC,ix1,iy,ix2,iy);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix1,iy);
    numstr(s,ln,length);
    XDrawString(theD,theW,theGC,ix-length*wF,iy+2,ln,length);
  }
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawRectangle(theD,theW,theGC,ix1,iy1,ix2-ix1,iy2-iy1);
  return(0);
}

int SetPlotLimits(int iW)
{
  theW	=WinP[iW].W;
  xmin=WinP[iW].xm;
  ymin=WinP[iW].ym;
  xmax=WinP[iW].xmx;
  ymax=WinP[iW].ymx;
  sx=WinP[iW].sx;
  sy=WinP[iW].sy;
  xg_0=WinP[iW].x;
  yg_0=WinP[iW].y;
  return(0);
}

int Plot2D(iWin,xdata,ydata,ndata,length,data_style,icol,ind_refresh)
     double*xdata,*ydata;
     int ndata,length,data_style,icol,ind_refresh;
     int iWin;
{
  static int i,i1,j,l;
  static double s;
  static int ix,iy;

  if(ndata == 0){
    return(0);
  }
  theW= WinP[iWin].W;
  if(ind_refresh > 0){
    InitXmxYmx();
    UpDateXmxYmx(iWin,xdata,ydata,ndata);
    PlotFrame(iWin,length,ind_refresh);
  }
  else{
    xmin= WinP[iWin].xm;
    ymin= WinP[iWin].ym;
    xmax= WinP[iWin].xmx;
    ymax= WinP[iWin].ymx;
    sx= WinP[iWin].sx;
    sy= WinP[iWin].sy;
    xg_0= WinP[iWin].x;
    yg_0= WinP[iWin].y;
  }
  XSetForeground(theD,theGC,ColorPix[icol]);
  j= data_style%2;
  for(i= 0;i<ndata;i++){
    ix= (int)(xg_0+(xdata[i]-xmin)*sx);
    iy= (int)(yg_0+(ydata[i]-ymin)*sy);
    if(j){
      if(ymin<=ydata[i]&&ydata[i]<=ymax){
	XDrawRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
	XDrawRectangle(theD,theW,theGC,ix,iy,0,0);
      }
    }
    else{
      if(i){
	i1= i-1;
	PlotLine(xdata[i1],ydata[i1],xdata[i],ydata[i]);
      }
    }
  }
  if(FlagPS){
    PSPlot2D(xdata,ydata,ndata,length,data_style,icol,ind_refresh);
  }
  return(0);
}

int PSPlotFrame(int length,int data_style)
{
  static int j,l;
  static char ln[10];
  static double s;
  static double ix,ix1,ix2,iy,iy1,iy2,i_tip= 7.;

  ix1	=PS_x+i_tip+length*PSfw;
  ix2	=PS_x+Reg_w-10;
  PSsx	=(ix2-ix1)/(xmax-xmin);
  PSx0	=ix1;
  iy1	=PS_y+PSfh+3;
  iy2	=PS_y+Reg_h-i_tip-PSfh;
  PSsy	=(iy1-iy2)/(ymax-ymin);
  PSy0	=iy2;
  if(data_style < 2){
    if(PSsx > -PSsy){
      PSsx	=-PSsy;
    }
    else{
      PSsy	=-PSsx;
    }
  }

#ifdef H
  PSSetForeground(12);
  PSDrawRectangle(PS_x,PS_y,Reg_w,Reg_h);
#endif

  fprintf(PSFile,"newpath %%X-axis\n");
  PSSetForeground(0);
  PSDrawLString(ix1,iy1-2,nameY,strlen(nameY));
  l= strlen(nameP);
  PSDrawRString(ix2,iy1-2,nameP,l);
  iy= iy2+i_tip;
  l= strlen(nameX);
  PSDrawRString(ix2,iy+PSfh-2,nameX,l);
  l= ix2-PSfw*l*0.7;
  for(j= mx1;j<=mx2;j++){
    s= unitx*j;
    ix= PSx0+(s-xmin)*PSsx;
    PSSetForeground(11);
    PSDrawLine(ix,iy1,ix,iy2);
    PSSetForeground(0);
    PSDrawLine(ix,iy,ix,iy2);
    if(ix+i_tip<l){
      numstr(s,ln,5);
      PSDrawRString(ix+i_tip,iy+PSfh-2,ln,5);
    }
  }
  fprintf(PSFile,"stroke\n");
  fprintf(PSFile,"newpath %%Y-axis\n");
  ix	=ix1-i_tip;
  for(j=my1; j <= my2; j++){
    s	=unity*j;
    iy	=PSy0+(s-ymin)*PSsy;
    PSSetForeground(11);
    PSDrawLine(ix1,iy,ix2,iy);
    PSSetForeground(0);
    PSDrawLine(ix,iy,ix1,iy);
    numstr(s,ln,length);
    PSDrawRString(ix-i_tip+2,iy+2,ln,length);
  }
  fprintf(PSFile,"stroke\n");
  PSSetForeground(0);
  PSDrawRectangle(ix1,iy1,ix2-ix1,iy2-iy1);
  ix= PSx0+(xmax-xmin)*PSsx;
  iy= Paper_h-PSy0;
  iy1= Paper_h-PSy0+(ymax-ymin)*PSsy;
  nLine=0;
  return(0);
}

int CbGetScale(double *sX, double *sY)
{
  *sX=sx;
  *sY=sy;
  return(0);
}

int Scale2D(int iWin,int nL,double*xdata,double*ydata,
	    int ndata,int length,int ind)
{
  static int i,j,l;
  static double s;
  static int ix,iy;
  static char ln[10];

  if(ndata == 0) return(0);
  theW	=WinP[iWin].W;
  InitXmxYmx();
  UpDateXmxYmx(iWin,xdata,ydata,ndata);
  if(nL > 1){
    WinP[iWin].iy	=(nL+1)*(hF+1);
    PlotFrame(iWin,length,ind);
  }
  if(FlagPS) PSPlotFrame(length,ind);
#ifdef H
  PSScale2D(xdata,ydata,ndata,length,ind);
#endif
  return(0);
}

int XCbSetUnitScaleXY(double scX,double scY)
{
  scUx	=scX;
  scUy	=scY;
  iscUx	=scUx == 1. ? 0 : 1;
  iscUy	=scUy == 1. ? 0 : 1;
  return(0);
}

int SetScale2D(int iWin)
{
  theW	=WinP[iWin].W;
  xmin	=WinP[iWin].xm;
  ymin	=WinP[iWin].ym;
  xmax	=WinP[iWin].xmx;
  ymax	=WinP[iWin].ymx;
  sx	=WinP[iWin].sx;
  sy	=WinP[iWin].sy;
  xg_0	=WinP[iWin].x;
  yg_0	=WinP[iWin].y;
  return(0);
}

int ReScale2D(int iWin,double*xdata,double*ydata,
	      int ndata,int length,int ind)
{
  static int i,j,l;
  static double s;
  static int ix,iy,i_tip= 5;
  static char ln[10];

  if(ndata==0)
    return(0);
  theW= WinP[iWin].W;
  xmin= WinP[iWin].xm;
  ymin= WinP[iWin].ym;
  xmax= WinP[iWin].xmx;
  ymax= WinP[iWin].ymx;

  UpDateXmxYmx(iWin,xdata,ydata,ndata);
  PlotFrame(iWin,length,ind);
  if(FlagPS){
    PSReScale2D(xdata,ydata,ndata,length,ind);
  }
  return(0);
}

int Scale1D(iWP,x01,x02,ind)
     double x01,x02;
     int ind;
     int iWP;
{
  static int i,j,l;
  static double s,un;
  static int ix,ix1,ix2,iy,i_tip= 5,mxmin,mxmax;
  static char ln[10];
  theW	=WinP[iWP].W;
  ix1	=WinP[iWP].ix+5;
  ix2	=WinP[iWP].ix+WinP[iWP].iw-5;
  xg_0	=(double)ix1;
  iy	=3*hF+9;

  yg_0	=(double)iy;
  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,theW,theGC,0,iy-9-hF,WinP[iWP].iW,i_tip+2*hF+9);
  if(ind == 0){
    return(0);
  }
  xmin= x01;
  xmax= x02;
  u_choice(&xmin,&mxmin,&xmax,&mxmax,&un);
  sx= (ix2-ix1)/(xmax-xmin);
  for(j= mxmin;j<=mxmax;j++){
    s= un*j;
    ix= (int)(xg_0+(s-xmin)*sx);
    XSetForeground(theD,theGC,ColorPix[11]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy-3);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy+i_tip);
    numstr(s,ln,5);
    XDrawString(theD,theW,theGC,ix-4*wF,iy+hF-2,ln,5);
  }
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawRectangle(theD,theW,theGC,ix1,iy-1,ix2-ix1,1);
  XDrawString(theD,theW,theGC,ix1,iy-9,nameX,strlen(nameX));
  l= strlen(nameP);
  XDrawString(theD,theW,theGC,ix2-wF*l,iy-9,nameP,l);

  WinP[iWP].xm= xmin;
  WinP[iWP].ym= 0.;
  WinP[iWP].xmx= xmax;
  WinP[iWP].ymx=WinP[iWP].iy+WinP[iWP].ih-yg_0;
  WinP[iWP].sx= sx;
  WinP[iWP].sy= -1.;
  WinP[iWP].x= xg_0;
  WinP[iWP].y= yg_0-7.;

  return(0);
}

int rule(iWP,x01,x02,x1,x2,x,icol,ind)
     double x01,x02,x1,x2,x;
     int icol,ind;
     int iWP;
{
  static int i,j,l;
  static double s,un;
  static int ix,ix1,ix2,iy,i_tip= 5,mxmin,mxmax;
  static char ln[10];
  theW= WinP[iWP].W;
  ix1= WinP[iWP].ix+5;
  ix2= WinP[iWP].ix+WinP[iWP].iw-5;
  xg_0= (double)ix1;
  iy= 4*hF;
  yg_0= (double)iy;
  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,theW,theGC,0,iy-9-hF,WinP[iWP].iW,i_tip+2*hF+9);
  if(ind==0){
    return(0);
  }
  xmin= x01;
  xmax= x02;
  u_choice(&xmin,&mxmin,&xmax,&mxmax,&un);
  sx= (ix2-ix1)/(xmax-xmin);
  for(j= mxmin;j<=mxmax;j++){
    s= un*j;
    ix= (int)(xg_0+(s-xmin)*sx);
    XSetForeground(theD,theGC,ColorPix[11]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy-3);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy+i_tip);
    numstr(s,ln,5);
    XDrawString(theD,theW,theGC,ix-4*wF,iy+hF-2,ln,5);
  }
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawRectangle(theD,theW,theGC,ix1,iy-1,ix2-ix1,1);
  XDrawString(theD,theW,theGC,ix1,iy-9,nameX,strlen(nameX));
  ix= (int)(xg_0+(x1-xmin)*sx);
  XFillRectangle(theD,theW,theGC,ix-1,iy-6,2,7);
  ix= (int)(xg_0+(x2-xmin)*sx);
  XFillRectangle(theD,theW,theGC,ix-1,iy-6,2,7);
  XSetForeground(theD,theGC,ColorPix[icol]);
  if(x<x02&&x>x01){
    ix= (int)(xg_0+(x-xmin)*sx);
    XFillRectangle(theD,theW,theGC,ix-1,iy-7,2,6);
  }
  WinP[iWP].xm= xmin;
  WinP[iWP].ym= 0.;
  WinP[iWP].xmx= xmax;
  WinP[iWP].ymx= 1.;
  WinP[iWP].sx= sx;
  WinP[iWP].sy= 1.;
  WinP[iWP].x= xg_0;
  WinP[iWP].y= yg_0-7.;
  return(0);
}

int CbPSBegOfLine(int icol)
{
  fprintf(PSFile,"newpath %%Line=%d\n",nLine);
  if(PSLineWidth != 1.){
    fprintf(PSFile,"1 setlinewidth\n");
    PSLineWidth	=1;
  }
  nLine++;
  fprintf(PSFile,"%13.6e %13.6e translate\n",PSx0,Paper_h-PSy0);
  fprintf(PSFile,"%15.8e %15.8e scale\n",PSsx,-PSsy);
  fprintf(PSFile,"%13.6e %13.6e translate\n",-xmin,-ymin);
  PSSetForeground(icol);
  nDots= 0;
  return(0);
}

int CbPSStartOfLine(double x,double y)
{
  int k;
  double ix;
  double iy;
  nDots= 0;
  ix= x;
  iy= y;
  if(ZPlotCheck(&ix,&iy,&ix,&iy)){
    fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
    nDots++;
  }
  return(0);
}

int PSDrawSegm(double PSx1,double PSy1,double PSx,double PSy)
{
  int k;
  double ix,ix1;
  double iy,iy1;

  ix= PSx;
  iy= PSy;
  ix1= PSx1;
  iy1= PSy1;

  k= ZPlotCheck(&ix1,&iy1,&ix,&iy);
  if(k>0){
    fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
    nDots++;
  }
  if(k==-1){
    nDots= 0;
    fprintf(PSFile,"%13.6e %13.6e\n",ix1,iy1);
    nDots++;
    fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
    nDots++;
  }
  if(k==-2){
    fprintf(PSFile,"%13.6e %13.6e moveto\n",ix,iy);
    fprintf(PSFile,"%d{lineto}repeat\n",nDots);
    nDots= 0;
  }
  if(nDots>100){
    fprintf(PSFile,"moveto %d{lineto}repeat\n",nDots-1);
    fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
    nDots= 1;
  }
  return(0);
}

int CbPSStartOfObj()
{
  fprintf(PSFile,"newpath %%Rect\n");
  return(0);
}

int CbPSDrawRectangle(double x,double y,double w,double h)
{
  fprintf(PSFile,"%13.6e %13.6e  moveto\n",x,y);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,h);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,-h);
  return(0);
}

int CbPSFillRectangle(double x,double y,double w,double h)
{
  fprintf(PSFile,"%13.6e %13.6e  moveto\n",x,y);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,h);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,-h);
  return(0);
}

int CbPSEndOfObj()
{
  fprintf(PSFile,"%13.6e %13.6e translate\n",xmin,ymin);
  fprintf(PSFile,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
  fprintf(PSFile,"stroke\n");
  fprintf(PSFile,"%13.6e %13.6e translate\n",-PSx0,PSy0-Paper_h);
  return(0);
}

int CbPSEndOfLine()
{
  if(nDots){
    fprintf(PSFile," moveto\n");
    if(nDots>1)
      fprintf(PSFile,"%d{lineto}repeat\n",nDots-1);
    else
      fprintf(PSFile,"0 0 rlineto\n");
  }
  fprintf(PSFile,"%13.6e %13.6e translate\n",xmin,ymin);
  fprintf(PSFile,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
  fprintf(PSFile,"stroke\n");
  fprintf(PSFile,"%13.6e %13.6e translate\n",-PSx0,PSy0-Paper_h);
  fprintf(PSFile,"0.3 setlinewidth\n");
  PSLineWidth	=0.3;
  return(0);
}

int PSPlot2D(xdata,ydata,ndata,length,data_style,icol,ind_refresh)
     double*xdata,*ydata;
     int ndata,length,data_style,icol,ind_refresh;
{
  static int i,i1,j,n,k;
  static double s;
  static double ix,ix1,ix2,iy,iy1,iy2;
  if(ind_refresh == 1){
    if(PSFile == NULL){
      PSFileOpen(1,1);
    }
    PSPlotFrame(length,data_style);
  }
  fprintf(PSFile,"newpath %%Line=%d\n",nLine);
  nLine++;
  fprintf(PSFile,"%13.6e %13.6e translate\n",PSx0,Paper_h-PSy0);
  fprintf(PSFile,"%15.8e %15.8e scale\n",PSsx,-PSsy);
  fprintf(PSFile,"%13.6e %13.6e translate\n",-xmin,-ymin);
  PSSetForeground(icol);
  j	=data_style%2;
  if(j){
    n	=0;
    for(i=0; i < ndata; i++){
      ix	=xdata[i];
      iy	=ydata[i];
      if(ZPlotCheck(&ix,&iy,&ix,&iy)>0){
	fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
	n++;
      }
      if(n > 100){
	ix	=2./PSsx;
	iy	=2./PSsy;
	fprintf(PSFile,"%d{moveto 0 0 rlineto %13.6e %13.6e rmoveto\n",n
		,-ix,-iy);
	ix	*=2.;
	iy	*=2.;
	fprintf(PSFile," 0 %13.6e rlineto %13.6e 0 rlineto\n",iy,ix);
	fprintf(PSFile," 0 %13.6e rlineto %13.6e 0 rlineto}repeat\n",-iy,-ix);
	n= 0;
      }
    }
    if(n){
      ix	=2./PSsx;
      iy	=2./PSsy;
      fprintf(PSFile,"%d{moveto 0 0 rlineto %13.6e %13.6e rmoveto\n",n,
	      -ix,-iy);
      ix	*=2.;
      iy	*=2.;
      fprintf(PSFile," 0 %13.6e rlineto %13.6e 0 rlineto\n",iy,ix);
      fprintf(PSFile," 0 %13.6e rlineto %13.6e 0 rlineto}repeat\n",-iy,-ix);
    }
  }
  else{
    for(i=0; i < ndata; i++){
      ix	=xdata[i];
      iy	=ydata[i];
      if(i){
	i1	=i-1;
	ix1	=xdata[i1];
	iy1	=ydata[i1];
	k	=ZPlotCheck(&ix1,&iy1,&ix,&iy);
	if(k > 0){
	  fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
	  n++;
	}
	if(k == -1){
	  n	=0;
	  fprintf(PSFile,"%13.6e %13.6e\n",ix1,iy1);
	  n++;
	  fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
	  n++;
	}
	if(k == -2){
	  fprintf(PSFile,"%13.6e %13.6e moveto\n",ix,iy);
	  fprintf(PSFile,"%d{lineto}repeat\n",n);
	  n	=0;
	}
      }
      else{
	n	=0;
	k	=ZPlotCheck(&ix,&iy,&ix,&iy);
	if(k){
	  fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
	  n++;
	}
      }

      if(n > 100){
	fprintf(PSFile,"moveto %d{lineto}repeat\n",n-1);
	fprintf(PSFile,"%13.6e %13.6e\n",ix,iy);
	n	=1;
      }
    }
    if(n){
      fprintf(PSFile," moveto\n");
      if(n > 1)
	fprintf(PSFile,"%d{lineto}repeat\n",n-1);
      else
	fprintf(PSFile,"0 0 rlineto\n");
    }
  }
  fprintf(PSFile,"%13.6e %13.6e translate\n",xmin,ymin);
  fprintf(PSFile,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
  fprintf(PSFile,"stroke\n");
  fprintf(PSFile,"%13.6e %13.6e translate\n",-PSx0,PSy0-Paper_h);
  if(ind_refresh == -1){
    if(FlagPS == 2){
      FlagPSopen	=0;
      fprintf(PSFile,"showpage\n");
    }
    FlagPS	=0;
    PSFilePos	=ftell(PSFile);
    fprintf(PSFile,"showpage\n");
    fclose(PSFile);
    PSFile	=NULL;
  }
  return(0);
}

int CbPageTitle(char*PageName,int*PageCnt)
{
  time_t T;
  time(&T);
  fprintf(PSFile,"%%%%Page: %d %d\n",*PageCnt+1,*PageCnt+1);

#ifdef H

  fprintf(PSFile,"/Helvetica-Oblique findfont setfont\n");
  fprintf(PSFile,"306 54. moveto\n");
  fprintf(PSFile,"6.25e-02  16. (%s) Mshow\n",PageName);
  fprintf(PSFile,"576 36. moveto\n");
#endif

  fprintf(PSFile,"/Helvetica findfont setfont\n");

#ifdef H
  fprintf(PSFile,"0.1  10. (Page %2d) Rshow\n",*PageCnt+1);
  printf("PS Page=%d\n",*PageCnt+1);
  fprintf(PSFile,"%13.6e %13.6e moveto\n",Paper_w-72,Paper_h-24);
  fprintf(PSFile,"0.125  8. (Generated by Cb%s, %s) Rshow\n"
	  ,CbGetCodeNm(),ctime(&T));
#endif

  (*PageCnt)++;
  PSLineWidth	=0.;
  return(0);
}

int CbPSFigClose(long int *Pos)
{
  if(FlagPS == 0){
    return(0);
  }
  FlagPS	=0;
  *Pos	=ftell(PSFile);
  fprintf(PSFile,"showpage\n");
  fclose(PSFile);
  PSFile	=NULL;
  return(0);
}

int CbPSDefinitions()
{
  fprintf(PSFile,"%%!PS-Adobe-2.0\n\
/Lshow {exch dup scale show dup scale}def\n\
/Rshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll mul neg 0 rmoveto\n\
dup scale show dup scale}def\n\
/Mshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll -0.5 mul mul 0 rmoveto\n\
dup scale show dup scale}def\n");


#ifdef New
/Rshow {dup stringwidth pop 3 -1 roll
dup 3 -1 roll mul neg 0 rmoveto
dup dup scale exch show 1 exch div dup scale}def
#endif


  return(0);
}

int CbPSFileOpen(char*NmF,char*PageName,
		 int*FlagPSopn,int*Figcnt,int*PageCnt,long int *Pos)
{
  int i;
  switch(*FlagPSopn){
  case 0:
    PSFile= fopen(NmF,"w+");
    PSdivXY= PSdivX*PSdivY;
    if(PSFile != NULL){
      fseek(PSFile,0L,0);
      printf("%s file is open\n",NmF);
      CbPSDefinitions();
      *FlagPSopn= 1;
      *Figcnt= 0;
      *PageCnt= 0;
      CbPageTitle(PageName,PageCnt);
      printf("Fig %d\n",*Figcnt);
      fprintf(PSFile,"");
      fprintf(PSFile,"%%Figure %2d\n2 setlinejoin\n%g setlinewidth\n"
	      ,*Figcnt,0.3);
      PSLineWidth	=0.3;
      fprintf(PSFile,"72 72 translate %10.8f %10.8f scale -72 -72 translate\n",
	      1./(double)PSdivX,1./(double)PSdivY);
      fprintf(PSFile,"0 %g translate\n",(Paper_h-108)*(PSdivY-1));
      *Pos= ftell(PSFile);
    }
    else{
      printf("%s -  PSFile cannot be opened\n",NmF);
    }
    break;
  default:
    PSFile	=fopen(NmF,"r+");
    if(PSFile != NULL){
      (*Figcnt)++;
      i	=(*Figcnt)%PSdivXY;
      fseek(PSFile,*Pos,0);
      if(i == 0){
#ifdef H
	fseek(PSFile,0L,2);
#endif
	fprintf(PSFile,"showpage\n");

	CbPSDefinitions();

	CbPageTitle(PageName,PageCnt);
      }
      fprintf(PSFile,"%%Figure %2d\n2 setlinejoin\n%g setlinewidth\n"
	      ,*Figcnt,0.3);
      PSLineWidth	=0.3;
      printf("Fig %d\n",*Figcnt);
      if(i){
	if(i%PSdivX){
	  fprintf(PSFile,"%g 0 translate\n",Paper_w-108);
	}
	else{
	  fprintf(PSFile,"%g %g translate\n",
		  -(Paper_w-108)*(PSdivX-1),-Paper_h+108);
	}
      }
      else{
	fprintf(PSFile,
		"72 72 translate %11.8f %11.8f scale -72 -72 translate\n",
		1./(double)PSdivX,1./(double)PSdivY);
	fprintf(PSFile,"0 %g translate\n",(Paper_h-108)*(PSdivY-1));
      }
      *Pos= ftell(PSFile);
    }
    else{
      FlagPS	=0;
      printf("%s cannot be reopen\n",NmF);
    }
    break;
  }
  *Pos= ftell(PSFile);
  return(0);
}

/* For use out of CodeBuilder */
int PSScale2DExt(int length,int data_style)
{
  if(PSFile == NULL){
    PSFileOpen(1,1);
  }
  fseek(PSFile,PSFilePos,0);
  PSPlotFrame(length,data_style);
  return(0);
}

int PSReScale2D(int length,int data_style)
{
  fseek(PSFile,PSFilePos,0);
  PSPlotFrame(length,data_style);
  return(0);
}

int PSSetForeground(i)
     int i;
{
  static char*CNm[]= {"0 0 0",
			"0.80392  0.75294  0.69020",
			"0.93333  0.87451  0.80000",
			"1.00000  1.00000  1.00000",

			"0.00000  0.00000  1.00000",
			"0.52941  0.80784  0.92157",
			"0.90196  0.90196  0.98039",

			"0.00000  0.80392  0.80392",
			"0.00000  0.93333  0.93333",
			"0.00000  1.00000  1.00000",

			"0.00000  0.39216  0.00000",
			"0.00000  1.00000  0.00000",
			"1.00000  1.00000  0.00000",

			"1.00000  0.00000  1.00000",
			"1.00000  0.00000  0.00000",
			"0.85098  0.85098  0.85098",

			"1.00000  0.07843  0.57647",
			"1.00000  0.64706  0.00000",
			"0.98039  0.94118  0.90196",

			"1.00000  0.51373  0.98039",
			"0.93333  0.68235  0.93333",
			"1.00000  0.73333  1.00000"
		    };
  if(i < 22){
    fprintf(PSFile,"%s setrgbcolor\n",CNm[i]);
  }
  else{
    fprintf(PSFile,"%s setrgbcolor\n",CNm[0]);
  }
  return(0);
}

int PSDrawRectangle(double x,double y,double w,double h)
{
  fprintf(PSFile,"newpath %%Rect\n");
  fprintf(PSFile,"%13.6e %13.6e  moveto\n",x,Paper_h-y);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,-h);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,h);
  fprintf(PSFile,"stroke\n");
  return(0);
}

int PSFillRectangle(x,y,w,h)
     double x,y,w,h;
{
  fprintf(PSFile,"newpath %%Rectangle\n");
  fprintf(PSFile,"%13.6e %13.6e  moveto\n",x,Paper_h-y);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,-h);
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,h);
  fprintf(PSFile,"fill\n");
  return(0);
}

int PSDrawLine(x1,y1,x2,y2)
     double x1,y1,x2,y2;
{
  fprintf(PSFile,"%13.6e %13.6e %13.6e %13.6e moveto lineto\n"
	  ,x2,Paper_h-y2,x1,Paper_h-y1);
  return(0);
}

int PSDrawLString(x,y,ln,n)
     double x,y;
     char*ln;
     int n;
{
  ln[n]= '\0';
  fprintf(PSFile,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSFile,"%13.6e %13.6e (%s) Lshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int PSDrawRString(x,y,ln,n)
     double x,y;
     char*ln;
     int n;
{
  ln[n]= '\0';
  fprintf(PSFile,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSFile,"%13.6e %13.6e (%s) Rshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int PSDrawMString(x,y,ln,n)
     double x,y;
     char*ln;
     int n;
{
  ln[n]= '\0';
  fprintf(PSFile,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSFile,"%13.6e %13.6e (%s) Mshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int DisplayRect(x1,y1,x2,y2,col)
     double x1,y1,x2,y2;
     int col;
{
  int ix1,ix2,iy1,iy2,i;
  XSetForeground(theD,theGC,ColorPix[col]);
  ix1= (int)(xg_0+(x1-xmin)*sx);
  ix2= (int)(xg_0+(x2-xmin)*sx);
  iy1= (int)(yg_0+(y1-ymin)*sy);
  iy2= (int)(yg_0+(y2-ymin)*sy);
  if(ix1>ix2){
    i= ix2;
    ix2= ix1-ix2;
    ix1= i;
  }
  else
    ix2-= ix1;
  if(iy1>iy2){
    i= iy2;
    iy2= iy1-iy2;
    iy1= i;
  }
  else
    iy2-= iy1;

  XFillRectangle(theD,theW,theGC,ix1,iy1,ix2+1,iy2+1);
  if(FlagPS){
    double s;
    PSSetForeground(col);
    fprintf(PSFile,"newpath %%FillRectangle\n");
    s	=fabs((y2-y1)*PSsy);
    if(PSLineWidth != s){
      fprintf(PSFile,"%g setlinewidth\n",s);
      PSLineWidth	=s;
    }
    fprintf(PSFile,"%13.6e %13.6e  moveto\n",PSx0+(x1-xmin)*PSsx,
	    Paper_h-(PSy0+(0.5*(y1+y2)-ymin)*PSsy));
    fprintf(PSFile,"%13.6e 0. rlineto\n",(x2-x1)*PSsx);
    fprintf(PSFile,"stroke\n");
  }
  return(0);
}

int PlotString(x,y,ln,len)
     double x,y;
     char*ln;
     int len;
{
  static int ix,iy;

  if(ymin<=y&&y<=ymax&&xmin<=x&&x<=xmax){
    ix= (int)(xg_0+(x-xmin)*sx);
    iy= (int)(yg_0+(y-ymin)*sy)+hF/2;
    XDrawString(theD,theW,theGC,ix,iy,ln,len);
    if(FlagPS){
      PSDrawLString(PSx0+(x-xmin)*PSsx-14.,
		    PSy0+(y-ymin)*PSsy,ln,len);
    }
  }
  return(0);
}

int PlotLine(x,y,x1,y1)
     double x,y,x1,y1;
{
  if(y1<ymin){
    if(y<ymin)
      return(0);
    x1+= (x-x1)*(ymin-y1)/(y-y1);
    y1= ymin;
  }
  if(ymax<y1){
    if(ymax<y)
      return(0);
    x1+= (x-x1)*(ymax-y1)/(y-y1);
    y1= ymax;
  }
  if(x1<xmin){
    if(x<xmin)
      return(0);
    y1+= (y-y1)*(xmin-x1)/(x-x1);
    x1= xmin;
  }
  if(xmax<x1){
    if(xmax<x)
      return(0);
    y1+= (y-y1)*(xmax-x1)/(x-x1);
    x1= xmax;
  }
  if(y<ymin){
    x+= (x1-x)*(ymin-y)/(y1-y);
    y= ymin;
  }
  if(ymax<y){
    x+= (x1-x)*(ymax-y)/(y1-y);
    y= ymax;
  }
  if(x<xmin){
    y+= (y1-y)*(xmin-x)/(x1-x);
    x= xmin;
  }
  if(xmax<x){
    y+= (y1-y)*(xmax-x)/(x1-x);
    x= xmax;
  }
  XDrawLine(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx),(int)(yg_0+(y-ymin)*sy),
	    (int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy));
#ifdef H
  XFlush(theD);
#endif
  return(1);
}

int PlotPolyLine(double *X,double *Y,int n)
{
  int i;
  double x1,y1,x2,y2;

  x2	=X[0];
  y2	=Y[0];
  for(i=1; i < n; i++){
    x1	=x2;
    y1	=y2;
    x2	=X[i];
    y2	=Y[i];
    if(ZPlotCheck(&x1,&y1,&x2,&y2)){
      XDrawLine(theD,theW,theGC
		,(int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy)
		,(int)(xg_0+(x2-xmin)*sx),(int)(yg_0+(y2-ymin)*sy));
    }
  }
  return(0);
}

int CbFlush()
{
  XFlush(theD);
  return(0);
}

int PlotSimpleLine(double x,double y,double x1,double y1)
{
  XDrawLine(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx),(int)(yg_0+(y-ymin)*sy),
	    (int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy));
  return(1);
}

int ZColor(int col)
{
  XSetForeground(theD,theGC,ColorPix[col]);
  iCol	=col;
  if(FlagPS){
    PSSetForeground(col);
  }
  return(0);
}

int ZPlotCheck(double*x,double*y,double*x1,double*y1)
{
  int i;
  i	=1;
  if(*y1 < ymin){
    if(*y < ymin){
      return(0);
    }
    *x1	+=(*x-*x1)*(ymin-*y1)/(*y-*y1);
    *y1	=ymin;
    i	=-2;
  }
  if(ymax < *y1){
    if(ymax < *y){
      return(0);
    }
    *x1 +=(*x-*x1)*(ymax-*y1)/(*y-*y1);
    *y1	=ymax;
    i	=-2;
  }
  if(*x1<xmin){
    if(*x<xmin){
      return(0);
    }
    *y1	+=(*y-*y1)*(xmin-*x1)/(*x-*x1);
    *x1	=xmin;
    i	=-2;
  }
  if(xmax < *x1){
    if(xmax < *x){
      return(0);
    }
    *y1	+=(*y-*y1)*(xmax-*x1)/(*x-*x1);
    *x1	=xmax;
    i	=-2;
  }

  if(*y<ymin){
    *x	+=(*x1-*x)*(ymin-*y)/(*y1-*y);
    *y	=ymin;
    i	=-1;
  }
  if(ymax < *y){
    *x	+=(*x1-*x)*(ymax-*y)/(*y1-*y);
    *y	=ymax;
    i	=-1;
  }
  if(*x < xmin){
    *y	+=(*y1-*y)*(xmin-*x)/(*x1-*x);
    *x	=xmin;
    i	=-1;
  }
  if(xmax < *x){
    *y	+=(*y1-*y)*(xmax-*x)/(*x1-*x);
    *x	=xmax;
    i	=-1;
  }
  return(i);
}

int ZPlotRect(double x1,double y1,double x2,double y2,int col)
{
  XSetForeground(theD,theGC,ColorPix[col]);
  if(iscUx){
    x1	*=scUx;
    x2	*=scUx;
  }
  if(iscUy){
    y1	*=scUy;
    y2	*=scUy;
  }
  if(x1 > x2){
    double x;
    x	=x2;
    x2	=x1;
    x1	=x;
  }
  if(y1 > y2){
    double y;
    y	=y2;
    y2	=y1;
    y1	=y;
  }

  if(x2 < xmin || x1 > xmax || y2 < ymin || y1 > ymax) return(0);
  if(x1 < xmin) x1=xmin;
  if(x2 > xmax) x2=xmax;
  if(y1 < ymin) y1=ymin;
  if(y2 > ymax) y2=ymax;
  XFillRectangle(theD,theW,theGC
		 ,(int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y2-ymin)*sy)
		 ,(int)((x2-x1)*sx)+1,(int)((y1-y2)*sy)+1);
  if(FlagPS){
    double s;
    PSSetForeground(col);
    fprintf(PSFile,"newpath %%FillRectangle\n");
    s	=fabs((y2-y1)*PSsy);
    if(PSLineWidth != s){
      fprintf(PSFile,"%g setlinewidth\n",s);
      PSLineWidth	=s;
    }
    fprintf(PSFile,"%13.6e %13.6e moveto %13.6e 0. rlineto\n"
	    ,PSx0+(x1-xmin)*PSsx,Paper_h-(PSy0+(0.5*(y1+y2)-ymin)*PSsy)
	    ,(x2-x1)*PSsx);
    fprintf(PSFile,"stroke\n");
  }
  return(0);
}

int ZPlotRect0(double x1,double y1,double x2,double y2,int col)
{
  XSetForeground(theD,theGC,ColorPix[col]);
  if(iscUx){
    x1	*=scUx;
    x2	*=scUx;
  }
  if(iscUy){
    y1	*=scUy;
    y2	*=scUy;
  }
  if(x1 > x2){
    double x;
    x	=x2;
    x2	=x1;
    x1	=x;
  }
  if(y1 > y2){
    double y;
    y	=y2;
    y2	=y1;
    y1	=y;
  }

  if(x2 < xmin || x1 > xmax || y2 < ymin || y1 > ymax) return(0);
  if(x1 < xmin) x1=xmin;
  if(x2 > xmax) x2=xmax;
  if(y1 < ymin) y1=ymin;
  if(y2 > ymax) y2=ymax;
  XFillRectangle(theD,theW,theGC
		 ,(int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y2-ymin)*sy)
		 ,(int)((x2-x1)*sx)+1,(int)((y1-y2)*sy)+1);
  if(FlagPS){
    double s;
    PSSetForeground(col);
    fprintf(PSFile,"newpath %%FillRectangle\n");
    s	=fabs((y2-y1)*PSsy);
    if(PSLineWidth != s){
      fprintf(PSFile,"%g setlinewidth\n",s);
      PSLineWidth	=s;
    }
    fprintf(PSFile,"%13.6e %13.6e moveto %13.6e 0. rlineto\n"
	    ,PSx0+(x1-xmin)*PSsx,Paper_h-(PSy0+(0.5*(y1+y2)-ymin)*PSsy)
	    ,(x2-x1)*PSsx);
    fprintf(PSFile,"stroke\n");
  }
  return(0);
}

int ZPlotIntRect(double x,double y,int iw,int ih,int col)
{
  XSetForeground(theD,theGC,ColorPix[col]);
  if(iscUx) x*=scUx;
  if(iscUy) y*=scUy;
  if(x < xmin || x > xmax || y < ymin || y > ymax) return(0);
  XFillRectangle(theD,theW,theGC
		 ,(int)(xg_0+(x-xmin)*sx)-iw/2,(int)(yg_0+(y-ymin)*sy)-ih/2
		 ,iw+1,ih+1);
  if(FlagPS){
    double s;
    PSSetForeground(col);
    fprintf(PSFile,"newpath %%FillRectangle\n");
    s	=ih;
    if(PSLineWidth != s){
      fprintf(PSFile,"%g setlinewidth\n",s);
      PSLineWidth	=s;
    }
    fprintf(PSFile,"%13.6e %13.6e  moveto\n",PSx0+(x-xmin)*PSsx-0.5*iw,
	    Paper_h-(PSy0+(y-ymin)*PSsy));
    fprintf(PSFile,"%d 0. rlineto\n",iw);
    fprintf(PSFile,"stroke\n");
  }
  return(0);
}

int ZPlotTopLString(char* ln,int len)
{
  XDrawString(theD,theW,theGC,ixmin+wF,iymin+hF,ln,len);
  if(FlagPS) PSDrawLString(PSx0+PSfw,PS_y+PSfh+5+PSfh,ln,len);
  return(0);
}

int ZPlotTopRString(char* ln,int len)
{
  XDrawString(theD,theW,theGC,ixmax-(len+1)*wF,iymin+hF,ln,len);
  if(FlagPS) PSDrawRString(PS_x+Reg_w-10-PSfw,PS_y+PSfh+5+PSfh,ln,len);
  return(0);
}

int ZPlotTopMString(char* ln,int len)
{
  XDrawString(theD,theW,theGC,(ixmin+ixmax-len*wF)/2,iymin+hF,ln,len);
  if(FlagPS) PSDrawMString((PSx0+PS_x+Reg_w-10)/2,PS_y+PSfh+5+PSfh,ln,len);
  return(0);
}

int ZPlotUTopMString(char* ln,int len)
{
  XDrawString(theD,theW,theGC,(ixmin+ixmax-len*wF)/2,iymin-1,ln,len);
  if(FlagPS) PSDrawMString((PSx0+PS_x+Reg_w-10)/2,PS_y+PSfh,ln,len);
  return(0);
}

int ZPlotLUString(double x,double y,char* ln,int len)
{
  int ix;

  if(iscUx) x*=scUx;
  if(iscUy) y*=scUy;
  if(wF*len < (xmin-x)*sx || x > xmax || y < ymin || hF > (y-ymax)*sy){
    return(0);
  }
  if(FlagPS)PSDrawLString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy,ln,len);
  if(wF*len > (xmax-x)*sx)len=(int)((xmax-x)*sx/wF);
  ix	=(int)(xg_0+(x-xmin)*sx);
  if(x < xmin){
    ix	=(int)((xmin-x)*sx/wF);
    len	-=ix;
    ln	+=ix;
    ix	=(int)xg_0;
  }
  XDrawString(theD,theW,theGC,ix,(int)(yg_0+(y-ymin)*sy),ln,len);
  return(0);
}

int ZPlotLDString(double x,double y,char* ln,int len)
{
  int ix;
  if(iscUx) x*=scUx;
  if(iscUy) y*=scUy;
  if(wF*len < (xmin-x)*sx || x > xmax || hF <(y-ymin)*sy || y > ymax)return(0);
  if(FlagPS)PSDrawLString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy+PSfh,ln,len);
  if(wF*len > (xmax-x)*sx) len=(int)((xmax-x)*sx/wF);
  ix	=(int)(xg_0+(x-xmin)*sx);
  if(x < xmin){
    ix	=(int)((xmin-x)*sx/wF);
    len	-=ix;
    ln	+=ix;
    ix	=(int)xg_0;
  }
  XDrawString(theD,theW,theGC,ix,(int)(yg_0+(y-ymin)*sy)+hF,ln,len);
  return(0);
}

int ZPlotRUString(double x,double y,char* ln,int len)
{
  if(iscUx) x*=scUx;
  if(iscUy) y*=scUy;
  if(x< xmin || wF*len < (x-xmax)*sx || y < ymin || hF > (y-ymax)*sy)return(0);
  if(FlagPS) PSDrawRString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy,ln,len);
  if(wF*len > (x-xmax)*sx) len-=(int)((x-xmax)*sx/wF);
  XDrawString(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx)-wF*len
	      ,(int)(yg_0+(y-ymin)*sy),ln,len);
  return(0);
}
int ZPlotRDString(double x,double y,char* ln,int len)
{
  if(iscUx){
    x	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
  }
  if(x < xmin || wF*len < (x-xmax)*sx || hF < (y-ymin)*sy || y > ymax){
    return(0);
  }
  if(wF*len > (x-xmax)*sx){
    len	-=(int)((x-xmax)*sx/wF);
  }
  if(FlagPS){
    PSDrawRString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy+PSfh,ln,len);
  }
  XDrawString(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx)-wF*len
	      ,(int)(yg_0+(y-ymin)*sy)+hF,ln,len);
  return(0);
}
int ZPlotMUString(double x,double y,char* ln,int len)
{
  static int ix,iy;
  if(iscUx){
    x	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
  }
  ix	=(int)(xg_0+(x-xmin)*sx)-wF*len/2;
  iy	=(int)(yg_0+(y-ymin)*sy);
  XDrawString(theD,theW,theGC,ix,iy,ln,len);
  if(FlagPS){
    PSDrawMString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy,ln,len);
  }
  return(0);
}

int ZPlotMDString(double x,double y,char* ln,int len)
{
  static int ix,iy;

  if(iscUx){
    x	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
  }
  ix	=(int)(xg_0+(x-xmin)*sx)-wF*len/2;
  iy	=(int)(yg_0+(y-ymin)*sy)+hF;
  XDrawString(theD,theW,theGC,ix,iy,ln,len);
  if(FlagPS){
    PSDrawMString(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy+PSfh,ln,len);
  }
  return(0);
}

int ZPlotMark(double x,double y,int Mark)
{
  int ix,iy,ih;

  if(iscUx) x*=scUx;
  if(iscUy) y*=scUy;
  if(x < xmin || xmax < x || y < ymin || ymax < y) return(0);
  ix	=xg_0+(x-xmin)*sx;
  iy	=yg_0+(y-ymin)*sy;

  if(Mark == 0 || (Mark&0x01)) XDrawPoint(theD,theW,theGC,ix,iy);
  if((Mark&0x02)){
    XFillRectangle(theD,theW,theGC,ix-1,iy-1,2,2);
  }
  if((Mark&0x04)){
    XDrawRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
  }
  if((Mark&0x08)){
    XFillRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
  }
  if((Mark&0x10)){
    XDrawRectangle(theD,theW,theGC,ix-2,iy,4,0);
  }
  if((Mark&0x20)){
    XFillRectangle(theD,theW,theGC,ix,iy-2,0,4);
  }
  if((Mark&0x40)){
    XDrawLine(theD,theW,theGC,ix-2,iy-2,ix+2,iy+2);
  }
  if((Mark&0x80)){
    XDrawLine(theD,theW,theGC,ix-2,iy+2,ix+2,iy-2);
  }
  if((Mark&0x0100)){
    ih	=(int)(y*sy);
    if(ih > 0){
      XDrawRectangle(theD,theW,theGC,ix,iy-ih,0,ih);
    }
    else{
      XDrawRectangle(theD,theW,theGC,ix,iy,0,-ih);
    }
  }
  if(FlagPS){
    x	=PSx0+(x-xmin)*PSsx;
    y	=Paper_h-PSy0-(y-ymin)*PSsy;
    if(Mark == 0 || (Mark&0x01)){
      if(PSLineWidth != 0.5){
	fprintf(PSFile,"0.5 setlinewidth\n");
	PSLineWidth	=0.5;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 0 %6.4f rlineto stroke\n"
	      ,x-PSLineWidth/2,y,PSLineWidth);
    }
    if((Mark&0x02)){
      if(PSLineWidth != 2.){
	fprintf(PSFile,"2. setlinewidth\n");
	PSLineWidth	=2.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 0 %6.4f rlineto stroke\n"
	      ,x-PSLineWidth/2,y,PSLineWidth);
    }
    if((Mark&0x04)){
      XDrawRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
      if(PSLineWidth != 0.5){
	fprintf(PSFile,"0.5 setlinewidth\n");
	PSLineWidth	=0.5;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 0 4 rlineto"
	      ,x-2.,y-2.);
      fprintf(PSFile," 4 0 rlineto 0 -4 rlineto -4 0 rlineto stroke\n");
    }
    if((Mark&0x08)){
      if(PSLineWidth != 4.){
	fprintf(PSFile,"4. setlinewidth\n");
	PSLineWidth	=4.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 0 %6.4f rlineto stroke\n"
	      ,x-PSLineWidth/2,y,PSLineWidth);
    }
    if((Mark&0x10)){
      if(PSLineWidth != 1.){
	fprintf(PSFile,"1. setlinewidth\n");
	PSLineWidth	=1.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 4 0 rlineto stroke\n"
	      ,x-2.,y);
    }
    if((Mark&0x20)){
      if(PSLineWidth != 1.){
	fprintf(PSFile,"1. setlinewidth\n");
	PSLineWidth	=1.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 0 4 rlineto stroke\n"
	      ,x,y-2.);
    }
    if((Mark&0x40)){
      if(PSLineWidth != 1.){
	fprintf(PSFile,"1. setlinewidth\n");
	PSLineWidth	=1.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 4 4 rlineto stroke\n"
	      ,x-2.,y-2.);
    }
    if((Mark&0x80)){
      if(PSLineWidth != 1.){
	fprintf(PSFile,"1. setlinewidth\n");
	PSLineWidth	=1.;
      }
      fprintf(PSFile,"newpath %13.6e %13.6e moveto 4 -4 rlineto stroke\n"
	      ,x-2.,y+2.);
    }
    if((Mark&0x0100)){
      if(PSLineWidth != 1.){
	fprintf(PSFile,"1. setlinewidth\n");
	PSLineWidth	=1.;
      }
      fprintf(PSFile
	      ,"newpath %13.6e %13.6e moveto %13.6e %13.6e lineto stroke\n"
	      ,x,y,x,Paper_h-PSy0+ymin*PSsy);
    }
  }
  return(1);
}

int ZNewPath()
{
  if(FlagPS){
    if(PSLineWidth != .3){
      fprintf(PSFile,"newpath 0.3 setlinewidth %%Line\n");
      PSLineWidth	=.3;
    }
    else{
      fprintf(PSFile,"newpath\n");
    }
  }
  return(0);
}

int ZStroke()
{
  if(FlagPS) fprintf(PSFile,"stroke\n");
  return(0);
}

int ZPlotLine(double x,double y,double x1,double y1)
{
  if(iscUx){
    x	*=scUx;
    x1	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
    y1	*=scUy;
  }
  if(ZPlotCheck(&x,&y,&x1,&y1) == 0){
    return(0);
  }
  XDrawLine(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx),(int)(yg_0+(y-ymin)*sy),
	    (int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy));
  if(FlagPS){
    PSDrawLine(PSx0+(x-xmin)*PSsx,PSy0+(y-ymin)*PSsy,
	       PSx0+(x1-xmin)*PSsx,PSy0+(y1-ymin)*PSsy);
  }
  return(1);
}

int ZPlotPolyLine(double *X,double *Y,int n)
{
  int i,ii,k,j;
  double x1,y1,x2,y2;

  if(FlagPS){
    if(PSLineWidth != 1.){
      fprintf(PSFile,"newpath 1 setlinewidth %%PolyLine\n");
      PSLineWidth	=1.;
    }
    else{
      fprintf(PSFile,"newpath %%PolyLine\n");
    }
    k	=0;
  }
  for(i=0,ii=1; ii < n; i++, ii++){
    x1	=X[i];
    y1	=Y[i];
    x2	=X[ii];
    y2	=Y[ii];
    if(iscUx){
      x2	*=scUx;
      x1	*=scUx;
    }
    if(iscUy){
      y2	*=scUy;
      y1	*=scUy;
    }
    if(j=ZPlotCheck(&x1,&y1,&x2,&y2)){
      XDrawLine(theD,theW,theGC
		,(int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy)
		,(int)(xg_0+(x2-xmin)*sx),(int)(yg_0+(y2-ymin)*sy));
      if(FlagPS){
	fprintf(PSFile,"%13.6e %13.6e\n"
		,PSx0+(x1-xmin)*PSsx,Paper_h-(PSy0+(y1-ymin)*PSsy));
	k++;	/* number of points */
	if(k == 128 || j < 0){
	  fprintf(PSFile,"%13.6e %13.6e moveto %d{lineto}repeat\n"
		  ,PSx0+(x2-xmin)*PSsx,Paper_h-(PSy0+(y2-ymin)*PSsy),k);
	  k	=0;
	}
      }
    }
  }
  if(FlagPS){
    if(k%128){
      fprintf(PSFile,"%13.6e %13.6e moveto %d{lineto}repeat\n"
	      ,PSx0+(x2-xmin)*PSsx,Paper_h-(PSy0+(y2-ymin)*PSsy),k);
    }
    fputs("stroke\n",PSFile);
  }
  return(0);
}

int ZPlotPolyLineC(double *X,double *Y,int n)
{
  int i,ii,j,k;
  double x1,y1,x2,y2;

  if(FlagPS){
    if(PSLineWidth != 1.){
      fprintf(PSFile,"newpath 1 setlinewidth %%PolyLineC\n");
      PSLineWidth	=1.;
    }
    else{
      fprintf(PSFile,"newpath %%PolyLineC\n");
    }
    k	=0;
  }
  for(i=0, ii=1; i < n; i++, ii++){
    x1	=X[i];
    y1	=Y[i];
    if(ii == n){
      ii	=0;
    }
    x2	=X[ii];
    y2	=Y[ii];
    if(iscUx){
      x2	*=scUx;
      x1	*=scUx;
    }
    if(iscUy){
      y2	*=scUy;
      y1	*=scUy;
    }
    if(j=ZPlotCheck(&x1,&y1,&x2,&y2)){
      XDrawLine(theD,theW,theGC
		,(int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy)
		,(int)(xg_0+(x2-xmin)*sx),(int)(yg_0+(y2-ymin)*sy));
      if(FlagPS){
	fprintf(PSFile,"%13.6e %13.6e\n"
		,PSx0+(x1-xmin)*PSsx,Paper_h-(PSy0+(y1-ymin)*PSsy));
	k++;
	if(k == 128 || j < 0){
	  fprintf(PSFile,"%13.6e %13.6e moveto %d{lineto}repeat\n"
		  ,PSx0+(x2-xmin)*PSsx,Paper_h-(PSy0+(y2-ymin)*PSsy),k);
	  k	=0;
	}
      }
    }
  }
  if(FlagPS){
    if(k%128){
      fprintf(PSFile,"%13.6e %13.6e moveto %d{lineto}repeat\n"
	      ,PSx0+(x2-xmin)*PSsx,Paper_h-(PSy0+(y2-ymin)*PSsy),k);
    }
  }
  if(FlagPS){
    fprintf(PSFile,"stroke\n");
  }
  return(0);
}

int ZPlotXLine(x,y,x1,y1)
     double x,y,x1,y1;
{
  if(iscUx){
    x	*=scUx;
    x1	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
    y1	*=scUy;
  }
  if(ZPlotCheck(&x,&y,&x1,&y1) == 0){
    return(0);
  }
  XDrawLine(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx),(int)(yg_0+(y-ymin)*sy),
	    (int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy));
  return(1);
}

int ZPlotSimpleLine(x,y,x1,y1)
     double x,y,x1,y1;
{
  if(iscUx){
    x	*=scUx;
    x1	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
    y1	*=scUy;
  }
  XDrawLine(theD,theW,theGC,(int)(xg_0+(x-xmin)*sx),(int)(yg_0+(y-ymin)*sy),
	    (int)(xg_0+(x1-xmin)*sx),(int)(yg_0+(y1-ymin)*sy));
  return(1);
}

int ZWarning(double x,double y,char*ln)
{
  int ix,iy,iw,ih,i;
  char *p;
  if(iscUx){
    x	*=scUx;
  }
  if(iscUy){
    y	*=scUy;
  }
  ih	=0;
  iw	=0;
  i	=0;
  p	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      if(iw < i) iw=i;
      i	=0;
      ih++;
    }
    else{
      i++;
    }
    p++;
  }
  if(i){
    if(iw < i) iw=i;
    ih++;
  }
 
  iw	=wF*iw+5;
  ix	=ixmax-iw;
  iy	=iymin+1;
  XSetForeground(theD,theGC,ColorPix[14]);
  XFillRectangle(theD,theW,theGC,ix,iymin+1,iw,hF*ih+5);
  ix	+=2;
  iy	+=2;

  i	=0;
  p	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      XDrawString(theD,theW,theGCM,ix,iy+hF,ln,i);
      ln	=p+1;
      iy	+=hF;
      i	=0;
    }
    else{
      i++;
    }
    p++;
  }
  if(i){
    XDrawString(theD,theW,theGCM,ix,iy+hF,ln,i);
  }
  putchar(7);
  fflush(stdout);
  return(0);
}

int ZMessage(char*ln)
{
  extern char *EventNm[];
  extern Window theHW;
  extern int xMessW,yMessW,kMessW;
  int ix,iy,iw,ih;
  char *p,*lc;

  ih	=0;
  iw	=0;
  p	=ln;
  lc	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      iy=p-lc;
      if(iw < iy) iw=iy;
      lc=p+1;
      ih++;
    }
    p++;
  }
  iy	=p-lc;
  if(iy){
    if(iw < iy) iw=iy;
    ih++;
  }
  XSetForeground(theD,theGC,ColorPix[4]);
  iw	=wF*iw+5;
  ih	=hF*ih+4;

  XMoveWindow(theD,theHW,xMessW,yMessW);
  XResizeWindow(theD,theHW,iw,ih);
  XMapWindow(theD,theHW);
  XRaiseWindow(theD,theHW);
  kMessW=1;
  ix	=0;
  iy	=0;
  XFillRectangle(theD,theHW,theGC,ix,iy,iw,ih);
  ix	+=2;
  iy	+=1;
  p	=ln;
  lc	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      XDrawString(theD,theHW,theGCM,ix,iy+hF,lc,(int)(p-lc));
      lc	=p+1;
      iy	+=hF;
    }
    p++;
  }
  if(lc < p) XDrawString(theD,theHW,theGCM,ix,iy+hF,lc,(int)(p-lc));
  XFlush(theD);
  return(0);
}

int ZZMessage(char*ln)
{
  int ix,iy,iw,ih;
  char *p,*lc;

  ih	=0;
  iw	=0;
  p	=ln;
  lc	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      iy=p-lc;
      if(iw < iy) iw=iy;
      lc=p+1;
      ih++;
    }
    p++;
  }
  iy	=p-lc;
  if(iy){
    if(iw < iy) iw=iy;
    ih++;
  }
  XSetForeground(theD,theGC,ColorPix[10]);
  iw	=wF*iw+5;
  ix	=ixmax-iw;
  iy	=iymin+1;
  ih	=hF*ih+4;

#ifdef H
  iy	=iymax-ih;
  if(iy < iymin){
    ih	+=iy-iymin;
    iy	=iymin;
  }
#endif
  XFillRectangle(theD,theW,theGC,ix,iy,iw,ih);
  ix	+=2;
  iy	+=1;
  p	=ln;
  lc	=ln;
  while(*p != '\0'){
    if(*p == '\n'){
      XDrawString(theD,theW,theGCM,ix,iy+hF,lc,(int)(p-lc));
      lc	=p+1;
      iy	+=hF;
    }
    p++;
  }
  if(lc < p) XDrawString(theD,theW,theGCM,ix,iy+hF,lc,(int)(p-lc));
  XFlush(theD);
  return(0);
}


/********************************************************************/

#ifdef H
double PSx0,PSy0,PSsx,PSsy;
static int nLine,nDots;
static int iCol=0;
extern int XCbNColor;
static double unitx,unity,xmax,ymax,xmin,ymin,xg_0,yg_0,sx,sy;
static int ixmax,ixmin,iymax,iymin;

static int ix1,ix2,iy1,iy2,i_tip= 5;
static int mx1,mx2,my1,my2;
#endif
static int PSkA=0;
char *PSNmF0="00000i00.ps",*PSNmF=NULL;
static int PSnX,PSnY,PSiX=0,PSiY=0,PSnXY;
static double PSrXY;
static int PSnFig=0,PSnPg=0;
static FILE *PSlF=NULL;
static long int PSkF=0;
static int PSL=6;
static int PSiS=0;
static int PSnD=0;
static int PSnL=0;
static char*PSCNm[]= {"0 0 0",
			"0.80392  0.75294  0.69020",
			"0.93333  0.87451  0.80000",
			"1.00000  1.00000  1.00000",

			"0.00000  0.00000  1.00000",
			"0.52941  0.80784  0.92157",
			"0.90196  0.90196  0.98039",

			"0.00000  0.80392  0.80392",
			"0.00000  0.93333  0.93333",
			"0.00000  1.00000  1.00000",

			"0.00000  0.39216  0.00000",
			"0.00000  1.00000  0.00000",
			"1.00000  1.00000  0.00000",

			"1.00000  0.00000  1.00000",
			"1.00000  0.00000  0.00000",
			"0.85098  0.85098  0.85098",

			"1.00000  0.07843  0.57647",
			"1.00000  0.64706  0.00000",
			"0.98039  0.94118  0.90196",

			"1.00000  0.51373  0.98039",
			"0.93333  0.68235  0.93333",
			"1.00000  0.73333  1.00000"
};

static int ZFlagPS=0;
static FILE *ZPSFile=NULL;

int ZPSFileOpen(int nX, int nY)
{
  int i;
  if(PSkA == 0){
    if(PSNmF == NULL) PSNmF=PSNmF0;
    PSlF	=fopen(PSNmF,"w+");
    if(PSlF != NULL){
#ifdef H
      fseek(PSlF,0L,0);
#endif
      PSDefinitions();
      PSkA	=0x09;
      PSnFig	=0;
      PSnPg	=0;
      PSiX	=0;
      PSiY	=0;
    }
    else{
      printf("%s cannot be open%c\n",PSNmF,7);
      PSkA	=0;
      PSkF	=0L;
      return(0);
    }
  }
  else{
    PSlF	=fopen(PSNmF,"r+");
    if(PSlF != NULL){
      PSkA	|=0x09;
      if(PSnX == nX && PSnY == nY){
      }
      else{
	PSiX	=0;
	PSiY	=0;
      }
      fseek(PSlF,PSkF,0);
    }
    else{
      printf("%s cannot be reopen%c\n",PSNmF,7);
      PSkA	=0;
      PSkF	=0L;
      return(0);
    }
  }
  PSnX	=nX;
  PSnY	=nY;
  PSnXY	=PSnX*PSnY;
  PSrXY	=PSnX < PSnY ? 1./PSnY : 1./PSnX;
  PSLineWidth	=0.;

  ZFlagPS	=FlagPS;
  ZPSFile	=PSFile;
  FlagPS	=1;
  PSFile	=PSlF;
  return(0);
}

int ZPSFileClose()
{
  static char ln[32];
  extern char *CbUserMessage;
  int x,y;

  if(PSlF == NULL) return(0);
  PSkF	=ftell(PSlF);
  fprintf(PSlF,"showpage\n");
  fclose(PSlF);
  PSlF	=NULL;
  PSkA	-=0x08;
  CbUserMessage	=ln;

  if(PSiX){
    x	=PSiX;
    y	=PSiY+1;
  }
  else{
    x	=PSnX;
    y	=PSiY ? PSiY : PSnY;
  }
  sprintf(ln,"Page %d(%d,%d) %s\n",PSnPg,x,y,PSNmF);
  FlagPS	=ZFlagPS;
  PSFile	=ZPSFile;
  return(0);
}


int ZScale2D(int iWin,double*xdata,double*ydata,
	    int ndata,int length,int ind)
{
  static int i,j,l;
  static double s;
  static int ix,iy;
  static char ln[10];

  if(ndata == 0) return(0);
  theW	=WinP[iWin].W;
  InitXmxYmx();
  for(i=0; i < ndata; i++){
    if(xdata[i] < xmin) xmin= xdata[i];
    if(xdata[i] > xmax) xmax= xdata[i];
    if(ydata[i] < ymin) ymin= ydata[i];
    if(ydata[i] > ymax) ymax= ydata[i];
  }
  if(iscUx){
    xmin	*=scUx;
    xmax	*=scUx;
  }
  if(iscUy){
    ymin	*=scUy;
    ymax	*=scUy;
  }
  u_choice(&xmin,&mx1,&xmax,&mx2,&unitx);
  u_choice(&ymin,&my1,&ymax,&my2,&unity);
  WinP[iWin].xm	=xmin;
  WinP[iWin].ym	=ymin;
  WinP[iWin].xmx=xmax;
  WinP[iWin].ymx=ymax;
  PlotFrame(iWin,length,ind);
#ifdef H
  if(FlagPS) PSPlotFrame(length,ind);
#endif
  if(FlagPS){
    PSnD=ndata;
    PSL	=length;
    PSiS=ind;
    PSNewFrame();
  }
  return(0);
}

int PSColor(int i)
{
  static int i0;

  if(i0 == i) return(0);
  i0	=i;
  if(i < 22){
    fprintf(PSlF,"%s setrgbcolor\n",PSCNm[i]);
  }
  else{
    fprintf(PSlF,"%s setrgbcolor\n",PSCNm[0]);
  }
  return(0);
}

int PSRectDraw(double x,double y,double w,double h)
{
  fprintf(PSlF,"newpath %%Rect\n");
  fprintf(PSlF,"%13.6e %13.6e  moveto\n",x,Paper_h-y);
  fprintf(PSlF,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,-h);
  fprintf(PSlF,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,h);
  fprintf(PSlF,"stroke\n");
  return(0);
}

int PSRectFill(double x,double y,double w,double h)
{
  fprintf(PSlF,"newpath %%Rectangle\n");
  fprintf(PSlF,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSlF,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",w,0.,0.,-h);
  fprintf(PSlF,"%13.6e %13.6e %13.6e %13.6e rlineto rlineto\n",-w,0.,0.,h);
  fprintf(PSlF,"fill\n");
  return(0);
}

int PSLine(x1,y1,x2,y2)
     double x1,y1,x2,y2;
{
  fprintf(PSlF,"%13.6e %13.6e %13.6e %13.6e moveto lineto\n"
	  ,x2,Paper_h-y2,x1,Paper_h-y1);
  return(0);
}

int PSMove(double x,double y)
{
  fprintf(PSlF,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  return(0);
}

int PSLineCont(double x,double y)
{
  fprintf(PSlF,"%13.6e %13.6e lineto\n",x,Paper_h-y);
  return(0);
}

int PSLString(double x,double y,char *ln,int n)
{
  ln[n]= '\0';
  fprintf(PSlF,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSlF,"%13.6e %13.6e (%s) Lshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int PSRString(x,y,ln,n)
     double x,y;
     char*ln;
     int n;
{
  ln[n]= '\0';
  fprintf(PSlF,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSlF,"%13.6e %13.6e (%s) Rshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int PSMString(x,y,ln,n)
     double x,y;
     char*ln;
     int n;
{
  ln[n]= '\0';
  fprintf(PSlF,"%13.6e %13.6e moveto\n",x,Paper_h-y);
  fprintf(PSlF,"%13.6e %13.6e (%s) Mshow\n",1./PSfh,PSfh,ln);
  return(0);
}

int PSPolyLine(double *xdata,double *ydata,double ndata)
{
  int i,i1,k,n;
  double x,y,x1,y1;

  x	=xdata[0];
  y	=ydata[0];
  n	=0;
  k	=ZPlotCheck(&x,&y,&x,&y);
  if(k){
    fprintf(PSlF,"%13.6e %13.6e\n",x,y);
    n++;
  }
  for(i=1; i < ndata; i++){
    x	=xdata[i];
    y	=ydata[i];
    i1	=i-1;
    x1	=xdata[i1];
    y1	=ydata[i1];
    k		=ZPlotCheck(&x1,&y1,&x,&y);
    if(k > 0){
      fprintf(PSlF,"%13.6e %13.6e\n",x,y);
      n++;
    }
    if(k == -1){
      n	=0;
      fprintf(PSlF,"%13.6e %13.6e\n",x1,y1);
      n++;
      fprintf(PSlF,"%13.6e %13.6e\n",x,y);
      n++;
    }
    if(k == -2){
      fprintf(PSlF,"%13.6e %13.6e moveto\n",x,y);
      fprintf(PSlF,"%d{lineto}repeat\n",n);
      n	=0;
    }
    if(n > 100){
      fprintf(PSlF,"moveto %d{lineto}repeat\n",n-1);
      fprintf(PSlF,"%13.6e %13.6e\n",x,y);
      n	=1;
    }
  }
  if(n){
    fprintf(PSlF," moveto\n");
    if(n > 1){
      fprintf(PSlF,"%d{lineto}repeat\n",n-1);
    }
    else{
      fprintf(PSlF,"0 0 rlineto\n");
    }
  }
  return(0);
}

int PageTitle()
{
  time_t T;
  time(&T);
  fprintf(PSlF,"%%%%Page: %d %d\n",PSnPg+1,PSnPg+1);

#ifdef H
  fprintf(PSlF,"/Helvetica-Oblique findfont setfont\n");
  fprintf(PSlF,"306 54. moveto\n");
  fprintf(PSlF,"6.25e-02  16. (%s) Mshow\n",PageName);
  fprintf(PSlF,"576 36. moveto\n");
#endif
  fprintf(PSlF,"/Helvetica findfont setfont\n");

#ifdef H
  fprintf(PSlF,"0.1  10. (Page %2d) Rshow\n",PSnPg+1);
  fprintf(PSlF,"%13.6e %13.6e moveto\n",Paper_w-72,Paper_h-24);
  fprintf(PSlF,"0.125  8. (Generated by Cb%s, %s) Rshow\n"
	  ,CbGetCodeNm(),ctime(&T));
#endif
  PSnPg++;
  PSLineWidth	=0.;
  return(0);
}

int PSSetFileName(char *Nm)
{
  PSNmF	=Nm != NULL ? Nm : PSNmF0;
  return(0);
}

int PSDefinitions()
{
  fprintf(PSlF,"%%!PS-Adobe-2.0\n\
/Lshow {exch dup scale show dup scale}def\n\
/Rshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll mul neg 0 rmoveto\n\
dup scale show dup scale}def\n\
/Mshow {dup stringwidth pop 3 -1 roll\n\
dup 3 -1 roll -0.5 mul mul 0 rmoveto\n\
dup scale show dup scale}def\n");
  fprintf(PSlF,"/Helvetica findfont setfont\n");
  fprintf(PSlF,"2 setlinejoin\n");



#ifdef New
/Rshow {dup stringwidth pop 3 -1 roll
dup 3 -1 roll mul neg 0 rmoveto
dup dup scale exch show 1 exch div dup scale}def
#endif

  return(0);
}

int PSFileOpen(int nX, int nY)
{
  int i;

  if(PSkA == 0){
    if(PSNmF == NULL) PSNmF=PSNmF0;
    PSlF	=fopen(PSNmF,"w+");
    if(PSlF != NULL){
#ifdef H
      fseek(PSlF,0L,0);
#endif
      PSDefinitions();
      PSkA	=0x09;
      PSnFig	=0;
      PSnPg	=0;
      PSiX	=0;
      PSiY	=0;
    }
    else{
      printf("%s cannot be open%c\n",PSNmF,7);
      PSkA	=0;
      PSkF	=0L;
      return(0);
    }
  }
  else{
    PSlF	=fopen(PSNmF,"r+");
    if(PSlF != NULL){
      PSkA	|=0x09;
      if(PSnX == nX && PSnY == nY){
      }
      else{
	PSiX	=0;
	PSiY	=0;
      }
      fseek(PSlF,PSkF,0);
    }
    else{
      printf("%s cannot be reopen%c\n",PSNmF,7);
      PSkA	=0;
      PSkF	=0L;
      return(0);
    }
  }
  PSnX	=nX;
  PSnY	=nY;
  PSnXY	=PSnX*PSnY;
  PSrXY	=PSnX < PSnY ? 1./PSnY : 1./PSnX;
  PSLineWidth	=0.;
  return(0);
}

int PSFileClose()
{
  int x,y;

  if(PSlF == NULL) return(0);
  PSkF	=ftell(PSlF);
  fprintf(PSlF,"showpage\n");
  fclose(PSlF);
  PSlF	=NULL;
  PSkA	-=0x08;

  if(PSiX){
    x	=PSiX;
    y	=PSiY+1;
  }
  else{
    x	=PSnX;
    y	=PSiY ? PSiY : PSnY;
  }
  CbStr2UserMessage("Page %d(%d,%d) %s\n",PSnPg,x,y,PSNmF);
  return(0);
}

int PlotFrame2d(int iWin,int length,int ind)
{
  static int i,j,l;
  static char ln[10];
  static double s;
  static int ix,iy;

  theW	=WinP[iWin].W;
  ix1	=WinP[iWin].ix+i_tip+length*wF;
  ix2	=WinP[iWin].ix+WinP[iWin].iw-5;
  ixmin	=ix1;
  ixmax	=ix2;
  sx	=(ix2-ix1)/(xmax-xmin);
  xg_0	=(double)ix1;

  iy1	=2.*hF+3;
  iy2	=WinP[iWin].iH-5-hF-i_tip;

  iymin	=iy1;
  iymax	=iy2;
  sy	=(iy1-iy2)/(ymax-ymin);
  yg_0	=(double)iy2;

  if(ind < 2){
    if(sx > -sy){
      xmax	=xmin-(xmax-xmin)*sx/sy;
      WinP[iWin].xmx=xmax;
      sx	=-sy;
    }
    else{
      ymax	=ymin-(ymax-ymin)*sy/sx;
      WinP[iWin].ymx=ymax;
      sy	=-sx;
    }
  }
  WinP[iWin].sx	=sx;
  WinP[iWin].sy	=sy;
  WinP[iWin].x	=xg_0;
  WinP[iWin].y	=yg_0;

  iy	=WinP[iWin].iH-5-hF;
  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,theW,theGC,WinP[iWin].ix+1,hF+1,WinP[iWin].iw,iy);
  XSetForeground(theD,theGC,ColorPix[12]);
  XDrawRectangle(theD,theW,theGC,WinP[iWin].ix+1,hF+1,WinP[iWin].iw,iy);

  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawString(theD,theW,theGC,ix1,iy1-2,nameY,strlen(nameY));
  l= strlen(nameP);
  XDrawString(theD,theW,theGC,ix2-wF*l,iy1-2,nameP,l);
  l= strlen(nameX);
  iy= iy2+i_tip;
  XDrawString(theD,theW,theGC,ix2-wF*l,iy+hF-2,nameX,l);
  l= ix2-wF*l;
  for(j= mx1;j<=mx2;j++){
    s= unitx*j;
    ix= (int)(xg_0+(s-xmin)*sx);
    XSetForeground(theD,theGC,ColorPix[1]);
    XDrawLine(theD,theW,theGC,ix,iy1,ix,iy2);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix,iy2);
    if(ix+wF<l){
      numstr(s,ln,5);
      XDrawString(theD,theW,theGC,ix-4*wF,iy+hF-2,ln,5);
    }
  }
  ix= ix1-i_tip;
  for(j= my1;j<=my2;j++){
    s= unity*j;
    iy= (int)(yg_0+(s-ymin)*sy);
    XSetForeground(theD,theGC,ColorPix[1]);
    XDrawLine(theD,theW,theGC,ix1,iy,ix2,iy);
    XSetForeground(theD,theGC,ColorPix[0]);
    XDrawLine(theD,theW,theGC,ix,iy,ix1,iy);
    numstr(s,ln,length);
    XDrawString(theD,theW,theGC,ix-length*wF,iy+2,ln,length);
  }
  XSetForeground(theD,theGC,ColorPix[0]);
  XDrawRectangle(theD,theW,theGC,ix1,iy1,ix2-ix1,iy2-iy1);
  return(0);
}

int Scale2d(int iWin,double *xdata,double *ydata,int n,int length,int ind)
{
  PSnD	=n;
  if(n == 0) return(0);
  theW	=WinP[iWin].W;
  InitXmxYmx();
  UpDateXmxYmx(iWin,xdata,ydata,n);
  PlotFrame2d(iWin,length,ind);
  PSL	=length;
  PSiS	=ind;
  return(0);
}

int PSInit(int nX,int nY)
{
  PSFileOpen(nX,nY);
  return(0);
}

int Plot2d(iWin,xdata,ydata,ndata,length,data_style,icol,ind_refresh)
     double*xdata,*ydata;
     int ndata,length,data_style,icol,ind_refresh;
     int iWin;
{
  int i,i1,j,l;
  double s;
  int ix,iy,ih;

  if(ndata == 0) return(0);
  if(iWin >= 0) theW=WinP[iWin].W;
  if(ind_refresh && iWin >= 0){
    InitXmxYmx();
    UpDateXmxYmx(iWin,xdata,ydata,ndata);
    PlotFrame(iWin,length,ind_refresh);
  }
#ifdef H
  else{
    xmin	=WinP[iWin].xm;
    ymin	=WinP[iWin].ym;
    xmax	=WinP[iWin].xmx;
    ymax	=WinP[iWin].ymx;
    sx		=WinP[iWin].sx;
    sy		=WinP[iWin].sy;
    xg_0	=WinP[iWin].x;
    yg_0	=WinP[iWin].y;
  }
#endif
  XSetForeground(theD,theGC,ColorPix[icol]);
  if(data_style == 0 || (data_style&0x01)){
    PlotPolyLine(xdata,ydata,ndata);
    if(data_style < 2) return(0);
  }
  for(i=0; i < ndata; i++){
    if(xmin <= xdata[i] && xdata[i] <= xmax 
       && ymin <= ydata[i] && ydata[i] <= ymax){
      ix	=(int)(xg_0+(xdata[i]-xmin)*sx);
      iy	=(int)(yg_0+(ydata[i]-ymin)*sy);
      if((data_style&0x02)){
	XFillRectangle(theD,theW,theGC,ix,iy,0,0);
      }
      if((data_style&0x04)){
	XDrawRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
      }
      if((data_style&0x08)){
	XFillRectangle(theD,theW,theGC,ix-2,iy-2,4,4);
      }
      if((data_style&0x10)){
	XDrawRectangle(theD,theW,theGC,ix-2,iy,4,0);
      }
      if((data_style&0x20)){
	XFillRectangle(theD,theW,theGC,ix,iy-2,0,4);
      }
      if((data_style&0x40)){
	XDrawLine(theD,theW,theGC,ix-2,iy-2,ix+2,iy+2);
      }
      if((data_style&0x80)){
	XDrawLine(theD,theW,theGC,ix-2,iy+2,ix+2,iy-2);
      }
      if((data_style&0x0100)){
	ih	=(int)(ydata[i]*sy);
	if(ih > 0){
	  XDrawRectangle(theD,theW,theGC,ix,iy-ih,0,ih);
	}
	else{
	  XDrawRectangle(theD,theW,theGC,ix,iy,0,-ih);
	}
      }
    }
  }
  return(0);
}

int SetPlotName(char *NmX,char *NmY,char *NmP)
{
  if(NmX != NULL) strcpy(nameX,NmX);
  if(NmY != NULL) strcpy(nameY,NmY);
  if(NmP != NULL) strcpy(nameP,NmP);
  return(0);
}

int PlotUTopMString(char* ln,int len,int Fl)
{
  XDrawString(theD,theW,theGC,(ixmin+ixmax-len*wF)/2,iymin+hF,ln,len);
  if(Fl){
    double x,y;
    ln[len]= '\0';

    x	=0.5*(xmin+xmax);
    y	=ymax;

    x	=x-xmin;
    y	=y-ymin;
    fprintf(PSlF,"%13.6e %13.6e moveto\n",PSx0+x*PSsx
	    ,Paper_h-PSy0-y*PSsy-PSfh);
    x	=PSfh/PSnX;
    if(x < 10.) x=10.;
    fprintf(PSlF,"%13.6e %13.6e (%s) Mshow\n",1./x,x,ln);
  }
  return(0);
}

int PSNewFrame()
{
  int j,l;
  char ln[12];
  double s;
  double ix,ix1,ix2,iy,iy1,iy2,i_tip;
  
  if((PSkA&0x08) == 0) return(0);
  if(PSiX == 0 && PSiY == 0){
    if((PSkA&0x02)) fprintf(PSlF,"showpage\n");
    PSDefinitions();
    PageTitle();
    PSkA	|=0x02;
  }
  fprintf(PSlF,"%%Figure %2d\n",PSnFig++);
  if(PSLineWidth != 0.3){
    fprintf(PSlF,"0.3 setlinewidth\n");
    PSLineWidth	=0.3;
  }
  if(PSnY > PSnX){
    fprintf(PSlF,"/Helvetica findfont %g scalefont setfont\n",1./PSnY);
  }
  else{
    if(PSnX != 1){
      fprintf(PSlF,"/Helvetica findfont %g scalefont setfont\n",1./PSnX);
    }
  }
  if(PSiX || PSiY){
    if(PSiX){
      fprintf(PSlF,"%g 0 translate\n",(Paper_w-108.)/PSnX);
    }
    else{
      fprintf(PSlF,"%g %g translate\n",-(Paper_w-108.)*(PSnX-1)/PSnX
	      ,(-Paper_h+108)/PSnY);
    }
  }
  else{
    fprintf(PSlF,"72 -72. translate\n");
  }
  PSiX++;
  if(PSiX == PSnX){
    PSiX	=0;
    PSiY++;
    if(PSiY == PSnY) PSiY=0;
  }
  i_tip	=7.*PSrXY;
  ix1	=i_tip+PSL*PSfw*PSrXY;
  ix2	=Reg_w/PSnX-10*PSrXY;
  PSsx	=(ix2-ix1)/(xmax-xmin);
  PSx0	=ix1;
  iy1	=(PSfh+3)/PSnY;
  iy2	=Reg_h/PSnY-PSfh*PSrXY-i_tip;
  PSsy	=(iy1-iy2)/(ymax-ymin);
  PSy0	=iy2;
  if(PSiS < 2){
    if(PSsx > -PSsy){
      PSsx	=-PSsy;
    }
    else{
      PSsy	=-PSsx;
    }
  }

#ifdef H
  PSColor(12);
  PSRectDraw(0.,0.,Reg_w/PSnX,Reg_h/PSnY);
#endif

  fprintf(PSlF,"newpath %%X-axis\n");
  PSColor(0);
  PSLString(ix1,iy1-2*PSrXY,nameY,strlen(nameY));
  l	=strlen(nameP);
  PSRString(ix2,iy1-2*PSrXY,nameP,l);
  iy	=iy2+i_tip;
  l	=strlen(nameX);
  PSRString(ix2,iy+(PSfh-2)*PSrXY,nameX,l);
  l	=ix2-PSfw*PSrXY*l*0.7;
  for(j=mx1; j <= mx2; j++){
    s	=unitx*j;
    ix	=PSx0+(s-xmin)*PSsx;
    PSLine(ix,iy,ix,iy2);
    if(ix+i_tip < l){
      numstr(s,ln,5);
      PSRString(ix+i_tip,iy+(PSfh-2)*PSrXY,ln,5);
    }
  }
  fprintf(PSlF,"stroke\n");
  fprintf(PSlF,"newpath %%X-grid\n");
  fprintf(PSlF,"[1 3] 0 setdash\n");
  PSColor(11);
  for(j=mx1; j <= mx2; j++){
    ix	=PSx0+(unitx*j-xmin)*PSsx;
    PSLine(ix,iy1,ix,iy2);
  }
  fprintf(PSlF,"stroke\n");
  fprintf(PSlF,"[] 0 setdash\n");
  fprintf(PSlF,"newpath %%Y-axis\n");
  PSColor(0);
  ix	=ix1-i_tip;
  for(j=my1; j <= my2; j++){
    s	=unity*j;
    iy	=PSy0+(s-ymin)*PSsy;
    PSLine(ix,iy,ix1,iy);
    numstr(s,ln,PSL);
    PSRString(ix-i_tip+2*PSrXY,iy+2*PSrXY,ln,PSL);
  }
  fprintf(PSlF,"stroke\n");

  fprintf(PSlF,"newpath %%Y-grid\n");
  PSColor(11);
  fprintf(PSlF,"[1 3] 0 setdash\n");
  for(j=my1; j <= my2; j++){
    iy	=PSy0+(unity*j-ymin)*PSsy;
    PSLine(ix1,iy,ix2,iy);
  }
  fprintf(PSlF,"stroke\n");
  fprintf(PSlF,"[] 0 setdash\n");

  PSColor(0);
  PSRectDraw(ix1,iy1,ix2-ix1,iy2-iy1);
  PSnL	=0;
  return(0);
}

int PSPlot2d(xdata,ydata,ndata,length,data_style,icol,ind)
     double*xdata,*ydata;
     int ndata,length,data_style,icol,ind;
{
  int i,n;
  double dx,dy,wL;
  
  if(ind == 1){
    if(PSlF == NULL){
      PSFileOpen(PSnX,PSnY);
      PSNewFrame();
    }
  }
  wL	=1.;
  fprintf(PSlF,"newpath %%Line=%d\n",PSnL);
  PSnL++;
  PSColor(icol);
  fprintf(PSlF,"%13.6e %13.6e translate\n",PSx0,Paper_h-PSy0);
  fprintf(PSlF,"%15.8e %15.8e scale\n",PSsx,-PSsy);
  fprintf(PSlF,"%13.6e %13.6e translate\n",-xmin,-ymin);
  if(data_style){
    if(PSLineWidth != PSrXY){
      fprintf(PSlF,"%g setlinewidth\n",PSrXY);
      PSLineWidth	=PSrXY;
    }
  }
  if(data_style == 0 || (data_style&0x01)){
    PSPolyLine(xdata,ydata,ndata);
    if(data_style < 2){
      fprintf(PSlF,"%13.6e %13.6e translate\n",xmin,ymin);
      fprintf(PSlF,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
      fprintf(PSlF,"stroke\n");
      fprintf(PSlF,"%13.6e %13.6e translate\n",-PSx0,PSy0-Paper_h);
      return(0);
    }
  }
  n	=0;
  dx	=4.*PSrXY/PSsx;
  dy	=4.*PSrXY/PSsy;
  for(i=0; i < ndata; i++){
    if(xmin <= xdata[i] && xdata[i] <= xmax 
       && ymin <= ydata[i] && ydata[i] <= ymax){
      fprintf(PSlF,"%13.6e %13.6e\n",xdata[i],ydata[i]);
      n++;
      if(i == ndata-1 || n > 100){
	if((data_style&0x0100)){
	  fprintf(PSlF,"%d{dup 3 1 roll moveto ",n);
	}
	else{
	  fprintf(PSlF,"%d{moveto ",n);
	}
	if((data_style&0x04)){
	  fprintf(PSlF,"%13.6e %13.6e rmoveto\n",-dx,-dy);
	  fprintf(PSlF,"0 %13.6e rlineto %13.6e 0 rlineto\n",2.*dy,2.*dx);
	  fprintf(PSlF,"0 %13.6e rlineto %13.6e 0 rlineto",-2.*dy,-2.*dx);
	  if(data_style > 0x07){
	    fprintf(PSlF," %13.6e %13.6e rmoveto\n",dx,dy);
	  }
	}
	if((data_style&0x10)){
	  fprintf(PSlF,"%13.6e 0 rmoveto\n",-dx);
	  fprintf(PSlF,"%13.6e 0 rlineto",2.*dx);
	  if(data_style > 0x1F){
	    fprintf(PSlF," %13.6e 0 rmoveto\n",-dx);
	  }
	}
	if((data_style&0x20)){
	  fprintf(PSlF,"0 %13.6e rmoveto\n",-dy);
	  fprintf(PSlF,"0 %13.6e rlineto",2.*dy);
	  if(data_style > 0x3F){
	    fprintf(PSlF," 0 %13.6e rmoveto\n",-dy);
	  }
	}
	if((data_style&0x40)){
	  fprintf(PSlF,"%13.6e %13.6e rmoveto\n",-dx,-dy);
	  fprintf(PSlF,"%13.6e %13.6e rlineto",2.*dx,2.*dy);
	  if(data_style > 0x7F){
	    fprintf(PSlF," %13.6e %13.6e rmoveto\n",-dx,-dy);
	  }
	}
	if((data_style&0x80)){
	  fprintf(PSlF,"%13.6e %13.6e rmoveto\n",-dx,dy);
	  fprintf(PSlF,"%13.6e %13.6e rlineto",2.*dx,-2.*dy);
	  if(data_style > 0xFF){
	    fprintf(PSlF," %13.6e %13.6e rmoveto\n",-dx,dy);
	  }
	}
	if((data_style&0x0100)){
	  fprintf(PSlF,"neg 0 exch rlineto");
	}
	fprintf(PSlF,"}repeat\n");
	n	=0;
      }
    }
  }
  fprintf(PSlF,"%13.6e %13.6e translate\n",xmin,ymin);
  fprintf(PSlF,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
  fprintf(PSlF,"stroke\n");

  wL	=1.;
  if((data_style&0x08)){
    wL	=2.;
  }
  dx	=wL*PSrXY/PSsx;
  if((data_style&0x0A)){
    fprintf(PSlF,"newpath %%Same Line\n");
    if(PSLineWidth != 2.*wL*PSrXY){
      PSLineWidth	=2.*wL*PSrXY;
      fprintf(PSlF,"%g setlinewidth\n",PSLineWidth);
    }
    fprintf(PSlF,"%15.8e %15.8e scale\n",PSsx,-PSsy);
    fprintf(PSlF,"%13.6e %13.6e translate\n",-xmin,-ymin);
    n	=0;
    for(i=0; i < ndata; i++){
      if(xmin <= xdata[i] && xdata[i] <= xmax 
	 && ymin <= ydata[i] && ydata[i] <= ymax){
	fprintf(PSlF,"%13.6e %13.6e\n",xdata[i],ydata[i]);
	n++;
	if(n > 100){
	  fprintf(PSlF,"%d{moveto ",n);
	  fprintf(PSlF,"%13.6e 0 rmoveto\n",-dx);
	  fprintf(PSlF,"%13.6e 0 rlineto\n",2.*dx);
	  fprintf(PSlF,"}repeat\n");
	  fprintf(PSlF,"%13.6e %13.6e\n",xdata[i],ydata[i]);
	  n	=1;
	}
      }
    }
    if(n){
      fprintf(PSlF,"%d{moveto ",n);
      fprintf(PSlF,"%13.6e 0 rmoveto\n",-dx);
      fprintf(PSlF,"%13.6e 0 rlineto\n",2.*dx);
      fprintf(PSlF,"}repeat\n");
      n	=0;
    }
    fprintf(PSlF,"%13.6e %13.6e translate\n",xmin,ymin);
    fprintf(PSlF,"%15.8e %15.8e scale\n",1./PSsx,-1./PSsy);
    fprintf(PSlF,"stroke\n");
  }
  fprintf(PSlF,"%13.6e %13.6e translate\n",-PSx0,PSy0-Paper_h);
  return(0);
}
