/*
  Routine for updating files <CodeName>.Cntr in data base file system

  cc -o zup Src/zup.c
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>

int Usage()
{
  puts("Usage:");
  puts("zup <Input Dir, e.g. Wrk> <Code name, e.g. esc> <Dir for Scan>");
  puts("zup Wrk j2e ../dB0");
  exit(1);
}
 
struct dirent*direntp;
struct stat statbuf;
char ln[256],str[128];
DIR *dirp;

int ND=0x20;
int iD=0;
struct dirent *lF0[0x20];
DIR *lD[0x20];
int L[0x20];
char Nm[0x80];
int LInp,LOut;
char bUpd[0x8000];
char bInp[0x8000];
char bOut[0x8000];

int nNmS,nNmT,LT;
int iS[0x1000],iT[0x1000];
char NmS[0x0100][16],NmT[0x0100][16];

int MakeSesctionNames(int *nNm,char Nmm[][16], int *iL, char* lI)
{
  int k,n;
  char *lc,*lt;
  lc	=lI;
  n	=0;
  do{
    k	=0;
    iL[n]	=lc-lI;
    while(*lc != ':' && *lc != '\n' && *lc) lc++;
    if(*lc == ':'){
      lc++;
      while(isspace(*lc) && *lc != '\n') lc++;
      if(*lc != '\n'){
	lt	=Nmm[n];
	while(!isspace(*lc) && *lc) *lt++=*lc++;
	*lt	='\0';
	n++;
	while(isspace(*lc) && *lc != '\n') lc++;
	if(*lc == '\n') lc++;
	k	=1;
      }
    }
  }while(k);
  LT	=0;
  if(n){
    lc	=lI;
    while(*lc != ':') lc++;
    LT	=lc-lI;
  }
  *nNm	=n;
  return(0);
}

int Update()
{
  int i,j,j1,k;
  char *lc,*lt;

  strcpy(bUpd,bInp);
  j1	=0;
  for(i=0; i < nNmS; i++){
    lc	=NmS[i];
    k	=1;
    for(j=j1; j < nNmT; j++){
      lt	=NmT[j];
      if(*lt != '\0' && strcmp(lc,lt) == 0){
	memcpy(bUpd+iS[i],bOut+iT[j],LT);
	*lt	='\0';
      }
      if(k && *lt != '\0'){
	k	=0;
	j1	=j;
      }
    }
  }
  return(0);
}

int main(int argc, char** argv)
{
  int i,iW;
  char NmCntr[32]="";
  char NmI[0x20];
  char *lc;
  FILE *lF;
  FILE *lT;

  if(argc < 4) Usage();

  i=sprintf(NmI,"%s",argv[1]);
  if(NmI[i-1] != '/'){
    NmI[i++]	='/';
    NmI[i]	='\0';
  }
  sprintf(NmCntr,"%s.Cntr",argv[2]);
  strcpy(NmI+i,NmCntr);
  if(stat(NmI,&statbuf)){
    printf("<%s>: absent\n",NmI);
    exit(1);
  }
  LInp	=statbuf.st_size;
  printf("size=%d\n",LInp);
  lF=fopen(NmI,"r");
  fread(bInp,1,LInp,lF);
  bInp[LInp]='\0';
  MakeSesctionNames(&nNmS,NmS,iS,bInp);

  iD	=0;
  i=sprintf(Nm,"%s",argv[3]);
  if(Nm[i-1] != '/'){
    Nm[i++]	='/';
    Nm[i]	='\0';
  }
  L[iD]=i;
  iW	=0;
  lD[iD]	=opendir(Nm);
  printf("%d <%s>\n",iD,Nm);
  if(lD[iD] == NULL){
    printf("<%s> - wrong name\n",Nm);
    return(0);
  }
  puts(Nm);
  do{
    if((lF0[iD]=readdir(lD[iD])) != NULL){
      lc	=lF0[iD]->d_name;
      if(*lc != '.'){
	strcpy(Nm+L[iD],lc);
	if(stat(Nm,&statbuf) == 0){
	  if(S_ISREG(statbuf.st_mode) && strcmp(lc,NmCntr) == 0){
	    LOut	=statbuf.st_size;
	    lT=fopen(Nm,"r+");
	    fread(bOut,1,LOut,lT);
	    bOut[LOut]	='\0';
	    MakeSesctionNames(&nNmT,NmT,iT,bOut);
	    printf("%d %4d %s %s\n",iD,LOut,lc,Nm);
	    Update();
	    rewind(lT);
	    fwrite(bUpd,1,LInp,lT);
	    fclose(lT);
	  }
	  if(S_ISDIR(statbuf.st_mode)){
	    i	=strlen(lc);
	    if(lc[i-1]	!= '/'){
	      lc[i++]	='/';
	      lc[i]	='\0';
	    }
	    strcpy(Nm+L[iD],lc);
	    i	+=L[iD];
	    iD++;
	    if(iD == ND){
	      puts("Depth limit was reached");
	      exit(0);
	    }
	    L[iD]	=i;
#ifdef H
	    printf("%d <%s>\n",iD,Nm);
#endif
	    lD[iD]	=opendir(Nm);
	  }
	}
      }	
    }
    else{
      closedir(lD[iD]);
      if(iD == 0) break;
      iD--;
      Nm[L[iD]]='\0';
    }
  }while(1);
  fclose(lF);
  return(0);
}

#ifdef HH

int ND=0x20;
int iD=0;
DIR *lD[0x20];
int L[0x20];
char Nm[0x80];


	  sprintf(NmD+L0,"%s/",lF0->d_name);
	  k	=stat(NmD,&statbuf);
	  if(k == 0 && S_ISDIR(statbuf.st_mode)){
	    L1	=strlen(NmD);
#ifdef H
	    strcpy(NmD+L1,"In/CbDir.st");
	    ChangePattern(NmD,"cdx","esc");
	    strcpy(NmD+L1,"Wrk/cdx.Cntr");
	    ChangePattern(NmD,"cdx","esc");
#endif
	    strcpy(NmD+L1,"Wrk/cdx.Cntr");
	    ChangePattern(NmD,"CDX","ESC");
	    *(NmD+L1)	='\0';
	    lD1	=opendir(NmD);
	    if(lD1 != NULL){
	      while((lF0 =readdir(lD1)) != NULL){
		if(*(lF0->d_name) != '.'){
		  sprintf(NmD+L1,"%s/",lF0->d_name);
		  k	=stat(NmD,&statbuf);
		  if(k == 0 && S_ISDIR(statbuf.st_mode)){
		    L2	=strlen(NmD);
#ifdef H
		    strcpy(NmD+L2,"In/CbDir.st");
		    ChangePattern(NmD,"cdx","esc");
		    strcpy(NmD+L2,"Wrk/cdx.Cntr");
		    ChangePattern(NmD,"cdx","esc");
#endif
		    strcpy(NmD+L2,"Wrk/cdx.Cntr");
		    ChangePattern(NmD,"CDX","ESC");
		    *(NmD+L2)	='\0';
		    lD2	=opendir(NmD);
		    if(lD2 != NULL){
		      while((lF0 =readdir(lD2)) != NULL){
			if(*(lF0->d_name) != '.'){
			  sprintf(NmD+L2,"%s/",lF0->d_name);
			  k	=stat(NmD,&statbuf);
			  if(k == 0 && S_ISDIR(statbuf.st_mode)){
			    L3	=strlen(NmD);
#ifdef H
			    strcpy(NmD+L3,"In/CbDir.st");
			    ChangePattern(NmD,"cdx","esc");
			    strcpy(NmD+L3,"Wrk/cdx.Cntr");
			    ChangePattern(NmD,"cdx","esc");
#endif
			    strcpy(NmD+L3,"Wrk/cdx.Cntr");
			    ChangePattern(NmD,"CDX","ESC");
			  }
			}
		      }	
		      closedir(lD2);
		    }
		    *(NmD+L2)	='\0';
		  }
		}		
	      }
	      closedir(lD1);
	    }
	    *(NmD+L1)	='\0';
	  }
	}
#endif

#ifdef HH
  int NList=0x1000,NDepth=0x20;
  char List[0x1000][0x20];

#ifdef H
  strcpy(NmD+L0,"Wrk/cdx.Cntr");
  ChangePattern(NmD,"cdx","esc");
#endif
  strcpy(NmD+L0,"Wrk/cdx.Cntr");
  ChangePattern(NmD,"CDX","ESC");
  *(NmD+L0)	='\0';
  lD	=opendir(NmD);
  if(lD != NULL){
    while((lF0 =readdir(lD)) != NULL){
      if(*(lF0->d_name) != '.'){
	sprintf(NmD+L0,"%s/",lF0->d_name);
	k	=stat(NmD,&statbuf);
	if(k == 0 && S_ISDIR(statbuf.st_mode)){
	  L1	=strlen(NmD);
#ifdef H
	  strcpy(NmD+L1,"In/CbDir.st");
	  ChangePattern(NmD,"cdx","esc");
	  strcpy(NmD+L1,"Wrk/cdx.Cntr");
	  ChangePattern(NmD,"cdx","esc");
#endif
	  strcpy(NmD+L1,"Wrk/cdx.Cntr");
	  ChangePattern(NmD,"CDX","ESC");
	  *(NmD+L1)	='\0';
	  lD1	=opendir(NmD);
	  if(lD1 != NULL){
	    while((lF0 =readdir(lD1)) != NULL){
	      if(*(lF0->d_name) != '.'){
		sprintf(NmD+L1,"%s/",lF0->d_name);
		k	=stat(NmD,&statbuf);
		if(k == 0 && S_ISDIR(statbuf.st_mode)){
		  L2	=strlen(NmD);
#ifdef H
		  strcpy(NmD+L2,"In/CbDir.st");
		  ChangePattern(NmD,"cdx","esc");
		  strcpy(NmD+L2,"Wrk/cdx.Cntr");
		  ChangePattern(NmD,"cdx","esc");
#endif
		  strcpy(NmD+L2,"Wrk/cdx.Cntr");
		  ChangePattern(NmD,"CDX","ESC");
		  *(NmD+L2)	='\0';
		  lD2	=opendir(NmD);
		  if(lD2 != NULL){
		    while((lF0 =readdir(lD2)) != NULL){
		      if(*(lF0->d_name) != '.'){
			sprintf(NmD+L2,"%s/",lF0->d_name);
			k	=stat(NmD,&statbuf);
			if(k == 0 && S_ISDIR(statbuf.st_mode)){
			  L3	=strlen(NmD);
#ifdef H
			  strcpy(NmD+L3,"In/CbDir.st");
			  ChangePattern(NmD,"cdx","esc");
			  strcpy(NmD+L3,"Wrk/cdx.Cntr");
			  ChangePattern(NmD,"cdx","esc");
#endif
			  strcpy(NmD+L3,"Wrk/cdx.Cntr");
			  ChangePattern(NmD,"CDX","ESC");
			}
		      }
		    }	
		    closedir(lD2);
		  }
		  *(NmD+L2)	='\0';
		}
	      }		
	    }
	    closedir(lD1);
	  }
	  *(NmD+L1)	='\0';
	}
      }
    }	
    closedir(lD);
  }
#endif
