#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include "CbType.h"
#include "XCbType.h"

#ifndef mzl_X
char *EventNm[]={
"",
"",
"KeyPress",
"KeyRelease",
"ButtonPress",
"ButtonRelease",
"MotionNotify",
"EnterNotify",
"LeaveNotify",
"FocusIn",
"FocusOut",
"KeymapNotify",
"Expose",
"GraphicsExpose",
"NoExpose",
"VisibilityNotify",
"CreateNotify",
"DestroyNotify",
"UnmapNotify",
"MapNotify",
"MapRequest",
"ReparentNotify",
"ConfigureNotify",
"ConfigureRequest",
"GravityNotify",
"ResizeRequest",
"CirculateNotify",
"CirculateRequest",
"PropertyNotify",
"SelectionClear",
"SelectionRequest",
"SelectionNotify",
"ColormapNotify"
"ClientMessage"
"MappingNotify"
};

static struct stat statbuf;

extern int CbMemoryL;

static int itheW;

extern Display*theD;
extern int theD_w,theD_h;
extern Window theW,theHW,theMW,CPanelW,theRW;
extern unsigned int Wmode;
extern GC theGC,theGCE,theGCT,theGCH;
extern int NWin;
extern int *ExposeW,*ConfW;
extern WinPar*WinP;
extern int wF,hF;
extern int XCbNColor;
extern unsigned long int ColorPix[];

extern XEvent msg;

#ifdef OPENGL
extern Window WinGL;
extern int (*CbUserGLRoutine)(XEvent *);
#endif

extern CbUnits*XUnits;
extern int NXUnits;

extern void (*CbUserControl)(void);
extern Window theUserCW;

extern int xMessW,yMessW,kMessW;

static int hF1;
static int iT=0;
int xshift;
int CbBoxFl=0;
double CbBoxX[2]={0.,0.,},CbBoxY[2]={0.,0.};

static int Wwidth,Hheight;
static char line[128],line1[128];

static int theBk,theBx,theBy;

static int kStM=7,kStO=4,kStI=5;
extern int mSetM;
extern int mSetO;
extern int mSetI;
static int UnSetM,UnSetO,UnSetI,nx80;
static char*CbMode[]={" On ","~Sv ","~Tab","~Rd ","~Wrt"," ~X ","~Lp ","~Set"};
static char*CbMODE[]={"Off "," Sv "," Tab"," Rd "," Wrt","  X "," Lp "," Set"};
static char*CbOut[]= {"~As","~Bn","~ps"," ~X","~St"};
static char*CbOUT[]= {" As"," Bn"," ps","  X","Set"};
static char*CbInp[]= {"~Tb","~Pl","~As","~Bn"," ~X","~St"};
static char*CbINP[]= {" Tb"," Pl"," As"," Bn","  X","Set"};

typedef struct SWMENU{
char *Nm;
int L;
int n;
int w;
int k;
int sL[16];
char *s[16];
}SWMENU;

static SWMENU SwMenu[4]={
  {
    "<- Modes:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- Off / On",
    "- Save in .sv",
    "- Take from  .tb",
    "- Read from .rd",
    "- Write to .wr",
    "- X On/Off",
    "- Loop On/Off",
    "EntireBlock",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 },
  {
    "<- Outputs:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- ASCII to .ao",
    "- Binary to .bo",
    "- PostScript to .ps",
    "- X On/Off",
    "Entire Block",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 },
  {
    "<- Inputs:",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    "Take from Buff",
    "Copy to Buff",
    "Top in !-blb",
    "- Table",
    "- Graphics",
    "- ASCII from .ai",
    "- Binary from .bi",
    "- X On/Off",
    "Entire Block",
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
  },
  {
    "Save (with <mouse-M>) CPanel at",
    0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
 }
};

static int wM,wO,wI,wMOI;
static char*strID[3]= {"t0","dt","t1"};
static PanelCell*XCPCell;
static InputCell*XIDCell;
static int*nXCPCell,*kXCPCell,nXCPC,*nXIDCell,*kXIDCell,nXIDC,ixPC=0,iyPC=0;
static int iCPanelW,iclmCP= 0,ioCPanel= 0;
static int XColBut;

static double *pxg_0,*pyg_0,*pxmin,*pymin,*pxmax,*pymax,*psx,*psy;
static double xg_0,yg_0,xmin,ymin,xmax,ymax,sx,sy;

#ifdef H
char *ColorNames1[]= {"Black"
,"AntiqueWhite3","AntiqueWhite2","White"
,"Blue","SkyBlue1","lavender"
,"cyan3","cyan2","cyan"
,"DarkGreen","Green","Yellow"
,"Magenta","Red","Grey85"
,"DeepPink","orange","linen"
,"orchid1","plum2","plum1"
,"Black"					/* Text of Buttons */
,"White","AntiqueWhite2","AntiqueWhite3"	/* Help Button */
,"lavender","SkyBlue1","Blue"
,"cyan","cyan2","cyan3" 			/* Activity Button */
,"Yellow","Green","DarkGreen"			/* Return Button */
,"Grey85","Red","Magenta"
,"linen","orange","DeepPink"			/* GuiEButtons */
,"plum1","plum2","orchid1"			/* ESC Button */
,"Grey85"					/* BackGround of Windows */
,"Grey85"					/* BackGround of Plots */
,"Red"						/* Trace of Graphic data 46*/
,"cyan"						/* Table Background DataCell */
,"cyan2"					/* Inactive Data Cell */
,"Green"					/* Input Data Cell */
};
#endif

char*txtR[]= {"Enter","Save ","Save?","Save?","Save?","Save?","Save?","Read?"};
char*txtE[]= {"Esc"};
char*txtA[]= {"Active ","Passive"," Movie ","Hidden "};
char*txtM[]= {"Table ","WriteT","SavePS","Save T",
		"StT+PS","StrmPS","Strm T","Read T"};
char*txtIO[]= {"Output","Input "};


static Pixmap theP1;
static int nPixR=0,ixPixR=0,iyPixR=0,iwPixR=800,ihPixR=600;
static char FNm[0x100]="Pix/aaa";
static int NotSave=0;

int XCbSetPixR(int ix,int iy,int iw,int ih)
{
  nPixR=0;
  ixPixR=ix;
  iyPixR=iy;
  iwPixR=iw;
  ihPixR=ih;
  return(0);
}

int XCbGetPixR(int *iw,int *ih)
{
  *iw=iwPixR;
  *ih=ihPixR;
  return(0);
}

int XCbPixR2pnm()
{
  char str[0x100];
  XImage *theIm;
  long int mask=-1;
  char *lD,*lN;

  CbGetCurrentCbName(&lD,&lN);
  sprintf(FNm,"%s/Out/%s",lD,lN);
  if(WinP[NWin].iW != iwPixR || WinP[NWin].iH != ihPixR){
    WinP[NWin].iW	=iwPixR;
    WinP[NWin].iH	=ihPixR;
    XResizeWindow(theD,theHW,iwPixR,ihPixR);
  }
  theIm=XGetImage(theD,theRW,0,0,iwPixR,ihPixR,-1,ZPixmap);
  XPutImage(theD,theHW,theGC,theIm,0,0,0,0,iwPixR,ihPixR);
  sprintf(str,"xwd -id 0x%lx|xwdtopnm > %s%3.3d.ppm",theHW,FNm,nPixR);
  system(str);
  printf("%s%3.3d.ppm %d %d\n",FNm,nPixR,iwPixR,ihPixR);
  XDestroyImage(theIm);
  nPixR++;
  return(0);
}

int XCbNotSave()
{
  NotSave	=1;
  return(0);
}

int CbExit()
{
  XFreePixmap(theD,theP1);
  if(NotSave == 0) XCbSaveWindowGeom(".");
  XCbDeInitX();
  CbDeInitCb();
  return(0);
}

#ifndef stg_HELP
typedef struct HELP{
  char *v;	/* Visible text on the button */
  char *m;	/* Text in menu */
  char f[32];	/* File name with text help */
  char *t;	/* Text help */
  char dvi[64];	/* System command for .dvi help*/
  char ps[32];	/* System command for .ps help*/
}HELP;

static int nH0=6,nH1=4;
static HELP Help0[10],*Help1,lH0,lH1;

char*listH1[4];
char*listH0[6];
int XCbFreeHelpTxt()
{
  int i,n;
  n	=nH0+nH1;
  for(i=0; i < n; i++){
    if(Help0[i].t != NULL) free(Help0[i].t);
  }
  return(0);
}

int XCbInitHelpTxt()
{
  int i,k,n;
  FILE *fp;
  HELP *lH;
  char Nm[10][16]={
    "HelpH0",
    "CntrPanel",
    "HelpW0",
    "HelpMSw",
    "HelpOSw",
    "HelpISw",
    "HelpW",
    "HelpT",
    "HelpP",
    "CommControl"
  };
  sprintf(Nm[1],"%sCntr",CbGetCodeNm());

  Help1	=Help0+nH0;
  
  Help0[0].v	="Help  ";
  Help0[0].m	="Help";
  Help0[1].v	="HlpRun";
  Help0[1].m	="Running the code";
  Help0[2].v	="Help W";
  Help0[2].m	="Window";
  Help0[3].v	="ModeSw";
  Help0[3].m	="Mode Switch";
  Help0[4].v	="Out Sw";
  Help0[4].m	="Output Switch";
  Help0[5].v	="Inp Sw";
  Help0[5].m	="Input Switch";

  Help0[6].v	="Help W";
  Help0[6].m	="Window";
  Help0[7].v	="Help T";
  Help0[7].m	="GUI Table";
  Help0[8].v	="Help P";
  Help0[8].m	="Plot";
  Help0[9].v	="HelpCC";
  Help0[9].m	="Input / Output";

  n	=nH0+nH1;
  lH	=Help0;
  for(i=0; i < n; i++){
    sprintf(lH->f,"Hlp/%s.txt",Nm[i]);
    sprintf(lH->dvi,"xdvi -expert -s 6 Hlp/%s.dvi&",Nm[i]);
    sprintf(lH->ps,"gv Hlp/%s.ps&",Nm[i]);
    lH->t	=NULL;
    if(stat(lH->f,&statbuf) == 0){
      k		=statbuf.st_size;
      fp	=fopen(lH->f,"r");
      if(fp != NULL){
	lH->t	=(char*)malloc((k+1)*sizeof(char));
	fread(lH->t,1,k,fp);
	fclose(fp);
      }
    }
    if(i < nH0){
      listH0[i]		=lH->m;
    }
    else{
      k	=i-nH0;
      listH1[k]		=lH->m;
    }
    lH++;
  }

  CbMemoryL |=0x00002000;
  return(0);
}

int XCbDisplaySectHelp(int ix,int iy,int kC)
{
  switch(msg.xkey.state){
  case 0:
    XCbHelpWindow(iCPanelW,ix,iy,XCPCell[kC].pH,1);
    break;
  case 1:
  case 3:
    {
      char ln[128];
      sprintf(ln,"gv ./Hlp/%s.ps&",XCPCell[kC].pn);
      system(ln);
    }
    break;
  case 4:
  case 6:
    {
      char ln[128];
      sprintf(ln,"xdvi -expert -s 6 ./Hlp/%s.dvi&",XCPCell[kC].pn);
      system(ln);
    }
    break;
  }
  return(0);
}
#endif/*stg_HELP*/

#ifndef stg_GUI
static unsigned int xB,xB3,yB2,yB3,hB,hB2,hB3,
LR,xR,xR1,xR2,xR3,wBR,wBR3,
LE,xE,xE1,xE2,xE3,wBE,wBE3,
LA,xA,xA1,xA2,xA3,wBA,wBA3,
LM,xM,xM1,xM2,xM3,wBM,wBM3,
LH,xH,xH1,xH2,xH3,wBH,wBH3;
int XCbSetWindowButtons()
{
  hF1	=hF+1;
  wM	=4*wF+3;
  wO	=3*wF+3;
  wI	=3*wF+3;
  wMOI	=wM+wO+wI+3;

  hB	=hF;
  hB2	=hB-2;
  hB3	=hB-3;
  yB2	=hF-1;
  yB3	=hF;

  xB= 0;

  LR= 5;
  xR= xB;
  wBR= LR*wF+6;
  wBR3= wBR-3;
  xR1= xR+2;
  xR2= xR1+wBR3;
  xR3= xR2+1;

  LE= 3;
  xE= xR3+2;
  wBE= LE*wF+6;
  wBE3= wBE-3;
  xE1= xE+2;
  xE2= xE1+wBE3;
  xE3= xE2+1;

  LA= 7;
  xA= xE3+2;
  wBA= LA*wF+6;
  wBA3= wBA-3;
  xA1= xA+2;
  xA2= xA1+wBA3;
  xA3= xA2+1;

  LM= 6;
  xM= xA3+2;
  wBM= LM*wF+6;
  wBM3= wBM-3;
  xM1= xM+2;
  xM2= xM1+wBM3;
  xM3= xM2+1;

  xB3= xM1+2;

  LH= 6;
  wBH= LH*wF+6;
  wBH3= wBH-3;

  XColBut	=23;
  return(0);
}

int GuiHButton(int iW)
{
  Window W;
  int ic;
  W	=WinP[iW].W;
  xH3= WinP[iW].iW-1;
  xH2= xH3-1;
  xH1= xH2-wBH3;
  xH= xH1-2;

  ic=23;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xH,0,wBH,2);
  XFillRectangle(theD,W,theGC,xH,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xH1,2,wBH3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xH1,yB3,wBH3,1);
  XFillRectangle(theD,W,theGC,xH2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  
  ic	=WinP[iW].Hlp;
  XDrawString(theD,W,theGC,xH1+1,yB2,iW ? Help1[ic].v : Help0[ic].v,LH);
  return(0);
}

int GuiEButton(int iW)
{
  Window W;
  int ic;
  W	=WinP[iW].W;

  ic	=38;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xE,0,wBE,2);
  XFillRectangle(theD,W,theGC,xE,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xE1,2,wBE3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xE1,yB3,wBE3,1);
  XFillRectangle(theD,W,theGC,xE2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xE1+1,yB2,txtE[0],LE);
  return(0);
}

int GuiEraseRButton(Window W)
{
  int ic;
  XSetForeground(theD,theGC,ColorPix[15]);
  XFillRectangle(theD,W,theGC,xR,0,wBR,hF1);
  return(0);
}

int GuiRButton(W,m)
     Window W;
     int m;
{
  int ic;

  ic=32;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xR,0,wBR,2);
  XFillRectangle(theD,W,theGC,xR,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xR1,2,wBR3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xR1,yB3,wBR3,1);
  XFillRectangle(theD,W,theGC,xR2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xR1+1,yB2,txtR[m],LR);
  return(0);
}

int GuiERButtons(int iW)
{
  Window W;
  int ic;
  W	=WinP[iW].W;

  GuiRButton(W,0);
  ic= 38;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xE,0,wBE,2);
  XFillRectangle(theD,W,theGC,xE,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xE1,2,wBE3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xE1,yB3,wBE3,1);
  XFillRectangle(theD,W,theGC,xE2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xE1+1,yB2,txtE[0],LE);
  return(0);
}

int GuiMButton(W,m)
     Window W;
     int m;
{
  int ic;

  ic=23;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xM,0,wBM,2);
  XFillRectangle(theD,W,theGC,xM,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xM1,2,wBM3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xM1,yB3,wBM3,1);
  XFillRectangle(theD,W,theGC,xM2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xM1+1,yB2,txtM[m],LM);
  return(0);
}

int GuiIOButton(Window W,int m)
{
  int ic;

  ic=23;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xM,0,wBM,2);
  XFillRectangle(theD,W,theGC,xM,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xM1,2,wBM3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xM1,yB3,wBM3,1);
  XFillRectangle(theD,W,theGC,xM2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xM1+1,yB2,txtIO[m],LM);
  return(0);
}

int GuiAButton(W,i)
     Window W;
     int i;
{
  int ic;

  ic=29;
  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,xA,0,wBA,2);
  XFillRectangle(theD,W,theGC,xA,2,2,hB2);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xA1,2,wBA3,hB3);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,xA1,yB3,wBA3,1);
  XFillRectangle(theD,W,theGC,xA2,2,1,hB2);

  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,W,theGC,xA1+1,yB2,txtA[i],LA);
  return(0);
}

int GuiButton(Window W,int ix,int iy,int iw,int n)
{
  int ic;
  ic	=XColBut+3*n;

  XSetForeground(theD,theGC,ColorPix[ic]);
  XFillRectangle(theD,W,theGC,ix,iy,iw,2);
  XFillRectangle(theD,W,theGC,ix,iy,2,hF);

  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  iw	-=2;
  ix	+=2;
  iy	+=2;
  XFillRectangle(theD,W,theGC,ix,iy,iw,hB3);
  XSetForeground(theD,theGC,ColorPix[(++ic)]);
  XFillRectangle(theD,W,theGC,ix,iy+hB3-1,iw,1);
  XFillRectangle(theD,W,theGC,ix+iw-1,iy,1,hB3);
  return(0);
}

int GuiRect(W,ix,iy,iw,n)
     Window W;
     int ix,iy,iw,n;
{
  XSetForeground(theD,theGC,ColorPix[n ? 13 : 52]);
  XFillRectangle(theD,W,theGC,ix,iy,iw,hB);
  return(0);
}

int XCbCleanWindow(int i)
{
  XFillRectangle(theD,WinP[i].W,theGCE,0,0,WinP[i].iW,WinP[i].iH);
  return(0);
}

int GuiShowAHButtons(int i)
{
  GuiAButton(WinP[i].W,WinP[i].mode&0xF);
  GuiHButton(i);
  return(0);
}

int DisplayActivity()
{
  int i;
  for(i=0; i < NWin; i++){
    GuiAButton(WinP[i].W,WinP[i].mode&0xF);
    GuiHButton(i);
  }
  return(0);
}

int GuiReSetWP(int i)
{
  Window theP,cw;
  int x,y;
  unsigned int b,d;

  XGetGeometry(theD,WinP[i].W,&theP,&x,&y,&WinP[i].iW,&WinP[i].iH,&b,&d);
  XTranslateCoordinates(theD,WinP[i].W,theP,x,y,&WinP[i].iX,&WinP[i].iY,&cw);

  WinP[i].iw=WinP[i].iW-2*WinP[i].ix;
  WinP[i].ih=WinP[i].iH-WinP[i].iy-10;
  GuiShowAHButtons(i);
  return(0);
}

int XCbTableErase()
{
  XFillRectangle(theD,theW,theGCE,0,hF+1,Wwidth,Hheight);
  return(0);
}
#endif/*stg_GUI*/

#ifndef stg_MENU

int XCbSetMenuTexts()
{
  int i,k,ix;
  SWMENU *lM;

  UnSetM	=~mSetM-0x80;
  UnSetO	=~mSetO-0x80;
  UnSetI	=~mSetI-0x80;
  nx80		=~0x80;

  for(k=0; k < 3; k++){
    lM	=SwMenu+k;
    lM->L	=strlen(lM->Nm);
    lM->w	=0.;
    i	=0;
    while(lM->s[i] != NULL){
      ix	= strlen(lM->s[i]);
      if(lM->w < ix) lM->w	=ix;
      lM->sL[i]	=ix;
      i++;
    }
    lM->sL[i]	=0;
    lM->k	=i-1;
    lM->n	=i;
  }

  theP1	=XCreatePixmap(theD,theMW,16,8,DefaultDepth(theD,0));

  XSetForeground(theD,theGC,ColorPix[53]);
  XFillRectangle(theD,theP1,theGC,0,0,8,8);
  XSetForeground(theD,theGC,ColorPix[52]);
  XFillRectangle(theD,theP1,theGC,0,0,7,1);
  XFillRectangle(theD,theP1,theGC,0,0,1,7);
  XFillRectangle(theD,theP1,theGCH,1,1,6,1);
  XFillRectangle(theD,theP1,theGCH,1,1,1,6);
  XSetForeground(theD,theGC,ColorPix[51]);
  XFillRectangle(theD,theP1,theGC,6,1,1,6);
  XFillRectangle(theD,theP1,theGC,1,6,6,1);
  XSetForeground(theD,theGC,ColorPix[26]);
  XFillRectangle(theD,theP1,theGC,7,0,1,8);
  XFillRectangle(theD,theP1,theGC,0,7,8,1);

  ix	=8;
  XSetForeground(theD,theGC,ColorPix[50]);
  XFillRectangle(theD,theP1,theGC,ix,0,8,8);
  XSetForeground(theD,theGC,ColorPix[51]);
  XFillRectangle(theD,theP1,theGC,ix,0,8,1);
  XFillRectangle(theD,theP1,theGC,ix,0,1,8);

  XSetForeground(theD,theGC,ColorPix[26]);
  XFillRectangle(theD,theP1,theGC,ix+1,1,7,1);
  XFillRectangle(theD,theP1,theGC,ix+1,1,1,7);

  XSetForeground(theD,theGC,ColorPix[52]);
  XFillRectangle(theD,theP1,theGC,ix+6,1,1,6);
  XFillRectangle(theD,theP1,theGC,ix+1,6,6,1);

  XFillRectangle(theD,theP1,theGCH,ix+7,1,1,7);
  XFillRectangle(theD,theP1,theGCH,ix+1,7,7,1);

  return(0);
}

int XCbSetOutDirMenu()
{
  int i,L;
  SWMENU *lM;
  
  lM	=SwMenu+3;
  lM->L	=strlen(lM->Nm);
  XCbOutDirNames2Menu(lM->s);
  i	=0;
  lM->w	=lM->L;
  while(lM->s[i] != NULL){
    lM->sL[i]	=strlen(lM->s[i]);
    if(lM->w < lM->sL[i]) lM->w	=lM->sL[i];
    i++;
  }
  lM->s[i]	="Save X-Windows Layout in ./Wrk";
  lM->sL[i]	=strlen(lM->s[i]);
  if(lM->w < lM->sL[i]) lM->w=lM->sL[i];
  i++;
#ifdef H
#endif
  lM->s[i]	=NULL;
  lM->k	=i;
  lM->n	=i;
  return(0);
}

int OneChoiceMenu(int *M,char*Nm,char**llc,int n,int x,int y, int iWin)
{
  int i,kW;
  int m,iy0,iy,iym,ix;
  int L[n+1];

  kW	=NWin+1;
  x	+=WinP[iWin].iX;
  y	+=WinP[iWin].iY;
  m	=0;
  for(i=0; i < n; i++){
    L[i]	=strlen(llc[i]);
    if(m < L[i]){
      m	=L[i];
    }
  }
  WinP[kW].iH	=n*hF1+hF/2;
  if(Nm != NULL){
    L[n]	=strlen(Nm);
    if(m < L[n]){
      m	=L[n];
    }
    WinP[kW].iH	+=hF+3;
  }
  WinP[kW].iW	=3+8+(m+2)*wF;

  if(x+WinP[kW].iW > theD_w){
    x	+=theD_w-x-WinP[kW].iW;
  }
  if(y+WinP[kW].iH > theD_h){
    y	+=theD_h-y-WinP[kW].iH;
  }
  WinP[kW].iX	=x;
  WinP[kW].iY	=y;
  XMoveWindow(theD,theMW,x,y);
  XResizeWindow(theD,theMW,WinP[kW].iW,WinP[kW].iH);
  XMapWindow(theD,theMW);
  XRaiseWindow(theD,theMW);
  XSetForeground(theD,theGC,ColorPix[9]);
  XFillRectangle(theD,theMW,theGC,0,0,2,WinP[kW].iH);
  XFillRectangle(theD,theMW,theGC,0,0,WinP[kW].iW,2);
  XSetForeground(theD,theGC,ColorPix[7]);
  x	=WinP[kW].iW-2;
  y	=WinP[kW].iH-2;
  XFillRectangle(theD,theMW,theGC,x,0,2,WinP[kW].iH);
  XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,2);

  XSetForeground(theD,theGCH,ColorPix[0]);
  y	=0;
  x	=3+8+wF;

  if(Nm != NULL){
    y	=hF;
    XDrawString(theD,theMW,theGCH,3,y,Nm,L[n]);
    XSetForeground(theD,theGC,ColorPix[26]);
    XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,1);
    y++;
    XFillRectangle(theD,theMW,theGCH,0,y,WinP[kW].iW,1);
    y++;
    XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,1);
    y	+=2;
  }

  m	=*M;
  ix	=3;
  iy0	=y+hF/2;
  iy	=iy0;
  for(i=0; i < n; i++){
    y	+=hF1;
    if(i == m){
      XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,ix,iy);
      iym	=iy;
    }
    else{
      XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,ix,iy);
    }
    XDrawString(theD,theMW,theGCH,x,y,llc[i],L[i]);
    iy	+=hF1;
  }
  while(1){
    XNextEvent(theD,&msg);
    if(msg.type == ButtonPress){
      if(msg.xany.window != theMW || msg.xbutton.x < ix
	 || ix+8 <= msg.xbutton.x){
	break;
      }
      iy	=iy0;
      for(i=0; i < n; i++){
	if(iy <= msg.xbutton.y && msg.xbutton.y <= iy+8){
	  if(m != i){
	    XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,ix,iy);
	    XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,ix,iym);
	    iym	=iy;
	    m	=i;
	  }
	  break;
	}
	iy	+=hF1;
      }
    }
  }
  *M	=m;
  XUnmapWindow(theD,theMW);
  while(XCheckMaskEvent(theD,ExposureMask|StructureNotifyMask,&msg)
	|| XCheckTypedEvent(theD,UnmapNotify,&msg)){
    ;
  }
  return(msg.xbutton.button);
}

int XTAdvanceMenu(int iB,char**unit)
{
  static char*chp;

  chp= *unit;
  if(iB==2){
    chp++;
    while(*(chp-1)!='\0')
      chp++;
    if(*chp=='\0'){
      while(*(chp-1)!='\0'||*(chp-2)!='\0')
	chp--;
    }
    *unit= chp;
    return(2);
  }
  if(iB==3){
    chp--;
    while(*(chp-1)!='\0')
      chp--;
    if(*chp=='\0'){
      while(*(chp+1)!='\0'||*(chp+2)!='\0')
	chp++;
      while(*(chp-1)!='\0')
	chp--;
    }
    *unit= chp;
    return(3);
  }
  return(0);
}

int ColumnOfSmallButtons(int m,int n,char ch,int ix, int iy)
{
  XDrawString(theD,theMW,theGCH,ix,iy-hF/2,&ch,1);
  while(n){
    if((m%2)){
      XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,ix,iy);
    }
    else{
      XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,ix,iy);
    }
    iy	+=hF1;
    m	>>=1;
    n--;
  }
  return(0);
}

int XCbMenuWindow(int k,int *M,int *Madd,int *Mor,int x,int y)
{
  int kW,iWin,Fl;
  int i,j,m,iy0,iy,ix,dw;
  int xS,Xad,xO;
  int mA,mO,iA,iO;
  char **llc;
  SWMENU *lM;
  int nxE;

  dw	=0;
  if(Madd != NULL){
    mA	=*Madd;
    dw	=2;
  }
  if(Mor != NULL){
    mO	=*Mor;
    dw	=4;
  }
  lM	=SwMenu+k;
  nxE	=(0x20<<lM->k)+0x80;

  m	=*M;
  llc	=lM->s;
  iWin	=0;
  kW	=NWin+1;

  x	+=WinP[iWin].iX+2;
  y	+=WinP[iWin].iY-2;

  WinP[kW].iW	=(4+dw+lM->w)*wF;
  WinP[kW].iH	=hF1+hF1+2+lM->n*hF1;

  if(x+WinP[kW].iW > theD_w){
    x	+=theD_w-x-WinP[kW].iW;
  }
  WinP[kW].iX	=x;
  WinP[kW].iY	=y;

  XMoveWindow(theD,theMW,x,y);
  XResizeWindow(theD,theMW,WinP[kW].iW,WinP[kW].iH);
  XMapWindow(theD,theMW);
  XRaiseWindow(theD,theMW);

  /*Entire Menu Rectangle*/
  XSetForeground(theD,theGC,ColorPix[9]);
  XFillRectangle(theD,theMW,theGC,0,0,2,WinP[kW].iH);
  XFillRectangle(theD,theMW,theGC,0,0,WinP[kW].iW,2);
  XSetForeground(theD,theGC,ColorPix[7]);
  x	=WinP[kW].iW-2;
  y	=WinP[kW].iH-2;
  XFillRectangle(theD,theMW,theGC,x,0,2,WinP[kW].iH);
  XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,2);

  /*Title*/
  XSetForeground(theD,theGCH,ColorPix[0]);
  y	=hF;
  XDrawString(theD,theMW,theGCH,3,y,lM->Nm,lM->L);
  XSetForeground(theD,theGC,ColorPix[26]);
  y	+=2;
  XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,1);
  y++;
  XFillRectangle(theD,theMW,theGCH,0,y,WinP[kW].iW,1);
  y++;
  XFillRectangle(theD,theMW,theGC,0,y,WinP[kW].iW,1);

  xS	=3+8+wF+dw*wF;
  ix	=3;
  Xad	=ix+2*wF;
  xO	=ix+4*wF;

  iy0	=y+hF/2;
  iy	=iy0;
  i	=0;
  j	=0x20;
  while(lM->sL[i]){/*Item in the list*/
    y	+=hF1;
    if((m&j)){
      XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,ix,iy);
    }
    else{
      XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,ix,iy);
    }
    XDrawString(theD,theMW,theGCH,xS,y,llc[i],lM->sL[i]);
    iy	+=hF1;
    j	<<=1;
    i++;
  }
  iA	=3;
  iO	=3;
  if((m&nxE)){
    if(Madd != NULL){
      ColumnOfSmallButtons(mA>>8,lM->k-3,'|',Xad,iy0+3*hF1);
      iA	=lM->k;
    }
    if(Mor != NULL){
      ColumnOfSmallButtons(mO>>8,lM->k-3,'&',xO,iy0+3*hF1);
      iO	=lM->k;
    }
  }
  Fl	=1;
  while(Fl){
    XNextEvent(theD,&msg);
    if(msg.type == ButtonPress){
      Fl	=0;
      if(msg.xany.window != theMW) break;
      dw	=msg.xbutton.x-ix;
      if(0 <= dw && dw <= 8){
	iy	=iy0;
	i	=0;
	j	=0x20;
	while(i < lM->n){
	  dw	=msg.xbutton.y-iy;
	  if(0 <= dw && dw <= 8){
	    m	^=j;
	    if((m&j)){
	      XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,ix,iy);
	    }
	    else{
	      XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,ix,iy);
	    }
	    Fl	=1;
	  }
	  iy	+=hF1;
	  j	<<=1;
	  i++;
	}
      }
      if(Madd != NULL){
	if((m&nxE)){
	  if(iA < 4){
	    ColumnOfSmallButtons(mA>>8,lM->k-3,'|',Xad,iy0+3*hF1);
	    iA	=lM->k;
	  }
	  dw	=msg.xbutton.x-Xad;
	  if(0 <= dw && dw <= 8){
	    iy	=iy0+3*hF1;
	    i	=3;
	    j	=0x100;
	    while(i < lM->k){
	      dw	=msg.xbutton.y-iy;
	      if(0 <= dw && dw <= 8){
		mA	^=j;
		if((mA&j)){
		  XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,Xad,iy);
		}
		else{
		  XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,Xad,iy);
		}
		Fl	=1;
	      }
	      iy	+=hF1;
	      j	<<=1;
	      i++;
	    }	
	  }
	}
	else{
	  if(iA > 3){
	    XSetForeground(theD,theGC,ColorPix[8]);
	    XFillRectangle(theD,theMW,theGC,Xad,iy0+2*hF1,8,hF1*(iA-2));
	    iA	=3;
	    mA	=*Madd;
	  }
	}
      }
      if(Mor != NULL){
	if((m&nxE)){
	  if(iO < 4){
	    ColumnOfSmallButtons(mO>>8,lM->k-3,'&',xO,iy0+3*hF1);
	    iO	=lM->k;
	  }
	  dw	=msg.xbutton.x-xO;
	  if(0 <= dw && dw <= 8){
	    iy	=iy0+3*hF1;
	    i	=3;
	    j	=0x100;
	    while(i < lM->k){
	      dw	=msg.xbutton.y-iy;
	      if(0 <= dw && dw <= 8){
		mO	^=j;
		if((mO&j)){
		  XCopyArea(theD,theP1,theMW,theGC,0,0,8,8,xO,iy);
		}
		else{
		  XCopyArea(theD,theP1,theMW,theGC,8,0,8,8,xO,iy);
		}
		Fl	=1;
	      }
	      iy	+=hF1;
	      j	<<=1;
	      i++;
	    }	
	  }
	}
	else{
	  if(iO > 3){
	    XSetForeground(theD,theGC,ColorPix[8]);
	    XFillRectangle(theD,theMW,theGC,xO,iy0+2*hF1,8,hF1*(iO-2));
	    iO	=3;
	    mO	=*Mor;
	  }
	}
      }
    }
  }
  *M	=m;
  if(Madd != NULL) *Madd	=mA;
  if(Mor != NULL) *Mor	=mO;
  XUnmapWindow(theD,theMW);
  while(XCheckMaskEvent(theD,ExposureMask|ConfigureNotify,&msg)
	|| XCheckTypedEvent(theD,UnmapNotify,&msg)){
    ;
  }
  return(msg.xbutton.button);
}

#endif/*stg_MENU*/

#ifndef stg_EVENTS
int WinNumber(nw)
     int*nw;
{
  *nw	=0;
  while(*nw < NWin && msg.xany.window != WinP[*nw].W){
    (*nw)++;
  }
  if(*nw < NWin){
    return(1);
  }
  else{
    return(0);
  }
}

int CheckActivity()
{
  int i,m;

  if(WinNumber(&i) == 0){
    return(0);
  }
  if(0 <= theBy && theBy <= hF){
    if(xA <= theBx && theBx <= xA3){
      m	=WinP[i].mode&0xF;
      if(theBk == 1){
	m++;
      }
      else{
	m--;
      }
      if(m > 3){
	m	=0;
      }
      if(m < 0){
	m	=3;
      }
      WinP[i].mode	&=0xF0;
      WinP[i].mode	|=m;
      if(i == itheW){
	Wmode	=WinP[i].mode;
      }
      GuiAButton(msg.xany.window,m);
      return(0);
    }

    if(i == itheW && xM <= theBx && theBx <= xM3){
      m	=(WinP[i].mode>>4)&0xF;
      if(theBk == 1){
	m++;
      }
      else{
	m--;
      }
      if(m > 7){
	m	=0;
      }
      if(m < 0){
	m	=7;
      }
      WinP[i].mode	&=0x0F;
      WinP[i].mode	|=(m<<4);
      if(m){
	GuiRButton(theW,m);
      }
      Wmode= WinP[i].mode;
      GuiMButton(msg.xany.window,m);
      return(0);
    }

    xH3	=WinP[i].iW-1;
    xH	=xH3-3-wBH3;
    if(xH <= theBx && theBx <= xH3){
      m	=WinP[i].Hlp;
      if(theBk == 2){
	m++;
	if((i && m == nH1) || (i == 0 && m == nH0)){
	  m	=0;
	}
	WinP[i].Hlp	=m;
	GuiHButton(i);
	return(0);
      }
      switch(msg.xkey.state){
      case 0:
	if(theBk ==1){
	  if(i){
	    OneChoiceMenu(&m,"Help for :",listH1,nH1,xH,hF,i);
	  }
	  else{
	    OneChoiceMenu(&m,"Help for :",listH0,nH0,xH,hF,i);
	  }
	  WinP[i].Hlp	=m;
	  GuiHButton(i);
	}
	XCbHelpWindow(i,xH,hF+1,i ? Help1[m].t : Help0[m].t,i ? 2 : 3);
	break;
      case 1:
      case 3:
	system(i ? Help1[m].ps : Help0[m].ps);
	break;
      case 4:
      case 6:
	system(i ? Help1[m].dvi : Help0[m].dvi);
	break;
      }
      msg.xkey.state	=0;
      return(4);
    }
  }
  return(0);

}

int XIDShowCells()
{
  int i,ix,kD,m;
  int iw,iy,iy1,iwd,ixu,iy2,ix2,iw2;
  char**p,str[LBLBID+1];

  for(i=0; i < nXIDC; i++){
    kD=kXIDCell[i];
    ix=ixPC+XIDCell[kD].x;
    iy=iyPC+XIDCell[kD].y;
    iy1= iy+hB3;
    if(ix+XIDCell[kD].w > 0 && ix < Wwidth){
      if(XIDCell[kD].ids == 0){
	if(ioCPanel == 0){
	  XSetForeground(theD,theGC,ColorPix[47]);
	  XFillRectangle(theD,CPanelW,theGC,ix,iy,XIDCell[kD].w,hF);
	  XSetForeground(theD,theGC,ColorPix[22]);
	  XDrawString(theD,CPanelW,theGC,ix,iy1,XIDCell[kD].pv,LBLBID);
	}
	else{
	  GuiButton(CPanelW,ix,iy,XIDCell[kD].w+4,0);
	  XSetForeground(theD,theGC,ColorPix[22]);
	  m=*XIDCell[kD].vs;
	  p=(char**)XIDCell[kD].ps;
	  XDrawString(theD,CPanelW,theGC,ix+2,iy1,p[m],LBLBID);
	}
      }
      else{
	XIDCell[kD].pn=strID[XIDCell[kD].h];
	iwd=5*wF;
	iw=XIDCell[kD].w-iwd;
	ixu=ix+iw;
	GuiButton(CPanelW,ix,iy,iw,2);
	XSetForeground(theD,theGC,ColorPix[47]);
	XFillRectangle(theD,CPanelW,theGC,ixu,iy,iwd,hF);
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,CPanelW,theGC,ix+3,iy1,XIDCell[kD].pn,2);
	numstr(*(double*)XIDCell[kD].pv,str,5);
	XDrawString(theD,CPanelW,theGC,ixu,iy1,str,5);
      }
    }
  }
  return(0);
}

int ConfExposeAction()
{
  int i,k;
  static unsigned int x,y,w,h;

#ifdef H
  XSetInputFocus(theD,theW,RevertToPointerRoot,CurrentTime);
  XGrabButton(theD,AnyButton,AnyModifier,theW,True,ButtonRelease
	      ,GrabModeAsync,GrabModeAsync,None,None);
  XUngrabButton(theD,AnyButton,AnyModifier,theW);
  XGrabPointer(theD,theW,True,ButtonRelease
	       ,GrabModeAsync,GrabModeAsync,None,None,CurrentTime);
  XFlush(theD);
  XUngrabPointer(theD,CurrentTime);
  XFlush(theD);
#endif
  k	=0;
  while(msg.type == Expose || msg.type == NoExpose
	|| msg.type == ConfigureNotify){
    if(WinNumber(&i)){
      if(msg.type == Expose) ExposeW[i] |=1;
      if(msg.type == ConfigureNotify) ConfW[i] |=1;
      if(i == iCPanelW && msg.type != NoExpose){
	XCbCleanWindow(i);
	if(itheW == iCPanelW){
	  GuiERButtons(i);
	}
	else{
	  if(ioCPanel == 0) GuiRButton(CPanelW,1);
	}
	GuiIOButton(CPanelW,ioCPanel);
#ifdef H
	XCopyArea(theD,pixCP,CPanelW,theGC,0,0,w,h,ixPC+x,iyPC+y);
#endif
	GuiReSetWP(iCPanelW);
	XIDShowCells();
	XCPanelShowCells();
	ConfW[i]	=0;
	ExposeW[i]	=0;
      }
    }
    XNextEvent(theD,&msg);
#ifdef H
    out("iisiIs",i,NWin,"  --Event",msg.type,msg.xany.window
	,EventNm[msg.type]);
#endif
  }
  k	=0;
  for(i=0; i < NWin; i++){
    if(ConfW[i]){
      if(GuiReSetWP(i))	ExposeW[i] |=1;
      ConfW[i]	=0;
    }	
    if(ExposeW[i]){
      ExposeW[i]	=0;
      if(i == itheW) k=1;
      GuiShowAHButtons(i);
    }
  }
  return(k);
}

int ingtxt(char str[],int len,int *il,int ix0,int iy0)
{
  int t;
  KeySym key,inds;
  int j,ix,iy,n_last,l,l_m1,iwin;

  l_m1	=len-1;
  iy	=iy0+hF-1;

  if(len){
    XSetForeground(theD,theGC,ColorPix[49]);
    XFillRectangle(theD,theW,theGC,ix0,iy0,len*wF,hF);
    XSetForeground(theD,theGC,ColorPix[22]);
    XDrawString(theD,theW,theGC,ix0,iy-2,str,len);
    l	=*il;
    while(str[l] == ' ' && l) l--;
    ix	=ix0+l*wF;
    XDrawRectangle(theD,theW,theGC,ix,iy-1,wF,2);	/* cursor */
  }
  n_last	=0;
  do{
    do{
      XNextEvent(theD,&msg);
      t	=msg.type;
      if(kMessW){
	if(msg.xany.window == theHW){
	  if(t == MotionNotify){
	    theBx	=msg.xmotion.x;
	    theBy	=msg.xmotion.y;
	    do{
	      XWindowEvent(theD,theHW,Button1MotionMask|ButtonReleaseMask
			   ,&msg);
	      xMessW	+=msg.xmotion.x-theBx;
	      yMessW	+=msg.xmotion.y-theBy;
	      XMoveWindow(theD,theHW,xMessW,yMessW);
	    }while(msg.type == MotionNotify);
	  }
	  t	=msg.type;
	}
	else{
	  if(t == ButtonPress || t == KeyPress){
	    XUnmapWindow(theD,theHW);
	    kMessW	=0;
	  }
	}
      }
    }while(msg.type == UnmapNotify|| msg.type == MapNotify
	   || msg.type == EnterNotify);

#ifdef OPENGL
    if(CbUserGLRoutine != NULL && msg.xany.window == WinGL){
      CbUserGLRoutine(&msg);
    }
#endif

#ifdef H
    out("siIs","Event",msg.type,msg.xany.window,EventNm[msg.type]);
#endif
    if(CbUserControl != NULL && msg.xany.window == theUserCW){
      CbUserControl();
      return(5);
    }
    if(msg.type == ConfigureNotify || msg.type == Expose){
     ConfExposeAction();
      *il	=l;
#ifdef H
      return(4);
#endif
    }
    switch(msg.type){
    case ButtonPress:
      theBk	=msg.xbutton.button;
      theBx	=msg.xbutton.x;
      theBy	=msg.xbutton.y;
      if(msg.xany.window == CPanelW){
	if(XCbIfCPanelRE() < 4){
	  if(CpPos() >= 0) break;
	  if(theW != CPanelW){
	    CheckCPanelIO();
	  }
	  else{
	    CheckActivity();
	  }
	}
      }
      else{
	CheckActivity();
      }
      break;
    case MapNotify:
      if(WinNumber(&iwin)){
	WinP[iwin].state= 1;
	GuiShowAHButtons(iwin);
      }
      if(msg.xany.window==CPanelW){
	XIDShowCells();
	XCPanelShowCells();
      }
      break;
    case UnmapNotify:
      if(WinNumber(&j)){
	WinP[j].state= 0;
	WinP[j].mode|= 3;
      }
      break;
    }
    if(msg.xany.window == theW || msg.type == KeyPress){
      switch(msg.type){
      case UnmapNotify:
	*il	=l;
	return(0);
      case ButtonPress:
	theBk	=msg.xbutton.button;
	theBx	=msg.xbutton.x;
	theBy	=msg.xbutton.y;	
	if(theBy <= iy && iy-hF <= theBy && theBx <= ix0+len*wF
	   && ix0 <= theBx){ 
	  int k;
	  k	=(theBx-ix0)/wF;
	  if(k != l){
	    XDrawRectangle(theD,theW,theGCE,ix,iy-1,wF,2);	/* cursor */
	    l	=k;
	    ix	=ix0+k*wF;
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,ix,iy-1,wF,2);	/* cursor */
	  }
	}
	else{
	  XDrawRectangle(theD,theW,theGCE,ix,iy,wF,0);
	  *il	=l;
	  return(msg.xbutton.button);
	}
	break;
      case KeyPress:
	key	=XKeycodeToKeysym(theD,msg.xkey.keycode,0);
	inds	=0xff00&key;
	if(inds){
	  switch(key){
	  case XK_Escape:
	    *il	=l;
	    return(key^inds);
	  case XK_Return:
	    key	='\r';
	  case XK_Home:
	  case XK_End:
	    *il	=l;
	    return(key);
	  case XK_Left:
	  case XK_Right:
	  case XK_Up:
	  case XK_Down:
	    XDrawRectangle(theD,theW,theGCE,ix,iy-1,wF,2);
	    *il	=l;
	    return(key);
#ifdef H
	  case XK_Delete:
#endif
	  case XK_BackSpace:
	    if(l&&len){
	      XDrawRectangle(theD,theW,theGCE,ix,iy-1,wF,2);	/* cursor */
	      l--;
	      ix	-=wF;
	      str[l]= ' ';
	      XSetForeground(theD,theGC,ColorPix[49]);
	      XFillRectangle(theD,theW,theGC,ix,iy0,wF,hF);
	      XSetForeground(theD,theGC,ColorPix[22]);
	      XDrawRectangle(theD,theW,theGC,ix,iy-1,wF,2);	/* cursor */
	    }
	    break;
#ifdef H
	  case XK_BackSpace:
#endif
	  case XK_Delete:
	    if(len){
	      XSetForeground(theD,theGC,ColorPix[49]);
	      XFillRectangle(theD,theW,theGC,ix,iy0,wF,hF);
	      str[l]= ' ';
	      if(l<l_m1){
		XDrawRectangle(theD,theW,theGCE,ix,iy-1,wF,2);	/* cursor */
		l++;
		ix	+=wF;
		XSetForeground(theD,theGC,ColorPix[22]);
		XDrawRectangle(theD,theW,theGC,ix,iy-1,wF,2);	/* cursor */
	      }
	    }
	    break;
	  }
	}
	else{
	  switch(msg.xkey.state){
	  case 1:
	    if(0x5A < key && key < 0x5E){
	      key	+=0x20;
	      break;
	    }
	    switch(key){
	    case XK_0:key= ')';break;
	    case XK_1:key= '!';break;
	    case XK_2:key= 0x40;break;
	    case XK_3:key= '#';break;
	    case XK_4:key= '$';break;
	    case XK_5:key= '%';break;
	    case XK_6:key= '^';break;
	    case XK_7:key= '&';break;
	    case XK_8:key= '*';break;
	    case XK_9:key= '(';break;
	    case '`':key= '~';break;
	    case '-':key= '_';break;
	    case '=':key= '+';break;
	    case ',':key= '<';break;
	    case '.':key= '>';break;
	    case '/':key= '?';break;
	    case ';':key= ':';break;
	    case 0x27:key= '"';break;
	    }
	  case 2:
	    if(0x60 < key && key < 0x7B)
	      key	-=0x20;
	    break;
	  case 4:
	  case 6:
	    if(0x60 < key && key < 0x7B)
	      key	-=0x60;
	    break;
	  }
	  switch(key){
	  case 1:
	    XCbSwitchColorMap();
	    break;
	  case 2:
	    CbBoxFl	|=1;
	    *il	=l;
	    return(4);
	  case 8:
	    printf("Cntr-h - this help.\n");
	    printf("Cntr-c - terminates the code normally.\n");
	    printf("Cntr-b - activates Box limits for plotting.\n");
	    printf("Cntr-m - magnifies the plot. Activates Box limits.\n");
	    printf("Cntr-n - normalizes and\n");
	    printf("         activates plot Box limits.\n");
	    printf("Cntr-q - deactivate plot Box limits.\n");
	    printf("Cntr-r - shrink the plot. Activates Box limits.\n");
	    printf("Shift-XK_Left,Right,Up,Down - moves\n");
	    printf("         the plot. Activates Box limits.\n");
	    printf("Cntr-Button-L-motion then Button M Click- \n");
	    printf("         specify plotting Box limits.\n");
	    printf("Shft-Button-L-motion then Button M Click- \n");
	    printf("         specify shift in plot.\n");
	    break;
	  case 13:
	    {
	      double x,dx;
	      dx	=0.45*(CbBoxX[1]-CbBoxX[0]);
	      x		=0.5*(CbBoxX[1]+CbBoxX[0]);
	      CbBoxX[0]	=x-dx;
	      CbBoxX[1]	=x+dx;
	      dx	=0.45*(CbBoxY[1]-CbBoxY[0]);
	      x		=0.5*(CbBoxY[1]+CbBoxY[0]);
	      CbBoxY[0]	=x-dx;
	      CbBoxY[1]	=x+dx;
	    }
	    CbBoxFl	|=8+4+1;
	    *il	=l;
	    return(4);
	  case 14:
	    out("sdddd","0 CbBox=",CbBoxX[0],CbBoxX[1],CbBoxY[0],CbBoxY[1]);
	    CbBoxFl	|=4;
	    *il	=l;
	    return(4);
	  case 15: /* o,O */
	    XCbPixR2pnm();
	    break;
	  case 17:
	    CbBoxFl	|=2;
	    *il	=l;
	    return(4);
	  case 18:
	    {
	      double x,dx;
	      dx	=0.55*(CbBoxX[1]-CbBoxX[0]);
	      x		=0.5*(CbBoxX[1]+CbBoxX[0]);
	      CbBoxX[0]	=x-dx;
	      CbBoxX[1]	=x+dx;
	      dx	=0.55*(CbBoxY[1]-CbBoxY[0]);
	      x		=0.5*(CbBoxY[1]+CbBoxY[0]);
	      CbBoxY[0]	=x-dx;
	      CbBoxY[1]	=x+dx;
	    }
	    CbBoxFl	|=8+4+1;
	    *il	=l;
	    return(4);
	  case 26:
	    *il	=l;
	    return(key);
	  case 3:
	    CbExit();
	    exit(0);
	  }
	  if(key > 31 && len){
	    if(l < l_m1){
	      str[l]= key;
	      XSetForeground(theD,theGC,ColorPix[49]);
	      XFillRectangle(theD,theW,theGC,ix,iy0,wF,hF);
	      XDrawRectangle(theD,theW,theGCE,ix,iy-1,wF,2);	/* cursor */
	      XSetForeground(theD,theGC,ColorPix[22]);
	      XDrawString(theD,theW,theGC,ix,iy-2,str+l,1);
	      l++;
	      ix	+=wF;
	      XDrawRectangle(theD,theW,theGC,ix,iy-1,wF,2);	/* cursor */
	      n_last= 0;
	    }
	    else{
	      if(n_last){
		for(l=0; l < l_m1; l++) str[l]=str[l+1];
		str[l]=key;
		XSetForeground(theD,theGC,ColorPix[49]);
		XFillRectangle(theD,theW,theGC,ix0,iy0,wF*len,hF);
		XSetForeground(theD,theGC,ColorPix[22]);
		XDrawString(theD,theW,theGC,ix0,iy-2,str,len);
	      }
	      else{
		str[l]	=key;
		XSetForeground(theD,theGC,ColorPix[49]);
		XFillRectangle(theD,theW,theGC,ix,iy0,wF,hF);
		XSetForeground(theD,theGC,ColorPix[22]);
		XDrawString(theD,theW,theGC,ix,iy-2,str+l,1);
		n_last=1;
	      }
	    }
	  }
	}
      }
    }
  }while(1);
}

int CheckIfEvents()
{
  static int i;

  while(XCheckMaskEvent(theD,
			ButtonPressMask|ExposureMask|StructureNotifyMask,
			&msg)){
    if(msg.type == ButtonPress){
      theBk	=msg.xbutton.button;
      theBx	=msg.xbutton.x;
      theBy	=msg.xbutton.y;
      CheckActivity();
    }
    if(WinNumber(&i) == 0) return 0;
    switch(msg.type){
    case ConfigureNotify:
      if(msg.xconfigure.send_event){
#ifdef H
	WinP[i].iX= msg.xconfigure.x;
	WinP[i].iY= msg.xconfigure.y;
	WinP[i].iX= msg.xconfigure.x-3;
	WinP[i].iY= msg.xconfigure.y-21;
	WinP[i].iX= msg.xconfigure.x-4;
	WinP[i].iY= msg.xconfigure.y-22;
#endif
      }
      WinP[i].iW= msg.xconfigure.width;
      WinP[i].iH= msg.xconfigure.height;
      WinP[i].iw= WinP[i].iW-2*WinP[i].ix;
      WinP[i].ih= WinP[i].iH-WinP[i].iy-10;
      GuiAButton(msg.xany.window,WinP[i].mode&0xF);
      GuiMButton(msg.xany.window,(WinP[i].mode>>4)&0xF);
      break;
    case Expose:
      if(i == iCPanelW){
	XCbCleanWindow(i);
	if(itheW == iCPanelW){
	  GuiERButtons(i);
	}
	else{
	  if(ioCPanel == 0) GuiRButton(CPanelW,1);
	}
	GuiIOButton(CPanelW,ioCPanel);
	GuiReSetWP(iCPanelW);
	XIDShowCells();
	XCPanelShowCells();
	ConfW[i]	=0;
	ExposeW[i]	=0;
      }
#ifdef H
      i=XEventsQueued(theD,QueuedAfterReading);
      out("sI","XEventsQueued=",i);
#endif
      break;
    case MapNotify:
      if(WinNumber(&i)){
	WinP[i].state= 1;
	GuiShowAHButtons(i);
      }
      break;
    case UnmapNotify:
      WinP[i].state= 0;
      WinP[i].mode|= 3;
      break;
    }
  }
  return(0);
}

int IsButtonPress()
{
  XMaskEvent(theD,ButtonPressMask,&msg);
  return(msg.xbutton.button);
}

int CheckIfButtonEvents()
{
  while(XCheckMaskEvent(theD,ButtonPressMask,&msg)){
    theBk	=msg.xbutton.button;
    theBx	=msg.xbutton.x;
    theBy	=msg.xbutton.y;
    CheckActivity();
  }
  return(0);
}

int CbCheckIfEvents()
{
  int i;
  while(XCheckMaskEvent(theD,ButtonPressMask|ButtonReleaseMask,&msg)){
    theBk	=msg.xbutton.button;
    theBx	=msg.xbutton.x;
    theBy	=msg.xbutton.y;
    if(msg.xany.window == CPanelW){
      CpPos();
    }
    else{
      CheckActivity();
    }
  }
  return(0);
}

int EvGetCntrKey()
{
  KeySym key,inds;
  int iW;

  do{
    XNextEvent(theD,&msg);
#ifdef H
    out("siIs","cc Event",msg.type,msg.xany.window,EventNm[msg.type]);
#endif
    if(msg.type == ConfigureNotify || msg.type == Expose){
      if(ConfExposeAction()) return(4);
    }
    switch(msg.type){
    case ButtonPress:
      theBk	=msg.xbutton.button;
      theBx	=msg.xbutton.x;
      theBy	=msg.xbutton.y;
      CheckCPanelIO();
      return(theBk);
    case MapNotify:
      if(WinNumber(&iW)){
	WinP[iW].state	=1;
	GuiAButton(WinP[iW].W,WinP[iW].mode&0xF);
#ifdef H
	if(iW != iCPanelW){
	  GuiMButton(WinP[iW].W,(WinP[iW].mode>>4)&0xF);
	}
	else{
	  GuiIOButton(CPanelW,ioCPanel);
	}
#endif
	GuiHButton(iW);
      }
      break;
    case UnmapNotify:
      if(WinNumber(&iW)){
	WinP[iW].state= 0;
	WinP[iW].mode|= 3;
      }
      if(iW == iCPanelW){
	return(4);
      }
      break;
    case KeyPress:
      key	=XKeycodeToKeysym(theD,msg.xkey.keycode,0);
      switch(key){
      case XK_Escape:
	return((int)27);
      case XK_Return:
	return((int)'\r');
      }
      if(msg.xkey.state == 4){
	switch(key){
	case XK_z:
	case XK_Z:
	  return((int)26);
	case XK_c:
	case XK_C:
	  CbExit();
	  exit(0);
	}
      }
      break;
    }
  }while(1);
}
#endif/*stg_EVENTS*/

#ifndef stg_Table
int CbSend2XUTable(int iTable)
{
  iT	=iTable;
  return(0);
}

int XCbInitTblPlotAddress(Xg_0,Yg_0,Xmin,Ymin,Xmax,Ymax,Sx,Sy)
     double *Xg_0,*Yg_0,*Xmin,*Ymin,*Xmax,*Ymax,*Sx,*Sy;
{
  pxg_0	=Xg_0;
  pyg_0	=Yg_0;
  pxmin	=Xmin;
  pymin	=Ymin;
  pxmax	=Xmax;
  pymax	=Ymax;
  psx	=Sx;
  psy	=Sy;
  return(0);
}

int XCbSetPlotLimits(double *gdx,double *gdy,int *xg0,int *yg0,int*xg1,int*yg1)
{
  xg_0	=*pxg_0;
  yg_0	=*pyg_0;
  xmin	=*pxmin;
  ymin	=*pymin;
  xmax	=*pxmax;
  ymax	=*pymax;
  sx	=*psx;
  sy	=*psy;
  *gdx	=(xmax-xmin)*0.001;
  *gdy	=(ymax-ymin)*0.001;
  *xg0	=(int)(xg_0-2.);
  *yg0	=(int)(yg_0+2.);
  *xg1	=(int)(xg_0+(xmax-xmin)*sx+2.);
  *yg1	=(int)(yg_0+(ymax-ymin)*sy-2.);
  return(0);
}

int XCbGetPlotLimits(double *xg0,double *pxmn,double *pxmx,double *psx
		     ,double *yg0,double *pymn,double *pymx,double *psy)
{
  *xg0	=xg_0;
  *yg0	=yg_0;
  *pxmn	=xmin;
  *pymn	=ymin;
  *pxmx	=xmax;
  *pymx	=ymax;
  *psx	=sx;
  *psy	=sy;
  return(0);
}

int Show1DDot(InputCell *lC,int ic)
{
  int ix;
  double x;
  XSetForeground(theD,theGC,ColorPix[ic]);
  switch((lC->ids&7)){
  case 1:
    x	=*(double*)lC->pv;
    break;
  case 2:
  case 5:
    x	=*(int*)lC->pv;
    break;
  default:
    break;
  }
  ix	=(int)(xg_0+(x-xmin)*sx)-2;
  XDrawRectangle(theD,theW,theGC,ix,(int)yg_0-6,4,4);
  return(0);
}

int XCbDotShow(InputCell*data,int nkx,int *kx2j,int *ky2j
	     ,int *kx,int *ky,double gdx,double gdy)
{
  int i,ik,icol;
  double x,y;

  for(ik=0; ik < nkx; ik++){
    i	=kx2j[ik];
    if((data[i].ids&7) == 2 || (data[i].ids&7) == 4){
      x	=(double)(*(int*)data[i].pv);
      y	=(double)(*(int*)data[ky2j[ik]].pv);
    }
    else{
      x	=*(double*)data[i].pv;
      y	=*(double*)data[ky2j[ik]].pv;
    }
    if(xmin <= x+gdx && x <=xmax+gdx && ymin <= y+gdy
       && y <= ymax+gdy){
      kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
      ky[ik]	=(int)(yg_0+(y-ymin)*sy)-2;
      icol	=data[i].c&0xff;
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
      if(icol == 9){
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawRectangle(theD,theW,theGC,kx[ik],ky[ik],4,4);
      }
    }
    else{
      kx[ik]	=-4;
      ky[ik]	=-4;
    }
  }
  return(0);
}

int ZTableShow(InputCell *data,int n_data)
{
  int i,ii,ix;
  int iy,length;

  for(i=0; i < n_data; i++){
    ix	=xshift+data[i].x;
    if(ix+data[i].w > 0 && ix < Wwidth){
      iy	=data[i].y;
      length	=data[i].l;
      if((data[i].ids&8)){
	GuiButton(theW,ix,iy,data[i].wn,3);
      }
      else{
	XSetForeground(theD,theGC,ColorPix[48]);
/****/
	XSetForeground(theD,theGC,ColorPix[12]);

	XFillRectangle(theD,theW,theGC,ix,iy,data[i].wn,hB);
      }
      XSetForeground(theD,theGC,ColorPix[data[i].c&0xff]);
      XFillRectangle(theD,theW,theGC,xshift+data[i].xd,iy,data[i].wd,hB);
      if(data[i].ws){
	GuiButton(theW,xshift+data[i].xs,iy,data[i].ws,0);
      }
      if(data[i].lu){
	GuiButton(theW,xshift+data[i].xu,iy,data[i].wu,0);
      }
      XSetForeground(theD,theGC,ColorPix[22]);
      iy	+=hB3;
      if(data[i].ln){
	XDrawString(theD,theW,theGC,ix+2,iy,data[i].pn,strlen(data[i].pn));
      }
      if(data[i].ws){
	XDrawString(theD,theW,theGC,xshift+data[i].xs+3,iy,data[i].ps,1);
      }
      switch((data[i].ids&7)){
      case 0:
	if(length){
	  ii	=CbStrCpy1(line,data[i].pv);
	  for(; ii < length; ii++){
	    *(line+ii)=' ';
	  }
	  *(line+length)= '\0';
	  XDrawString(theD,theW,theGC,xshift+data[i].xd+2,iy,line,length);
	}
	break;
      case 1:
	numstr(*(double*)data[i].pv,line,length);
	XDrawString(theD,theW,theGC,xshift+data[i].xd+2,iy,line,length);
	break;
      case 2:
	sprintf(line,"%10d",*(int*)data[i].pv);
	XDrawString(theD,theW,theGC,xshift+data[i].xd+2,iy,
		    line+10-length,length);
	line[10]= '\0';
	break;
      case 5:
	ii	=*(int*)data[i].pv;
	if(ii < 0 && ii > -100){
	  sprintf(line,"    -0.%2.2d",abs(ii));
	}
	else{
	  sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
	}
	XDrawString(theD,theW,theGC,xshift+data[i].xd+2,iy,line,length);
	break;
      }
      if(data[i].lu){
	XDrawString(theD,theW,theGC,xshift+data[i].xu+2,iy,
		    data[i].pu,data[i].lu);
      }
    }
  }
  return(0);
}

int XCb2DTableInput(iWin,L,data,n_data,kx2j,ky2j,j2kx,j2ky,kx,ky,nkx,iclm)
     int iWin,L;
     InputCell*data;
     int n_data,*kx2j,*ky2j,*j2kx,*j2ky,*kx,*ky,nkx,*iclm;
{
  KeySym k;
  int i,ii,ix,ix1,iy,iw,ih,itab;
  int j,length,icol;
  double x,y,dx,dy,gdx,gdy;
  int ik,iy0,xg0,yg0,xg1,yg1;
  int pW,pH;
  char *p;
  float s;

  XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
  theW		=WinP[iWin].W;
  itheW		=iWin;
  Wwidth	=WinP[iWin].iW;
  Hheight	=L*(hF+1);
  Wmode= WinP[iWin].mode;

  pW	=xg1-xg0;
  pH	=yg0-yg1;

  XCbTableErase();
  GuiERButtons(iWin);
  GuiAButton(theW,Wmode&0xF);
  GuiMButton(theW,(Wmode>>4)&0xF);
  GuiHButton(iWin);
  i= data[*iclm].x+data[*iclm].w;
  j= xshift+i;
  if(j > Wwidth-wF){
    xshift= Wwidth/2-data[*iclm].x;
    if(xshift+i > Wwidth-wF) xshift=Wwidth-wF-i;
  }

  ZTableShow(data,n_data);

  for(ik=0; ik < nkx; ik++){
    i	=kx2j[ik];
    if((data[i].ids&7)==2){
      x	=(double)*(int*)data[i].pv;
      y	=(double)*(int*)data[ky2j[ik]].pv;
    }
    else{
      x= *(double*)data[i].pv;
      y= *(double*)data[ky2j[ik]].pv;
    }
    if(xmin <= x+gdx && x <= xmax+gdx && ymin <= y+gdy && y <= ymax+gdy){
      kx[ik]= (int)(xg_0+(x-xmin)*sx)-2;
      ky[ik]= (int)(yg_0+(y-ymin)*sy)-2;
      icol	=data[i].c&0xff;
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
      if(icol == 9){
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawRectangle(theD,theW,theGC,kx[ik],ky[ik],4,4);
      }
    }
    else{
      kx[ik]=-4;
      ky[ik]=-4;
    }
  }
  do{
    i	=data[*iclm].x+data[*iclm].w;
    j	=xshift+i;
    if(j > Wwidth-wF){
      xshift	= Wwidth/2-data[*iclm].x;
      if(xshift+i > Wwidth-wF) xshift=Wwidth-wF-i;
    }
    ix	=xshift+data[*iclm].x;
    if(ix < wF-wF){
      xshift= Wwidth/2-data[*iclm].x;
      if(xshift+data[0].x > 0) 	xshift= 0;
      if(xshift+i>Wwidth-wF) xshift= Wwidth-wF-i;
    }
    if(j > Wwidth-wF || ix < wF-wF){
      iy	=hF+1;
      ih	=data[n_data-1].y-data[0].y+hF+1;
      XFillRectangle(theD,theW,theGCE,0,hF+1,Wwidth,Hheight);
      ZTableShow(data,n_data);
    }
    j	=*iclm;
    icol=data[j].c&0xff;
    ix	=xshift+data[j].xd+2;
    iy	=data[j].y;
    ih	=data[j].h;
    length= data[j].l;
    if(nkx && j2kx[j] >= 0){
      ik	=j2kx[j];
      if(xg0 <= kx[ik] && kx[ik] <= xg1 && yg1 <= ky[ik] && ky[ik] <= yg0){
	XSetForeground(theD,theGC,ColorPix[46]);
	XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
      }
    }
    switch((data[j].ids&7)){
    case 0:
      if(length){
	ii	=CbStrCpy1(line,data[j].pv);
	for(;ii<length;ii++) *(line+ii)=' ';
      }
      *(line+length)= '\0';
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      if(length){
	if(1 || icol==9){
	  p	=data[j].pv;
	  ii	=CbStrCpy1(p,line);
#ifdef H
	  line[length]='\0';
	  p	=data[j].pv;
	  ii	=CbStrCpy1(p,line);
	  for(i=ii; i < length; i++){
	    p[i]=' ';
	  }
#endif
	}
	XSetForeground(theD,theGC,ColorPix[icol]);
	XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,data[j].h);
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,theW,theGC,ix,iy+hB3,data[j].pv,ii);
      }
      break;
    case 1:
      numstr(*(double*)data[j].pv,line,length);
      line[length]	='\0';
      strcpy(line1,line);
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
      if(strcmp(line1,line)){
#ifdef H
	if(data[j].c==9&&!sscanf(line,"%lg",(double*)data[j].pv))
	  k	=4;
#endif
	if(!sscanf(line,"%lg",(double*)data[j].pv)) k=4;
	numstr(*(double*)data[j].pv,line,length);
      }
      XDrawString(theD,theW,theGC,ix,iy+hB3,line,length);
      if(nkx && j2kx[j] >= 0){
	ik	=j2kx[j];
	if(xg0 <= kx[ik] && kx[ik] <= xg1 && yg1 <= ky[ik] && ky[ik] <= yg0){
	  XFillRectangle(theD,theW,theGCE,kx[ik],ky[ik],5,5);
	}
	x	=*(double*)data[kx2j[ik]].pv;
	y	=*(double*)data[ky2j[ik]].pv;
	if(xmin <= x+gdx && x <= xmax+gdx && ymin <= y+gdy && y <= ymax+gdy){
	  kx[ik]= (int)(xg_0+(x-xmin)*sx)-2;
	  ky[ik]= (int)(yg_0+(y-ymin)*sy)-2;

	  icol= data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
	  if(1 || icol==9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],ky[ik],4,4);
	  }
	}
	else{
	  kx[ik]=-4;
	  ky[ik]=-4;
	}
      }
      break;
    case 2:
      sprintf(line,"%10d",*(int*)data[j].pv);
      k	=ingtxt(line+10-length,length,&data[j].il,ix,iy);
      line[10]= '\0';
      if(k != 5){
	if(!sscanf(line,"%d",(int*)data[j].pv)) k=4;
	sprintf(line,"%10d",*(int*)data[j].pv);
      }
      else{
	j	=CbGetUserControlCell();
	*iclm	=j;
      }
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
      XDrawString(theD,theW,theGC,ix,iy+hB3,line+10-length,length);
      if(nkx && j2kx[j] >= 0){
	ik= j2kx[j];
	if(xg0<=kx[ik]&&kx[ik]<=xg1&& yg1<=ky[ik]&&ky[ik]<=yg0){
	  XFillRectangle(theD,theW,theGCE,kx[ik],ky[ik],5,5);
	}
	x	=(double)(*(int*)data[kx2j[ik]].pv);
	y	=(double)(*(int*)data[ky2j[ik]].pv);
	if(xmin <= x+gdx && x <= xmax+gdx && ymin <= y+gdy && y <= ymax+gdy){
	  kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
	  ky[ik]	=(int)(yg_0+(y-ymin)*sy)-2;
	  icol= data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
	  if(1 || icol==9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],ky[ik],4,4);
	  }
	}
      }
      break;
    case 5:	/* Money format */
      ii	=*(int*)data[j].pv;
      if(ii < 0 && ii > -100){
	sprintf(line,"    -0.%2.2d",abs(ii));
      }
      else{
	sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
      }
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);

      p =line;
      while(isspace(*p)){
	p++;
      }
      if(*p == '-' || *p == '+'){
	*line	=*p;
	p++;
      }
      ii	=0;
      while(*p <= '9' && *p >= '0'){
	ii	=(*p-'0')+ii*10;
	p++;
      }
      if(*p == '\0' || isspace(*p)){
	ii	*=100;
      }
      else{
	if(*p == '.'){
	  p++;
	  ik	=0;
	  while(*p <= '9' && *p >= '0' &&  ik < 2){
	    ii	=(*p-'0')+ii*10;
	    p++;
	    ik++;
	  }
	  if(*p == '\0' || isspace(*p)){
	    while(ik < 2){
	      ii	*=10;
	      ik++;
	    }
	  }
	  else{
	    k	=4;
	  }
	}
	else{
	  k	=4;
	}
      }
      if(*line == '-'){
	ii	=-ii;
      }
      *(int*)data[j].pv	=ii;
      if(ii < 0 && ii > -100){
	sprintf(line,"    -0.%2.2d",abs(ii)%100);
      }
      else{
	sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
      }
      XDrawString(theD,theW,theGC,ix,iy+hB3,line,length);
      if(nkx && j2kx[j] >= 0){
	ik	=j2kx[j];
	if(xg0 <= kx[ik] && kx[ik] <= xg1&&yg1 <= ky[ik] && ky[ik] <= yg0){
	  XFillRectangle(theD,theW,theGCE,kx[ik],ky[ik],5,5);
	}
	x	=(double)(*(int*)data[kx2j[ik]].pv);
	y	=(double)(*(int*)data[ky2j[ik]].pv);
	if(xmin <= x+gdx && x <= xmax+gdx && ymin <= y+gdy && y <= ymax+gdy){
	  kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
	  ky[ik]	=(int)(yg_0+(y-ymin)*sy)-2;
	  icol	=data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
	  if(1 || icol == 9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],ky[ik],4,4);
	  }
	}
      }
      break;
    case 7:	/*Fortran String of characters */
      if(length){
	ii	=CbStrCpy1(line,data[j].pv);
	for(;ii<length;ii++){
	  *(line+ii)=' ';
	}
      }
      *(line+length)= '\0';
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      if(length){
	if(1 || icol==9){
	  p	=data[j].pv;
	  ii	=CbStrCpy1(p,line);
	  for(i=ii; i < length; i++){
	    p[i]=' ';
	  }
	}
	XSetForeground(theD,theGC,ColorPix[icol]);
	XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,data[j].h);
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,theW,theGC,ix,iy+hB3,data[j].pv,ii);
      }
      break;
    }
    switch(k){
    case 1:
    case 2:
    case 3:
      itab	=0;
      j		=tab_position(theBx,theBy,data,n_data);
      if(j >= 0){
	if(j == n_data) k='\r';
	if(j == n_data+1) k=27;
	if(j < n_data){
	  itab	=1;
	  *iclm	=j;

	  ix	=xshift+data[j].x;
	  ix1	=ix+data[j].wn;
	  if(ix < theBx && theBx <= ix1){
	    switch(k){
	    case 1:
	      if((data[j].ids&8)){
		int M,n;
		char *llc[32];
		n	=ZGetMenuList4Cell(&M,llc,j);
		if(n){
		  OneChoiceMenu(&M,NULL,llc,n,ix,data[j].y+hF,iWin);
		  XCbReSetTblCells(j,M);
		  XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
		  ZTableShow(data,n_data);
		  XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
		}
	      }
	      break;
	    case 2:
	      if((data[j].ids&8)){
		XCbReSetTblCells(j,-1);
		XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
		ZTableShow(data,n_data);
		XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
	      }
	      break;
	    case 3:
	      XCbHelpWindow(iWin,ix,data[j].y,data[j].pH,0);
	      XCbRepeatInputTable(iT);
	      XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
	      ZTableShow(data,n_data);
	      XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
	      itab	=0;
	      break;
	    }
	  }
	  
	  ix	=ix1;
	  ix1	+=data[j].ws;
	  if(data[j].ws && ix < theBx && theBx <= ix1 && k < 3){
 	    switch(k){
	    case 1:
	      if(*(data[j].vs)){
		(*data[j].vs)--;
		data[j].ps--;
	      }
	      else{
		p	=data[j].ps;
		while(*p !=  '\0') p++;
		p--;
		*data[j].vs	=p-data[j].ps0;
		data[j].ps	=p;
	      }
	      iy	=data[j].y;
	      break;
	    case 2:
	      data[j].ps++;
	      if(*(data[j].ps) == '\0') data[j].ps=data[j].ps0;
	      *data[j].vs	=data[j].ps-data[j].ps0;
	      break;
	    case 3:
	      break;
	    }
	    iy	=data[j].y;
	    GuiButton(theW,ix,iy,data[j].ws,0);
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawString(theD,theW,theGC,ix+3,iy+hB3,data[j].ps,1);
	  }
	  ix	=ix1;
	  ix1	+=data[j].wd;
	  if(data[j].wd && ix < theBx && theBx <= ix1){
 	    switch(k){
	    case 1:
	      break;
	    case 2:
	      break;
	    case 3:
	      if(nkx&&j2kx[j] >= 0){
		ik	=j2kx[j];
		if((data[j].c&0xff) == 9){
		  data[kx2j[ik]].c	=2;
		  data[ky2j[ik]].c	=2;
		}
		else{
		  data[kx2j[ik]].c	=9;
		  data[ky2j[ik]].c	=9;
		}
		icol	=data[j].c&0xff;
		display_cell(data+kx2j[ik],icol);
		display_cell(data+ky2j[ik],icol);
	      }
	      itab	=0;
	      break;
	    }
	  }
	  ix	=ix1;
	  ix1	+=data[j].wu;
	  if(data[j].wu && ix < theBx && theBx <= ix1
	     && XUnits[data[j].nU].nU > 1){
	    switch(k){
	    case 1:
	      XCbBackwardTblUnits(j);
	      break;
	    case 2:
	      XCbReSetTblUnits(j);
	      break;
	    case 3:
	      break;
	    }
	    XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
	    ZTableShow(data,n_data);
	    XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
	  }
	}
      }
      else{
	if(nkx){
	  for(i=0;i < nkx; i++){
	    if(kx[i] <= theBx && theBx <= kx[i]+5
	       &&ky[i]<=theBy&&theBy<=ky[i]+5){
	      itab	=2;
	      j	=kx2j[i];
	      *iclm	=j;
	      theBx	=kx[i]+2;
	      theBy	=ky[i]+2;
	      break;
	    }
	  }
	}
      }
      if(itab == 0){
	if(msg.xkey.state == 1){
	  int ix0,iy0;
	  ix0	=msg.xbutton.x;
	  iy0	=msg.xbutton.y;
	  do{
	    XWindowEvent(theD,theW,Button1MotionMask|ButtonReleaseMask,&msg);
	    if(msg.type == MotionNotify){
	      XSetFunction(theD,theGCE,GXxor);
	      XDrawLine(theD,theW,theGCE,ix0,iy0,theBx,theBy);
	      XDrawLine(theD,theW,theGCE,ix0,iy0,msg.xmotion.x,msg.xmotion.y);
	      theBx=msg.xmotion.x;
	      theBy=msg.xmotion.y;
	    }
	  }while(msg.type == MotionNotify);
	  XWindowEvent(theD,theW,ButtonPressMask,&msg);
	  XDrawLine(theD,theW,theGCE,ix0,iy0,theBx,theBy);
	  XSetFunction(theD,theGCE,GXcopy);
	  theBk	=msg.xbutton.button;
	  if(theBk == 2){
	    x	=(theBx-ix0)/sx;
	    y	=(theBy-iy0)/sy;
	    CbBoxX[0]	-=x;
	    CbBoxX[1]	-=x;
	    CbBoxY[0]	-=y;
	    CbBoxY[1]	-=y;
	    CbBoxFl	|=8+1+4;
	    XCbRepeatInputTable(iT);
	    XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
	    ZTableShow(data,n_data);
	    XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
	    k	=2;
	  }
	}
	if(msg.xkey.state == 4){
	  int ix0,iy0,ix,iy,iw=0,ih=0;
	  ix0	=msg.xbutton.x;
	  iy0	=msg.xbutton.y;
	  ix	=ix0;
	  iy	=iy0;
	  do{
	    XWindowEvent(theD,theW,Button1MotionMask|ButtonReleaseMask,&msg);
	    if(msg.type == MotionNotify){
	      XSetFunction(theD,theGCE,GXxor);
	      XDrawRectangle(theD,theW,theGCE,ix,iy,iw,ih);
	      theBx=msg.xmotion.x;
	      theBy=msg.xmotion.y;
	      if(theBx > ix0){
		ix	=ix0;
		iw	=theBx-ix0;
	      }
	      else{
		ix	=theBx;
		iw	=ix0-theBx;
	      }
	      if(theBy > iy0){
		iy	=iy0;
		ih	=theBy-iy0;
	      }
	      else{
		iy	=theBy;
		ih	=iy0-theBy;
	      }
	      XDrawRectangle(theD,theW,theGCE,ix,iy,iw,ih);
	    }
	  }while(msg.type == MotionNotify);
	  XWindowEvent(theD,theW,ButtonPressMask,&msg);
	  XDrawRectangle(theD,theW,theGCE,ix,iy,iw,ih);
	  XSetFunction(theD,theGCE,GXcopy);
	  theBk	=msg.xbutton.button;
	  if(theBk == 2){
	    CbBoxX[0]	=xmin+(ix0-xg_0)/sx;
	    CbBoxX[1]	=xmin+(theBx-xg_0)/sx;
	    CbBoxY[0]	=ymin+(iy0-yg_0)/sy;
	    CbBoxY[1]	=ymin+(theBy-yg_0)/sy;
	    CbBoxFl	|=8+1+4;
	    XCbRepeatInputTable(iT);
	    XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
	    ZTableShow(data,n_data);
	    XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
	    k	=2;
	  }
	}
      }
      if(itab == 2){
	ik	=j2kx[j];
	if(xg0 <= kx[ik] && kx[ik] <= xg1 && yg1 <= ky[ik] && ky[ik] <= yg0){
	  XSetForeground(theD,theGC,ColorPix[46]);
	  XFillRectangle(theD,theW,theGC,kx[ik],ky[ik],5,5);
	}
	j	=kx2j[ik];
	i	=ky2j[ik];
	display_cell(data+j,11);
	display_cell(data+i,11);
	switch((data[j].ids&7)){
	case 1:
	  x	=*(double*)data[j].pv;
	  y	=*(double*)data[i].pv;
	  break;
	case 2:
	  x	=(double)*(int*)data[j].pv;
	  y	=(double)*(int*)data[i].pv;
	  break;
	case 5:
	  x	=(double)*(int*)data[j].pv;
	  y	=(double)*(int*)data[i].pv;
	  break;
	default:
	  break;
	}
	itab= 0;
	theBk	=msg.xbutton.button;
	do{
	  XWindowEvent(theD,theW,Button1MotionMask|Button2MotionMask
		       |ButtonReleaseMask,&msg);
	  switch(msg.type){
	  case MotionNotify:
	    if(itab && theBk == 2){
	      XFillRectangle(theD,theW,theGCE,xg0,theBy,pW,1);
	      XFillRectangle(theD,theW,theGCE,theBx,yg1,1,pH);
	    }
	    if(itab == 0){
	      XSetFunction(theD,theGCE,GXxor);
	      itab	=1;
	      if(theBk == 2) 
		XSetForeground(theD,theGCE,(ColorPix[45]^ColorPix[12]));
	    }
	    XDrawRectangle(theD,theW,theGCE,theBx-2,theBy-2,4,4);
	    theBx= msg.xmotion.x;
	    theBy= msg.xmotion.y;
	    XDrawRectangle(theD,theW,theGCE,theBx-2,theBy-2,4,4);
	    if(theBk == 2){
	      XFillRectangle(theD,theW,theGCE,xg0,theBy,pW,1);
	      XFillRectangle(theD,theW,theGCE,theBx,yg1,1,pH);
	    }
	    dx= (theBx-2-kx[ik])/sx;
	    dy= (theBy-2-ky[ik])/sy;
	    switch(data[j].ids&7){
	    case 1:
	      *(double*)data[j].pv= x+dx;
	      *(double*)data[i].pv= y+dy;
	      break;
	    case 2:
	    case 5:
	      *(int*)data[j].pv=x+dx > 0. ? (int)(x+dx+0.5) : (int)(x+dx-0.5);
	      *(int*)data[i].pv=y+dy > 0. ? (int)(y+dy+0.5) : (int)(y+dy-0.5);
	      break;
	    default:
	      break;
	    }
#ifdef H
	    XSetFunction(theD,theGCE,GXcopy);
#endif
	    display_cell(data+j,11);
	    display_cell(data+i,11);
	    break;
	  case ButtonRelease:
	    if(itab){
	      if(theBk == 2){
		XFillRectangle(theD,theW,theGCE,xg0,theBy,pW,1);
		XFillRectangle(theD,theW,theGCE,theBx,yg1,1,pH);
		XFlush(theD);
	      }
	      XSetFunction(theD,theGCE,GXcopy);
	      if(theBk == 2) XSetForeground(theD,theGCE,ColorPix[45]);
	      theBx= msg.xbutton.x;
	      theBy= msg.xbutton.y;

	      dx=(theBx-2-kx[ik])/sx;
	      dy=(theBy-2-ky[ik])/sy;
	      switch(data[j].ids&7){
	      case 1:
		*(double*)data[j].pv= x+dx;
		*(double*)data[i].pv= y+dy;
		break;
	      case 2:
	      case 5:
		*(int*)data[j].pv=x+dx > 0. ? (int)(x+dx+0.5) :(int)(x+dx-0.5);
		*(int*)data[i].pv=y+dy > 0. ? (int)(y+dy+0.5) :(int)(y+dy-0.5);
		break;
	      default:
		break;
	      }
	      XDrawRectangle(theD,theW,theGCE,kx[ik],ky[ik],4,4);
	      kx[ik]= theBx-2;
	      ky[ik]= theBy-2;
	    }
	    icol= data[j].c&0xff;
	    display_cell(data+j,icol);
	    display_cell(data+i,icol);
	    break;
	  }
	}while(msg.type == MotionNotify);

      }
      break;
    case 4:
      XCbRepeatInputTable(iT);
      XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
      GuiERButtons(itheW);
      GuiMButton(theW,(Wmode>>4)&0xF);
      ZTableShow(data,n_data);
      XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
      break;
    case XK_Home:
      j	=0;
      *iclm	=0;
      break;
    case XK_Left:
      if(msg.xkey.state == 1){
	x	=0.1*fabs(CbBoxX[1]-CbBoxX[0]);
	CbBoxX[0]	+=x;
	CbBoxX[1]	+=x;
      }
      else{
	if(msg.xkey.state == 4){
	  j	=0;
	  *iclm	=0;
	}
	else{
	  int i,ii,m,k;
	  m	=-1;
	  for(i=0; i < n_data; i++){
	    if(data[i].y == iy && data[i].x < data[j].x){
	      ii	=abs(data[i].x-data[j].x);
	      if(m == -1){
		m	=ii;
		k	=i;
	      }
	      else{
		if(m > ii){
		  m	=ii;
		  k	=i;
		}
	      }
	    }
	  }
	  if(m >= 0){
	    j	=k;
	    *iclm	=j;
	  }
	}
      }
      break;
    case XK_End:
      {
	int i,ii,m,k;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(m < data[i].x){
	    m	=data[i].x;
	    k	=i;
	  }
	}
	j	=k;
	*iclm	=j;
      }
      break;
    case XK_Right:
      if(msg.xkey.state == 1){
	x	=0.1*fabs(CbBoxX[1]-CbBoxX[0]);
	CbBoxX[0]	-=x;
	CbBoxX[1]	-=x;
	break;
      }
      else{
	int i,ii,m,k;
	m	=-1;
	if(msg.xkey.state == 4){
	  for(i=0; i < n_data; i++){
	    if(m < data[i].x){
	      m=data[i].x;
	      k=i;
	    }
	  }
	  j	=k;
	  *iclm	=j;
	  break;
	}
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy && data[i].x > data[j].x){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    case XK_Up:
      if(msg.xkey.state == 1){
	y	=0.1*fabs(CbBoxY[1]-CbBoxY[0]);
	CbBoxY[0]	-=y;
	CbBoxY[1]	-=y;
      }
      else{
	int i,ii,m,k;
	iy	-=hF+1;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    case XK_Down:
      if(msg.xkey.state == 1){
	y	=0.1*fabs(CbBoxY[1]-CbBoxY[0]);
	CbBoxY[0]	+=y;
	CbBoxY[1]	+=y;
      }
      else{
	int i,ii,m,k;
	iy	+=hF+1;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }	
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    }
    if(msg.xkey.state == 1 && 
       (k == XK_Left || k == XK_Right || k == XK_Up || k == XK_Down)){
      CbBoxFl	|=8+1+4;
      XCbRepeatInputTable(iT);
      XCbSetPlotLimits(&gdx,&gdy,&xg0,&yg0,&xg1,&yg1);
      ZTableShow(data,n_data);
      XCbDotShow(data,nkx,kx2j,ky2j,kx,ky,gdx,gdy);
    }
  }while(k && (k-'\r') && (k-26) && (k-27));

  XCbTableErase();
  XFillRectangle(theD,theW,theGCE,xR,0,xE3,hF+1);
  XFlush(theD);
  return(k);
}

int XCb1DDotShow(InputCell*data,int nkx,int *kx2j,int *kx)
{
  int i,ik,icol;
  double x,y;

  for(ik=0; ik < nkx; ik++){
    i	=kx2j[ik];
    if((data[i].ids&7) == 2 || (data[i].ids&7) == 4){
      x	=(double)(*(int*)data[i].pv);
    }
    else{
      x	=*(double*)data[i].pv;
    }
    if(xmin <= x && x <=xmax){
      kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
      icol	=data[i].c&0xff;
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,kx[ik],(int)yg_0-6,5,5);
      if(icol == 9){
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawRectangle(theD,theW,theGC,kx[ik],(int)yg_0-6,4,4);
      }
    }
    else{
      kx[ik]	=-4;
    }
  }
  return(0);
}

int XCb1DTableInput(iWin,data,n_data,kx2j,j2kx,kx,nkx,iclm)
     int iWin;
     InputCell*data;
     int n_data,*kx2j,*j2kx,*kx,nkx,*iclm;
{
  KeySym k;
  static int i,ii,ix,ix1,iy,iw,ih,itab;
  static int j,length,icol,nU;
  static double x,y,dx,dy;
  static int ik,iy0,xg0,yg0,xg1,yg1;
  char*p;
  float s;

  xg_0= *pxg_0;
  yg_0= *pyg_0;
  xmin= *pxmin;
  ymin= *pymin;
  xmax= *pxmax;
  ymax= *pymax;
  sx	=*psx;
  sy	=*psy;
  xg0	=(int)(xg_0-2.);
  yg0	=(int)(yg_0-4.);
  xg1	=(int)(xg_0+(xmax-xmin)*sx+2.);

  theW= WinP[iWin].W;
  itheW	=iWin;
  Wwidth= WinP[iWin].iW;
  Wmode= WinP[iWin].mode;

  GuiERButtons(iWin);
  GuiAButton(theW,Wmode&0xF);
  GuiMButton(theW,(Wmode>>4)&0xF);
  GuiHButton(iWin);
  i= data[*iclm].x+data[*iclm].w;
  j= xshift+i;
  if(j>Wwidth-wF){
    xshift= Wwidth/2-data[*iclm].x;
    if(xshift+i>Wwidth-wF) xshift= Wwidth-wF-i;
  }
  ZTableShow(data,n_data);

  iy0= (int)yg0-2;
  for(ik=0; ik < nkx; ik++){
    i	=kx2j[ik];
    if((data[i].ids&7) == 2){
      x	=(double)*(int*)data[i].pv;
    }
    else{
      x	=*(double*)data[i].pv;
    }
    if(xmin <= x && x <= xmax){
      kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
      icol	=data[i].c&0xff;
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
      if(icol == 9){
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
      }
    }
    else{
      kx[ik]	=-4;
    }
  }
  do{
    i	=data[*iclm].x+data[*iclm].w;
    j	=xshift+i;
    if(j > Wwidth-wF){
      xshift	=Wwidth/2-data[*iclm].x;
      if(xshift+i > Wwidth-wF) 	xshift	=Wwidth-wF-i;
    }
    ix	=xshift+data[*iclm].x;
    if(ix < wF-wF){
      xshift	=Wwidth/2-data[*iclm].x;
      if(xshift+data[0].x > 0) xshift	=0;
      if(xshift+i > Wwidth-wF) xshift	=Wwidth-wF-i;
    }
    if(j > Wwidth-wF || ix < wF-wF){
      iy	=hF+1;
      ih	=data[n_data-1].y-data[0].y+hF+1;
      XFillRectangle(theD,theW,theGCE,0,iy,Wwidth,ih);
      ZTableShow(data,n_data);
    }
    j	=*iclm;
    icol= data[j].c&0xff;
    ix	=xshift+data[j].xd+2;
    iy	=data[j].y;
    ih	=data[j].h;
    length= data[j].l;

    if(nkx && j2kx[j]>=0){
      ik	=j2kx[j];
      if(xg0<=kx[ik]&&kx[ik]<=xg1){
	XSetForeground(theD,theGC,ColorPix[46]);
	XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
      }
    }
    switch((data[j].ids&7)){
    case 0:
      if(length){
	ii=CbStrCpy1(line,data[j].pv);
	for(;ii<length;ii++)
	  *(line+ii)= ' ';
      }
      *(line+length)= '\0';
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      if(length){
	if(1 || icol == 9){
	  p= data[j].pv;
	  ii= CbStrCpy1(p,line);
#ifdef H
	  line[length]='\0';
	  p= data[j].pv;
	  ii= CbStrCpy1(p,line);
	  for(i=ii; i < length; i++){
	    p[i]= ' ';
	  }
#endif
	}
	XSetForeground(theD,theGC,ColorPix[icol]);
	XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,data[j].h);
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,theW,theGC,ix,iy+hB3,data[j].pv,ii);
      }
      break;
    case 1:
      numstr(*(double*)data[j].pv,line,length);
      line[length]= '\0';
      strcpy(line1,line);
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
      if(strcmp(line1,line)){
#ifdef H
	if(data[j].c==9&&!sscanf(line,"%lg",(double*)data[j].pv))
	  k	=4;
#endif
	if(!sscanf(line,"%lg",(double*)data[j].pv)) k=4;
	numstr(*(double*)data[j].pv,line,length);
      }
      XDrawString(theD,theW,theGC,ix,iy+hB3,line,length);
      if(nkx && j2kx[j] >= 0){
	ik= j2kx[j];
	if(xg0<=kx[ik]&&kx[ik]<=xg1){
	  XFillRectangle(theD,theW,theGCE,kx[ik],iy0,5,5);
	}
	x	=*(double*)data[kx2j[ik]].pv;
	if(xmin <= x && x <= xmax){
	  kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
	  icol	=data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
	  if(1 || icol==9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
	  }
	}
      }
      break;
    case 2:
      sprintf(line,"%10d",*(int*)data[j].pv);
      k	=ingtxt(line+10-length,length,&data[j].il,ix,iy);
      line[10]= '\0';
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
#ifdef H
      if(icol==9&&!sscanf(line,"%d",(int*)data[j].pv))
	k= 4;
#endif
      if(!sscanf(line,"%d",(int*)data[j].pv)) k= 4;
      sprintf(line,"%10d",*(int*)data[j].pv);
      XDrawString(theD,theW,theGC,ix,iy+hB3,line+10-length,length);
      if(nkx && j2kx[j] >= 0){
	ik=j2kx[j];
	if(xg0<=kx[ik]&&kx[ik]<=xg1){
	  XFillRectangle(theD,theW,theGCE,kx[ik],iy0,5,5);
	}
	x=(double)(*(int*)data[kx2j[ik]].pv);
	if(xmin <= x && x <= xmax){
	  kx[ik]= (int)(xg_0+(x-xmin)*sx)-2;
	  icol= data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
	  if(1 || icol==9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
	  }
	}
      }
      break;
    case 5:
      ii	=*(int*)data[j].pv;
      if(ii < 0 && ii > -100){
	sprintf(line,"    -0.%2.2d",abs(ii));
      }
      else{
	sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
      }
      k	=ingtxt(line,length,&data[j].il,ix,iy);
      XSetForeground(theD,theGC,ColorPix[icol]);
      XFillRectangle(theD,theW,theGC,ix-2,iy,data[j].wd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
      p =line;
      while(isspace(*p)){
	p++;
      }
      if(*p == '-' || *p == '+'){
	*line	=*p;
	p++;
      }
      ii	=0;
      while(*p <= '9' && *p >= '0'){
	ii	=(*p-'0')+ii*10;
	p++;
      }
      if(*p == '\0' || isspace(*p)){
	ii	*=100;
      }
      else{
	if(*p == '.'){
	  p++;
	  ik	=0;
	  while(*p <= '9' && *p >= '0' &&  ik < 2){
	    ii	=(*p-'0')+ii*10;
	    p++;
	    ik++;
	  }
	  if(*p == '\0' || isspace(*p)){
	    while(ik < 2){
	      ii	*=10;
	      ik++;
	    }
	  }
	  else{
	    k	=4;
	  }
	}
	else{
	  k	=4;
	}
      }
      if(*line == '-'){
	ii	=-ii;
      }
      *(int*)data[j].pv	=ii;
      if(ii < 0 && ii > -100){
	sprintf(line,"    -0.%2.2d",abs(ii));
      }
      else{
	sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
      }
      XDrawString(theD,theW,theGC,ix,iy+hB3,line,length);
      if(nkx && j2kx[j]>=0){
	ik	=j2kx[j];
	if(xg0 <= kx[ik] && kx[ik] <= xg1){
	  XFillRectangle(theD,theW,theGCE,kx[ik],iy0,5,5);
	}
	x	=(double)(*(int*)data[kx2j[ik]].pv);
	if(xmin <= x && x <= xmax){
	  kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
	  icol	=data[j].c&0xff;
	  XSetForeground(theD,theGC,ColorPix[icol]);
	  XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
	  if(1 || icol==9){
	    XSetForeground(theD,theGC,ColorPix[22]);
	    XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
	  }
	}
      }
      break;
    }
    switch(k){
    case 1:
    case 2:
    case 3:
      itab	=0;
      j	=tab_position(theBx,theBy,data,n_data);
      if(j >= 0){
	if(j == n_data){
	  k='\r';
	}
	if(j == n_data+1){
	  k	=27;
	}
	if(0 <=j && j < n_data){
	  itab	=1;
	  *iclm	=j;
	  if(k < 3){
	    ix	=xshift+data[j].x;
	    ix1	=ix+data[j].wn;
	    if((data[j].ids&8) && ix < theBx && theBx <= ix1){
	      if(k == 1){
		int M,n;
		char *llc[32];
		n	=ZGetMenuList4Cell(&M,llc,j);
		if(n){
		  OneChoiceMenu(&M,NULL,llc,n,ix,data[j].y+hF,iWin);
		  XCbReSetTblCells(j,M);
		}
	      }
	      else{
		XCbReSetTblCells(j,-1);
	      }
	      xg_0	=*pxg_0;
	      yg_0	=*pyg_0;
	      xmin	=*pxmin;
	      ymin	=*pymin;
	      xmax	=*pxmax;
	      ymax	=*pymax;
	      sx	=*psx;
	      sy	=*psy;
	      xg0	=(int)(xg_0-2.);
	      yg0	=(int)(yg_0+2.);
	      xg1	=(int)(xg_0+(xmax-xmin)*sx+2.);
	      ZTableShow(data,n_data);
	      iy0	=(int)yg0-2;
	      for(ik=0; ik < nkx; ik++){
		i	=kx2j[ik];
		if((data[i].ids&7) == 2){
		  x	=(double)*(int*)data[i].pv;
		}
		else{
		  x	=*(double*)data[i].pv;
		}
		kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
		if(xmin <= x && x <= xmax){
		  icol	=data[i].c&0xff;
		  XSetForeground(theD,theGC,ColorPix[icol]);
		  XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
		  if(icol == 9){
		    XSetForeground(theD,theGC,ColorPix[22]);
		    XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
		  }
		}
	      }
	    }
	    ix	=ix1;
	    ix1	+=data[j].ws;
	    if(data[j].ws && ix < theBx && theBx <= ix1){
	      data[j].ps++;
	      if(*(data[j].ps) != '\0'){
		*(data[j].vs)	=data[j].ps-data[j].ps0;
	      }
	      else{
		data[j].ps	=data[j].ps0;
		*(data[j].vs)	=0;
	      }
	      iy	=data[j].y;
	      GuiButton(theW,ix,iy,data[j].ws,0);
	      XSetForeground(theD,theGC,ColorPix[22]);
	      XDrawString(theD,theW,theGC,ix+3,iy+hB3,data[j].ps,1);
	    }
	    else{
	      ix	=ix1+data[j].wd;
	      if(data[j].lu && ix < theBx && theBx <= ix+data[j].wu){
		nU	=data[j].nU;
		if(XUnits[nU].nU > 1){
		  XCbReSetTblUnits(j);
		  xg_0= *pxg_0;
		  yg_0= *pyg_0;
		  xmin= *pxmin;
		  ymin= *pymin;
		  xmax= *pxmax;
		  ymax= *pymax;
		  sx= *psx;
		  sy= *psy;
		  xg0= (int)(xg_0-2.);
		  yg0= (int)(yg_0+2.);
		  xg1= (int)(xg_0+(xmax-xmin)*sx+2.);
		  ZTableShow(data,n_data);
		  iy0= (int)yg0-2;
		  for(ik=0; ik < nkx; ik++){
		    i	=kx2j[ik];
		    if(data[i].ids&7==2){
		      x	=(double)*(int*)data[i].pv;
		    }
		    else{
		      x	=*(double*)data[i].pv;
		    }
		    if(xmin <= x && x <= xmax){
		      kx[ik]	=(int)(xg_0+(x-xmin)*sx)-2;
		      icol	=data[i].c&0xff;
		      XSetForeground(theD,theGC,ColorPix[icol]);
		      XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
		      if(icol == 9){
			XSetForeground(theD,theGC,ColorPix[22]);
			XDrawRectangle(theD,theW,theGC,kx[ik],iy0,4,4);
		      }
		    }
		    else{
		      kx[ik]	=-4;
		    }
		  }
		}
	      }
	    }
	  }
	  if(k == 3){
	    ix	=xshift+data[j].x;
	    if(ix<theBx&&theBx<=ix+data[j].wn){
	      XCbHelpWindow(iWin,ix,data[j].y,data[j].pH,0);
	    }
	    else{
	      if((data[j].c&0xff) == 9)
		data[j].c	=2;
	      else
		data[j].c	=9;
	      icol	=data[j].c;
	      display_cell(data+j,icol);
	    }
	    itab	=0;
	  }
	}
      }
      else{
	if(nkx){
	  for(i= 0;i<nkx;i++){
	    if(kx[i]<=theBx&&theBx<=kx[i]+5
	       &&iy0<=theBy&&theBy<=iy0+5){
	      itab= 2;
	      j= kx2j[i];
	      *iclm= j;
	      theBx= kx[i]+2;
	      theBy= iy0+2;
	      break;
	    }
	  }
	}
      }
      if(itab==2){
	ik= j2kx[j];
	if(xg0<=kx[ik]&&kx[ik]<=xg1){
	  XSetForeground(theD,theGC,ColorPix[46]);
	  XFillRectangle(theD,theW,theGC,kx[ik],iy0,5,5);
	}
	display_cell(data+j,11);
	switch(data[j].ids&7){
	case 1:
	  x= *(double*)data[j].pv;
	  break;
	case 2:
	  x= (double)*(int*)data[j].pv;
	  break;
	case 5:
	  x= (double)*(int*)data[j].pv;
	  break;
	default:
	  break;
	}
	itab= 0;
	do{
	  XWindowEvent(theD,theW,Button1MotionMask|ButtonReleaseMask,&msg);
	  switch(msg.type){
	  case MotionNotify:
	    itab= 1;
	    XSetFunction(theD,theGCE,GXxor);
	    XDrawRectangle(theD,theW,theGCE,theBx-2,iy0,4,4);
	    theBx= msg.xmotion.x;
	    theBy= msg.xmotion.y;
	    XDrawRectangle(theD,theW,theGCE,theBx-2,iy0,4,4);
	    XSetFunction(theD,theGCE,GXcopy);
	    dx	=(theBx-2-kx[ik])/sx;
	    switch((data[j].ids&7)){
	    case 1:
	      *(double*)data[j].pv= x+dx;
	      break;
	    case 2:
	    case 5:
	      *(int*)data[j].pv=x+dx > 0. ? (int)(x+dx+0.5) :(int)(x+dx-0.5);
	      break;
	    default:
	      break;
	    }
	    display_cell(data+j,11);
	    break;
	  case ButtonRelease:
	    if(itab){
	      XSetFunction(theD,theGC,GXcopy);
	      theBx= msg.xbutton.x;
	      theBy= msg.xbutton.y;
	      dx= (theBx-2-kx[ik])/sx;
	      switch(data[j].ids&7){
	      case 1:
		*(double*)data[j].pv=x+dx;
		break;
	      case 2:
	      case 5:
		*(int*)data[j].pv=x+dx > 0. ? (int)(x+dx+0.5) :(int)(x+dx-0.5);
		break;
	      default:
		break;
	      }
	      XDrawRectangle(theD,theW,theGCE,kx[ik],iy0,4,4);
	      kx[ik]= theBx-2;
	    }
	    icol= data[j].c&0xff;
	    display_cell(data+j,icol);
	    break;
	  }
	}while(msg.type==MotionNotify);
      }
      break;
    case 4:
      for(i=0; i < NWin; i++){
	GuiReSetWP(i);
      }
      XCbRepeatInputTable(iT);
      GuiERButtons(itheW);
      GuiMButton(theW,(Wmode>>4)&0xF);
      ZTableShow(data,n_data);
      XCb1DDotShow(data,nkx,kx2j,kx);
      break;
    case XK_Left:
      {
	int i,ii,m,k;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy && data[i].x < data[j].x){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    case XK_Right:
      {
	int i,ii,m,k;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy && data[i].x > data[j].x){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    case XK_Up:
      iy	-=hF+1;
      {
	int i,ii,m,k;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    case XK_Down:
      iy	+=hF+1;
      {
	int i,ii,m,k;
	m	=-1;
	for(i=0; i < n_data; i++){
	  if(data[i].y == iy){
	    ii	=abs(data[i].x-data[j].x);
	    if(m == -1){
	      m	=ii;
	      k	=i;
	    }
	    else{
	      if(m > ii){
		m	=ii;
		k	=i;
	      }
	    }
	  }
	}
	if(m >= 0){
	  j	=k;
	  *iclm	=j;
	}
      }
      break;
    }
  }while(k && (k-'\r') && (k-26) && (k-27));
  XCbTableErase();
  XFillRectangle(theD,theW,theGCE,xR,0,xE3,hF+1);
  XFlush(theD);
  return((int)k);
}

int display_cell(data,color)
     InputCell*data;
     int color;
{
  int ix,iy,ih,ii;
  char line[32];

  if(data->l == 0) return(0);

  XSetForeground(theD,theGC,ColorPix[color]);
  ix= xshift+data->xd;
  iy= data->y;
  ih= data->h;
  XFillRectangle(theD,theW,theGC,ix,iy,data->wd,ih);
  XSetForeground(theD,theGC,ColorPix[22]);
  iy	+=ih-2;
  switch((data->ids&3)){
  case 0:
    XDrawString(theD,theW,theGC,ix+2,iy,data->pv,strlen(data->pv));
    break;
  case 1:
    numstr(*(double*)data->pv,line,data->l);
    XDrawString(theD,theW,theGC,ix+2,iy,line,data->l);
    break;
  case 2:
    sprintf(line,"%10d",*(int*)data->pv);
    XDrawString(theD,theW,theGC,ix+2,iy,line+10-data->l,data->l);
    break;
  case 5:
    ii	=*(int*)data->pv;
    if(ii < 0 && ii > -100){
      sprintf(line,"    -0.%2.2d",abs(ii));
    }
    else{
      sprintf(line,"%6d.%2.2d",ii/100,abs(ii)%100);
    }
    XDrawString(theD,theW,theGC,ix+2,iy,line,data->l);
    break;
  }
  return(0);
}

int tab_position(ix,iy,data,n_data)
     InputCell*data;
     int ix,iy,n_data;
{
  static int i;

  for(i=0; i < n_data; i++){
    if(data[i].y <= iy && iy <= data[i].y+data[i].h &&
       xshift+data[i].x <= ix && ix <= xshift+data[i].x+data[i].w)
      return(i);
  }
  if(0<=iy&&iy<=hF){
    if(xR<=ix&&ix<=xR3)
      return(n_data);
    if(xE<=ix&&ix<=xE3)
      return(n_data+1);
  }
  return(-1);
}
#endif/*stg_Table*/

#ifndef stg_CPanel

int XCbInitXCPCell(PanelCell*CPCell,int*kCPCell,int*nCPCell,
		   InputCell*IDCell,int*kIDCell,int*nIDCell)
{
  XCPCell	=CPCell;
  kXCPCell	=kCPCell;
  nXCPCell	=nCPCell;
  XIDCell	=IDCell;
  kXIDCell	=kIDCell;
  nXIDCell	=nIDCell;
  iCPanelW	=0;
  CPanelW	=WinP[iCPanelW].W;
  return(0);
}

int XCbGetCntrPanel()
{
  static int M=0;
  int i,m[8],k;
  char ln[128];
  char *llc[8];
  FILE *lf;

  CbReSetBlbInputFiles(0,0,NULL,NULL,NULL,NULL);
  i	=0;
  k	=0;
  XCbReSetCPanelCells(0,&i,&k);
  XCPanelShowSwitches();
  XIDShowCells();
  GuiRButton(CPanelW,0);
  k	=0;
  for(i=0; i < nXIDC; i++){
    if(XIDCell[i].ids == 0){
      sprintf(ln,"%s/Wrk/%s.Cntr",XIDCell[i].pH,XCPCell[0].pn);
      lf	=fopen(ln,"r");
      if(lf != NULL){
	llc[k]	=*((char**)XIDCell[i].ps+*XIDCell[i].vs);
	m[k]	=i;
	k++;
	fclose(lf);
      }
    }
  }
  llc[k]	=NULL;
  if(k){
    if(M >= k) M=0;
    if(OneChoiceMenu(&M,"Get CPanel file from",llc,k,0,hF,0) != 3){
      i	=m[M];
      if(CbRestoreCntrPanel(XIDCell[i].pH)){
	printf("%s/Wrk/%s.Cntr: bad file\a\n",XIDCell[i].pH,XCPCell[0].pn);
      }	
      else{
	CbDeInitListInputFiles();
	CbInitListInputFiles();
	CbInitSwitches();
	i	=0;
	k	=0;
	XCbReSetCPanelCells(0,&i,&k);
	XCPanelShowSwitches();
	XIDShowCells();
	GuiRButton(CPanelW,0);
      }
    }
  }




  return(0);
}

int XCbGetInputRootDirName(int kD, int iy)
{
  int i,k,ix;
  char **llc,*lc;

  llc	=(char**)XIDCell[kD].ps+(*XIDCell[kD].vs);
  if(llc[1] != NULL){
    return(4);
  }
  lc	=llc[0];
  ix	=ixPC+XIDCell[kD].x;
  for(i=0; i < LBLBID; i++){
    line[i]	=lc[i];
  }
  line[LBLBID]	='\0';
  k	=ingtxt(line,LBLBID,&XIDCell[kD].il,ix+2,iy);
  if(k < 4){
    if(0 <= theBy && theBy <= hF){
      if(xR <= theBx && theBx <= xR3){
	k	='\r';;
      }
      if(xE <= theBx && theBx <= xE3){
	k	=27;
      }
    }
  }
  for(i=0; i < LBLBID; i++){
    lc[i]	=line[i];
  }
  GuiButton(CPanelW,ix,iy,XIDCell[kD].w+4,0);
  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,CPanelW,theGC,ix+2,iy+hB3,lc,LBLBID);
  return(k);
}

int XCbGetDirName(int kD, int iy)
{
  int i,k,ix;
  char *lc;

  ix	=ixPC+XIDCell[kD].x;
  lc	=XIDCell[kD].pv;
  for(i=0; i < LBLBID; i++){
    line[i]	=lc[i];
  }
  line[LBLBID]	='\0';
  k	=ingtxt(line,LBLBID,&XIDCell[kD].il,ix,iy);
  for(i=0; i < LBLBID; i++) lc[i]=line[i];
  XSetForeground(theD,theGC,ColorPix[47]);
  XFillRectangle(theD,CPanelW,theGC,ix,iy,XIDCell[kD].w,hF);
  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,CPanelW,theGC,ix,iy+hB3,XIDCell[kD].pv,LBLBID);
  if(k < 4){
    if(0 <= theBy && theBy <= hF){
      if(xR <= theBx && theBx <= xR3){
	if(k == 2){
	  XCbSetOutDirMenu();
	  XCbSaveCntrPanel();
	}
	k	='\r';
      }
      if(xE <= theBx && theBx <= xE3){
	k	=27;
      }
    }
  }
  return(k);
}

int XCbGetStreemPar(int kD,int iy)
{
  int k,ix,ix2;

  ix	=ixPC+XIDCell[kD].x;
  ix2	=ix+XIDCell[kD].w-5*wF;
  if(theBk == 2 && theBx < ix2){
    double *ld;
    k	=XIDCell[kD].h;
    ld 	=(double*)XIDCell[kD].pv;
    ld	-=k;
    k++;
    if(k > 2){
      k	=0;
    }
    XIDCell[kD].h	=k;
    XIDCell[kD].pn	=strID[k];
    XIDCell[kD].pv	=(char*)(ld+k);
    GuiButton(CPanelW,ix,iy,XIDCell[kD].w,2);
    XSetForeground(theD,theGC,ColorPix[47]);
    XFillRectangle(theD,CPanelW,theGC,ix2,iy,5*wF,hF);
    XSetForeground(theD,theGC,ColorPix[22]);
    XDrawString(theD,CPanelW,theGC,ix+3,iy+hB3,XIDCell[kD].pn,2);
    numstr(*(double*)XIDCell[kD].pv,line,5);
    XDrawString(theD,CPanelW,theGC,ix2,iy+hB3,line,5);
    return(4);
  }
  numstr(*(double*)XIDCell[kD].pv,line,5);
  line[5]	='\0';
  strcpy(line1,line);
  k	=ingtxt(line,5,&XIDCell[kD].il,ix2,iy);
  if(strcmp(line1,line)){
    sscanf(line,"%lg",(double*)XIDCell[kD].pv);
    numstr(*(double*)XIDCell[kD].pv,line,5);
  }
  XSetForeground(theD,theGC,ColorPix[47]);
  XFillRectangle(theD,CPanelW,theGC,ix2,iy,5*wF,hF);
  XSetForeground(theD,theGC,ColorPix[22]);
  XDrawString(theD,CPanelW,theGC,ix2,iy+hB3,line,5);
  if(k < 4){
    if(0 <= theBy && theBy <= hF){
      if(xR <= theBx && theBx <= xR3){
	if(k == 2){
	  XCbSetOutDirMenu();
	  XCbSaveCntrPanel();
	}
	k	='\r';
      }
      if(xE <= theBx && theBx <= xE3){
	k	=27;
      }
    }
  }
  return(k);
}

int XCPanelShowCells()
{
  int i,ix,kC,m,mp,mm,mv,mpO,mpI,mvO,mvI;
  int xM,xO,xI;
  int iw,iy,iw1,iw2,ix2,iy2;
  char**p;

  for(i=0; i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=ixPC+XCPCell[kC].x;
    iw	=XCPCell[kC].w+wMOI;
    if(ix+iw > 0 && ix < Wwidth){
      iy	=iyPC+XCPCell[kC].y;
      iw1	=XCPCell[kC].w;
      switch(XCPCell[kC].ids){
      case 0:
	GuiButton(CPanelW,ix,iy,iw1,1);
	break;
      case 1:
	GuiButton(CPanelW,ix,iy,iw1,2);
	break;
      case 2:
	XSetForeground(theD,theGC,ColorPix[49]);
	XFillRectangle(theD,CPanelW,theGC,ix,iy,iw1,hF);
	break;
      }
      xM	=ix+iw1+1;
      if(ioCPanel == 0){
	m	=*XCPCell[kC].m;
	mp	=m&0x7f;
	mv	=m&(0x100<<mp);
	if((m&mSetM)){
	  GuiRect(CPanelW,xM,iy,wM,m&0x100);
	}
	else{
	  GuiButton(CPanelW,xM,iy,wM,(m&0x100) ? 5 : 0);
	}
      }
      else{
	GuiButton(CPanelW,xM,iy,wM,0);
      }
      
      xO	=xM+wM+1;
      if(ioCPanel == 0){
	m	=*XCPCell[kC].O;
	mpO	=m&0x7f;
	mvO	=m&(0x100<<mpO);
	if((m&mSetO)){
	  GuiRect(CPanelW,xO,iy,wO,0);
	}
	else{
	  GuiButton(CPanelW,xO,iy,wO,0);
	}
      }
      else{
	GuiButton(CPanelW,xO,iy,wO,0);
      }

      xI	=xO+wO+1;
      if(ioCPanel==0){
	m	=*XCPCell[kC].I;
	mpI	=m&0x7f;
	mvI	=m&(0x100<<mpI);
	if((m&mSetI))
	  GuiRect(CPanelW,xI,iy,wI,0);
	else
	  GuiButton(CPanelW,xI,iy,wI,0);
      }
      else{
	GuiButton(CPanelW,xI,iy,wI,0);
      }

      iy	+=hB3;
      XDrawString(theD,CPanelW,theGCT,ix+3,iy,XCPCell[kC].pn,XCPCell[kC].ln);
      if(ioCPanel == 0){
	p	=mv ? CbMODE : CbMode;
	XDrawString(theD,CPanelW,theGCT,xM+2,iy,p[mp],4);
	p	=mvO ? CbOUT : CbOut;
	XDrawString(theD,CPanelW,theGCT,xO+2,iy,p[mpO],3);
	p	=mvI ? CbINP : CbInp;
	XDrawString(theD,CPanelW,theGCT,xI+2,iy,p[mpI],3);
      }
      else{
	m	=XCPCell[kC].kW;
	p	=XCPCell[kC].pW;
	XDrawString(theD,CPanelW,theGCT,xM+wF+2,iy,p[m],3);
	m	=XCPCell[kC].kO;
	p	=XCPCell[kC].pO;
	XDrawString(theD,CPanelW,theGCT,xO+2,iy,p[m],3);
	m	=XCPCell[kC].kI;
	p	=XCPCell[kC].pI;
	XDrawString(theD,CPanelW,theGCT,xI+2,iy,p[m],3);
      }
    }
  }
  XCntrPanelRect(ixPC,iyPC,1);
  XCbShowInstActiveBlock();
  return(0);
}

int XCPanelEraseCells()
{
  int i,ix,iw,iy,kC;

  for(i=0;i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=ixPC+XCPCell[kC].x;
    iy	=iyPC+XCPCell[kC].y;
    iw	=XCPCell[kC].w+wMOI;
    if(ix+iw > 0 && ix < Wwidth){
      XFillRectangle(theD,CPanelW,theGCE,ix,iy,iw,hF+1);
    }
  }
  XCntrPanelRect(ixPC,iyPC,0);
  XIDEraseCells();
  return(0);
}

int XCPanelShowSwitch(int key)
{
  int i,ix,kC,m,mp,mm,ms,mv;
  int xM,xO,xI;
  int iw,iy,iw1,iw2,ix2,iy2;
  char *lc;

  for(i=0; i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=ixPC+XCPCell[kC].x;
    iw	=XCPCell[kC].w+wMOI;
    if(ix+iw > 0 && ix < Wwidth){
      iy	=iyPC+XCPCell[kC].y;
      iw1	=XCPCell[kC].w;
      xM	=ix+iw1+1;
      switch(key){
      case 0:
	m	=*XCPCell[kC].m;
	mp	=m&0x7f;
	mv	=m&(0x100<<mp);
	if((m&(0x100<<kStM))){
	  GuiRect(CPanelW,xM,iy,wM,m&0x100);
	}
	else{
	  GuiButton(CPanelW,xM,iy,wM,(m&0x100) ? 5 : 0);
	}
	iy	+=hB3;
	lc	=mv ? CbMODE[mp] : CbMode[mp];
	XDrawString(theD,CPanelW,theGCT,xM+2,iy,lc,4);
	break;
      case 1:
	xO	=xM+wM+1;
	m	=*XCPCell[kC].O;
	mp	=m&0x7f;
	mm	=m&0x80;
	ms	=mp == kStO ? 0x80 : 0x100<<mp;
	mv	=m&ms;
	if(mm){
	  GuiRect(CPanelW,xO,iy,wO,0);
	}
	else{
	  GuiButton(CPanelW,xO,iy,wO,0);
	}
	iy	+= hB3;
	lc	=mv ? CbOUT[mp] : CbOut[mp];
	XDrawString(theD,CPanelW,theGCT,xO+2,iy,lc,3);
	break;
      case 2:
	xO	=xM+wM+1;
	xI	=xO+wO+1;
	m	=*XCPCell[kC].I;
	mp	=m&0x7F;
	mm	=m&0x80;
	ms	=mp == kStI ? 0x80 : 0x100<<mp;
	mv	=m&ms;
	if(mm){
	  GuiRect(CPanelW,xI,iy,wI,0);
	}
	else{
	  GuiButton(CPanelW,xI,iy,wI,0);
	}
	iy	+= hB3;
	lc	=mv ? CbINP[mp] : CbInp[mp];
	XDrawString(theD,CPanelW,theGCT,xI+2,iy,lc,3);
	break;
      }
    }
  }
  return(0);
}

int XCPanelShowSwitches()
{
  int i,ix,kC,m,mp,mm,mv,mpO,mpI,mvO,mvI;
  int xM,xO,xI;
  int iw,iy,iw1,iw2,ix2,iy2;
  char**p;

  for(i=0; i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=ixPC+XCPCell[kC].x;
    iw	=XCPCell[kC].w+wMOI;
    if(ix+iw > 0 && ix < Wwidth){
      iy	=iyPC+XCPCell[kC].y;
      iw1	=XCPCell[kC].w;

      xM	=ix+iw1+1;
      if(ioCPanel == 0){
	m	=*XCPCell[kC].m;
	mp	=m&0x7f;
	mv	=m&(0x100<<mp);
	if((m&mSetM)){
	  GuiRect(CPanelW,xM,iy,wM,m&0x100);
	}
	else{
	  GuiButton(CPanelW,xM,iy,wM,(m&0x100) ? 5 : 0);
	}
      }	
      else{
	GuiButton(CPanelW,xM,iy,wM,0);
      }
      xO= xM+wM+1;
      if(ioCPanel == 0){
	m	=*XCPCell[kC].O;
	mpO	=m&0x7f;
	mm	=m&0x80;
	mvO	=m&(0x100<<mpO);
	if(mm)
	  GuiRect(CPanelW,xO,iy,wO,0);
	else
	  GuiButton(CPanelW,xO,iy,wO,0);
      }
      else{
	GuiButton(CPanelW,xO,iy,wO,0);
      }

      xI= xO+wO+1;
      if(ioCPanel == 0){
	m	=*XCPCell[kC].I;
	mpI	=m&0x7f;
	mm	=m&0x80;
	mvI	=m&(0x100<<mpI);
	if(mm)
	  GuiRect(CPanelW,xI,iy,wI,0);
	else
	  GuiButton(CPanelW,xI,iy,wI,0);
      }
      else{
	GuiButton(CPanelW,xI,iy,wI,0);
      }

      XSetForeground(theD,theGC,ColorPix[22]);
      iy	+= hB3;
      if(ioCPanel == 0){
	p	=mv ? CbMODE : CbMode;
	XDrawString(theD,CPanelW,theGC,xM+2,iy,p[mp],4);
	p	=mvO ? CbOUT : CbOut;
	XDrawString(theD,CPanelW,theGC,xO+2,iy,p[mpO],3);
	p	=mvI ? CbINP : CbInp;
	XDrawString(theD,CPanelW,theGC,xI+2,iy,p[mpI],3);
      }
      else{
	m	=XCPCell[kC].kW;
	p	=XCPCell[kC].pW;
	XDrawString(theD,CPanelW,theGC,xM+wF+2,iy,p[m],3);
	m	=XCPCell[kC].kO;
	p	=XCPCell[kC].pO;
	XDrawString(theD,CPanelW,theGC,xO+2,iy,p[m],3);
	m	=XCPCell[kC].kI;
	p	=XCPCell[kC].pI;
	XDrawString(theD,CPanelW,theGC,xI+2,iy,p[m],3);
      }
    }
  }
  return(0);
}

int XIDEraseCells()
{
  int i,ix,kD;
  int iw,iy,iy1;

  for(i= 0;i<nXIDC;i++){
    kD= kXIDCell[i];
    ix= ixPC+XIDCell[kD].x;
    if(ix+XIDCell[kD].w>0&&ix<Wwidth){
      iy= iyPC+XIDCell[kD].y;
      XFillRectangle(theD,CPanelW,theGCE,ix,iy,XIDCell[kD].w,hF);
    }
  }
  return(0);
}

int XIDCellPos()
{
  static int i,m,ix,iy,kD,n;
  char**p;

  for(i=0; i < nXIDC; i++){
    kD	=kXIDCell[i];
    ix	=ixPC+XIDCell[kD].x;
    iy	=iyPC+XIDCell[kD].y;
    if(iy <= theBy && theBy <= iy+hF &&
       ix <= theBx && theBx <= ix+XIDCell[kD].w){
      if(ioCPanel == 0) return(i);
      m	=*XIDCell[kD].vs;
      p	=(char**)XIDCell[kD].ps;
      n	=0;
      while(p[n] != NULL) n++;
      switch(theBk){
      case 1:
	OneChoiceMenu(&m,NULL,p,n,ix,iy+hF,0);
	if(m != *XIDCell[kD].vs){
	  int j,jj;
	  *XIDCell[kD].vs	=m;
	  CbReSetBlbInputFiles(0,0,NULL,NULL,NULL,NULL);
	  j	=0;
	  jj	=0;
	  XCbReSetCPanelCells(0,&j,&jj);
	  XCPanelShowSwitches();
	  XIDShowCells();
	  GuiRButton(CPanelW,0);
	  return(i);
	}
	break;
      case 2:
	m++;
	if(p[m] == NULL){
	  m	=0;
	}
	break;
      case 3:
	m--;
	if(m < 0){
	  m	=n-1;
	}
	break;
      }
      *XIDCell[kD].vs	=m;
      GuiButton(CPanelW,ix,iy,XIDCell[kD].w+4,0);
      XSetForeground(theD,theGC,ColorPix[22]);
      XDrawString(theD,CPanelW,theGC,ix+2,iy+hB3,p[m],LBLBID);
      GuiRButton(CPanelW,7);
      return(i);
    }
  }
  return(-1);
}

int XCbClickOnCPanelTbl()
{
  if(XCheckTypedWindowEvent(theD,CPanelW,ButtonPress,&msg)){
    int i,ix,xI,iy;
    int Bk,Bx,By,kC,m;

    Bk	=msg.xbutton.button;
    Bx	=msg.xbutton.x;
    By	=msg.xbutton.y;
    
    for(i=0; i < nXCPC; i++){
      kC	=kXCPCell[i];
      iy	=iyPC+XCPCell[kC].y;
      if(iy <= By && By <= iy+hF){
	ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+wMOI;
	xI	=ix-wI-1;
	if(xI <= Bx && Bx < ix){
	  m	=*XCPCell[kC].I;
	  printf("--------------Imode[%d]=0x%8.8x\n",i,m&0x0000FFFF);
	  return(1);
	}
      }
    }
  }
  return(0);
}

int XCbIfCPanelRE()
{
  char**p;

  if(0 <= theBy && theBy <= hF){
    if(xR <= theBx && theBx <= xR3){
      if(theBk == 2){
	if(ioCPanel){
	  if(itheW == iCPanelW) XCbGetCntrPanel();
	}
	else{
	  XCbSetOutDirMenu();
	  XCbSaveCntrPanel();
	}
      }	
      return(itheW == iCPanelW ? (int)'\r' : 4);
    }
    if(xE <= theBx && theBx <= xE3){
      return(itheW == iCPanelW ? 27 : 4);
    }
  }
  return(theBk);
}

int CpShowOneModSwitch(int kC)
{
  int m,mp;
  int xM,iy;
  char**p;
  
  xM	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1;
  iy	=iyPC+XCPCell[kC].y;
  if(ioCPanel == 0){
    m	=*XCPCell[kC].m;
    mp	=m&0x7f;
    if((m&mSetM)){
      GuiRect(CPanelW,xM,iy,wM,m&0x100);
    }
    else{
      GuiButton(CPanelW,xM,iy,wM,(m&0x100) ? 5 : 0);
    }
    p	=m&(0x100<<mp) ? CbMODE : CbMode;
    XDrawString(theD,CPanelW,theGCT,xM+2,iy+hB3,p[mp],4);
  }
  else{
    GuiButton(CPanelW,xM,iy,wM,0);
    m	=XCPCell[kC].kW;
    p	=XCPCell[kC].pW;
    XDrawString(theD,CPanelW,theGCT,xM+wF+2,iy+hB3,p[m],3);
  }
  return(0);
}

int CpShowOneOutSwitch(int kC)
{
  int m,mp;
  int ix,iy;
  char**p;
  
  ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1;
  iy	=iyPC+XCPCell[kC].y;
  if(ioCPanel == 0){
    m	=*XCPCell[kC].O;
    mp	=m&0x7f;
    if((m&mSetO)){
      GuiRect(CPanelW,ix,iy,wO,0);
    }
    else{
      GuiButton(CPanelW,ix,iy,wO,0);
    }
    p	=(m&(0x100<<mp)) ? CbOUT : CbOut;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[mp],3);
  }
  else{
    GuiButton(CPanelW,xM,iy,wO,0);
    m	=XCPCell[kC].kO;
    p	=XCPCell[kC].pO;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[m],3);
  }
  return(0);
}

int CpShowOneInpSwitch(int kC)
{
  int m,mp;
  int ix,iy;
  char**p;
  
  ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1+wO+1;
  iy	=iyPC+XCPCell[kC].y;
  if(ioCPanel == 0){
    m	=*XCPCell[kC].I;
    mp	=m&0x7f;
    if((m&mSetI)){
      GuiRect(CPanelW,ix,iy,wI,0);
    }
    else{
      GuiButton(CPanelW,ix,iy,wI,0);
    }
    p	=(m&(0x100<<mp)) ? CbINP : CbInp;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[mp],3);
  }
  else{
    GuiButton(CPanelW,xM,iy,wM,0);
    m	=XCPCell[kC].kI;
    p	=XCPCell[kC].pI;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[m],3);
  }
  return(0);
}

int CpShowBlbModSwitches(int kC)
{
  int d;
  int m,mp;
  int ix,iy;
  char **p;
 
  d	=XCPCell[kC].d;
  do{
    ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1;
    iy	=iyPC+XCPCell[kC].y;
    m	=*XCPCell[kC].m;
    mp	=m&0x7f;

    if((m&mSetM)){
      GuiRect(CPanelW,ix,iy,wM,m&0x100);
    }
    else{
      GuiButton(CPanelW,ix,iy,wM,(m&0x100) ? 5 : 0);
    }
    p	=(m&(0x100<<mp)) ? CbMODE : CbMode;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[mp],4);
    kC++;
  }while(kC < nXCPC && (XCPCell[kC].ids || XCPCell[kC].d > d));
  return(0);
}

int CpShowBlbOutSwitches(int kC)
{
  int d;
  int m,mp;
  int ix,iy;
  char **p;
 
  d	=XCPCell[kC].d;
  do{
    ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1;
    iy	=iyPC+XCPCell[kC].y;
    m	=*XCPCell[kC].O;
    mp	=m&0x7f;
    if((m&mSetO)){
      GuiRect(CPanelW,ix,iy,wO,0);
    }
    else{
      GuiButton(CPanelW,ix,iy,wO,0);
    }
    p	=(m&(0x100<<mp)) ? CbOUT : CbOut;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[mp],3);
    kC++;
  }while(kC < nXCPC && (XCPCell[kC].ids || XCPCell[kC].d > d));
  return(0);
}

int CpShowBlbInpSwitches(int kC)
{
  int d;
  int m,mp;
  int ix,iy;
  char **p;
 
  d	=XCPCell[kC].d;
  do{
    ix	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1+wO+1;
    iy	=iyPC+XCPCell[kC].y;
    m	=*XCPCell[kC].I;
    mp	=m&0x7f;
    if((m&mSetI)){
      GuiRect(CPanelW,ix,iy,wI,0);
    }
    else{
      GuiButton(CPanelW,ix,iy,wI,0);
    }
    p	=(m&(0x100<<mp)) ? CbINP : CbInp;
    XDrawString(theD,CPanelW,theGCT,ix+2,iy+hB3,p[mp],3);
    kC++;
  }while(kC < nXCPC && (XCPCell[kC].ids || XCPCell[kC].d > d));
  return(0);
}

int CpReSetModSwitch(int kC)
{
  int M,m,mp,mAdd=0x00,mOr=-1;
  unsigned int msk =0xffffffe0;
  unsigned int mskC=0xffffff9f;
  int i,d,id;
  int kCT;
  int iM;
  int Fl;

  iM	=XCPCell[kC].iM;
  d	=XCPCell[kC].d;
  id	=XCPCell[kC].ids;
  M	=*XCPCell[kC].m;
  mp	=M&0x1f;
  kCT	=0;/*Copy-Take flag*/

  m	=M;
  /*Get new Mode*/
  switch(theBk){/*Type of Block*/
  case 1:
    i	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1;
    if(id < 2){
      XCbMenuWindow(0,&m,&mAdd,&mOr,i,iyPC+XCPCell[kC].y);
    }
    else{
      XCbMenuWindow(0,&m,NULL,NULL,i,iyPC+XCPCell[kC].y);
    }
    kCT	=m&0x60;
    m	-=kCT;
    break;
  case 2:
    mp++;
    if(mp > kStM) mp	=0;
    m	=(M&msk)+mp;
    break;
  case 3:
    m	^=(0x100<<mp);
    break;
  }
  if((m&0x100)){
    m	&=UnSetM;
    M	&=UnSetM;
    *XCPCell[kC].m	&=UnSetM;	
    *XCPCell[kC].O	&=UnSetO;	
    *XCPCell[kC].I	&=UnSetI;	
  }
  switch(XCPCell[kC].ids){/*Type of Block*/
  case 0:	/*blb*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetM;
      m	&=nx80;
      *XCPCell[kC].m	=m&UnSetM;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetM) && ((M&0x080) || (M&mSetM) == 0)){
	  CbTakeModSwitchBlb(XCPCell[kC].iB);
	}
	else{
	  CbTakeOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-blb */
	if((m&mSetM) == 0){ /*Shut down !-blb*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].m	&=UnSetM;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].m	=((*XCPCell[kC].m|mSetM|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].m)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].m	=((((*XCPCell[i].m&msk)|mSetM)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-blb*/
        if((M&mSetM)){/*Was inside !-blb*/
	  *XCPCell[kC].m	|=mSetM;
	  Fl	=1;
	}
	else{/*Was outside !-blb*/
	  if((m&mSetM)){	/*Activate !-blb*/
	    *XCPCell[kC].m	|=mSetM|0x80;
	    *XCPCell[kC].m	=((*XCPCell[kC].m)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].m)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].m	=((((*XCPCell[i].m&msk)|mSetM)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneModSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyModSwitchBlb(XCPCell[kC].iB);
	}
	CpShowBlbModSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetM) == 0){ /*Outside !-blb */
	*XCPCell[kC].m	=m;
	CpShowOneModSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-blb*/
	*XCPCell[kC].m	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0){
	    *XCPCell[i].m	=(*XCPCell[i].m&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbModSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].m	=m;
      if((M&mSetM) == 0){ /*Outside !-blb */
	if((m&mSetM) == 0){/*Not the top of !-blb */
	  *XCPCell[kC].m	&=UnSetM;
	  Fl	=1;
	}
	else{/* Activate !-blb*/
	  *XCPCell[kC].m	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].m	=((*XCPCell[i].m&msk)+mp)|mSetM;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-blb*/
	  if((m&mSetM)){
	    *XCPCell[kC].m	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].m	=((*XCPCell[i].m&msk)+mp)&UnSetM;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-blb*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneModSwitch(kC);
      if(Fl == 2) CpShowBlbModSwitches(kC);
      break;
    }
    break;
  case 1:	/*mzl*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetM;
      m	&=nx80;
      *XCPCell[kC].m	=m&UnSetM;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetM) && ((M&0x080) || (M&mSetM) == 0)){
	  CbTakeModSwitchMzl(XCPCell[kC].iB,iM);
	}
	else{
	  CbTakeOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-mzl */
	if((m&mSetM) == 0){ /*Shut down !-mzl*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].m	&=UnSetM;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].m	=((*XCPCell[kC].m|mSetM|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].m)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].m	=((((*XCPCell[i].m&msk)|mSetM)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-mzl*/
        if((M&mSetM)){/*Was inside !-mzl*/
	  *XCPCell[kC].m	|=mSetM;
	  Fl	=1;
	}
	else{/*Was outside !-mzl*/
	  if((m&mSetM)){	/*Activate !-mzl*/
	    *XCPCell[kC].m	|=mSetM|0x80;
	    *XCPCell[kC].m	=((*XCPCell[kC].m)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].m)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
		*XCPCell[i].m	=((((*XCPCell[i].m&msk)|mSetM)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneModSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyModSwitchMzl(XCPCell[kC].iB,iM);
	}
	CpShowBlbModSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetM) == 0){ /*Outside !-mzl */
	*XCPCell[kC].m	=m;
	CpShowOneModSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-mzl*/
	*XCPCell[kC].m	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	    *XCPCell[i].m	=(*XCPCell[i].m&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbModSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].m	=m;
      if((M&mSetM) == 0){ /*Outside !-mzl */
	if((m&mSetM) == 0){/*Not the top of !-mzl */
	  *XCPCell[kC].m	&=UnSetM;
	  Fl	=1;
	}
	else{/* Activate !-mzl*/
	  *XCPCell[kC].m	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	      *XCPCell[i].m	=((*XCPCell[i].m&msk)+mp)|mSetM;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-mzl*/
	  if((m&mSetM)){
	    *XCPCell[kC].m	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
		*XCPCell[i].m	=((*XCPCell[i].m&msk)+mp)&UnSetM;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-mzl*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneModSwitch(kC);
      if(Fl == 2) CpShowBlbModSwitches(kC);
      break;
    }
    break;
  case 2:	/*stg*/
    if(theBk == 2 && (M&mSetM) == 0){/*<mouse-M> and Outside !-blb*/
      *XCPCell[kC].m	=m;
      CpShowOneModSwitch(kC);
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].m	=(M&mSetM)+(m&UnSetM);
      CpShowOneModSwitch(kC);
      break;
    }
    if(theBk == 1){/*<mouse-L>*/
      if((kCT&0x20)){/*Take On*/
	kCT -=0x20;
	CbTakeOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	if((M&mSetM)) *XCPCell[kC].m	|=mSetM;
      }
      else{
	m	&=UnSetM;
	*XCPCell[kC].m	=(M&mSetM) ? m|mSetM : m;
      }
      if(kCT){
	CbCopyOneModSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
      }
      CpShowOneModSwitch(kC);
      break;
    }
  }
  return(0);
}

int CpReSetOutSwitch(int kC)
{
  int M,m,mp,mAdd=0x00,mOr=-1;
  unsigned int msk =0xffffffe0;
  unsigned int mskC=0xffffff9f;
  int i,d,id;
  int kCT;
  int iM;
  int Fl;

  iM	=XCPCell[kC].iM;
  d	=XCPCell[kC].d;
  id	=XCPCell[kC].ids;
  M	=*XCPCell[kC].O;
  mp	=M&0x1f;
  kCT	=0;/*Copy-Take flag*/

  m	=M;
  /*Get new Mode*/
  switch(theBk){/*Type of Block*/
  case 1:
    i	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1;
    if(id < 2){
      XCbMenuWindow(1,&m,&mAdd,&mOr,i,iyPC+XCPCell[kC].y);
    }
    else{
      XCbMenuWindow(1,&m,NULL,NULL,i,iyPC+XCPCell[kC].y);
    }
    kCT	=m&0x60;
    m	-=kCT;
    break;
  case 2:
    mp++;
    if(mp > kStO) mp	=0;
    m	=(M&msk)+mp;
    break;
  case 3:
    m	^=(0x100<<mp);
    break;
  }
  switch(XCPCell[kC].ids){/*Type of Block*/
  case 0:	/*blb*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetO;
      m	&=nx80;
      *XCPCell[kC].O	=m&UnSetO;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetO) && ((M&0x080) || (M&mSetO) == 0)){
	  CbTakeOutSwitchBlb(XCPCell[kC].iB);
	}
	else{
	  CbTakeOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-blb */
	if((m&mSetO) == 0){ /*Shut down !-blb*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].O	&=UnSetO;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].O	=((*XCPCell[kC].O|mSetO|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].O)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].O	=((((*XCPCell[i].O&msk)|mSetO)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-blb*/
        if((M&mSetO)){/*Was inside !-blb*/
	  *XCPCell[kC].O	|=mSetO;
	  Fl	=1;
	}
	else{/*Was outside !-blb*/
	  if((m&mSetO)){	/*Activate !-blb*/
	    *XCPCell[kC].O	|=mSetO|0x80;
	    *XCPCell[kC].O	=((*XCPCell[kC].O)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].O)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].O	=((((*XCPCell[i].O&msk)|mSetO)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneOutSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyOutSwitchBlb(XCPCell[kC].iB);
	}
	CpShowBlbOutSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetO) == 0){ /*Outside !-blb */
	*XCPCell[kC].O	=m;
	CpShowOneOutSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-blb*/
	*XCPCell[kC].O	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0){
	    *XCPCell[i].O	=(*XCPCell[i].O&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbOutSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].O	=m;
      if((M&mSetO) == 0){ /*Outside !-blb */
	if((m&mSetO) == 0){/*Not the top of !-blb */
	  *XCPCell[kC].O	&=UnSetO;
	  Fl	=1;
	}
	else{/* Activate !-blb*/
	  *XCPCell[kC].O	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].O	=((*XCPCell[i].O&msk)+mp)|mSetO;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-blb*/
	  if((m&mSetO)){
	    *XCPCell[kC].O	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].O	=((*XCPCell[i].O&msk)+mp)&UnSetO;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-blb*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneOutSwitch(kC);
      if(Fl == 2) CpShowBlbOutSwitches(kC);
      break;
    }
    break;
  case 1:	/*mzl*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetO;
      m	&=nx80;
      *XCPCell[kC].O	=m&UnSetO;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetO) && ((M&0x080) || (M&mSetO) == 0)){
	  CbTakeOutSwitchMzl(XCPCell[kC].iB,iM);
	}
	else{
	  CbTakeOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-mzl */
	if((m&mSetO) == 0){ /*Shut down !-mzl*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].O	&=UnSetO;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].O	=((*XCPCell[kC].O|mSetO|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].O)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].O	=((((*XCPCell[i].O&msk)|mSetO)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-mzl*/
        if((M&mSetO)){/*Was inside !-mzl*/
	  *XCPCell[kC].O	|=mSetO;
	  Fl	=1;
	}
	else{/*Was outside !-mzl*/
	  if((m&mSetO)){	/*Activate !-mzl*/
	    *XCPCell[kC].O	|=mSetO|0x80;
	    *XCPCell[kC].O	=((*XCPCell[kC].O)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].O)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
		*XCPCell[i].O	=((((*XCPCell[i].O&msk)|mSetO)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneOutSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyOutSwitchMzl(XCPCell[kC].iB,iM);
	}
	CpShowBlbOutSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetO) == 0){ /*Outside !-mzl */
	*XCPCell[kC].O	=m;
	CpShowOneOutSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-mzl*/
	*XCPCell[kC].O	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	    *XCPCell[i].O	=(*XCPCell[i].O&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbOutSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].O	=m;
      if((M&mSetO) == 0){ /*Outside !-mzl */
	if((m&mSetO) == 0){/*Not the top of !-mzl */
	  *XCPCell[kC].O	&=UnSetO;
	  Fl	=1;
	}
	else{/* Activate !-mzl*/
	  *XCPCell[kC].O	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	      *XCPCell[i].O	=((*XCPCell[i].O&msk)+mp)|mSetO;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-mzl*/
	  if((m&mSetO)){
	    *XCPCell[kC].O	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
		*XCPCell[i].O	=((*XCPCell[i].O&msk)+mp)&UnSetO;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-mzl*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneOutSwitch(kC);
      if(Fl == 2) CpShowBlbOutSwitches(kC);
      break;
    }
    break;
  case 2:	/*stg*/
    if(theBk == 2 && (M&mSetO) == 0){/*<mouse-M> and Outside !-blb*/
      *XCPCell[kC].O	=m;
      CpShowOneOutSwitch(kC);
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].O	=(M&mSetO)+(m&UnSetO);
      CpShowOneOutSwitch(kC);
      break;
    }
    if(theBk == 1){/*<mouse-L>*/
      if((kCT&0x20)){/*Take On*/
	kCT -=0x20;
	CbTakeOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	if((M&mSetO)) *XCPCell[kC].O	|=mSetO;
      }
      else{
	m	&=UnSetO;
	*XCPCell[kC].O	=(M&mSetO) ? m|mSetO : m;
      }
      if(kCT){
	CbCopyOneOutSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
      }
      CpShowOneOutSwitch(kC);
      break;
    }
  }
  return(0);
}

int CpReSetInpSwitch(int kC)
{
  int M,m,mp,mAdd=0x00,mOr=-1;
  unsigned int msk =0xffffffe0;
  unsigned int mskC=0xffffff9f;
  int i,d,id;
  int kCT;
  int iM;
  int Fl;

  iM	=XCPCell[kC].iM;
  d	=XCPCell[kC].d;
  id	=XCPCell[kC].ids;
  M	=*XCPCell[kC].I;
  mp	=M&0x1f;
  kCT	=0;/*Copy-Take flag*/

  m	=M;
  /*Get new Mode*/
  switch(theBk){/*Type of Block*/
  case 1:
    i	=ixPC+XCPCell[kC].x+XCPCell[kC].w+1+wM+1+wO+1;
    if(id < 2){
      XCbMenuWindow(2,&m,&mAdd,&mOr,i,iyPC+XCPCell[kC].y);
    }
    else{
      XCbMenuWindow(2,&m,NULL,NULL,i,iyPC+XCPCell[kC].y);
    }
    kCT	=m&0x60;
    m	-=kCT;
    break;
  case 2:
    mp++;
    if(mp > kStI) mp	=0;
    m	=(M&msk)+mp;
    break;
  case 3:
    m	^=(0x100<<mp);
    break;
  }
  switch(XCPCell[kC].ids){/*Type of Block*/
  case 0:	/*blb*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetI;
      m	&=nx80;
      *XCPCell[kC].I	=m&UnSetI;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetI) && ((M&0x080) || (M&mSetI) == 0)){
	  CbTakeInpSwitchBlb(XCPCell[kC].iB);
	}
	else{
	  CbTakeOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-blb */
	if((m&mSetI) == 0){ /*Shut down !-blb*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].I	&=UnSetI;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].I	=((*XCPCell[kC].I|mSetI|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].I)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].I	=((((*XCPCell[i].I&msk)|mSetI)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-blb*/
        if((M&mSetI)){/*Was inside !-blb*/
	  *XCPCell[kC].I	|=mSetI;
	  Fl	=1;
	}
	else{/*Was outside !-blb*/
	  if((m&mSetI)){	/*Activate !-blb*/
	    *XCPCell[kC].I	|=mSetI|0x80;
	    *XCPCell[kC].I	=((*XCPCell[kC].I)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].I)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].I	=((((*XCPCell[i].I&msk)|mSetI)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneInpSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyInpSwitchBlb(XCPCell[kC].iB);
	}
	CpShowBlbInpSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetI) == 0){ /*Outside !-blb */
	*XCPCell[kC].I	=m;
	CpShowOneInpSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-blb*/
	*XCPCell[kC].I	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0){
	    *XCPCell[i].I	=(*XCPCell[i].I&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbInpSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].I	=m;
      if((M&mSetI) == 0){ /*Outside !-blb */
	if((m&mSetI) == 0){/*Not the top of !-blb */
	  *XCPCell[kC].I	&=UnSetI;
	  Fl	=1;
	}
	else{/* Activate !-blb*/
	  *XCPCell[kC].I	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0){
	      *XCPCell[i].I	=((*XCPCell[i].I&msk)+mp)|mSetI;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-blb*/
	  if((m&mSetI)){
	    *XCPCell[kC].I	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0){
		*XCPCell[i].I	=((*XCPCell[i].I&msk)+mp)&UnSetI;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-blb*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneInpSwitch(kC);
      if(Fl == 2) CpShowBlbInpSwitches(kC);
      break;
    }
    break;
  case 1:	/*mzl*/
    Fl	=0;
    if(theBk == 1){/*<mouse-L>*/
      if(m&0x80) m |=mSetI;
      m	&=nx80;
      *XCPCell[kC].I	=m&UnSetI;
      if((kCT&0x20)){
	kCT -=0x20;
	if((m&mSetI) && ((M&0x080) || (M&mSetI) == 0)){
	  CbTakeInpSwitchMzl(XCPCell[kC].iB,iM);
	}
	else{
	  CbTakeOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
      }
      if((M&0x080)){	/*Was the top of !-mzl */
	if((m&mSetI) == 0){ /*Shut down !-mzl*/
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].I	&=UnSetI;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	else{
	  *XCPCell[kC].I	=((*XCPCell[kC].I|mSetI|0x80)&mOr)|mAdd;
	  mp	=(*XCPCell[kC].I)&0x1f;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
	      *XCPCell[i].I	=((((*XCPCell[i].I&msk)|mSetI)+mp)&mOr)|mAdd;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	}
	Fl	=2;
      }
      else{/* Was not the top of !-mzl*/
        if((M&mSetI)){/*Was inside !-mzl*/
	  *XCPCell[kC].I	|=mSetI;
	  Fl	=1;
	}
	else{/*Was outside !-mzl*/
	  if((m&mSetI)){	/*Activate !-mzl*/
	    *XCPCell[kC].I	|=mSetI|0x80;
	    *XCPCell[kC].I	=((*XCPCell[kC].I)&mOr)|mAdd;	
	    mp	=(*XCPCell[kC].I)&0x1f;
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 &&  XCPCell[i].iM == iM){
		*XCPCell[i].I	=((((*XCPCell[i].I&msk)|mSetI)+mp)&mOr)|mAdd;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	  else{
	    Fl	=1;
	  }
	}
      }
      if(Fl == 1){
	if(kCT){
	  CbCopyOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	}
	CpShowOneInpSwitch(kC);
      }
      if(Fl == 2){
	if(kCT){
	  CbCopyInpSwitchMzl(XCPCell[kC].iB,iM);
	}
	CpShowBlbInpSwitches(kC);
      }
      break;
    }
    if(theBk == 2){	/*<mouse-M>*/
      if((M&mSetI) == 0){ /*Outside !-mzl */
	*XCPCell[kC].I	=m;
	CpShowOneInpSwitch(kC);
      }
      else if((M&0x80)){ /*Top of !-mzl*/
	*XCPCell[kC].I	=m;
	i	=kC+1;
	do{
	  if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	    *XCPCell[i].I	=(*XCPCell[i].I&msk)+mp;
	  }
	  i++;
	}while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	CpShowBlbInpSwitches(kC);
      }
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].I	=m;
      if((M&mSetI) == 0){ /*Outside !-mzl */
	if((m&mSetI) == 0){/*Not the top of !-mzl */
	  *XCPCell[kC].I	&=UnSetI;
	  Fl	=1;
	}
	else{/* Activate !-mzl*/
	  *XCPCell[kC].I	|=0x80;
	  i	=kC+1;
	  do{
	    if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
	      *XCPCell[i].I	=((*XCPCell[i].I&msk)+mp)|mSetI;
	    }
	    i++;
	  }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	  Fl	=2;
	}
      }
      else{
	if((M&0x80)){	/*Top of !-mzl*/
	  if((m&mSetI)){
	    *XCPCell[kC].I	|=0x80;
	    Fl	=1;
	  }
	  else{/* Deactivate */
	    i	=kC+1;
	    do{
	      if((*XCPCell[i].m&0x100) == 0 && XCPCell[i].iM == iM){
		*XCPCell[i].I	=((*XCPCell[i].I&msk)+mp)&UnSetI;
	      }
	      i++;
	    }while(i < nXCPC && (XCPCell[i].ids || XCPCell[i].d > d));
	    Fl	=2;
	  }
	}	
	else{/*Inside !-mzl*/
	  Fl	=1;
	}
      }
      if(Fl == 1) CpShowOneInpSwitch(kC);
      if(Fl == 2) CpShowBlbInpSwitches(kC);
      break;
    }
    break;
  case 2:	/*stg*/
    if(theBk == 2 && (M&mSetI) == 0){/*<mouse-M> and Outside !-blb*/
      *XCPCell[kC].I	=m;
      CpShowOneInpSwitch(kC);
      break;
    }
    if(theBk == 3){/*<mouse-R>*/
      *XCPCell[kC].I	=(M&mSetI)+(m&UnSetI);
      CpShowOneInpSwitch(kC);
      break;
    }
    if(theBk == 1){/*<mouse-L>*/
      if((kCT&0x20)){/*Take On*/
	kCT -=0x20;
	CbTakeOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
	if((M&mSetI)) *XCPCell[kC].I	|=mSetI;
      }
      else{
	m	&=UnSetI;
	*XCPCell[kC].I	=(M&mSetI) ? m|mSetI : m;
      }
      if(kCT){
	CbCopyOneInpSwitch(XCPCell[kC].iB,XCPCell[kC].iM,XCPCell[kC].iS);
      }
      CpShowOneInpSwitch(kC);
      break;
    }
  }
  return(0);
}

int CheckCPanelIO()
{
  static int i,x,y,b,m;
  b	=msg.xbutton.button;
  x	=msg.xbutton.x;
  y	=msg.xbutton.y;
  if(WinNumber(&i) == 0) return(0);

  if(0 <= y && y <= hF){
    if(xA <= x && x <= xA3){	/* Activity box */
      m	=WinP[i].mode&0xF;
      if(b == 1){
	m++;
      }
      else{
	m--;
      }
      if(m > 3)
	m	=0;
      if(m < 0){
	m= 3;
      }
      WinP[i].mode	&=0xF0;
      WinP[i].mode	|=m;
      if(WinP[i].W == theW) Wmode= WinP[i].mode;
      GuiAButton(msg.xany.window,m);
      return(0);
    }

    if(xM <= x && x <= xM3){	/* Mode box */
      if(i == iCPanelW){
	ioCPanel	^=0x01;
	if(itheW != iCPanelW){
	  if(ioCPanel == 0){
	    GuiRButton(CPanelW,1);
	  }
	  else{
	    GuiEraseRButton(CPanelW);
	  }
	}
	GuiIOButton(CPanelW,ioCPanel);
	XCPanelShowSwitches();
	XIDShowCells();
      }
      else{
	if(i == itheW){
	  m	=(WinP[i].mode>>4)&0xF;
	  if(b == 1)
	    m++;
	  else
	    m--;
	  if(m > 7)
	    m	=0;
	  if(m < 0)
	    m	=7;
	  WinP[i].mode	&=0x0f;
	  WinP[i].mode	|=(m<<4);
	  if(WinP[i].W == theW){
	    if(m) GuiRButton(theW,m);
	    Wmode	=WinP[i].mode;
	  }
	  GuiMButton(msg.xany.window,m);
	}
      }
      return(0);
    }
    xH3	=WinP[i].iW-1;
    xH	=xH3-3-wBH3;
    if(xH <= x && x<= xH3){	/* Help box */
      char *lc;
      m	=WinP[i].Hlp;
      if(b == 2){
	m++;
	if((i && m == nH1) || (i == 0 && m == nH0)){
	  m	=0;
	}
	WinP[i].Hlp	=m;
	GuiHButton(i);
	return(0);
      }
      switch(msg.xkey.state){
      case 0:
	if(b ==1){
	  if(i){
	    OneChoiceMenu(&m,"Help for :",listH1,nH1,xH,hF,i);
	  }
	  else{
	    OneChoiceMenu(&m,"Help for :",listH0,nH0,xH,hF,i);
	  }
	  WinP[i].Hlp	=m;
	  GuiHButton(i);
	}
	XCbHelpWindow(i,xH,hF+1,i ? Help1[m].t : Help0[m].t,i ? 2 : 3);
	break;
      case 1:
      case 3:
	system(i ? Help1[m].ps : Help0[m].ps);
	break;
      case 4:
      case 6:
	system(i ? Help1[m].dvi : Help0[m].dvi);
	break;
      }
      msg.xkey.state	=0;
      return(0);
    }
  }
  return(0);
}

int CpPos()
{
  static int i,ix,xM,xO,xI,iy,iw,iw1,iw2,ix2,iy2;
  int kC,m,mp,mm,ms,mv,iB;
  char**p;

  for(i=0; i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=ixPC+XCPCell[kC].x;
    iy	=iyPC+XCPCell[kC].y;
    iw	=XCPCell[kC].w+wMOI;
    if(iy <= theBy && theBy <= iy+hF && ix <= theBx && theBx <= ix+iw){
      iclmCP	=i;
      xM	=ix+XCPCell[kC].w+1;
      if(theBx < xM){/*Click on the section name*/
	if(theBk == 3){/*<mouse-R>*/
	  XCbDisplaySectHelp(ix,iy,kC);
	  return(i);
	}
	switch(XCPCell[kC].ids){
	case 0:
	  if(++(*XCPCell[kC].s) >= 3) *XCPCell[kC].s	=0;
	  break;
	case 1:
	  ++(*XCPCell[kC].xM);
	  break;
	default:
	  return(i);
	}
	XEraseCntrPanelRect(ixPC,iyPC,0);
	XCbReInitCntrPanel();
	nXCPC	=*nXCPCell;
	nXIDC	=*nXIDCell;
	XIDShowCells();
	XCPanelShowCells();
	return(i);
      }

      iB	=XCPCell[kC].iB;
      xO	=xM+wM+1;
      if(xM <= theBx && theBx < xO){/*Click on the Mode switch*/
	if(ioCPanel == 0){/*Output state of Control Panel*/
	  CpReSetModSwitch(kC);
	  return(i);
	}
	else{/*Input state of Control Panel*/
	  m	=XCPCell[kC].kW;
	  p	=XCPCell[kC].pW;
	  switch(theBk){
	  case 2:
	    m++;
	    if(p[m] == NULL){
	      m	=0;
	    }
	    XCPCell[kC].kW	=m;
	    break;
	  case 3:
	    if(p[m][0] == '.'){
	      p[m][0]	='~';
	    }
	    else{
	      p[m][0]	='.';
	    }
	    break;
	  }
	  GuiButton(CPanelW,xM,iy,wM,0);
	  iy	+=hB3;
	  XSetForeground(theD,theGC,ColorPix[22]);
	  XDrawString(theD,CPanelW,theGC,xM+wF+2,iy,p[m],3);
	}
	return(i);
      }

      xI	=xO+wO+1;
      if(xO <= theBx && theBx < xI){
	if(ioCPanel == 0){
	  CpReSetOutSwitch(kC);
	}
	else{
	  m	=XCPCell[kC].kO;
	  p	=XCPCell[kC].pO;
	  switch(theBk){
	  case 2:
	    m++;
	    if(p[m] == NULL){
	      m	=0;
	    }
	    XCPCell[kC].kO	=m;
	    break;
	  case 3:
	    if(p[m][0] == '.'){
	      p[m][0]	='~';
	    }
	    else{
	      p[m][0]	='.';
	    }
	    break;
	  }
	  GuiButton(CPanelW,xO,iy,wO,0);
	  iy	+=hB3;
	  XSetForeground(theD,theGC,ColorPix[22]);
	  XDrawString(theD,CPanelW,theGC,xO+2,iy,p[m],3);
	}
	return(i);
      }
      if(ioCPanel == 0){
	CpReSetInpSwitch(kC);
      }
      else{
	m	=XCPCell[kC].kI;
	p	=XCPCell[kC].pI;
	switch(theBk){
	case 2:
	  m++;
	  if(p[m] == NULL){
	    m	=0;
	  }
	  XCPCell[kC].kI	=m;
	  break;
	case 3:
	  if(p[m][0]=='.'){
	    p[m][0]	='~';
	  }
	  else{
	    p[m][0]	='.';
	  }
	  break;
	}
	GuiButton(CPanelW,xI,iy,wI,0);
	iy	+=hB3;
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,CPanelW,theGC,xI+2,iy,p[m],3);
      }
      return(i);
    }
  }
  return(-1);
}

int XCbInputCntrPanel()
{
  int k,m,kC,kD;
  static int i,ii,i1,i2,ix,iy,iw;
  static int j,xM,xO,xI;
  extern int CbNoX;

  theW	=CPanelW;
  itheW	=iCPanelW;

  if(CbNoX)	return(0);

#ifdef HHH
  msg.xkey.keycode	=XKeysymToKeycode(theD,XK_Escape);
  if(CbNoX){
    XSendEvent(theD,WinP[0].W,False,KeyPressMask,&msg);
    XNextEvent(theD,&msg);
    return(0);
  }
#endif
  XCbReInitCntrPanel();
  nXCPC	=*nXCPCell;
  nXIDC	=*nXIDCell;

  Wwidth	=WinP[iCPanelW].iW;
  GuiERButtons(iCPanelW);
  GuiAButton(CPanelW,Wmode&0xF);
  GuiIOButton(CPanelW,ioCPanel);
  kC	=kXCPCell[iclmCP];
  i	=XCPCell[kC].x+XCPCell[kC].w+wMOI;
  j	=ixPC+i;
  if(j > Wwidth-wF){
    ixPC	=Wwidth/2-XCPCell[kC].x;
    if(ixPC+i > Wwidth-wF){
      ixPC	=Wwidth-wF-i;
    }
  }
  XIDShowCells();
  XCPanelShowCells();
  do{
    Wwidth	=WinP[iCPanelW].iW;
    kC	=kXCPCell[iclmCP];
    iw	=XCPCell[kC].w+wMOI;
    i	=XCPCell[kC].x+iw;
    ix	=ixPC;
    if(ix+i > Wwidth-wF){
      ix	=Wwidth/2-XCPCell[kC].x;
      if(ix+i > Wwidth-wF){
	ix	=Wwidth-wF-i;
      }
    }
    if(ixPC+XCPCell[kC].x <= wF){
      ix	=(Wwidth-iw)/2-XCPCell[kC].x;
      if(ix+XCPCell[0].x > 0){
	ix	=0;
      }
      if(ix+i > Wwidth-wF){
	ix	=Wwidth-wF-i;
      }
    }

    if(ix != ixPC){
      XEraseCntrPanelRect(ixPC,iyPC,0);
      ixPC	=ix;
      XIDShowCells();
      XCPanelShowCells();
    }
    j	=iclmCP;
    kC	=kXCPCell[j];
    ix	=ixPC+XCPCell[kC].x;
    iw	=XCPCell[kC].w+wMOI;
    iy	=XCPCell[kC].y;
    k	=EvGetCntrKey();
    switch(k){
    case 1:
    case 2:
    case 3:
      if(msg.xany.window != theW) break;
      theBk	=msg.xbutton.button;
      theBx	=msg.xbutton.x;
      theBy	=msg.xbutton.y;
      k	=XCbIfCPanelRE();
      if(k > 4) break;
      kD	=XIDCellPos();
      if(kD >= 0){
	kD	=kXIDCell[kD];
	iw	=XIDCell[kD].w;
	i	=XIDCell[kD].x+iw;
	j	=ixPC+i;
	if(j > Wwidth-wF){
	  XEraseCntrPanelRect(ixPC,iyPC,0);
	  ixPC	=Wwidth-wF-i;
	  iclmCP	=XIDCell[kD].c;
	}
	ix	=ixPC+XIDCell[kD].x;
	if(j && ix <= wF){
	  XEraseCntrPanelRect(ixPC,iyPC,0);
	  ixPC	=(Wwidth-iw)/2-XIDCell[kD].x;
	  if(ixPC+XCPCell[0].x > 0){
	    ixPC	=0;
	  }
	  if(ixPC+i > Wwidth-wF){
	    ixPC	=Wwidth-wF-i;
	  }
	  iclmCP	=XIDCell[kD].c;
	}
	if(j > Wwidth-wF || (j && ix <= wF)){
	  XIDShowCells();
	  XCPanelShowCells();
	}
	iy	=iyPC+XIDCell[kD].y;
	if(XIDCell[kD].ids == 0){
	  k	=ioCPanel == 0 ? XCbGetDirName(kD,iy) :
	    kD == 0 ? XCbGetInputRootDirName(kD,iy) : k;
	}
	else{
	  k	=XCbGetStreemPar(kD,iy);
	}
	break;
      }
      CpPos();
      break;
    }
    if(k == '\r'){
      if(ioCPanel){
	CbReSetBlbInputFiles(0,0,NULL,NULL,NULL,NULL);
	i	=0;
	ii	=0;
	XCbReSetCPanelCells(0,&i,&ii);
	XCPanelShowSwitches();
	XIDShowCells();
	GuiRButton(CPanelW,0);
      }
      else{
	CbResetOutCPanel();
	XCPanelShowSwitches();
      }
    }
  }while(k-27);
  CbResetOutCPanel();
  XFillRectangle(theD,CPanelW,theGCE,xR,0,xE3,hF+1);
  GuiRButton(CPanelW,1);
  if(ioCPanel){
    ioCPanel	=0;
    GuiIOButton(CPanelW,ioCPanel);
    XCPanelShowSwitches();
    XIDShowCells();
  }
  return(k);
}
#endif/*stg_CPanel*/

#ifndef stg_Junk
/* Non active */
int XCbCPanel2PixCP(Pixmap lCP,int xP,int yP)
{
  int i,ix,kD,m;
  int iw,iy,iy1,iwd,ixu,iy2,ix2,iw2;
  char**p,str[LBLBID+1];
  int kC,mp,mm,mv,mpO,mpI,mvO,mvI;
  int xM,xO,xI;
  int iw1;

  for(i=0; i < nXIDC; i++){
    kD	=kXIDCell[i];
    ix	=XIDCell[kD].x-xP;
    iy	=XIDCell[kD].y-yP;
    iy1	=iy+hB3;
    if(XIDCell[kD].ids == 0){
      if(ioCPanel == 0){
	XSetForeground(theD,theGC,ColorPix[47]);
	XFillRectangle(theD,lCP,theGC,ix,iy,XIDCell[kD].w,hF);
	XSetForeground(theD,theGC,ColorPix[22]);
	XDrawString(theD,lCP,theGC,ix,iy1,XIDCell[kD].pv,LBLBID);
      }
      else{
	GuiButton(lCP,ix,iy,XIDCell[kD].w+4,0);
	XSetForeground(theD,theGC,ColorPix[22]);
	m	=*XIDCell[kD].vs;
	p	=(char**)XIDCell[kD].ps;
	XDrawString(theD,lCP,theGC,ix+2,iy1,p[m],LBLBID);
      }
    }
    else{
      XIDCell[kD].pn	=strID[XIDCell[kD].h];
      iwd	=5*wF;
      iw	=XIDCell[kD].w-iwd;
      ixu	=ix+iw;
      GuiButton(lCP,ix,iy,iw,2);
      XSetForeground(theD,theGC,ColorPix[47]);
      XFillRectangle(theD,lCP,theGC,ixu,iy,iwd,hF);
      XSetForeground(theD,theGC,ColorPix[22]);
      XDrawString(theD,lCP,theGC,ix+3,iy1,XIDCell[kD].pn,2);
      numstr(*(double*)XIDCell[kD].pv,str,5);
      XDrawString(theD,lCP,theGC,ixu,iy1,str,5);
    }
  }
  for(i=0; i < nXCPC; i++){
    kC	=kXCPCell[i];
    ix	=XCPCell[kC].x-xP;
    iw	=XCPCell[kC].w+wMOI;
    iy	=XCPCell[kC].y-yP;
    iw1	=XCPCell[kC].w;
    switch(XCPCell[kC].ids){
    case 0:
      GuiButton(lCP,ix,iy,iw1,1);
      break;
    case 1:
      GuiButton(lCP,ix,iy,iw1,2);
      break;
    case 2:
      XSetForeground(theD,theGC,ColorPix[49]);
      XFillRectangle(theD,lCP,theGC,ix,iy,iw1,hF);
      break;
    }
    xM= ix+iw1+1;
    if(ioCPanel == 0){
      m	=*XCPCell[kC].m;
      mp	=m&0x7f;
      mm	=m&0x80;
      mv	=m&(0x100<<mp);
      if(mm){
	GuiRect(lCP,xM,iy,wM,m&0x100);
      }
      else{
	GuiButton(lCP,xM,iy,wM,(m&0x100) ? 5 : 0);
      }
    }
    else{
      GuiButton(lCP,xM,iy,wM,0);
    }
    
    xO= xM+wM+1;
    if(ioCPanel==0){
      m	=*XCPCell[kC].O;
      mpO	=m&0x7f;
      mm	=m&0x80;
      mvO	=m&(0x100<<mpO);
      if(mm){
	GuiRect(lCP,xO,iy,wO,0);
      }
      else{
	GuiButton(lCP,xO,iy,wO,0);
      }
    }
    else{
      GuiButton(lCP,xO,iy,wO,0);
    }
    
    xI= xO+wO+1;
    if(ioCPanel == 0){
      m	=*XCPCell[kC].I;
      mpI	=m&0x7f;
      mm	=m&0x80;
      mvI	=m&(0x100<<mpI);
      if(mm)
	GuiRect(lCP,xI,iy,wI,0);
      else
	GuiButton(lCP,xI,iy,wI,0);
    }
    else{
      GuiButton(lCP,xI,iy,wI,0);
    }
    iy	+=hB3;
    XSetForeground(theD,theGC,ColorPix[22]);
    XDrawString(theD,lCP,theGC,ix+3,iy,XCPCell[kC].pn,XCPCell[kC].ln);
    if(ioCPanel==0){
      p	=mv ? CbMODE : CbMode;
      XDrawString(theD,lCP,theGC,xM+2,iy,p[mp],4);
      p	=mvO ? CbOUT : CbOut;
      XDrawString(theD,lCP,theGC,xO+2,iy,p[mpO],3);
      p	=mvI ? CbINP : CbInp;
      XDrawString(theD,lCP,theGC,xI+2,iy,p[mpI],3);
    }
    else{
      m	=XCPCell[kC].kW;
      p	=XCPCell[kC].pW;
      XDrawString(theD,lCP,theGC,xM+wF+2,iy,p[m],3);
      m	=XCPCell[kC].kO;
      p	=XCPCell[kC].pO;
      XDrawString(theD,lCP,theGC,xO+2,iy,p[m],3);
      m	=XCPCell[kC].kI;
      p	=XCPCell[kC].pI;
      XDrawString(theD,lCP,theGC,xI+2,iy,p[m],3);
    }
  }
  return(0);
}
#endif/*stg_Junk*/
#endif/*mzl_X*/
